/**
   @file	Starter.h
   @ingroup Frontend
   @brief   Base class for front-end starters header
   @author	Michael Gerndt
   @verbatim
        Revision:       $Revision$
        Revision date:  $Date$
        Committed by:   $Author$

        This file is part of the Periscope performance measurement tool.
        See http://www.lrr.in.tum.de/periscope for details.

        Copyright (c) 2005-2011, Technische Universitaet Muenchen, Germany
        See the COPYING file in the base directory of the package for details.
   @endverbatim
 */

#ifndef STARTER_H_
#define STARTER_H_

#include <string>
#include <stdlib.h>

/**
 * @class Starter
 * @ingroup Frontend
 *
 * @brief Starts the application to be monitored
 *
 */
class Starter {
protected:
    std::string executable;
    int         processes;
    int         threads;



public:
    Starter();

    virtual ~Starter();

    virtual bool runApplication() = 0;

    virtual bool rerunApplication() = 0;

    virtual bool runAgents() = 0;

    void instrumentRequiredRegions();
};



#endif /* STARTER_H_ */
