/**
   @file	SuperMUCStarter.h
   @ingroup Frontend
   @brief   Starter for SuperMUC jobs
   @author	Isaias Compres
   @verbatim
        Revision:       $Revision$
        Revision date:  $Date$
        Committed by:   $Author$

        This file is part of the Periscope performance measurement tool.
        See http://www.lrr.in.tum.de/periscope for details.

        Copyright (c) 2005-2011, Technische Universitaet Muenchen, Germany
        See the COPYING file in the base directory of the package for details.
   @endverbatim
 */


#ifndef SUPERMUC_STARTER_H_
#define SUPERMUC_STARTER_H_

#include "Starter.h"
using namespace std;

/**
 * @class SuperMUCStarter
 * @ingroup Frontend
 *
 * @brief Starts the agent hierarchy and application in the SuperMUC petascale system.
 *
 * @sa Starter
 */
class SuperMUCStarter : public Starter {
public:
    SuperMUCStarter();

    virtual ~SuperMUCStarter();

    bool runApplication();

    bool rerunApplication();

    bool runAgents();
};

#endif
