/*
 * model_inc.h
 *
 *  Created on: 11.08.2014
 *      Author: lu43jih
 */

#ifndef MODEL_INC_H_
#define MODEL_INC_H_


#define NUMBER_OF_FREQ 16
#define NUMBER_OF_COEF 11


using namespace std;
float frequency[ NUMBER_OF_FREQ ];
float xminval[ NUMBER_OF_COEF ];
float xmaxval[ NUMBER_OF_COEF ];
float coeffEnergy[ NUMBER_OF_COEF ][ NUMBER_OF_FREQ ][ NUMBER_OF_FREQ ];
float coeffPerformance[ NUMBER_OF_COEF ][ NUMBER_OF_FREQ ][ NUMBER_OF_FREQ ];
float energyMin[ NUMBER_OF_FREQ ][ NUMBER_OF_FREQ ];
float energyMax[ NUMBER_OF_FREQ ][ NUMBER_OF_FREQ ];
float performanceMin[ NUMBER_OF_FREQ ][ NUMBER_OF_FREQ ];
float performanceMax[ NUMBER_OF_FREQ ][ NUMBER_OF_FREQ ];
float powerMin[ NUMBER_OF_FREQ ][ NUMBER_OF_FREQ ];
float powerMax[ NUMBER_OF_FREQ ][ NUMBER_OF_FREQ ];
float coeffPower[ NUMBER_OF_COEF ][ NUMBER_OF_FREQ ][ NUMBER_OF_FREQ ];

void defineParams() {
    frequency[ 0 ]  =  1.20000;
    frequency[ 1 ]  =  1.30000;
    frequency[ 2 ]  =  1.40000;
    frequency[ 3 ]  =  1.50000;
    frequency[ 4 ]  =  1.60000;
    frequency[ 5 ]  =  1.70000;
    frequency[ 6 ]  =  1.80000;
    frequency[ 7 ]  =  1.90000;
    frequency[ 8 ]  =  2.00000;
    frequency[ 9 ]  =  2.10000;
    frequency[ 10 ] =  2.20000;
    frequency[ 11 ] =  2.30000;
    frequency[ 12 ] =  2.40000;
    frequency[ 13 ] =  2.50000;
    frequency[ 14 ] =  2.60000;
    frequency[ 15 ] =  2.70000;
    //Input: 1.][ GINST_per_s][ 1./GINST_per_s][ CPI][ 1/CPI][ L3Misses_per_s][ L3_Misses_per_s/GINST_per_s][ L2Misses_per_s][  L2_Misses_per_s/GINST_per_s][ 0][ 0;
    ////Limits for Input;
    xminval[ 0 ]  = 0.800000;
    xminval[ 1 ]  = 0.176160;
    xminval[ 2 ]  = 0.211696;
    xminval[ 3 ]  = 0.253360;
    xminval[ 4 ]  = 0.147984;
    xminval[ 5 ]  = 0.365760E-07;
    xminval[ 6 ]  = 0.186518E-07;
    xminval[ 7 ]  = 0.817600E-06;
    xminval[ 8 ]  = 0.449972E-06;
    xminval[ 9 ]  =  0.00000;
    xminval[ 10 ] =  0.00000;
    xmaxval[ 0 ]  =  1.20000;
    xmaxval[ 1 ]  =  4.53480;
    xmaxval[ 2 ]  =  5.44959;
    xmaxval[ 3 ]  =  6.48720;
    xmaxval[ 4 ]  =  3.78907;
    xmaxval[ 5 ]  = 0.248760;
    xmaxval[ 6 ]  = 0.467330;
    xmaxval[ 7 ]  = 0.249960;
    xmaxval[ 8 ]  = 0.469585;
    xmaxval[ 9 ]  =  0.00000;
    xmaxval[ 10 ] =  0.00000;
    // Limits and Coefficients for Reference frequency: = 1.20;
    energyMin[ 0 ][ 0 ]               = 0.800000;
    energyMax[ 0 ][ 0 ]               =  1.20000;
    coeffEnergy[ 0 ][ 0 ][ 0 ]        =  1.00000;
    coeffEnergy[ 1 ][ 0 ][ 0 ]        = -.140860E-14;
    coeffEnergy[ 2 ][ 0 ][ 0 ]        = -.208167E-16;
    coeffEnergy[ 3 ][ 0 ][ 0 ]        = 0.832667E-16;
    coeffEnergy[ 4 ][ 0 ][ 0 ]        = 0.160288E-14;
    coeffEnergy[ 5 ][ 0 ][ 0 ]        = -.507840E-14;
    coeffEnergy[ 6 ][ 0 ][ 0 ]        = 0.408527E-14;
    coeffEnergy[ 7 ][ 0 ][ 0 ]        = 0.263331E-14;
    coeffEnergy[ 8 ][ 0 ][ 0 ]        = -.248131E-14;
    coeffEnergy[ 9 ][ 0 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 0 ]       =  0.00000;
    performanceMin[ 0 ][ 0 ]          = 0.800000;
    performanceMax[ 0 ][ 0 ]          =  1.20000;
    coeffPerformance[ 0 ][ 0 ][ 0 ]   =  1.00000;
    coeffPerformance[ 1 ][ 0 ][ 0 ]   = 0.128411E-15;
    coeffPerformance[ 2 ][ 0 ][ 0 ]   = -.104375E-14;
    coeffPerformance[ 3 ][ 0 ][ 0 ]   = 0.927708E-15;
    coeffPerformance[ 4 ][ 0 ][ 0 ]   = -.122088E-15;
    coeffPerformance[ 5 ][ 0 ][ 0 ]   = 0.716138E-15;
    coeffPerformance[ 6 ][ 0 ][ 0 ]   = 0.124385E-15;
    coeffPerformance[ 7 ][ 0 ][ 0 ]   = 0.188665E-14;
    coeffPerformance[ 8 ][ 0 ][ 0 ]   = -.185167E-14;
    coeffPerformance[ 9 ][ 0 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 0 ]  =  0.00000;
    powerMin[ 0 ][ 0 ]                = 0.800000;
    powerMax[ 0 ][ 0 ]                =  1.20000;
    coeffPower[ 0 ][ 0 ][ 0 ]         =  1.00000;
    coeffPower[ 1 ][ 0 ][ 0 ]         = 0.128411E-15;
    coeffPower[ 2 ][ 0 ][ 0 ]         = -.104375E-14;
    coeffPower[ 3 ][ 0 ][ 0 ]         = 0.927708E-15;
    coeffPower[ 4 ][ 0 ][ 0 ]         = -.122088E-15;
    coeffPower[ 5 ][ 0 ][ 0 ]         = 0.716138E-15;
    coeffPower[ 6 ][ 0 ][ 0 ]         = 0.124385E-15;
    coeffPower[ 7 ][ 0 ][ 0 ]         = 0.188665E-14;
    coeffPower[ 8 ][ 0 ][ 0 ]         = -.185167E-14;
    coeffPower[ 9 ][ 0 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 0 ]        =  0.00000;
    energyMin[ 1 ][ 0 ]               = 0.762258;
    energyMax[ 1 ][ 0 ]               =  1.33108;
    coeffEnergy[ 0 ][ 1 ][ 0 ]        =  1.00537;
    coeffEnergy[ 1 ][ 1 ][ 0 ]        = -6.92656;
    coeffEnergy[ 2 ][ 1 ][ 0 ]        = -.597052;
    coeffEnergy[ 3 ][ 1 ][ 0 ]        = 0.495666;
    coeffEnergy[ 4 ][ 1 ][ 0 ]        =  8.27643;
    coeffEnergy[ 5 ][ 1 ][ 0 ]        =  1.38917;
    coeffEnergy[ 6 ][ 1 ][ 0 ]        = -.325630;
    coeffEnergy[ 7 ][ 1 ][ 0 ]        = -.240551;
    coeffEnergy[ 8 ][ 1 ][ 0 ]        = 0.197227;
    coeffEnergy[ 9 ][ 1 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 0 ]       =  0.00000;
    performanceMin[ 1 ][ 0 ]          = 0.803889;
    performanceMax[ 1 ][ 0 ]          =  1.31933;
    coeffPerformance[ 0 ][ 1 ][ 0 ]   =  1.07623;
    coeffPerformance[ 1 ][ 1 ][ 0 ]   = 0.761881E-01;
    coeffPerformance[ 2 ][ 1 ][ 0 ]   = -.433919;
    coeffPerformance[ 3 ][ 1 ][ 0 ]   = 0.355889;
    coeffPerformance[ 4 ][ 1 ][ 0 ]   = -.866744E-01;
    coeffPerformance[ 5 ][ 1 ][ 0 ]   = -2.12695;
    coeffPerformance[ 6 ][ 1 ][ 0 ]   =  1.05172;
    coeffPerformance[ 7 ][ 1 ][ 0 ]   = 0.280092;
    coeffPerformance[ 8 ][ 1 ][ 0 ]   = -.230376;
    coeffPerformance[ 9 ][ 1 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 0 ]  =  0.00000;
    powerMin[ 1 ][ 0 ]                = 0.816106;
    powerMax[ 1 ][ 0 ]                =  1.40179;
    coeffPower[ 0 ][ 1 ][ 0 ]         =  1.08147;
    coeffPower[ 1 ][ 1 ][ 0 ]         = -7.37683;
    coeffPower[ 2 ][ 1 ][ 0 ]         = -1.09728;
    coeffPower[ 3 ][ 1 ][ 0 ]         = 0.907050;
    coeffPower[ 4 ][ 1 ][ 0 ]         =  8.81887;
    coeffPower[ 5 ][ 1 ][ 0 ]         = -.667907;
    coeffPower[ 6 ][ 1 ][ 0 ]         = 0.720596;
    coeffPower[ 7 ][ 1 ][ 0 ]         = 0.340770E-01;
    coeffPower[ 8 ][ 1 ][ 0 ]         = -.344340E-01;
    coeffPower[ 9 ][ 1 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 0 ]        =  0.00000;
    energyMin[ 2 ][ 0 ]               = 0.740317;
    energyMax[ 2 ][ 0 ]               =  1.39161;
    coeffEnergy[ 0 ][ 2 ][ 0 ]        = 0.976745;
    coeffEnergy[ 1 ][ 2 ][ 0 ]        = -6.35404;
    coeffEnergy[ 2 ][ 2 ][ 0 ]        = 0.555528;
    coeffEnergy[ 3 ][ 2 ][ 0 ]        = -.459828;
    coeffEnergy[ 4 ][ 2 ][ 0 ]        =  7.59117;
    coeffEnergy[ 5 ][ 2 ][ 0 ]        =  3.32330;
    coeffEnergy[ 6 ][ 2 ][ 0 ]        = -.713180;
    coeffEnergy[ 7 ][ 2 ][ 0 ]        = -.105290E-02;
    coeffEnergy[ 8 ][ 2 ][ 0 ]        = -.786255E-01;
    coeffEnergy[ 9 ][ 2 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 0 ]       =  0.00000;
    performanceMin[ 2 ][ 0 ]          = 0.843011;
    performanceMax[ 2 ][ 0 ]          =  1.41844;
    coeffPerformance[ 0 ][ 2 ][ 0 ]   =  1.16420;
    coeffPerformance[ 1 ][ 2 ][ 0 ]   = -.404664;
    coeffPerformance[ 2 ][ 2 ][ 0 ]   = -.781763;
    coeffPerformance[ 3 ][ 2 ][ 0 ]   = 0.630111;
    coeffPerformance[ 4 ][ 2 ][ 0 ]   = 0.491290;
    coeffPerformance[ 5 ][ 2 ][ 0 ]   = -4.36302;
    coeffPerformance[ 6 ][ 2 ][ 0 ]   =  1.91569;
    coeffPerformance[ 7 ][ 2 ][ 0 ]   = 0.250897;
    coeffPerformance[ 8 ][ 2 ][ 0 ]   = -.459704E-01;
    coeffPerformance[ 9 ][ 2 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 0 ]  =  0.00000;
    powerMin[ 2 ][ 0 ]                = 0.849118;
    powerMax[ 2 ][ 0 ]                =  1.60623;
    coeffPower[ 0 ][ 2 ][ 0 ]         =  1.13631;
    coeffPower[ 1 ][ 2 ][ 0 ]         = -7.84170;
    coeffPower[ 2 ][ 2 ][ 0 ]         = -.246110;
    coeffPower[ 3 ][ 2 ][ 0 ]         = 0.188206;
    coeffPower[ 4 ][ 2 ][ 0 ]         =  9.37657;
    coeffPower[ 5 ][ 2 ][ 0 ]         = -.680694;
    coeffPower[ 6 ][ 2 ][ 0 ]         =  1.14697;
    coeffPower[ 7 ][ 2 ][ 0 ]         = 0.277321;
    coeffPower[ 8 ][ 2 ][ 0 ]         = -.160730;
    coeffPower[ 9 ][ 2 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 0 ]        =  0.00000;
    energyMin[ 3 ][ 0 ]               = 0.720196;
    energyMax[ 3 ][ 0 ]               =  1.37611;
    coeffEnergy[ 0 ][ 3 ][ 0 ]        = 0.923077;
    coeffEnergy[ 1 ][ 3 ][ 0 ]        = -6.29197;
    coeffEnergy[ 2 ][ 3 ][ 0 ]        = 0.773117;
    coeffEnergy[ 3 ][ 3 ][ 0 ]        = -.618147;
    coeffEnergy[ 4 ][ 3 ][ 0 ]        =  7.52869;
    coeffEnergy[ 5 ][ 3 ][ 0 ]        =  4.72569;
    coeffEnergy[ 6 ][ 3 ][ 0 ]        = -1.01379;
    coeffEnergy[ 7 ][ 3 ][ 0 ]        = 0.567333;
    coeffEnergy[ 8 ][ 3 ][ 0 ]        = -.711831;
    coeffEnergy[ 9 ][ 3 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 0 ]       =  0.00000;
    performanceMin[ 3 ][ 0 ]          = 0.869780;
    performanceMax[ 3 ][ 0 ]          =  1.52237;
    coeffPerformance[ 0 ][ 3 ][ 0 ]   =  1.26506;
    coeffPerformance[ 1 ][ 3 ][ 0 ]   = 0.483095;
    coeffPerformance[ 2 ][ 3 ][ 0 ]   = -.989994;
    coeffPerformance[ 3 ][ 3 ][ 0 ]   = 0.780802;
    coeffPerformance[ 4 ][ 3 ][ 0 ]   = -.576495;
    coeffPerformance[ 5 ][ 3 ][ 0 ]   = -6.90351;
    coeffPerformance[ 6 ][ 3 ][ 0 ]   =  2.72966;
    coeffPerformance[ 7 ][ 3 ][ 0 ]   = 0.717293E-01;
    coeffPerformance[ 8 ][ 3 ][ 0 ]   = 0.371806;
    coeffPerformance[ 9 ][ 3 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 0 ]  =  0.00000;
    powerMin[ 3 ][ 0 ]                = 0.877677;
    powerMax[ 3 ][ 0 ]                =  1.66145;
    coeffPower[ 0 ][ 3 ][ 0 ]         =  1.16973;
    coeffPower[ 1 ][ 3 ][ 0 ]         = -7.47911;
    coeffPower[ 2 ][ 3 ][ 0 ]         = -.226383;
    coeffPower[ 3 ][ 3 ][ 0 ]         = 0.177033;
    coeffPower[ 4 ][ 3 ][ 0 ]         =  8.95065;
    coeffPower[ 5 ][ 3 ][ 0 ]         = -1.37579;
    coeffPower[ 6 ][ 3 ][ 0 ]         =  1.55845;
    coeffPower[ 7 ][ 3 ][ 0 ]         = 0.774096;
    coeffPower[ 8 ][ 3 ][ 0 ]         = -.492702;
    coeffPower[ 9 ][ 3 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 0 ]        =  0.00000;
    energyMin[ 4 ][ 0 ]               = 0.707844;
    energyMax[ 4 ][ 0 ]               =  1.39625;
    coeffEnergy[ 0 ][ 4 ][ 0 ]        = 0.901593;
    coeffEnergy[ 1 ][ 4 ][ 0 ]        = -7.40297;
    coeffEnergy[ 2 ][ 4 ][ 0 ]        = 0.636279;
    coeffEnergy[ 3 ][ 4 ][ 0 ]        = -.491174;
    coeffEnergy[ 4 ][ 4 ][ 0 ]        =  8.85725;
    coeffEnergy[ 5 ][ 4 ][ 0 ]        =  6.84113;
    coeffEnergy[ 6 ][ 4 ][ 0 ]        = -1.94212;
    coeffEnergy[ 7 ][ 4 ][ 0 ]        = 0.679851;
    coeffEnergy[ 8 ][ 4 ][ 0 ]        = -.762270;
    coeffEnergy[ 9 ][ 4 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 0 ]       =  0.00000;
    performanceMin[ 4 ][ 0 ]          = 0.886520;
    performanceMax[ 4 ][ 0 ]          =  1.62342;
    coeffPerformance[ 0 ][ 4 ][ 0 ]   =  1.32575;
    coeffPerformance[ 1 ][ 4 ][ 0 ]   =  1.24442;
    coeffPerformance[ 2 ][ 4 ][ 0 ]   = -1.41804;
    coeffPerformance[ 3 ][ 4 ][ 0 ]   =  1.12994;
    coeffPerformance[ 4 ][ 4 ][ 0 ]   = -1.47316;
    coeffPerformance[ 5 ][ 4 ][ 0 ]   = -9.50026;
    coeffPerformance[ 6 ][ 4 ][ 0 ]   =  3.78251;
    coeffPerformance[ 7 ][ 4 ][ 0 ]   = 0.378401;
    coeffPerformance[ 8 ][ 4 ][ 0 ]   = 0.219739;
    coeffPerformance[ 9 ][ 4 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 0 ]  =  0.00000;
    powerMin[ 4 ][ 0 ]                = 0.907657;
    powerMax[ 4 ][ 0 ]                =  1.72771;
    coeffPower[ 0 ][ 4 ][ 0 ]         =  1.19777;
    coeffPower[ 1 ][ 4 ][ 0 ]         = -8.70027;
    coeffPower[ 2 ][ 4 ][ 0 ]         = -.840860;
    coeffPower[ 3 ][ 4 ][ 0 ]         = 0.699638;
    coeffPower[ 4 ][ 4 ][ 0 ]         =  10.4242;
    coeffPower[ 5 ][ 4 ][ 0 ]         = -1.18837;
    coeffPower[ 6 ][ 4 ][ 0 ]         =  1.45028;
    coeffPower[ 7 ][ 4 ][ 0 ]         =  1.29891;
    coeffPower[ 8 ][ 4 ][ 0 ]         = -.780478;
    coeffPower[ 9 ][ 4 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 0 ]        =  0.00000;
    energyMin[ 5 ][ 0 ]               = 0.691404;
    energyMax[ 5 ][ 0 ]               =  1.43003;
    coeffEnergy[ 0 ][ 5 ][ 0 ]        = 0.889225;
    coeffEnergy[ 1 ][ 5 ][ 0 ]        = -10.9222;
    coeffEnergy[ 2 ][ 5 ][ 0 ]        = 0.629265E-02;
    coeffEnergy[ 3 ][ 5 ][ 0 ]        = 0.504648E-01;
    coeffEnergy[ 4 ][ 5 ][ 0 ]        =  13.0672;
    coeffEnergy[ 5 ][ 5 ][ 0 ]        =  7.93937;
    coeffEnergy[ 6 ][ 5 ][ 0 ]        = -2.24863;
    coeffEnergy[ 7 ][ 5 ][ 0 ]        = 0.893940;
    coeffEnergy[ 8 ][ 5 ][ 0 ]        = -1.07042;
    coeffEnergy[ 9 ][ 5 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 0 ]       =  0.00000;
    performanceMin[ 5 ][ 0 ]          = 0.895047;
    performanceMax[ 5 ][ 0 ]          =  1.72446;
    coeffPerformance[ 0 ][ 5 ][ 0 ]   =  1.40888;
    coeffPerformance[ 1 ][ 5 ][ 0 ]   =  2.47504;
    coeffPerformance[ 2 ][ 5 ][ 0 ]   = -1.67387;
    coeffPerformance[ 3 ][ 5 ][ 0 ]   =  1.32023;
    coeffPerformance[ 4 ][ 5 ][ 0 ]   = -2.94104;
    coeffPerformance[ 5 ][ 5 ][ 0 ]   = -12.2676;
    coeffPerformance[ 6 ][ 5 ][ 0 ]   =  4.65237;
    coeffPerformance[ 7 ][ 5 ][ 0 ]   = 0.175129;
    coeffPerformance[ 8 ][ 5 ][ 0 ]   = 0.670841;
    coeffPerformance[ 9 ][ 5 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 0 ]  =  0.00000;
    powerMin[ 5 ][ 0 ]                = 0.946041;
    powerMax[ 5 ][ 0 ]                =  1.79177;
    coeffPower[ 0 ][ 5 ][ 0 ]         =  1.25865;
    coeffPower[ 1 ][ 5 ][ 0 ]         = -12.9276;
    coeffPower[ 2 ][ 5 ][ 0 ]         = -2.01646;
    coeffPower[ 3 ][ 5 ][ 0 ]         =  1.67941;
    coeffPower[ 4 ][ 5 ][ 0 ]         =  15.4849;
    coeffPower[ 5 ][ 5 ][ 0 ]         = -2.31237;
    coeffPower[ 6 ][ 5 ][ 0 ]         =  1.84808;
    coeffPower[ 7 ][ 5 ][ 0 ]         =  1.39590;
    coeffPower[ 8 ][ 5 ][ 0 ]         = -.727724;
    coeffPower[ 9 ][ 5 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 0 ]        =  0.00000;
    energyMin[ 6 ][ 0 ]               = 0.688226;
    energyMax[ 6 ][ 0 ]               =  1.46963;
    coeffEnergy[ 0 ][ 6 ][ 0 ]        = 0.885074;
    coeffEnergy[ 1 ][ 6 ][ 0 ]        = -14.1031;
    coeffEnergy[ 2 ][ 6 ][ 0 ]        = -.515196;
    coeffEnergy[ 3 ][ 6 ][ 0 ]        = 0.499965;
    coeffEnergy[ 4 ][ 6 ][ 0 ]        =  16.8709;
    coeffEnergy[ 5 ][ 6 ][ 0 ]        =  8.75794;
    coeffEnergy[ 6 ][ 6 ][ 0 ]        = -2.35446;
    coeffEnergy[ 7 ][ 6 ][ 0 ]        =  1.09588;
    coeffEnergy[ 8 ][ 6 ][ 0 ]        = -1.41383;
    coeffEnergy[ 9 ][ 6 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 0 ]       =  0.00000;
    performanceMin[ 6 ][ 0 ]          = 0.904828;
    performanceMax[ 6 ][ 0 ]          =  1.81877;
    coeffPerformance[ 0 ][ 6 ][ 0 ]   =  1.48809;
    coeffPerformance[ 1 ][ 6 ][ 0 ]   =  5.64047;
    coeffPerformance[ 2 ][ 6 ][ 0 ]   = -1.40106;
    coeffPerformance[ 3 ][ 6 ][ 0 ]   =  1.06591;
    coeffPerformance[ 4 ][ 6 ][ 0 ]   = -6.72197;
    coeffPerformance[ 5 ][ 6 ][ 0 ]   = -14.8146;
    coeffPerformance[ 6 ][ 6 ][ 0 ]   =  5.36121;
    coeffPerformance[ 7 ][ 6 ][ 0 ]   = -.118804;
    coeffPerformance[ 8 ][ 6 ][ 0 ]   =  1.25812;
    coeffPerformance[ 9 ][ 6 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 0 ]  =  0.00000;
    powerMin[ 6 ][ 0 ]                = 0.971380;
    powerMax[ 6 ][ 0 ]                =  1.86539;
    coeffPower[ 0 ][ 6 ][ 0 ]         =  1.32414;
    coeffPower[ 1 ][ 6 ][ 0 ]         = -15.0395;
    coeffPower[ 2 ][ 6 ][ 0 ]         = -2.59685;
    coeffPower[ 3 ][ 6 ][ 0 ]         =  2.15875;
    coeffPower[ 4 ][ 6 ][ 0 ]         =  18.0149;
    coeffPower[ 5 ][ 6 ][ 0 ]         = -3.64028;
    coeffPower[ 6 ][ 6 ][ 0 ]         =  2.41197;
    coeffPower[ 7 ][ 6 ][ 0 ]         =  1.48139;
    coeffPower[ 8 ][ 6 ][ 0 ]         = -.681332;
    coeffPower[ 9 ][ 6 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 0 ]        =  0.00000;
    energyMin[ 7 ][ 0 ]               = 0.683394;
    energyMax[ 7 ][ 0 ]               =  1.50188;
    coeffEnergy[ 0 ][ 7 ][ 0 ]        = 0.885559;
    coeffEnergy[ 1 ][ 7 ][ 0 ]        = -17.3481;
    coeffEnergy[ 2 ][ 7 ][ 0 ]        = -.948853;
    coeffEnergy[ 3 ][ 7 ][ 0 ]        = 0.868638;
    coeffEnergy[ 4 ][ 7 ][ 0 ]        =  20.7525;
    coeffEnergy[ 5 ][ 7 ][ 0 ]        =  10.5502;
    coeffEnergy[ 6 ][ 7 ][ 0 ]        = -3.20582;
    coeffEnergy[ 7 ][ 7 ][ 0 ]        = 0.828093;
    coeffEnergy[ 8 ][ 7 ][ 0 ]        = -1.09859;
    coeffEnergy[ 9 ][ 7 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 0 ]       =  0.00000;
    performanceMin[ 7 ][ 0 ]          = 0.909843;
    performanceMax[ 7 ][ 0 ]          =  1.91626;
    coeffPerformance[ 0 ][ 7 ][ 0 ]   =  1.54604;
    coeffPerformance[ 1 ][ 7 ][ 0 ]   =  10.7995;
    coeffPerformance[ 2 ][ 7 ][ 0 ]   = -1.14496;
    coeffPerformance[ 3 ][ 7 ][ 0 ]   = 0.842713;
    coeffPerformance[ 4 ][ 7 ][ 0 ]   = -12.8846;
    coeffPerformance[ 5 ][ 7 ][ 0 ]   = -18.3498;
    coeffPerformance[ 6 ][ 7 ][ 0 ]   =  6.95330;
    coeffPerformance[ 7 ][ 7 ][ 0 ]   = 0.635079;
    coeffPerformance[ 8 ][ 7 ][ 0 ]   = 0.672361;
    coeffPerformance[ 9 ][ 7 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 0 ]  =  0.00000;
    powerMin[ 7 ][ 0 ]                = 0.998716;
    powerMax[ 7 ][ 0 ]                =  1.93067;
    coeffPower[ 0 ][ 7 ][ 0 ]         =  1.37277;
    coeffPower[ 1 ][ 7 ][ 0 ]         = -15.4480;
    coeffPower[ 2 ][ 7 ][ 0 ]         = -3.08392;
    coeffPower[ 3 ][ 7 ][ 0 ]         =  2.56745;
    coeffPower[ 4 ][ 7 ][ 0 ]         =  18.5128;
    coeffPower[ 5 ][ 7 ][ 0 ]         = -4.68452;
    coeffPower[ 6 ][ 7 ][ 0 ]         =  2.86801;
    coeffPower[ 7 ][ 7 ][ 0 ]         =  1.99577;
    coeffPower[ 8 ][ 7 ][ 0 ]         = -.912627;
    coeffPower[ 9 ][ 7 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 0 ]        =  0.00000;
    energyMin[ 8 ][ 0 ]               = 0.677554;
    energyMax[ 8 ][ 0 ]               =  1.54095;
    coeffEnergy[ 0 ][ 8 ][ 0 ]        = 0.880990;
    coeffEnergy[ 1 ][ 8 ][ 0 ]        = -20.6831;
    coeffEnergy[ 2 ][ 8 ][ 0 ]        = -1.38777;
    coeffEnergy[ 3 ][ 8 ][ 0 ]        =  1.24538;
    coeffEnergy[ 4 ][ 8 ][ 0 ]        =  24.7456;
    coeffEnergy[ 5 ][ 8 ][ 0 ]        =  11.6849;
    coeffEnergy[ 6 ][ 8 ][ 0 ]        = -3.58912;
    coeffEnergy[ 7 ][ 8 ][ 0 ]        = 0.801883;
    coeffEnergy[ 8 ][ 8 ][ 0 ]        = -1.08831;
    coeffEnergy[ 9 ][ 8 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 0 ]       =  0.00000;
    performanceMin[ 8 ][ 0 ]          = 0.916614;
    performanceMax[ 8 ][ 0 ]          =  2.02566;
    coeffPerformance[ 0 ][ 8 ][ 0 ]   =  1.62712;
    coeffPerformance[ 1 ][ 8 ][ 0 ]   =  16.5956;
    coeffPerformance[ 2 ][ 8 ][ 0 ]   = -.515253;
    coeffPerformance[ 3 ][ 8 ][ 0 ]   = 0.293577;
    coeffPerformance[ 4 ][ 8 ][ 0 ]   = -19.8201;
    coeffPerformance[ 5 ][ 8 ][ 0 ]   = -21.5410;
    coeffPerformance[ 6 ][ 8 ][ 0 ]   =  8.10150;
    coeffPerformance[ 7 ][ 8 ][ 0 ]   = 0.848580;
    coeffPerformance[ 8 ][ 8 ][ 0 ]   = 0.733733;
    coeffPerformance[ 9 ][ 8 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 0 ]  =  0.00000;
    powerMin[ 8 ][ 0 ]                =  1.02645;
    powerMax[ 8 ][ 0 ]                =  2.04094;
    coeffPower[ 0 ][ 8 ][ 0 ]         =  1.43535;
    coeffPower[ 1 ][ 8 ][ 0 ]         = -15.3641;
    coeffPower[ 2 ][ 8 ][ 0 ]         = -3.18485;
    coeffPower[ 3 ][ 8 ][ 0 ]         =  2.64556;
    coeffPower[ 4 ][ 8 ][ 0 ]         =  18.4173;
    coeffPower[ 5 ][ 8 ][ 0 ]         = -6.13077;
    coeffPower[ 6 ][ 8 ][ 0 ]         =  3.45369;
    coeffPower[ 7 ][ 8 ][ 0 ]         =  2.32033;
    coeffPower[ 8 ][ 8 ][ 0 ]         = -.922700;
    coeffPower[ 9 ][ 8 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 0 ]        =  0.00000;
    energyMin[ 9 ][ 0 ]               = 0.675306;
    energyMax[ 9 ][ 0 ]               =  1.59923;
    coeffEnergy[ 0 ][ 9 ][ 0 ]        = 0.890782;
    coeffEnergy[ 1 ][ 9 ][ 0 ]        = -22.4154;
    coeffEnergy[ 2 ][ 9 ][ 0 ]        = -1.28677;
    coeffEnergy[ 3 ][ 9 ][ 0 ]        =  1.16737;
    coeffEnergy[ 4 ][ 9 ][ 0 ]        =  26.8118;
    coeffEnergy[ 5 ][ 9 ][ 0 ]        =  12.9107;
    coeffEnergy[ 6 ][ 9 ][ 0 ]        = -3.98122;
    coeffEnergy[ 7 ][ 9 ][ 0 ]        = 0.946401;
    coeffEnergy[ 8 ][ 9 ][ 0 ]        = -1.17323;
    coeffEnergy[ 9 ][ 9 ][ 0 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 0 ]       =  0.00000;
    performanceMin[ 9 ][ 0 ]          = 0.919875;
    performanceMax[ 9 ][ 0 ]          =  2.12189;
    coeffPerformance[ 0 ][ 9 ][ 0 ]   =  1.67308;
    coeffPerformance[ 1 ][ 9 ][ 0 ]   =  20.6597;
    coeffPerformance[ 2 ][ 9 ][ 0 ]   = -.244351;
    coeffPerformance[ 3 ][ 9 ][ 0 ]   = 0.529662E-01;
    coeffPerformance[ 4 ][ 9 ][ 0 ]   = -24.6623;
    coeffPerformance[ 5 ][ 9 ][ 0 ]   = -23.9500;
    coeffPerformance[ 6 ][ 9 ][ 0 ]   =  8.87376;
    coeffPerformance[ 7 ][ 9 ][ 0 ]   = 0.844848;
    coeffPerformance[ 8 ][ 9 ][ 0 ]   = 0.890185;
    coeffPerformance[ 9 ][ 9 ][ 0 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 0 ]  =  0.00000;
    powerMin[ 9 ][ 0 ]                =  1.05613;
    powerMax[ 9 ][ 0 ]                =  2.17850;
    coeffPower[ 0 ][ 9 ][ 0 ]         =  1.48525;
    coeffPower[ 1 ][ 9 ][ 0 ]         = -14.8332;
    coeffPower[ 2 ][ 9 ][ 0 ]         = -2.96329;
    coeffPower[ 3 ][ 9 ][ 0 ]         =  2.45784;
    coeffPower[ 4 ][ 9 ][ 0 ]         =  17.7933;
    coeffPower[ 5 ][ 9 ][ 0 ]         = -6.86153;
    coeffPower[ 6 ][ 9 ][ 0 ]         =  3.72461;
    coeffPower[ 7 ][ 9 ][ 0 ]         =  2.72511;
    coeffPower[ 8 ][ 9 ][ 0 ]         = -1.00611;
    coeffPower[ 9 ][ 9 ][ 0 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 0 ]        =  0.00000;
    energyMin[ 10 ][ 0 ]              = 0.676682;
    energyMax[ 10 ][ 0 ]              =  1.65926;
    coeffEnergy[ 0 ][ 10 ][ 0 ]       = 0.901468;
    coeffEnergy[ 1 ][ 10 ][ 0 ]       = -23.7873;
    coeffEnergy[ 2 ][ 10 ][ 0 ]       = -1.14241;
    coeffEnergy[ 3 ][ 10 ][ 0 ]       =  1.05278;
    coeffEnergy[ 4 ][ 10 ][ 0 ]       =  28.4495;
    coeffEnergy[ 5 ][ 10 ][ 0 ]       =  13.9977;
    coeffEnergy[ 6 ][ 10 ][ 0 ]       = -4.36649;
    coeffEnergy[ 7 ][ 10 ][ 0 ]       =  1.04424;
    coeffEnergy[ 8 ][ 10 ][ 0 ]       = -1.22394;
    coeffEnergy[ 9 ][ 10 ][ 0 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 0 ]      =  0.00000;
    performanceMin[ 10 ][ 0 ]         = 0.922382;
    performanceMax[ 10 ][ 0 ]         =  2.22197;
    coeffPerformance[ 0 ][ 10 ][ 0 ]  =  1.73638;
    coeffPerformance[ 1 ][ 10 ][ 0 ]  =  24.7309;
    coeffPerformance[ 2 ][ 10 ][ 0 ]  = -.508289E-01;
    coeffPerformance[ 3 ][ 10 ][ 0 ]  = -.126836;
    coeffPerformance[ 4 ][ 10 ][ 0 ]  = -29.5235;
    coeffPerformance[ 5 ][ 10 ][ 0 ]  = -26.8845;
    coeffPerformance[ 6 ][ 10 ][ 0 ]  =  9.97409;
    coeffPerformance[ 7 ][ 10 ][ 0 ]  = 0.921998;
    coeffPerformance[ 8 ][ 10 ][ 0 ]  = 0.975843;
    coeffPerformance[ 9 ][ 10 ][ 0 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 0 ] =  0.00000;
    powerMin[ 10 ][ 0 ]               =  1.08603;
    powerMax[ 10 ][ 0 ]               =  2.33774;
    coeffPower[ 0 ][ 10 ][ 0 ]        =  1.55926;
    coeffPower[ 1 ][ 10 ][ 0 ]        = -13.7504;
    coeffPower[ 2 ][ 10 ][ 0 ]        = -2.78372;
    coeffPower[ 3 ][ 10 ][ 0 ]        =  2.29861;
    coeffPower[ 4 ][ 10 ][ 0 ]        =  16.5015;
    coeffPower[ 5 ][ 10 ][ 0 ]        = -8.30947;
    coeffPower[ 6 ][ 10 ][ 0 ]        =  4.29204;
    coeffPower[ 7 ][ 10 ][ 0 ]        =  3.03171;
    coeffPower[ 8 ][ 10 ][ 0 ]        = -.996925;
    coeffPower[ 9 ][ 10 ][ 0 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 0 ]       =  0.00000;
    energyMin[ 11 ][ 0 ]              = 0.677973;
    energyMax[ 11 ][ 0 ]              =  1.72158;
    coeffEnergy[ 0 ][ 11 ][ 0 ]       = 0.912300;
    coeffEnergy[ 1 ][ 11 ][ 0 ]       = -27.7248;
    coeffEnergy[ 2 ][ 11 ][ 0 ]       = -1.53962;
    coeffEnergy[ 3 ][ 11 ][ 0 ]       =  1.39257;
    coeffEnergy[ 4 ][ 11 ][ 0 ]       =  33.1588;
    coeffEnergy[ 5 ][ 11 ][ 0 ]       =  15.5974;
    coeffEnergy[ 6 ][ 11 ][ 0 ]       = -4.95447;
    coeffEnergy[ 7 ][ 11 ][ 0 ]       = 0.785945;
    coeffEnergy[ 8 ][ 11 ][ 0 ]       = -1.08225;
    coeffEnergy[ 9 ][ 11 ][ 0 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 0 ]      =  0.00000;
    performanceMin[ 11 ][ 0 ]         = 0.927900;
    performanceMax[ 11 ][ 0 ]         =  2.32154;
    coeffPerformance[ 0 ][ 11 ][ 0 ]  =  1.80404;
    coeffPerformance[ 1 ][ 11 ][ 0 ]  =  31.4037;
    coeffPerformance[ 2 ][ 11 ][ 0 ]  = 0.646403;
    coeffPerformance[ 3 ][ 11 ][ 0 ]  = -.729953;
    coeffPerformance[ 4 ][ 11 ][ 0 ]  = -37.4999;
    coeffPerformance[ 5 ][ 11 ][ 0 ]  = -30.3445;
    coeffPerformance[ 6 ][ 11 ][ 0 ]  =  11.2343;
    coeffPerformance[ 7 ][ 11 ][ 0 ]  =  1.28547;
    coeffPerformance[ 8 ][ 11 ][ 0 ]  = 0.944423;
    coeffPerformance[ 9 ][ 11 ][ 0 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 0 ] =  0.00000;
    powerMin[ 11 ][ 0 ]               =  1.12279;
    powerMax[ 11 ][ 0 ]               =  2.46963;
    coeffPower[ 0 ][ 11 ][ 0 ]        =  1.62893;
    coeffPower[ 1 ][ 11 ][ 0 ]        = -13.7200;
    coeffPower[ 2 ][ 11 ][ 0 ]        = -2.84820;
    coeffPower[ 3 ][ 11 ][ 0 ]        =  2.34640;
    coeffPower[ 4 ][ 11 ][ 0 ]        =  16.4732;
    coeffPower[ 5 ][ 11 ][ 0 ]        = -9.68044;
    coeffPower[ 6 ][ 11 ][ 0 ]        =  4.84669;
    coeffPower[ 7 ][ 11 ][ 0 ]        =  3.31792;
    coeffPower[ 8 ][ 11 ][ 0 ]        = -.996703;
    coeffPower[ 9 ][ 11 ][ 0 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 0 ]       =  0.00000;
    energyMin[ 12 ][ 0 ]              = 0.679465;
    energyMax[ 12 ][ 0 ]              =  1.77076;
    coeffEnergy[ 0 ][ 12 ][ 0 ]       = 0.930670;
    coeffEnergy[ 1 ][ 12 ][ 0 ]       = -30.4404;
    coeffEnergy[ 2 ][ 12 ][ 0 ]       = -1.87631;
    coeffEnergy[ 3 ][ 12 ][ 0 ]       =  1.68203;
    coeffEnergy[ 4 ][ 12 ][ 0 ]       =  36.4019;
    coeffEnergy[ 5 ][ 12 ][ 0 ]       =  16.9829;
    coeffEnergy[ 6 ][ 12 ][ 0 ]       = -5.41517;
    coeffEnergy[ 7 ][ 12 ][ 0 ]       = 0.619228;
    coeffEnergy[ 8 ][ 12 ][ 0 ]       = -1.11659;
    coeffEnergy[ 9 ][ 12 ][ 0 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 0 ]      =  0.00000;
    performanceMin[ 12 ][ 0 ]         = 0.928401;
    performanceMax[ 12 ][ 0 ]         =  2.42448;
    coeffPerformance[ 0 ][ 12 ][ 0 ]  =  1.86683;
    coeffPerformance[ 1 ][ 12 ][ 0 ]  =  36.2757;
    coeffPerformance[ 2 ][ 12 ][ 0 ]  =  1.07192;
    coeffPerformance[ 3 ][ 12 ][ 0 ]  = -1.10757;
    coeffPerformance[ 4 ][ 12 ][ 0 ]  = -43.3175;
    coeffPerformance[ 5 ][ 12 ][ 0 ]  = -33.5274;
    coeffPerformance[ 6 ][ 12 ][ 0 ]  =  12.3131;
    coeffPerformance[ 7 ][ 12 ][ 0 ]  =  1.35098;
    coeffPerformance[ 8 ][ 12 ][ 0 ]  =  1.18468;
    coeffPerformance[ 9 ][ 12 ][ 0 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 0 ] =  0.00000;
    powerMin[ 12 ][ 0 ]               =  1.15497;
    powerMax[ 12 ][ 0 ]               =  2.54491;
    coeffPower[ 0 ][ 12 ][ 0 ]        =  1.71425;
    coeffPower[ 1 ][ 12 ][ 0 ]        = -13.5217;
    coeffPower[ 2 ][ 12 ][ 0 ]        = -3.06642;
    coeffPower[ 3 ][ 12 ][ 0 ]        =  2.51809;
    coeffPower[ 4 ][ 12 ][ 0 ]        =  16.2386;
    coeffPower[ 5 ][ 12 ][ 0 ]        = -11.1430;
    coeffPower[ 6 ][ 12 ][ 0 ]        =  5.36975;
    coeffPower[ 7 ][ 12 ][ 0 ]        =  3.28790;
    coeffPower[ 8 ][ 12 ][ 0 ]        = -.840873;
    coeffPower[ 9 ][ 12 ][ 0 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 0 ]       =  0.00000;
    energyMin[ 13 ][ 0 ]              = 0.687378;
    energyMax[ 13 ][ 0 ]              =  1.82131;
    coeffEnergy[ 0 ][ 13 ][ 0 ]       = 0.927934;
    coeffEnergy[ 1 ][ 13 ][ 0 ]       = -32.8016;
    coeffEnergy[ 2 ][ 13 ][ 0 ]       = -1.97658;
    coeffEnergy[ 3 ][ 13 ][ 0 ]       =  1.78005;
    coeffEnergy[ 4 ][ 13 ][ 0 ]       =  39.2304;
    coeffEnergy[ 5 ][ 13 ][ 0 ]       =  18.3374;
    coeffEnergy[ 6 ][ 13 ][ 0 ]       = -5.82959;
    coeffEnergy[ 7 ][ 13 ][ 0 ]       = 0.926368;
    coeffEnergy[ 8 ][ 13 ][ 0 ]       = -1.36180;
    coeffEnergy[ 9 ][ 13 ][ 0 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 0 ]      =  0.00000;
    performanceMin[ 13 ][ 0 ]         = 0.931661;
    performanceMax[ 13 ][ 0 ]         =  2.52166;
    coeffPerformance[ 0 ][ 13 ][ 0 ]  =  1.93759;
    coeffPerformance[ 1 ][ 13 ][ 0 ]  =  41.1778;
    coeffPerformance[ 2 ][ 13 ][ 0 ]  =  1.37326;
    coeffPerformance[ 3 ][ 13 ][ 0 ]  = -1.38187;
    coeffPerformance[ 4 ][ 13 ][ 0 ]  = -49.1760;
    coeffPerformance[ 5 ][ 13 ][ 0 ]  = -36.5214;
    coeffPerformance[ 6 ][ 13 ][ 0 ]  =  13.2848;
    coeffPerformance[ 7 ][ 13 ][ 0 ]  =  1.20393;
    coeffPerformance[ 8 ][ 13 ][ 0 ]  =  1.48393;
    coeffPerformance[ 9 ][ 13 ][ 0 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 0 ] =  0.00000;
    powerMin[ 13 ][ 0 ]               =  1.19355;
    powerMax[ 13 ][ 0 ]               =  2.72626;
    coeffPower[ 0 ][ 13 ][ 0 ]        =  1.77636;
    coeffPower[ 1 ][ 13 ][ 0 ]        = -13.1810;
    coeffPower[ 2 ][ 13 ][ 0 ]        = -3.15137;
    coeffPower[ 3 ][ 13 ][ 0 ]        =  2.58600;
    coeffPower[ 4 ][ 13 ][ 0 ]        =  15.8446;
    coeffPower[ 5 ][ 13 ][ 0 ]        = -12.4976;
    coeffPower[ 6 ][ 13 ][ 0 ]        =  5.82062;
    coeffPower[ 7 ][ 13 ][ 0 ]        =  3.71095;
    coeffPower[ 8 ][ 13 ][ 0 ]        = -.860250;
    coeffPower[ 9 ][ 13 ][ 0 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 0 ]       =  0.00000;
    energyMin[ 14 ][ 0 ]              = 0.689122;
    energyMax[ 14 ][ 0 ]              =  1.88394;
    coeffEnergy[ 0 ][ 14 ][ 0 ]       = 0.937648;
    coeffEnergy[ 1 ][ 14 ][ 0 ]       = -34.9899;
    coeffEnergy[ 2 ][ 14 ][ 0 ]       = -2.14884;
    coeffEnergy[ 3 ][ 14 ][ 0 ]       =  1.93776;
    coeffEnergy[ 4 ][ 14 ][ 0 ]       =  41.8481;
    coeffEnergy[ 5 ][ 14 ][ 0 ]       =  20.1801;
    coeffEnergy[ 6 ][ 14 ][ 0 ]       = -6.51089;
    coeffEnergy[ 7 ][ 14 ][ 0 ]       = 0.934866;
    coeffEnergy[ 8 ][ 14 ][ 0 ]       = -1.49834;
    coeffEnergy[ 9 ][ 14 ][ 0 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 0 ]      =  0.00000;
    performanceMin[ 14 ][ 0 ]         = 0.935172;
    performanceMax[ 14 ][ 0 ]         =  2.62460;
    coeffPerformance[ 0 ][ 14 ][ 0 ]  =  2.00916;
    coeffPerformance[ 1 ][ 14 ][ 0 ]  =  46.5541;
    coeffPerformance[ 2 ][ 14 ][ 0 ]  =  1.75850;
    coeffPerformance[ 3 ][ 14 ][ 0 ]  = -1.72660;
    coeffPerformance[ 4 ][ 14 ][ 0 ]  = -55.6027;
    coeffPerformance[ 5 ][ 14 ][ 0 ]  = -40.0644;
    coeffPerformance[ 6 ][ 14 ][ 0 ]  =  14.5628;
    coeffPerformance[ 7 ][ 14 ][ 0 ]  =  1.35327;
    coeffPerformance[ 8 ][ 14 ][ 0 ]  =  1.60206;
    coeffPerformance[ 9 ][ 14 ][ 0 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 0 ] =  0.00000;
    powerMin[ 14 ][ 0 ]               =  1.23167;
    powerMax[ 14 ][ 0 ]               =  2.84316;
    coeffPower[ 0 ][ 14 ][ 0 ]        =  1.85949;
    coeffPower[ 1 ][ 14 ][ 0 ]        = -11.4713;
    coeffPower[ 2 ][ 14 ][ 0 ]        = -3.12565;
    coeffPower[ 3 ][ 14 ][ 0 ]        =  2.56002;
    coeffPower[ 4 ][ 14 ][ 0 ]        =  13.8066;
    coeffPower[ 5 ][ 14 ][ 0 ]        = -13.9263;
    coeffPower[ 6 ][ 14 ][ 0 ]        =  6.34715;
    coeffPower[ 7 ][ 14 ][ 0 ]        =  4.09335;
    coeffPower[ 8 ][ 14 ][ 0 ]        = -1.00365;
    coeffPower[ 9 ][ 14 ][ 0 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 0 ]       =  0.00000;
    energyMin[ 15 ][ 0 ]              = 0.692703;
    energyMax[ 15 ][ 0 ]              =  1.94127;
    coeffEnergy[ 0 ][ 15 ][ 0 ]       = 0.950757;
    coeffEnergy[ 1 ][ 15 ][ 0 ]       = -37.3442;
    coeffEnergy[ 2 ][ 15 ][ 0 ]       = -2.21514;
    coeffEnergy[ 3 ][ 15 ][ 0 ]       =  2.00546;
    coeffEnergy[ 4 ][ 15 ][ 0 ]       =  44.6626;
    coeffEnergy[ 5 ][ 15 ][ 0 ]       =  21.7511;
    coeffEnergy[ 6 ][ 15 ][ 0 ]       = -6.96456;
    coeffEnergy[ 7 ][ 15 ][ 0 ]       = 0.987554;
    coeffEnergy[ 8 ][ 15 ][ 0 ]       = -1.69316;
    coeffEnergy[ 9 ][ 15 ][ 0 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 0 ]      =  0.00000;
    performanceMin[ 15 ][ 0 ]         = 0.935925;
    performanceMax[ 15 ][ 0 ]         =  2.72430;
    coeffPerformance[ 0 ][ 15 ][ 0 ]  =  2.07572;
    coeffPerformance[ 1 ][ 15 ][ 0 ]  =  51.3639;
    coeffPerformance[ 2 ][ 15 ][ 0 ]  =  2.01323;
    coeffPerformance[ 3 ][ 15 ][ 0 ]  = -1.96262;
    coeffPerformance[ 4 ][ 15 ][ 0 ]  = -61.3461;
    coeffPerformance[ 5 ][ 15 ][ 0 ]  = -43.5495;
    coeffPerformance[ 6 ][ 15 ][ 0 ]  =  15.7510;
    coeffPerformance[ 7 ][ 15 ][ 0 ]  =  1.47048;
    coeffPerformance[ 8 ][ 15 ][ 0 ]  =  1.80982;
    coeffPerformance[ 9 ][ 15 ][ 0 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 0 ] =  0.00000;
    powerMin[ 15 ][ 0 ]               =  1.27117;
    powerMax[ 15 ][ 0 ]               =  3.01357;
    coeffPower[ 0 ][ 15 ][ 0 ]        =  1.93655;
    coeffPower[ 1 ][ 15 ][ 0 ]        = -10.8392;
    coeffPower[ 2 ][ 15 ][ 0 ]        = -3.18237;
    coeffPower[ 3 ][ 15 ][ 0 ]        =  2.60303;
    coeffPower[ 4 ][ 15 ][ 0 ]        =  13.0639;
    coeffPower[ 5 ][ 15 ][ 0 ]        = -15.7038;
    coeffPower[ 6 ][ 15 ][ 0 ]        =  7.13925;
    coeffPower[ 7 ][ 15 ][ 0 ]        =  4.63017;
    coeffPower[ 8 ][ 15 ][ 0 ]        = -1.24255;
    coeffPower[ 9 ][ 15 ][ 0 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 0 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 1.30;
    energyMin[ 0 ][ 1 ]               = 0.721219;
    energyMax[ 0 ][ 1 ]               =  1.25942;
    coeffEnergy[ 0 ][ 0 ][ 1 ]        =  1.00808;
    coeffEnergy[ 1 ][ 0 ][ 1 ]        =  7.04176;
    coeffEnergy[ 2 ][ 0 ][ 1 ]        =  1.26166;
    coeffEnergy[ 3 ][ 0 ][ 1 ]        = -.980069;
    coeffEnergy[ 4 ][ 0 ][ 1 ]        = -9.12046;
    coeffEnergy[ 5 ][ 0 ][ 1 ]        = -1.33780;
    coeffEnergy[ 6 ][ 0 ][ 1 ]        = 0.617361;
    coeffEnergy[ 7 ][ 0 ][ 1 ]        = 0.132512;
    coeffEnergy[ 8 ][ 0 ][ 1 ]        = -.885837E-01;
    coeffEnergy[ 9 ][ 0 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 1 ]       =  0.00000;
    performanceMin[ 0 ][ 1 ]          = 0.727644;
    performanceMax[ 0 ][ 1 ]          =  1.19419;
    coeffPerformance[ 0 ][ 0 ][ 1 ]   = 0.921653;
    coeffPerformance[ 1 ][ 0 ][ 1 ]   = -.343102;
    coeffPerformance[ 2 ][ 0 ][ 1 ]   = -.568589;
    coeffPerformance[ 3 ][ 0 ][ 1 ]   = 0.450489;
    coeffPerformance[ 4 ][ 0 ][ 1 ]   = 0.443056;
    coeffPerformance[ 5 ][ 0 ][ 1 ]   =  2.04524;
    coeffPerformance[ 6 ][ 0 ][ 1 ]   = -1.11776;
    coeffPerformance[ 7 ][ 0 ][ 1 ]   = -.251781;
    coeffPerformance[ 8 ][ 0 ][ 1 ]   = 0.208639;
    coeffPerformance[ 9 ][ 0 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 1 ]  =  0.00000;
    powerMin[ 0 ][ 1 ]                = 0.684839;
    powerMax[ 0 ][ 1 ]                =  1.17632;
    coeffPower[ 0 ][ 0 ][ 1 ]         = 0.928888;
    coeffPower[ 1 ][ 0 ][ 1 ]         =  6.20108;
    coeffPower[ 2 ][ 0 ][ 1 ]         = 0.615652;
    coeffPower[ 3 ][ 0 ][ 1 ]         = -.469312;
    coeffPower[ 4 ][ 0 ][ 1 ]         = -8.03294;
    coeffPower[ 5 ][ 0 ][ 1 ]         = 0.767649;
    coeffPower[ 6 ][ 0 ][ 1 ]         = -.521331;
    coeffPower[ 7 ][ 0 ][ 1 ]         = -.118065;
    coeffPower[ 8 ][ 0 ][ 1 ]         = 0.112796;
    coeffPower[ 9 ][ 0 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 1 ]        =  0.00000;
    energyMin[ 1 ][ 1 ]               = 0.800000;
    energyMax[ 1 ][ 1 ]               =  1.20000;
    coeffEnergy[ 0 ][ 1 ][ 1 ]        =  1.00000;
    coeffEnergy[ 1 ][ 1 ][ 1 ]        = -.610858E-12;
    coeffEnergy[ 2 ][ 1 ][ 1 ]        = -.282251E-12;
    coeffEnergy[ 3 ][ 1 ][ 1 ]        = 0.217165E-12;
    coeffEnergy[ 4 ][ 1 ][ 1 ]        = 0.793177E-12;
    coeffEnergy[ 5 ][ 1 ][ 1 ]        = 0.169531E-12;
    coeffEnergy[ 6 ][ 1 ][ 1 ]        = -.146753E-12;
    coeffEnergy[ 7 ][ 1 ][ 1 ]        = -.999060E-13;
    coeffEnergy[ 8 ][ 1 ][ 1 ]        = 0.154975E-12;
    coeffEnergy[ 9 ][ 1 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 1 ]       =  0.00000;
    performanceMin[ 1 ][ 1 ]          = 0.800000;
    performanceMax[ 1 ][ 1 ]          =  1.20000;
    coeffPerformance[ 0 ][ 1 ][ 1 ]   =  1.00000;
    coeffPerformance[ 1 ][ 1 ][ 1 ]   = -.330455E-12;
    coeffPerformance[ 2 ][ 1 ][ 1 ]   = -.129959E-13;
    coeffPerformance[ 3 ][ 1 ][ 1 ]   = 0.974714E-14;
    coeffPerformance[ 4 ][ 1 ][ 1 ]   = 0.428759E-12;
    coeffPerformance[ 5 ][ 1 ][ 1 ]   = -.513351E-13;
    coeffPerformance[ 6 ][ 1 ][ 1 ]   = 0.214387E-13;
    coeffPerformance[ 7 ][ 1 ][ 1 ]   = -.189984E-13;
    coeffPerformance[ 8 ][ 1 ][ 1 ]   = 0.471855E-14;
    coeffPerformance[ 9 ][ 1 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 1 ]  =  0.00000;
    powerMin[ 1 ][ 1 ]                = 0.800000;
    powerMax[ 1 ][ 1 ]                =  1.20000;
    coeffPower[ 0 ][ 1 ][ 1 ]         =  1.00000;
    coeffPower[ 1 ][ 1 ][ 1 ]         = -.666668E-09;
    coeffPower[ 2 ][ 1 ][ 1 ]         = 0.706218E-09;
    coeffPower[ 3 ][ 1 ][ 1 ]         = -.548330E-09;
    coeffPower[ 4 ][ 1 ][ 1 ]         = 0.872015E-09;
    coeffPower[ 5 ][ 1 ][ 1 ]         = 0.459111E-09;
    coeffPower[ 6 ][ 1 ][ 1 ]         = 0.325831E-09;
    coeffPower[ 7 ][ 1 ][ 1 ]         = 0.832659E-09;
    coeffPower[ 8 ][ 1 ][ 1 ]         = -.111084E-08;
    coeffPower[ 9 ][ 1 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 1 ]        =  0.00000;
    energyMin[ 2 ][ 1 ]               = 0.767356;
    energyMax[ 2 ][ 1 ]               =  1.34976;
    coeffEnergy[ 0 ][ 2 ][ 1 ]        = 0.958556;
    coeffEnergy[ 1 ][ 2 ][ 1 ]        = 0.146277;
    coeffEnergy[ 2 ][ 2 ][ 1 ]        = -.945102;
    coeffEnergy[ 3 ][ 2 ][ 1 ]        = 0.749096;
    coeffEnergy[ 4 ][ 2 ][ 1 ]        = -.187045;
    coeffEnergy[ 5 ][ 2 ][ 1 ]        =  2.02672;
    coeffEnergy[ 6 ][ 2 ][ 1 ]        = -.591940;
    coeffEnergy[ 7 ][ 2 ][ 1 ]        = 0.259421;
    coeffEnergy[ 8 ][ 2 ][ 1 ]        = -.330175;
    coeffEnergy[ 9 ][ 2 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 1 ]       =  0.00000;
    performanceMin[ 2 ][ 1 ]          = 0.818313;
    performanceMax[ 2 ][ 1 ]          =  1.32111;
    coeffPerformance[ 0 ][ 2 ][ 1 ]   =  1.08619;
    coeffPerformance[ 1 ][ 2 ][ 1 ]   = -1.31276;
    coeffPerformance[ 2 ][ 2 ][ 1 ]   = 0.279887;
    coeffPerformance[ 3 ][ 2 ][ 1 ]   = -.234123;
    coeffPerformance[ 4 ][ 2 ][ 1 ]   =  1.70316;
    coeffPerformance[ 5 ][ 2 ][ 1 ]   = -2.25323;
    coeffPerformance[ 6 ][ 2 ][ 1 ]   = 0.878184;
    coeffPerformance[ 7 ][ 2 ][ 1 ]   = -.614885E-01;
    coeffPerformance[ 8 ][ 2 ][ 1 ]   = 0.202623;
    coeffPerformance[ 9 ][ 2 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 1 ]  =  0.00000;
    powerMin[ 2 ][ 1 ]                = 0.822175;
    powerMax[ 2 ][ 1 ]                =  1.44756;
    coeffPower[ 0 ][ 2 ][ 1 ]         =  1.04209;
    coeffPower[ 1 ][ 2 ][ 1 ]         = -1.15724;
    coeffPower[ 2 ][ 2 ][ 1 ]         = -.716670;
    coeffPower[ 3 ][ 2 ][ 1 ]         = 0.555864;
    coeffPower[ 4 ][ 2 ][ 1 ]         =  1.50416;
    coeffPower[ 5 ][ 2 ][ 1 ]         = -.113607;
    coeffPower[ 6 ][ 2 ][ 1 ]         = 0.252303;
    coeffPower[ 7 ][ 2 ][ 1 ]         = 0.214007;
    coeffPower[ 8 ][ 2 ][ 1 ]         = -.146870;
    coeffPower[ 9 ][ 2 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 1 ]        =  0.00000;
    energyMin[ 3 ][ 1 ]               = 0.722853;
    energyMax[ 3 ][ 1 ]               =  1.31507;
    coeffEnergy[ 0 ][ 3 ][ 1 ]        = 0.898632;
    coeffEnergy[ 1 ][ 3 ][ 1 ]        = 0.556553;
    coeffEnergy[ 2 ][ 3 ][ 1 ]        = -1.66592;
    coeffEnergy[ 3 ][ 3 ][ 1 ]        =  1.33282;
    coeffEnergy[ 4 ][ 3 ][ 1 ]        = -.705657;
    coeffEnergy[ 5 ][ 3 ][ 1 ]        =  3.61707;
    coeffEnergy[ 6 ][ 3 ][ 1 ]        = -.969764;
    coeffEnergy[ 7 ][ 3 ][ 1 ]        = 0.822727;
    coeffEnergy[ 8 ][ 3 ][ 1 ]        = -.979749;
    coeffEnergy[ 9 ][ 3 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 1 ]       =  0.00000;
    performanceMin[ 3 ][ 1 ]          = 0.836836;
    performanceMax[ 3 ][ 1 ]          =  1.45204;
    coeffPerformance[ 0 ][ 3 ][ 1 ]   =  1.18481;
    coeffPerformance[ 1 ][ 3 ][ 1 ]   = -.944066;
    coeffPerformance[ 2 ][ 3 ][ 1 ]   = 0.562653;
    coeffPerformance[ 3 ][ 3 ][ 1 ]   = -.477111;
    coeffPerformance[ 4 ][ 3 ][ 1 ]   =  1.21868;
    coeffPerformance[ 5 ][ 3 ][ 1 ]   = -4.59901;
    coeffPerformance[ 6 ][ 3 ][ 1 ]   =  1.67234;
    coeffPerformance[ 7 ][ 3 ][ 1 ]   = -.295514;
    coeffPerformance[ 8 ][ 3 ][ 1 ]   = 0.667091;
    coeffPerformance[ 9 ][ 3 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 1 ]  =  0.00000;
    powerMin[ 3 ][ 1 ]                = 0.839273;
    powerMax[ 3 ][ 1 ]                =  1.49732;
    coeffPower[ 0 ][ 3 ][ 1 ]         =  1.07050;
    coeffPower[ 1 ][ 3 ][ 1 ]         = -.340998;
    coeffPower[ 2 ][ 3 ][ 1 ]         = -1.26035;
    coeffPower[ 3 ][ 3 ][ 1 ]         = 0.982664;
    coeffPower[ 4 ][ 3 ][ 1 ]         = 0.454349;
    coeffPower[ 5 ][ 3 ][ 1 ]         = -.592954;
    coeffPower[ 6 ][ 3 ][ 1 ]         = 0.607182;
    coeffPower[ 7 ][ 3 ][ 1 ]         = 0.642317;
    coeffPower[ 8 ][ 3 ][ 1 ]         = -.448928;
    coeffPower[ 9 ][ 3 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 1 ]        =  0.00000;
    energyMin[ 4 ][ 1 ]               = 0.740234;
    energyMax[ 4 ][ 1 ]               =  1.35755;
    coeffEnergy[ 0 ][ 4 ][ 1 ]        = 0.872034;
    coeffEnergy[ 1 ][ 4 ][ 1 ]        = -.736854;
    coeffEnergy[ 2 ][ 4 ][ 1 ]        = -1.89839;
    coeffEnergy[ 3 ][ 4 ][ 1 ]        =  1.52495;
    coeffEnergy[ 4 ][ 4 ][ 1 ]        = 0.972395;
    coeffEnergy[ 5 ][ 4 ][ 1 ]        =  5.85176;
    coeffEnergy[ 6 ][ 4 ][ 1 ]        = -1.95624;
    coeffEnergy[ 7 ][ 4 ][ 1 ]        = 0.900264;
    coeffEnergy[ 8 ][ 4 ][ 1 ]        = -.994071;
    coeffEnergy[ 9 ][ 4 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 1 ]       =  0.00000;
    performanceMin[ 4 ][ 1 ]          = 0.851807;
    performanceMax[ 4 ][ 1 ]          =  1.49067;
    coeffPerformance[ 0 ][ 4 ][ 1 ]   =  1.24671;
    coeffPerformance[ 1 ][ 4 ][ 1 ]   = -.234532;
    coeffPerformance[ 2 ][ 4 ][ 1 ]   = 0.869248;
    coeffPerformance[ 3 ][ 4 ][ 1 ]   = -.725877;
    coeffPerformance[ 4 ][ 4 ][ 1 ]   = 0.310406;
    coeffPerformance[ 5 ][ 4 ][ 1 ]   = -7.00572;
    coeffPerformance[ 6 ][ 4 ][ 1 ]   =  2.77388;
    coeffPerformance[ 7 ][ 4 ][ 1 ]   = -.243901E-01;
    coeffPerformance[ 8 ][ 4 ][ 1 ]   = 0.528630;
    coeffPerformance[ 9 ][ 4 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 1 ]  =  0.00000;
    powerMin[ 4 ][ 1 ]                = 0.864707;
    powerMax[ 4 ][ 1 ]                =  1.55703;
    coeffPower[ 0 ][ 4 ][ 1 ]         =  1.09581;
    coeffPower[ 1 ][ 4 ][ 1 ]         = -1.35233;
    coeffPower[ 2 ][ 4 ][ 1 ]         = -1.33692;
    coeffPower[ 3 ][ 4 ][ 1 ]         =  1.04668;
    coeffPower[ 4 ][ 4 ][ 1 ]         =  1.77862;
    coeffPower[ 5 ][ 4 ][ 1 ]         = -.280277;
    coeffPower[ 6 ][ 4 ][ 1 ]         = 0.514478;
    coeffPower[ 7 ][ 4 ][ 1 ]         =  1.04857;
    coeffPower[ 8 ][ 4 ][ 1 ]         = -.643653;
    coeffPower[ 9 ][ 4 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 1 ]        =  0.00000;
    energyMin[ 5 ][ 1 ]               = 0.725637;
    energyMax[ 5 ][ 1 ]               =  1.38353;
    coeffEnergy[ 0 ][ 5 ][ 1 ]        = 0.857775;
    coeffEnergy[ 1 ][ 5 ][ 1 ]        = -3.21252;
    coeffEnergy[ 2 ][ 5 ][ 1 ]        = -2.19543;
    coeffEnergy[ 3 ][ 5 ][ 1 ]        =  1.76996;
    coeffEnergy[ 4 ][ 5 ][ 1 ]        =  4.18073;
    coeffEnergy[ 5 ][ 5 ][ 1 ]        =  7.02948;
    coeffEnergy[ 6 ][ 5 ][ 1 ]        = -2.37404;
    coeffEnergy[ 7 ][ 5 ][ 1 ]        =  1.18375;
    coeffEnergy[ 8 ][ 5 ][ 1 ]        = -1.36483;
    coeffEnergy[ 9 ][ 5 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 1 ]       =  0.00000;
    performanceMin[ 5 ][ 1 ]          = 0.860000;
    performanceMax[ 5 ][ 1 ]          =  1.60196;
    coeffPerformance[ 0 ][ 5 ][ 1 ]   =  1.32806;
    coeffPerformance[ 1 ][ 5 ][ 1 ]   = 0.620246;
    coeffPerformance[ 2 ][ 5 ][ 1 ]   = 0.900735;
    coeffPerformance[ 3 ][ 5 ][ 1 ]   = -.774527;
    coeffPerformance[ 4 ][ 5 ][ 1 ]   = -.794674;
    coeffPerformance[ 5 ][ 5 ][ 1 ]   = -9.59752;
    coeffPerformance[ 6 ][ 5 ][ 1 ]   =  3.69092;
    coeffPerformance[ 7 ][ 5 ][ 1 ]   = -.240601;
    coeffPerformance[ 8 ][ 5 ][ 1 ]   = 0.991262;
    coeffPerformance[ 9 ][ 5 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 1 ]  =  0.00000;
    powerMin[ 5 ][ 1 ]                = 0.885760;
    powerMax[ 5 ][ 1 ]                =  1.63758;
    coeffPower[ 0 ][ 5 ][ 1 ]         =  1.15407;
    coeffPower[ 1 ][ 5 ][ 1 ]         = -3.80060;
    coeffPower[ 2 ][ 5 ][ 1 ]         = -1.72248;
    coeffPower[ 3 ][ 5 ][ 1 ]         =  1.34060;
    coeffPower[ 4 ][ 5 ][ 1 ]         =  4.95413;
    coeffPower[ 5 ][ 5 ][ 1 ]         = -1.28634;
    coeffPower[ 6 ][ 5 ][ 1 ]         = 0.853494;
    coeffPower[ 7 ][ 5 ][ 1 ]         =  1.21263;
    coeffPower[ 8 ][ 5 ][ 1 ]         = -.650320;
    coeffPower[ 9 ][ 5 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 1 ]        =  0.00000;
    energyMin[ 6 ][ 1 ]               = 0.722303;
    energyMax[ 6 ][ 1 ]               =  1.41531;
    coeffEnergy[ 0 ][ 6 ][ 1 ]        = 0.847547;
    coeffEnergy[ 1 ][ 6 ][ 1 ]        = -6.44840;
    coeffEnergy[ 2 ][ 6 ][ 1 ]        = -2.96287;
    coeffEnergy[ 3 ][ 6 ][ 1 ]        =  2.37867;
    coeffEnergy[ 4 ][ 6 ][ 1 ]        =  8.37520;
    coeffEnergy[ 5 ][ 6 ][ 1 ]        =  7.72398;
    coeffEnergy[ 6 ][ 6 ][ 1 ]        = -2.49464;
    coeffEnergy[ 7 ][ 6 ][ 1 ]        =  1.45974;
    coeffEnergy[ 8 ][ 6 ][ 1 ]        = -1.77771;
    coeffEnergy[ 9 ][ 6 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 1 ]       =  0.00000;
    performanceMin[ 6 ][ 1 ]          = 0.869398;
    performanceMax[ 6 ][ 1 ]          =  1.71307;
    coeffPerformance[ 0 ][ 6 ][ 1 ]   =  1.40581;
    coeffPerformance[ 1 ][ 6 ][ 1 ]   =  3.00395;
    coeffPerformance[ 2 ][ 6 ][ 1 ]   =  1.35566;
    coeffPerformance[ 3 ][ 6 ][ 1 ]   = -1.15264;
    coeffPerformance[ 4 ][ 6 ][ 1 ]   = -3.87978;
    coeffPerformance[ 5 ][ 6 ][ 1 ]   = -11.8513;
    coeffPerformance[ 6 ][ 6 ][ 1 ]   =  4.38792;
    coeffPerformance[ 7 ][ 6 ][ 1 ]   = -.596351;
    coeffPerformance[ 8 ][ 6 ][ 1 ]   =  1.63263;
    coeffPerformance[ 9 ][ 6 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 1 ]  =  0.00000;
    powerMin[ 6 ][ 1 ]                = 0.909484;
    powerMax[ 6 ][ 1 ]                =  1.72452;
    coeffPower[ 0 ][ 6 ][ 1 ]         =  1.21205;
    coeffPower[ 1 ][ 6 ][ 1 ]         = -5.92500;
    coeffPower[ 2 ][ 6 ][ 1 ]         = -2.25255;
    coeffPower[ 3 ][ 6 ][ 1 ]         =  1.74553;
    coeffPower[ 4 ][ 6 ][ 1 ]         =  7.71267;
    coeffPower[ 5 ][ 6 ][ 1 ]         = -2.59353;
    coeffPower[ 6 ][ 6 ][ 1 ]         =  1.39636;
    coeffPower[ 7 ][ 6 ][ 1 ]         =  1.31086;
    coeffPower[ 8 ][ 6 ][ 1 ]         = -.625638;
    coeffPower[ 9 ][ 6 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 1 ]        =  0.00000;
    energyMin[ 7 ][ 1 ]               = 0.717231;
    energyMax[ 7 ][ 1 ]               =  1.45069;
    coeffEnergy[ 0 ][ 7 ][ 1 ]        = 0.840296;
    coeffEnergy[ 1 ][ 7 ][ 1 ]        = -10.1371;
    coeffEnergy[ 2 ][ 7 ][ 1 ]        = -3.79639;
    coeffEnergy[ 3 ][ 7 ][ 1 ]        =  3.03107;
    coeffEnergy[ 4 ][ 7 ][ 1 ]        =  13.1589;
    coeffEnergy[ 5 ][ 7 ][ 1 ]        =  9.49376;
    coeffEnergy[ 6 ][ 7 ][ 1 ]        = -3.43284;
    coeffEnergy[ 7 ][ 7 ][ 1 ]        =  1.19681;
    coeffEnergy[ 8 ][ 7 ][ 1 ]        = -1.45212;
    coeffEnergy[ 9 ][ 7 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 1 ]       =  0.00000;
    performanceMin[ 7 ][ 1 ]          = 0.874217;
    performanceMax[ 7 ][ 1 ]          =  1.77906;
    coeffPerformance[ 0 ][ 7 ][ 1 ]   =  1.46881;
    coeffPerformance[ 1 ][ 7 ][ 1 ]   =  7.81942;
    coeffPerformance[ 2 ][ 7 ][ 1 ]   =  2.41283;
    coeffPerformance[ 3 ][ 7 ][ 1 ]   = -1.98411;
    coeffPerformance[ 4 ][ 7 ][ 1 ]   = -10.1154;
    coeffPerformance[ 5 ][ 7 ][ 1 ]   = -15.0482;
    coeffPerformance[ 6 ][ 7 ][ 1 ]   =  6.09813;
    coeffPerformance[ 7 ][ 7 ][ 1 ]   = 0.198738E-01;
    coeffPerformance[ 8 ][ 7 ][ 1 ]   =  1.13188;
    coeffPerformance[ 9 ][ 7 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 1 ]  =  0.00000;
    powerMin[ 7 ][ 1 ]                = 0.935079;
    powerMax[ 7 ][ 1 ]                =  1.81858;
    coeffPower[ 0 ][ 7 ][ 1 ]         =  1.25823;
    coeffPower[ 1 ][ 7 ][ 1 ]         = -6.65434;
    coeffPower[ 2 ][ 7 ][ 1 ]         = -2.41271;
    coeffPower[ 3 ][ 7 ][ 1 ]         =  1.86702;
    coeffPower[ 4 ][ 7 ][ 1 ]         =  8.66797;
    coeffPower[ 5 ][ 7 ][ 1 ]         = -3.50898;
    coeffPower[ 6 ][ 7 ][ 1 ]         =  1.87460;
    coeffPower[ 7 ][ 7 ][ 1 ]         =  1.66089;
    coeffPower[ 8 ][ 7 ][ 1 ]         = -.734161;
    coeffPower[ 9 ][ 7 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 1 ]        =  0.00000;
    energyMin[ 8 ][ 1 ]               = 0.711102;
    energyMax[ 8 ][ 1 ]               =  1.48792;
    coeffEnergy[ 0 ][ 8 ][ 1 ]        = 0.830856;
    coeffEnergy[ 1 ][ 8 ][ 1 ]        = -12.8531;
    coeffEnergy[ 2 ][ 8 ][ 1 ]        = -4.51136;
    coeffEnergy[ 3 ][ 8 ][ 1 ]        =  3.59584;
    coeffEnergy[ 4 ][ 8 ][ 1 ]        =  16.6834;
    coeffEnergy[ 5 ][ 8 ][ 1 ]        =  10.6701;
    coeffEnergy[ 6 ][ 8 ][ 1 ]        = -3.92394;
    coeffEnergy[ 7 ][ 8 ][ 1 ]        =  1.22466;
    coeffEnergy[ 8 ][ 8 ][ 1 ]        = -1.48657;
    coeffEnergy[ 9 ][ 8 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 1 ]       =  0.00000;
    performanceMin[ 8 ][ 1 ]          = 0.880723;
    performanceMax[ 8 ][ 1 ]          =  1.88487;
    coeffPerformance[ 0 ][ 8 ][ 1 ]   =  1.54723;
    coeffPerformance[ 1 ][ 8 ][ 1 ]   =  11.6996;
    coeffPerformance[ 2 ][ 8 ][ 1 ]   =  3.15653;
    coeffPerformance[ 3 ][ 8 ][ 1 ]   = -2.58313;
    coeffPerformance[ 4 ][ 8 ][ 1 ]   = -15.1455;
    coeffPerformance[ 5 ][ 8 ][ 1 ]   = -18.0115;
    coeffPerformance[ 6 ][ 8 ][ 1 ]   =  7.35305;
    coeffPerformance[ 7 ][ 8 ][ 1 ]   = 0.944468E-01;
    coeffPerformance[ 8 ][ 8 ][ 1 ]   =  1.29155;
    coeffPerformance[ 9 ][ 8 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 1 ]  =  0.00000;
    powerMin[ 8 ][ 1 ]                = 0.961047;
    powerMax[ 8 ][ 1 ]                =  1.94069;
    coeffPower[ 0 ][ 8 ][ 1 ]         =  1.31517;
    coeffPower[ 1 ][ 8 ][ 1 ]         = -6.96656;
    coeffPower[ 2 ][ 8 ][ 1 ]         = -2.67477;
    coeffPower[ 3 ][ 8 ][ 1 ]         =  2.06349;
    coeffPower[ 4 ][ 8 ][ 1 ]         =  9.07882;
    coeffPower[ 5 ][ 8 ][ 1 ]         = -4.83578;
    coeffPower[ 6 ][ 8 ][ 1 ]         =  2.43141;
    coeffPower[ 7 ][ 8 ][ 1 ]         =  1.88048;
    coeffPower[ 8 ][ 8 ][ 1 ]         = -.679252;
    coeffPower[ 9 ][ 8 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 1 ]        =  0.00000;
    energyMin[ 9 ][ 1 ]               = 0.708742;
    energyMax[ 9 ][ 1 ]               =  1.53705;
    coeffEnergy[ 0 ][ 9 ][ 1 ]        = 0.831817;
    coeffEnergy[ 1 ][ 9 ][ 1 ]        = -15.5750;
    coeffEnergy[ 2 ][ 9 ][ 1 ]        = -5.14586;
    coeffEnergy[ 3 ][ 9 ][ 1 ]        =  4.09674;
    coeffEnergy[ 4 ][ 9 ][ 1 ]        =  20.2087;
    coeffEnergy[ 5 ][ 9 ][ 1 ]        =  11.8162;
    coeffEnergy[ 6 ][ 9 ][ 1 ]        = -4.41210;
    coeffEnergy[ 7 ][ 9 ][ 1 ]        =  1.34481;
    coeffEnergy[ 8 ][ 9 ][ 1 ]        = -1.56730;
    coeffEnergy[ 9 ][ 9 ][ 1 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 1 ]       =  0.00000;
    performanceMin[ 9 ][ 1 ]          = 0.883855;
    performanceMax[ 9 ][ 1 ]          =  1.95556;
    coeffPerformance[ 0 ][ 9 ][ 1 ]   =  1.59960;
    coeffPerformance[ 1 ][ 9 ][ 1 ]   =  16.9451;
    coeffPerformance[ 2 ][ 9 ][ 1 ]   =  3.98374;
    coeffPerformance[ 3 ][ 9 ][ 1 ]   = -3.23890;
    coeffPerformance[ 4 ][ 9 ][ 1 ]   = -21.9308;
    coeffPerformance[ 5 ][ 9 ][ 1 ]   = -20.0136;
    coeffPerformance[ 6 ][ 9 ][ 1 ]   =  8.15297;
    coeffPerformance[ 7 ][ 9 ][ 1 ]   = 0.997121E-01;
    coeffPerformance[ 8 ][ 9 ][ 1 ]   =  1.43663;
    coeffPerformance[ 9 ][ 9 ][ 1 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 1 ]  =  0.00000;
    powerMin[ 9 ][ 1 ]                = 0.988833;
    powerMax[ 9 ][ 1 ]                =  2.02093;
    coeffPower[ 0 ][ 9 ][ 1 ]         =  1.35998;
    coeffPower[ 1 ][ 9 ][ 1 ]         = -6.31593;
    coeffPower[ 2 ][ 9 ][ 1 ]         = -2.85782;
    coeffPower[ 3 ][ 9 ][ 1 ]         =  2.20453;
    coeffPower[ 4 ][ 9 ][ 1 ]         =  8.24666;
    coeffPower[ 5 ][ 9 ][ 1 ]         = -5.40214;
    coeffPower[ 6 ][ 9 ][ 1 ]         =  2.60694;
    coeffPower[ 7 ][ 9 ][ 1 ]         =  2.19285;
    coeffPower[ 8 ][ 9 ][ 1 ]         = -.723844;
    coeffPower[ 9 ][ 9 ][ 1 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 1 ]        =  0.00000;
    energyMin[ 10 ][ 1 ]              = 0.710186;
    energyMax[ 10 ][ 1 ]              =  1.57867;
    coeffEnergy[ 0 ][ 10 ][ 1 ]       = 0.833785;
    coeffEnergy[ 1 ][ 10 ][ 1 ]       = -17.9277;
    coeffEnergy[ 2 ][ 10 ][ 1 ]       = -5.65686;
    coeffEnergy[ 3 ][ 10 ][ 1 ]       =  4.50177;
    coeffEnergy[ 4 ][ 10 ][ 1 ]       =  23.2582;
    coeffEnergy[ 5 ][ 10 ][ 1 ]       =  12.9359;
    coeffEnergy[ 6 ][ 10 ][ 1 ]       = -4.94830;
    coeffEnergy[ 7 ][ 10 ][ 1 ]       =  1.40275;
    coeffEnergy[ 8 ][ 10 ][ 1 ]       = -1.59947;
    coeffEnergy[ 9 ][ 10 ][ 1 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 1 ]      =  0.00000;
    performanceMin[ 10 ][ 1 ]         = 0.886265;
    performanceMax[ 10 ][ 1 ]         =  2.06859;
    coeffPerformance[ 0 ][ 10 ][ 1 ]  =  1.66862;
    coeffPerformance[ 1 ][ 10 ][ 1 ]  =  21.6552;
    coeffPerformance[ 2 ][ 10 ][ 1 ]  =  4.88448;
    coeffPerformance[ 3 ][ 10 ][ 1 ]  = -3.95618;
    coeffPerformance[ 4 ][ 10 ][ 1 ]  = -28.0314;
    coeffPerformance[ 5 ][ 10 ][ 1 ]  = -22.6823;
    coeffPerformance[ 6 ][ 10 ][ 1 ]  =  9.37005;
    coeffPerformance[ 7 ][ 10 ][ 1 ]  = 0.177511;
    coeffPerformance[ 8 ][ 10 ][ 1 ]  =  1.51338;
    coeffPerformance[ 9 ][ 10 ][ 1 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 1 ] =  0.00000;
    powerMin[ 10 ][ 1 ]               =  1.01683;
    powerMax[ 10 ][ 1 ]               =  2.15670;
    coeffPower[ 0 ][ 10 ][ 1 ]        =  1.42829;
    coeffPower[ 1 ][ 10 ][ 1 ]        = -5.65477;
    coeffPower[ 2 ][ 10 ][ 1 ]        = -2.74358;
    coeffPower[ 3 ][ 10 ][ 1 ]        =  2.10797;
    coeffPower[ 4 ][ 10 ][ 1 ]        =  7.39423;
    coeffPower[ 5 ][ 10 ][ 1 ]        = -6.69835;
    coeffPower[ 6 ][ 10 ][ 1 ]        =  3.12346;
    coeffPower[ 7 ][ 10 ][ 1 ]        =  2.40156;
    coeffPower[ 8 ][ 10 ][ 1 ]        = -.662735;
    coeffPower[ 9 ][ 10 ][ 1 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 1 ]       =  0.00000;
    energyMin[ 11 ][ 1 ]              = 0.711542;
    energyMax[ 11 ][ 1 ]              =  1.63796;
    coeffEnergy[ 0 ][ 11 ][ 1 ]       = 0.839036;
    coeffEnergy[ 1 ][ 11 ][ 1 ]       = -20.1647;
    coeffEnergy[ 2 ][ 11 ][ 1 ]       = -6.45211;
    coeffEnergy[ 3 ][ 11 ][ 1 ]       =  5.12919;
    coeffEnergy[ 4 ][ 11 ][ 1 ]       =  26.1564;
    coeffEnergy[ 5 ][ 11 ][ 1 ]       =  14.5533;
    coeffEnergy[ 6 ][ 11 ][ 1 ]       = -5.66723;
    coeffEnergy[ 7 ][ 11 ][ 1 ]       =  1.32412;
    coeffEnergy[ 8 ][ 11 ][ 1 ]       = -1.60577;
    coeffEnergy[ 9 ][ 11 ][ 1 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 1 ]      =  0.00000;
    performanceMin[ 11 ][ 1 ]         = 0.891566;
    performanceMax[ 11 ][ 1 ]         =  2.14721;
    coeffPerformance[ 0 ][ 11 ][ 1 ]  =  1.73567;
    coeffPerformance[ 1 ][ 11 ][ 1 ]  =  26.0088;
    coeffPerformance[ 2 ][ 11 ][ 1 ]  =  5.79574;
    coeffPerformance[ 3 ][ 11 ][ 1 ]  = -4.68416;
    coeffPerformance[ 4 ][ 11 ][ 1 ]  = -33.6675;
    coeffPerformance[ 5 ][ 11 ][ 1 ]  = -25.8140;
    coeffPerformance[ 6 ][ 11 ][ 1 ]  =  10.7247;
    coeffPerformance[ 7 ][ 11 ][ 1 ]  = 0.317096;
    coeffPerformance[ 8 ][ 11 ][ 1 ]  =  1.65097;
    coeffPerformance[ 9 ][ 11 ][ 1 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 1 ] =  0.00000;
    powerMin[ 11 ][ 1 ]               =  1.05124;
    powerMax[ 11 ][ 1 ]               =  2.27155;
    coeffPower[ 0 ][ 11 ][ 1 ]        =  1.49312;
    coeffPower[ 1 ][ 11 ][ 1 ]        = -4.99716;
    coeffPower[ 2 ][ 11 ][ 1 ]        = -2.90707;
    coeffPower[ 3 ][ 11 ][ 1 ]        =  2.22941;
    coeffPower[ 4 ][ 11 ][ 1 ]        =  6.54952;
    coeffPower[ 5 ][ 11 ][ 1 ]        = -7.86550;
    coeffPower[ 6 ][ 11 ][ 1 ]        =  3.61220;
    coeffPower[ 7 ][ 11 ][ 1 ]        =  2.64427;
    coeffPower[ 8 ][ 11 ][ 1 ]        = -.653764;
    coeffPower[ 9 ][ 11 ][ 1 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 1 ]       =  0.00000;
    energyMin[ 12 ][ 1 ]              = 0.713107;
    energyMax[ 12 ][ 1 ]              =  1.70740;
    coeffEnergy[ 0 ][ 12 ][ 1 ]       = 0.852487;
    coeffEnergy[ 1 ][ 12 ][ 1 ]       = -22.4441;
    coeffEnergy[ 2 ][ 12 ][ 1 ]       = -6.73993;
    coeffEnergy[ 3 ][ 12 ][ 1 ]       =  5.36165;
    coeffEnergy[ 4 ][ 12 ][ 1 ]       =  29.1067;
    coeffEnergy[ 5 ][ 12 ][ 1 ]       =  15.8897;
    coeffEnergy[ 6 ][ 12 ][ 1 ]       = -6.19117;
    coeffEnergy[ 7 ][ 12 ][ 1 ]       =  1.25435;
    coeffEnergy[ 8 ][ 12 ][ 1 ]       = -1.71280;
    coeffEnergy[ 9 ][ 12 ][ 1 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 1 ]      =  0.00000;
    performanceMin[ 12 ][ 1 ]         = 0.892048;
    performanceMax[ 12 ][ 1 ]         =  2.25744;
    coeffPerformance[ 0 ][ 12 ][ 1 ]  =  1.80115;
    coeffPerformance[ 1 ][ 12 ][ 1 ]  =  30.3329;
    coeffPerformance[ 2 ][ 12 ][ 1 ]  =  6.47488;
    coeffPerformance[ 3 ][ 12 ][ 1 ]  = -5.23297;
    coeffPerformance[ 4 ][ 12 ][ 1 ]  = -39.2642;
    coeffPerformance[ 5 ][ 12 ][ 1 ]  = -28.6964;
    coeffPerformance[ 6 ][ 12 ][ 1 ]  =  11.8839;
    coeffPerformance[ 7 ][ 12 ][ 1 ]  = 0.299460;
    coeffPerformance[ 8 ][ 12 ][ 1 ]  =  1.94730;
    coeffPerformance[ 9 ][ 12 ][ 1 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 1 ] =  0.00000;
    powerMin[ 12 ][ 1 ]               =  1.08138;
    powerMax[ 12 ][ 1 ]               =  2.36231;
    coeffPower[ 0 ][ 12 ][ 1 ]        =  1.57503;
    coeffPower[ 1 ][ 12 ][ 1 ]        = -4.24481;
    coeffPower[ 2 ][ 12 ][ 1 ]        = -2.69268;
    coeffPower[ 3 ][ 12 ][ 1 ]        =  2.05232;
    coeffPower[ 4 ][ 12 ][ 1 ]        =  5.57656;
    coeffPower[ 5 ][ 12 ][ 1 ]        = -9.21233;
    coeffPower[ 6 ][ 12 ][ 1 ]        =  4.14211;
    coeffPower[ 7 ][ 12 ][ 1 ]        =  2.61898;
    coeffPower[ 8 ][ 12 ][ 1 ]        = -.501452;
    coeffPower[ 9 ][ 12 ][ 1 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 1 ]       =  0.00000;
    energyMin[ 13 ][ 1 ]              = 0.721413;
    energyMax[ 13 ][ 1 ]              =  1.77864;
    coeffEnergy[ 0 ][ 13 ][ 1 ]       = 0.847776;
    coeffEnergy[ 1 ][ 13 ][ 1 ]       = -24.0789;
    coeffEnergy[ 2 ][ 13 ][ 1 ]       = -7.02792;
    coeffEnergy[ 3 ][ 13 ][ 1 ]       =  5.60026;
    coeffEnergy[ 4 ][ 13 ][ 1 ]       =  31.2292;
    coeffEnergy[ 5 ][ 13 ][ 1 ]       =  17.2807;
    coeffEnergy[ 6 ][ 13 ][ 1 ]       = -6.74234;
    coeffEnergy[ 7 ][ 13 ][ 1 ]       =  1.55738;
    coeffEnergy[ 8 ][ 13 ][ 1 ]       = -1.97101;
    coeffEnergy[ 9 ][ 13 ][ 1 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 1 ]      =  0.00000;
    performanceMin[ 13 ][ 1 ]         = 0.895181;
    performanceMax[ 13 ][ 1 ]         =  2.35591;
    coeffPerformance[ 0 ][ 13 ][ 1 ]  =  1.87115;
    coeffPerformance[ 1 ][ 13 ][ 1 ]  =  34.0359;
    coeffPerformance[ 2 ][ 13 ][ 1 ]  =  7.09947;
    coeffPerformance[ 3 ][ 13 ][ 1 ]  = -5.74034;
    coeffPerformance[ 4 ][ 13 ][ 1 ]  = -44.0586;
    coeffPerformance[ 5 ][ 13 ][ 1 ]  = -31.4567;
    coeffPerformance[ 6 ][ 13 ][ 1 ]  =  12.9902;
    coeffPerformance[ 7 ][ 13 ][ 1 ]  = 0.987462E-01;
    coeffPerformance[ 8 ][ 13 ][ 1 ]  =  2.29820;
    coeffPerformance[ 9 ][ 13 ][ 1 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 1 ] =  0.00000;
    powerMin[ 13 ][ 1 ]               =  1.11750;
    powerMax[ 13 ][ 1 ]               =  2.46048;
    coeffPower[ 0 ][ 13 ][ 1 ]        =  1.63492;
    coeffPower[ 1 ][ 13 ][ 1 ]        = -3.71236;
    coeffPower[ 2 ][ 13 ][ 1 ]        = -2.58006;
    coeffPower[ 3 ][ 13 ][ 1 ]        =  1.96100;
    coeffPower[ 4 ][ 13 ][ 1 ]        =  4.89927;
    coeffPower[ 5 ][ 13 ][ 1 ]        = -10.4325;
    coeffPower[ 6 ][ 13 ][ 1 ]        =  4.57184;
    coeffPower[ 7 ][ 13 ][ 1 ]        =  2.93410;
    coeffPower[ 8 ][ 13 ][ 1 ]        = -.464069;
    coeffPower[ 9 ][ 13 ][ 1 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 1 ]       =  0.00000;
    energyMin[ 14 ][ 1 ]              = 0.723242;
    energyMax[ 14 ][ 1 ]              =  1.84087;
    coeffEnergy[ 0 ][ 14 ][ 1 ]       = 0.852674;
    coeffEnergy[ 1 ][ 14 ][ 1 ]       = -25.8243;
    coeffEnergy[ 2 ][ 14 ][ 1 ]       = -7.34264;
    coeffEnergy[ 3 ][ 14 ][ 1 ]       =  5.85934;
    coeffEnergy[ 4 ][ 14 ][ 1 ]       =  33.4926;
    coeffEnergy[ 5 ][ 14 ][ 1 ]       =  19.0910;
    coeffEnergy[ 6 ][ 14 ][ 1 ]       = -7.50004;
    coeffEnergy[ 7 ][ 14 ][ 1 ]       =  1.62787;
    coeffEnergy[ 8 ][ 14 ][ 1 ]       = -2.15958;
    coeffEnergy[ 9 ][ 14 ][ 1 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 1 ]      =  0.00000;
    performanceMin[ 14 ][ 1 ]         = 0.898554;
    performanceMax[ 14 ][ 1 ]         =  2.44409;
    coeffPerformance[ 0 ][ 14 ][ 1 ]  =  1.94400;
    coeffPerformance[ 1 ][ 14 ][ 1 ]  =  38.7640;
    coeffPerformance[ 2 ][ 14 ][ 1 ]  =  7.73140;
    coeffPerformance[ 3 ][ 14 ][ 1 ]  = -6.25380;
    coeffPerformance[ 4 ][ 14 ][ 1 ]  = -50.1839;
    coeffPerformance[ 5 ][ 14 ][ 1 ]  = -34.5820;
    coeffPerformance[ 6 ][ 14 ][ 1 ]  =  14.3328;
    coeffPerformance[ 7 ][ 14 ][ 1 ]  = 0.136383;
    coeffPerformance[ 8 ][ 14 ][ 1 ]  =  2.49908;
    coeffPerformance[ 9 ][ 14 ][ 1 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 1 ] =  0.00000;
    powerMin[ 14 ][ 1 ]               =  1.15319;
    powerMax[ 14 ][ 1 ]               =  2.57736;
    coeffPower[ 0 ][ 14 ][ 1 ]        =  1.71430;
    coeffPower[ 1 ][ 14 ][ 1 ]        = -1.74689;
    coeffPower[ 2 ][ 14 ][ 1 ]        = -2.47191;
    coeffPower[ 3 ][ 14 ][ 1 ]        =  1.87172;
    coeffPower[ 4 ][ 14 ][ 1 ]        =  2.35870;
    coeffPower[ 5 ][ 14 ][ 1 ]        = -11.6224;
    coeffPower[ 6 ][ 14 ][ 1 ]        =  5.08388;
    coeffPower[ 7 ][ 14 ][ 1 ]        =  3.20776;
    coeffPower[ 8 ][ 14 ][ 1 ]        = -.536245;
    coeffPower[ 9 ][ 14 ][ 1 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 1 ]       =  0.00000;
    energyMin[ 15 ][ 1 ]              = 0.727000;
    energyMax[ 15 ][ 1 ]              =  1.89413;
    coeffEnergy[ 0 ][ 15 ][ 1 ]       = 0.862273;
    coeffEnergy[ 1 ][ 15 ][ 1 ]       = -26.4610;
    coeffEnergy[ 2 ][ 15 ][ 1 ]       = -7.80716;
    coeffEnergy[ 3 ][ 15 ][ 1 ]       =  6.23500;
    coeffEnergy[ 4 ][ 15 ][ 1 ]       =  34.3152;
    coeffEnergy[ 5 ][ 15 ][ 1 ]       =  20.7070;
    coeffEnergy[ 6 ][ 15 ][ 1 ]       = -8.08193;
    coeffEnergy[ 7 ][ 15 ][ 1 ]       =  1.81371;
    coeffEnergy[ 8 ][ 15 ][ 1 ]       = -2.47506;
    coeffEnergy[ 9 ][ 15 ][ 1 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 1 ]      =  0.00000;
    performanceMin[ 15 ][ 1 ]         = 0.899277;
    performanceMax[ 15 ][ 1 ]         =  2.54329;
    coeffPerformance[ 0 ][ 15 ][ 1 ]  =  2.00660;
    coeffPerformance[ 1 ][ 15 ][ 1 ]  =  40.2862;
    coeffPerformance[ 2 ][ 15 ][ 1 ]  =  8.11516;
    coeffPerformance[ 3 ][ 15 ][ 1 ]  = -6.57713;
    coeffPerformance[ 4 ][ 15 ][ 1 ]  = -52.1439;
    coeffPerformance[ 5 ][ 15 ][ 1 ]  = -37.8694;
    coeffPerformance[ 6 ][ 15 ][ 1 ]  =  15.6404;
    coeffPerformance[ 7 ][ 15 ][ 1 ]  = 0.195180E-01;
    coeffPerformance[ 8 ][ 15 ][ 1 ]  =  2.90437;
    coeffPerformance[ 9 ][ 15 ][ 1 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 1 ] =  0.00000;
    powerMin[ 15 ][ 1 ]               =  1.19017;
    powerMax[ 15 ][ 1 ]               =  2.72314;
    coeffPower[ 0 ][ 15 ][ 1 ]        =  1.78516;
    coeffPower[ 1 ][ 15 ][ 1 ]        = -1.52419;
    coeffPower[ 2 ][ 15 ][ 1 ]        = -2.68683;
    coeffPower[ 3 ][ 15 ][ 1 ]        =  2.03338;
    coeffPower[ 4 ][ 15 ][ 1 ]        =  2.08432;
    coeffPower[ 5 ][ 15 ][ 1 ]        = -13.2658;
    coeffPower[ 6 ][ 15 ][ 1 ]        =  5.85289;
    coeffPower[ 7 ][ 15 ][ 1 ]        =  3.61485;
    coeffPower[ 8 ][ 15 ][ 1 ]        = -.698301;
    coeffPower[ 9 ][ 15 ][ 1 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 1 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 1.40;
    energyMin[ 0 ][ 2 ]               = 0.689848;
    energyMax[ 0 ][ 2 ]               =  1.29674;
    coeffEnergy[ 0 ][ 0 ][ 2 ]        =  1.04176;
    coeffEnergy[ 1 ][ 0 ][ 2 ]        =  7.76829;
    coeffEnergy[ 2 ][ 0 ][ 2 ]        = 0.456472;
    coeffEnergy[ 3 ][ 0 ][ 2 ]        = -.334151;
    coeffEnergy[ 4 ][ 0 ][ 2 ]        = -10.8408;
    coeffEnergy[ 5 ][ 0 ][ 2 ]        = -3.05337;
    coeffEnergy[ 6 ][ 0 ][ 2 ]        = 0.734284;
    coeffEnergy[ 7 ][ 0 ][ 2 ]        = 0.132316;
    coeffEnergy[ 8 ][ 0 ][ 2 ]        = -.104182;
    coeffEnergy[ 9 ][ 0 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 2 ]       =  0.00000;
    performanceMin[ 0 ][ 2 ]          = 0.676798;
    performanceMax[ 0 ][ 2 ]          =  1.13878;
    coeffPerformance[ 0 ][ 0 ][ 2 ]   = 0.850338;
    coeffPerformance[ 1 ][ 0 ][ 2 ]   = 0.468690;
    coeffPerformance[ 2 ][ 0 ][ 2 ]   = -.750745E-01;
    coeffPerformance[ 3 ][ 0 ][ 2 ]   = 0.751499E-01;
    coeffPerformance[ 4 ][ 0 ][ 2 ]   = -.656835;
    coeffPerformance[ 5 ][ 0 ][ 2 ]   =  3.62465;
    coeffPerformance[ 6 ][ 0 ][ 2 ]   = -1.74308;
    coeffPerformance[ 7 ][ 0 ][ 2 ]   = -.209032;
    coeffPerformance[ 8 ][ 0 ][ 2 ]   = 0.831144E-01;
    coeffPerformance[ 9 ][ 0 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 2 ]  =  0.00000;
    powerMin[ 0 ][ 2 ]                = 0.597672;
    powerMax[ 0 ][ 2 ]                =  1.13058;
    coeffPower[ 0 ][ 0 ][ 2 ]         = 0.886164;
    coeffPower[ 1 ][ 0 ][ 2 ]         =  7.11937;
    coeffPower[ 2 ][ 0 ][ 2 ]         = 0.286815;
    coeffPower[ 3 ][ 0 ][ 2 ]         = -.190052;
    coeffPower[ 4 ][ 0 ][ 2 ]         = -9.93808;
    coeffPower[ 5 ][ 0 ][ 2 ]         = 0.855021;
    coeffPower[ 6 ][ 0 ][ 2 ]         = -1.05757;
    coeffPower[ 7 ][ 0 ][ 2 ]         = -.740276E-01;
    coeffPower[ 8 ][ 0 ][ 2 ]         = -.285314E-01;
    coeffPower[ 9 ][ 0 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 2 ]        =  0.00000;
    energyMin[ 1 ][ 2 ]               = 0.711239;
    energyMax[ 1 ][ 2 ]               =  1.25105;
    coeffEnergy[ 0 ][ 1 ][ 2 ]        =  1.03717;
    coeffEnergy[ 1 ][ 1 ][ 2 ]        = 0.285015;
    coeffEnergy[ 2 ][ 1 ][ 2 ]        = -.428831;
    coeffEnergy[ 3 ][ 1 ][ 2 ]        = 0.298557;
    coeffEnergy[ 4 ][ 1 ][ 2 ]        = -.401125;
    coeffEnergy[ 5 ][ 1 ][ 2 ]        = -1.96001;
    coeffEnergy[ 6 ][ 1 ][ 2 ]        = 0.412850;
    coeffEnergy[ 7 ][ 1 ][ 2 ]        = -.129681;
    coeffEnergy[ 8 ][ 1 ][ 2 ]        = 0.160142;
    coeffEnergy[ 9 ][ 1 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 2 ]       =  0.00000;
    performanceMin[ 1 ][ 2 ]          = 0.726661;
    performanceMax[ 1 ][ 2 ]          =  1.17314;
    coeffPerformance[ 0 ][ 1 ][ 2 ]   = 0.920088;
    coeffPerformance[ 1 ][ 1 ][ 2 ]   = 0.438630;
    coeffPerformance[ 2 ][ 1 ][ 2 ]   = -.162987E-01;
    coeffPerformance[ 3 ][ 1 ][ 2 ]   = 0.257974E-01;
    coeffPerformance[ 4 ][ 1 ][ 2 ]   = -.612625;
    coeffPerformance[ 5 ][ 1 ][ 2 ]   =  1.86222;
    coeffPerformance[ 6 ][ 1 ][ 2 ]   = -.740423;
    coeffPerformance[ 7 ][ 1 ][ 2 ]   = 0.258805E-01;
    coeffPerformance[ 8 ][ 1 ][ 2 ]   = -.152098;
    coeffPerformance[ 9 ][ 1 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 2 ]  =  0.00000;
    powerMin[ 1 ][ 2 ]                = 0.663187;
    powerMax[ 1 ][ 2 ]                =  1.16764;
    coeffPower[ 0 ][ 1 ][ 2 ]         = 0.954847;
    coeffPower[ 1 ][ 1 ][ 2 ]         = 0.661961;
    coeffPower[ 2 ][ 1 ][ 2 ]         = -.435914;
    coeffPower[ 3 ][ 1 ][ 2 ]         = 0.318301;
    coeffPower[ 4 ][ 1 ][ 2 ]         = -.927491;
    coeffPower[ 5 ][ 1 ][ 2 ]         = 0.218306E-02;
    coeffPower[ 6 ][ 1 ][ 2 ]         = -.349204;
    coeffPower[ 7 ][ 1 ][ 2 ]         = -.983811E-01;
    coeffPower[ 8 ][ 1 ][ 2 ]         = 0.152257E-02;
    coeffPower[ 9 ][ 1 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 2 ]        =  0.00000;
    energyMin[ 2 ][ 2 ]               = 0.800000;
    energyMax[ 2 ][ 2 ]               =  1.20000;
    coeffEnergy[ 0 ][ 2 ][ 2 ]        =  1.00000;
    coeffEnergy[ 1 ][ 2 ][ 2 ]        = -.201070E-12;
    coeffEnergy[ 2 ][ 2 ][ 2 ]        = -.126600E-12;
    coeffEnergy[ 3 ][ 2 ][ 2 ]        = 0.893246E-13;
    coeffEnergy[ 4 ][ 2 ][ 2 ]        = 0.279602E-12;
    coeffEnergy[ 5 ][ 2 ][ 2 ]        = -.173777E-12;
    coeffEnergy[ 6 ][ 2 ][ 2 ]        = 0.235526E-13;
    coeffEnergy[ 7 ][ 2 ][ 2 ]        = -.554562E-13;
    coeffEnergy[ 8 ][ 2 ][ 2 ]        = 0.910581E-13;
    coeffEnergy[ 9 ][ 2 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 2 ]       =  0.00000;
    performanceMin[ 2 ][ 2 ]          = 0.800000;
    performanceMax[ 2 ][ 2 ]          =  1.20000;
    coeffPerformance[ 0 ][ 2 ][ 2 ]   =  1.00000;
    coeffPerformance[ 1 ][ 2 ][ 2 ]   = 0.394526E-13;
    coeffPerformance[ 2 ][ 2 ][ 2 ]   = 0.182283E-12;
    coeffPerformance[ 3 ][ 2 ][ 2 ]   = -.131811E-12;
    coeffPerformance[ 4 ][ 2 ][ 2 ]   = -.574272E-13;
    coeffPerformance[ 5 ][ 2 ][ 2 ]   = -.166080E-12;
    coeffPerformance[ 6 ][ 2 ][ 2 ]   = 0.195326E-12;
    coeffPerformance[ 7 ][ 2 ][ 2 ]   = 0.821631E-13;
    coeffPerformance[ 8 ][ 2 ][ 2 ]   = -.135454E-12;
    coeffPerformance[ 9 ][ 2 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 2 ]  =  0.00000;
    powerMin[ 2 ][ 2 ]                = 0.800000;
    powerMax[ 2 ][ 2 ]                =  1.20000;
    coeffPower[ 0 ][ 2 ][ 2 ]         =  1.00000;
    coeffPower[ 1 ][ 2 ][ 2 ]         = 0.118356E-12;
    coeffPower[ 2 ][ 2 ][ 2 ]         = -.162138E-14;
    coeffPower[ 3 ][ 2 ][ 2 ]         = 0.147306E-14;
    coeffPower[ 4 ][ 2 ][ 2 ]         = -.165423E-12;
    coeffPower[ 5 ][ 2 ][ 2 ]         = 0.230614E-13;
    coeffPower[ 6 ][ 2 ][ 2 ]         = -.178552E-13;
    coeffPower[ 7 ][ 2 ][ 2 ]         = 0.323134E-14;
    coeffPower[ 8 ][ 2 ][ 2 ]         = -.843302E-14;
    coeffPower[ 9 ][ 2 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 2 ]        =  0.00000;
    energyMin[ 3 ][ 2 ]               = 0.738713;
    energyMax[ 3 ][ 2 ]               =  1.31267;
    coeffEnergy[ 0 ][ 3 ][ 2 ]        = 0.948030;
    coeffEnergy[ 1 ][ 3 ][ 2 ]        =  2.02095;
    coeffEnergy[ 2 ][ 3 ][ 2 ]        = 0.415570;
    coeffEnergy[ 3 ][ 3 ][ 2 ]        = -.275352;
    coeffEnergy[ 4 ][ 3 ][ 2 ]        = -2.81170;
    coeffEnergy[ 5 ][ 3 ][ 2 ]        =  1.71209;
    coeffEnergy[ 6 ][ 3 ][ 2 ]        = -.420042;
    coeffEnergy[ 7 ][ 3 ][ 2 ]        = 0.584537;
    coeffEnergy[ 8 ][ 3 ][ 2 ]        = -.690783;
    coeffEnergy[ 9 ][ 3 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 2 ]       =  0.00000;
    performanceMin[ 3 ][ 2 ]          = 0.811493;
    performanceMax[ 3 ][ 2 ]          =  1.33930;
    coeffPerformance[ 0 ][ 3 ][ 2 ]   =  1.08865;
    coeffPerformance[ 1 ][ 3 ][ 2 ]   = -.106869E-01;
    coeffPerformance[ 2 ][ 3 ][ 2 ]   = -.167548;
    coeffPerformance[ 3 ][ 3 ][ 2 ]   = 0.100276;
    coeffPerformance[ 4 ][ 3 ][ 2 ]   = 0.961492E-02;
    coeffPerformance[ 5 ][ 3 ][ 2 ]   = -2.06154;
    coeffPerformance[ 6 ][ 3 ][ 2 ]   = 0.690981;
    coeffPerformance[ 7 ][ 3 ][ 2 ]   = -.215235;
    coeffPerformance[ 8 ][ 3 ][ 2 ]   = 0.434676;
    coeffPerformance[ 9 ][ 3 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 2 ]  =  0.00000;
    powerMin[ 3 ][ 2 ]                = 0.816637;
    powerMax[ 3 ][ 2 ]                =  1.36209;
    coeffPower[ 0 ][ 3 ][ 2 ]         =  1.03348;
    coeffPower[ 1 ][ 3 ][ 2 ]         =  2.11216;
    coeffPower[ 2 ][ 3 ][ 2 ]         = 0.275659;
    coeffPower[ 3 ][ 3 ][ 2 ]         = -.193441;
    coeffPower[ 4 ][ 3 ][ 2 ]         = -2.94385;
    coeffPower[ 5 ][ 3 ][ 2 ]         = -.269012;
    coeffPower[ 6 ][ 3 ][ 2 ]         = 0.261250;
    coeffPower[ 7 ][ 3 ][ 2 ]         = 0.411714;
    coeffPower[ 8 ][ 3 ][ 2 ]         = -.311917;
    coeffPower[ 9 ][ 3 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 2 ]        =  0.00000;
    energyMin[ 4 ][ 2 ]               = 0.762007;
    energyMax[ 4 ][ 2 ]               =  1.33175;
    coeffEnergy[ 0 ][ 4 ][ 2 ]        = 0.927201;
    coeffEnergy[ 1 ][ 4 ][ 2 ]        =  1.84501;
    coeffEnergy[ 2 ][ 4 ][ 2 ]        = 0.643697;
    coeffEnergy[ 3 ][ 4 ][ 2 ]        = -.428070;
    coeffEnergy[ 4 ][ 4 ][ 2 ]        = -2.56775;
    coeffEnergy[ 5 ][ 4 ][ 2 ]        =  3.85611;
    coeffEnergy[ 6 ][ 4 ][ 2 ]        = -1.36175;
    coeffEnergy[ 7 ][ 4 ][ 2 ]        = 0.724402;
    coeffEnergy[ 8 ][ 4 ][ 2 ]        = -.780138;
    coeffEnergy[ 9 ][ 4 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 2 ]       =  0.00000;
    performanceMin[ 4 ][ 2 ]          = 0.832436;
    performanceMax[ 4 ][ 2 ]          =  1.39462;
    coeffPerformance[ 0 ][ 4 ][ 2 ]   =  1.14580;
    coeffPerformance[ 1 ][ 4 ][ 2 ]   =  1.17460;
    coeffPerformance[ 2 ][ 4 ][ 2 ]   = 0.598386E-01;
    coeffPerformance[ 3 ][ 4 ][ 2 ]   = -.707207E-01;
    coeffPerformance[ 4 ][ 4 ][ 2 ]   = -1.63539;
    coeffPerformance[ 5 ][ 4 ][ 2 ]   = -4.06947;
    coeffPerformance[ 6 ][ 4 ][ 2 ]   =  1.59094;
    coeffPerformance[ 7 ][ 4 ][ 2 ]   = 0.764557E-01;
    coeffPerformance[ 8 ][ 4 ][ 2 ]   = 0.230253;
    coeffPerformance[ 9 ][ 4 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 2 ]  =  0.00000;
    powerMin[ 4 ][ 2 ]                = 0.841386;
    powerMax[ 4 ][ 2 ]                =  1.41599;
    coeffPower[ 0 ][ 4 ][ 2 ]         =  1.06503;
    coeffPower[ 1 ][ 4 ][ 2 ]         =  3.09148;
    coeffPower[ 2 ][ 4 ][ 2 ]         = 0.744128;
    coeffPower[ 3 ][ 4 ][ 2 ]         = -.524517;
    coeffPower[ 4 ][ 4 ][ 2 ]         = -4.30298;
    coeffPower[ 5 ][ 4 ][ 2 ]         = 0.138830;
    coeffPower[ 6 ][ 4 ][ 2 ]         = 0.992545E-01;
    coeffPower[ 7 ][ 4 ][ 2 ]         = 0.877283;
    coeffPower[ 8 ][ 4 ][ 2 ]         = -.628272;
    coeffPower[ 9 ][ 4 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 2 ]        =  0.00000;
    energyMin[ 5 ][ 2 ]               = 0.747143;
    energyMax[ 5 ][ 2 ]               =  1.36603;
    coeffEnergy[ 0 ][ 5 ][ 2 ]        = 0.913812;
    coeffEnergy[ 1 ][ 5 ][ 2 ]        = -.567489;
    coeffEnergy[ 2 ][ 5 ][ 2 ]        = 0.143238;
    coeffEnergy[ 3 ][ 5 ][ 2 ]        = -.543829E-01;
    coeffEnergy[ 4 ][ 5 ][ 2 ]        = 0.799009;
    coeffEnergy[ 5 ][ 5 ][ 2 ]        =  4.97531;
    coeffEnergy[ 6 ][ 5 ][ 2 ]        = -1.76641;
    coeffEnergy[ 7 ][ 5 ][ 2 ]        = 0.952550;
    coeffEnergy[ 8 ][ 5 ][ 2 ]        = -1.11502;
    coeffEnergy[ 9 ][ 5 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 2 ]       =  0.00000;
    performanceMin[ 5 ][ 2 ]          = 0.840737;
    performanceMax[ 5 ][ 2 ]          =  1.47913;
    coeffPerformance[ 0 ][ 5 ][ 2 ]   =  1.22222;
    coeffPerformance[ 1 ][ 5 ][ 2 ]   =  2.58740;
    coeffPerformance[ 2 ][ 5 ][ 2 ]   = 0.171913;
    coeffPerformance[ 3 ][ 5 ][ 2 ]   = -.171175;
    coeffPerformance[ 4 ][ 5 ][ 2 ]   = -3.60636;
    coeffPerformance[ 5 ][ 5 ][ 2 ]   = -6.29451;
    coeffPerformance[ 6 ][ 5 ][ 2 ]   =  2.34228;
    coeffPerformance[ 7 ][ 5 ][ 2 ]   = -.652336E-01;
    coeffPerformance[ 8 ][ 5 ][ 2 ]   = 0.603722;
    coeffPerformance[ 9 ][ 5 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 2 ]  =  0.00000;
    powerMin[ 5 ][ 2 ]                = 0.861870;
    powerMax[ 5 ][ 2 ]                =  1.57247;
    coeffPower[ 0 ][ 5 ][ 2 ]         =  1.12258;
    coeffPower[ 1 ][ 5 ][ 2 ]         =  1.62470;
    coeffPower[ 2 ][ 5 ][ 2 ]         = 0.295794;
    coeffPower[ 3 ][ 5 ][ 2 ]         = -.205291;
    coeffPower[ 4 ][ 5 ][ 2 ]         = -2.25530;
    coeffPower[ 5 ][ 5 ][ 2 ]         = -.715560;
    coeffPower[ 6 ][ 5 ][ 2 ]         = 0.346980;
    coeffPower[ 7 ][ 5 ][ 2 ]         =  1.03167;
    coeffPower[ 8 ][ 5 ][ 2 ]         = -.660333;
    coeffPower[ 9 ][ 5 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 2 ]        =  0.00000;
    energyMin[ 6 ][ 2 ]               = 0.740012;
    energyMax[ 6 ][ 2 ]               =  1.38999;
    coeffEnergy[ 0 ][ 6 ][ 2 ]        = 0.905853;
    coeffEnergy[ 1 ][ 6 ][ 2 ]        = -4.32647;
    coeffEnergy[ 2 ][ 6 ][ 2 ]        = -.427449;
    coeffEnergy[ 3 ][ 6 ][ 2 ]        = 0.368215;
    coeffEnergy[ 4 ][ 6 ][ 2 ]        =  6.04650;
    coeffEnergy[ 5 ][ 6 ][ 2 ]        =  5.45326;
    coeffEnergy[ 6 ][ 6 ][ 2 ]        = -1.79330;
    coeffEnergy[ 7 ][ 6 ][ 2 ]        =  1.16311;
    coeffEnergy[ 8 ][ 6 ][ 2 ]        = -1.48568;
    coeffEnergy[ 9 ][ 6 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 2 ]       =  0.00000;
    performanceMin[ 6 ][ 2 ]          = 0.848798;
    performanceMax[ 6 ][ 2 ]          =  1.57948;
    coeffPerformance[ 0 ][ 6 ][ 2 ]   =  1.29275;
    coeffPerformance[ 1 ][ 6 ][ 2 ]   =  5.44314;
    coeffPerformance[ 2 ][ 6 ][ 2 ]   = 0.292168;
    coeffPerformance[ 3 ][ 6 ][ 2 ]   = -.278270;
    coeffPerformance[ 4 ][ 6 ][ 2 ]   = -7.58924;
    coeffPerformance[ 5 ][ 6 ][ 2 ]   = -8.15210;
    coeffPerformance[ 6 ][ 6 ][ 2 ]   =  2.87927;
    coeffPerformance[ 7 ][ 6 ][ 2 ]   = -.313971;
    coeffPerformance[ 8 ][ 6 ][ 2 ]   =  1.13566;
    coeffPerformance[ 9 ][ 6 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 2 ]  =  0.00000;
    powerMin[ 6 ][ 2 ]                = 0.884955;
    powerMax[ 6 ][ 2 ]                =  1.65595;
    coeffPower[ 0 ][ 6 ][ 2 ]         =  1.17902;
    coeffPower[ 1 ][ 6 ][ 2 ]         = -.171697;
    coeffPower[ 2 ][ 6 ][ 2 ]         = -.253162;
    coeffPower[ 3 ][ 6 ][ 2 ]         = 0.184812;
    coeffPower[ 4 ][ 6 ][ 2 ]         = 0.256210;
    coeffPower[ 5 ][ 6 ][ 2 ]         = -1.94450;
    coeffPower[ 6 ][ 6 ][ 2 ]         = 0.843864;
    coeffPower[ 7 ][ 6 ][ 2 ]         =  1.10693;
    coeffPower[ 8 ][ 6 ][ 2 ]         = -.639857;
    coeffPower[ 9 ][ 6 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 2 ]        =  0.00000;
    energyMin[ 7 ][ 2 ]               = 0.738488;
    energyMax[ 7 ][ 2 ]               =  1.42336;
    coeffEnergy[ 0 ][ 7 ][ 2 ]        = 0.903474;
    coeffEnergy[ 1 ][ 7 ][ 2 ]        = -7.34914;
    coeffEnergy[ 2 ][ 7 ][ 2 ]        = -1.20530;
    coeffEnergy[ 3 ][ 7 ][ 2 ]        = 0.933359;
    coeffEnergy[ 4 ][ 7 ][ 2 ]        =  10.2661;
    coeffEnergy[ 5 ][ 7 ][ 2 ]        =  6.99772;
    coeffEnergy[ 6 ][ 7 ][ 2 ]        = -2.63792;
    coeffEnergy[ 7 ][ 7 ][ 2 ]        = 0.932654;
    coeffEnergy[ 8 ][ 7 ][ 2 ]        = -1.18108;
    coeffEnergy[ 9 ][ 7 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 2 ]       =  0.00000;
    performanceMin[ 7 ][ 2 ]          = 0.853449;
    performanceMax[ 7 ][ 2 ]          =  1.65085;
    coeffPerformance[ 0 ][ 7 ][ 2 ]   =  1.34680;
    coeffPerformance[ 1 ][ 7 ][ 2 ]   =  9.58058;
    coeffPerformance[ 2 ][ 7 ][ 2 ]   = 0.937137;
    coeffPerformance[ 3 ][ 7 ][ 2 ]   = -.749440;
    coeffPerformance[ 4 ][ 7 ][ 2 ]   = -13.3583;
    coeffPerformance[ 5 ][ 7 ][ 2 ]   = -10.8778;
    coeffPerformance[ 6 ][ 7 ][ 2 ]   =  4.30369;
    coeffPerformance[ 7 ][ 7 ][ 2 ]   = 0.285652;
    coeffPerformance[ 8 ][ 7 ][ 2 ]   = 0.582220;
    coeffPerformance[ 9 ][ 7 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 2 ]  =  0.00000;
    powerMin[ 7 ][ 2 ]                = 0.909859;
    powerMax[ 7 ][ 2 ]                =  1.74627;
    coeffPower[ 0 ][ 7 ][ 2 ]         =  1.22550;
    coeffPower[ 1 ][ 7 ][ 2 ]         = -.276355E-01;
    coeffPower[ 2 ][ 7 ][ 2 ]         = -.573012;
    coeffPower[ 3 ][ 7 ][ 2 ]         = 0.415093;
    coeffPower[ 4 ][ 7 ][ 2 ]         = 0.620360E-01;
    coeffPower[ 5 ][ 7 ][ 2 ]         = -2.78682;
    coeffPower[ 6 ][ 7 ][ 2 ]         =  1.23374;
    coeffPower[ 7 ][ 7 ][ 2 ]         =  1.48317;
    coeffPower[ 8 ][ 7 ][ 2 ]         = -.842639;
    coeffPower[ 9 ][ 7 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 2 ]        =  0.00000;
    energyMin[ 8 ][ 2 ]               = 0.732177;
    energyMax[ 8 ][ 2 ]               =  1.46078;
    coeffEnergy[ 0 ][ 8 ][ 2 ]        = 0.895912;
    coeffEnergy[ 1 ][ 8 ][ 2 ]        = -10.0939;
    coeffEnergy[ 2 ][ 8 ][ 2 ]        = -1.88326;
    coeffEnergy[ 3 ][ 8 ][ 2 ]        =  1.42987;
    coeffEnergy[ 4 ][ 8 ][ 2 ]        =  14.1015;
    coeffEnergy[ 5 ][ 8 ][ 2 ]        =  8.03777;
    coeffEnergy[ 6 ][ 8 ][ 2 ]        = -3.04539;
    coeffEnergy[ 7 ][ 8 ][ 2 ]        = 0.921194;
    coeffEnergy[ 8 ][ 8 ][ 2 ]        = -1.17023;
    coeffEnergy[ 9 ][ 8 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 2 ]       =  0.00000;
    performanceMin[ 8 ][ 2 ]          = 0.860961;
    performanceMax[ 8 ][ 2 ]          =  1.73870;
    coeffPerformance[ 0 ][ 8 ][ 2 ]   =  1.41813;
    coeffPerformance[ 1 ][ 8 ][ 2 ]   =  13.6542;
    coeffPerformance[ 2 ][ 8 ][ 2 ]   =  1.54494;
    coeffPerformance[ 3 ][ 8 ][ 2 ]   = -1.20414;
    coeffPerformance[ 4 ][ 8 ][ 2 ]   = -19.0462;
    coeffPerformance[ 5 ][ 8 ][ 2 ]   = -13.3760;
    coeffPerformance[ 6 ][ 8 ][ 2 ]   =  5.32539;
    coeffPerformance[ 7 ][ 8 ][ 2 ]   = 0.426397;
    coeffPerformance[ 8 ][ 8 ][ 2 ]   = 0.644342;
    coeffPerformance[ 9 ][ 8 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 2 ]  =  0.00000;
    powerMin[ 8 ][ 2 ]                = 0.935127;
    powerMax[ 8 ][ 2 ]                =  1.84421;
    coeffPower[ 0 ][ 8 ][ 2 ]         =  1.28108;
    coeffPower[ 1 ][ 8 ][ 2 ]         = 0.254490;
    coeffPower[ 2 ][ 8 ][ 2 ]         = -.813746;
    coeffPower[ 3 ][ 8 ][ 2 ]         = 0.582921;
    coeffPower[ 4 ][ 8 ][ 2 ]         = -.327148;
    coeffPower[ 5 ][ 8 ][ 2 ]         = -3.93571;
    coeffPower[ 6 ][ 8 ][ 2 ]         =  1.71748;
    coeffPower[ 7 ][ 8 ][ 2 ]         =  1.68852;
    coeffPower[ 8 ][ 8 ][ 2 ]         = -.807840;
    coeffPower[ 9 ][ 8 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 2 ]        =  0.00000;
    energyMin[ 9 ][ 2 ]               = 0.729748;
    energyMax[ 9 ][ 2 ]               =  1.50611;
    coeffEnergy[ 0 ][ 9 ][ 2 ]        = 0.901111;
    coeffEnergy[ 1 ][ 9 ][ 2 ]        = -12.5358;
    coeffEnergy[ 2 ][ 9 ][ 2 ]        = -2.14088;
    coeffEnergy[ 3 ][ 9 ][ 2 ]        =  1.62148;
    coeffEnergy[ 4 ][ 9 ][ 2 ]        =  17.5063;
    coeffEnergy[ 5 ][ 9 ][ 2 ]        =  9.06343;
    coeffEnergy[ 6 ][ 9 ][ 2 ]        = -3.43830;
    coeffEnergy[ 7 ][ 9 ][ 2 ]        = 0.994798;
    coeffEnergy[ 8 ][ 9 ][ 2 ]        = -1.19292;
    coeffEnergy[ 9 ][ 9 ][ 2 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 2 ]       =  0.00000;
    performanceMin[ 9 ][ 2 ]          = 0.864075;
    performanceMax[ 9 ][ 2 ]          =  1.82456;
    coeffPerformance[ 0 ][ 9 ][ 2 ]   =  1.46018;
    coeffPerformance[ 1 ][ 9 ][ 2 ]   =  17.7252;
    coeffPerformance[ 2 ][ 9 ][ 2 ]   =  1.81348;
    coeffPerformance[ 3 ][ 9 ][ 2 ]   = -1.40720;
    coeffPerformance[ 4 ][ 9 ][ 2 ]   = -24.7140;
    coeffPerformance[ 5 ][ 9 ][ 2 ]   = -15.0508;
    coeffPerformance[ 6 ][ 9 ][ 2 ]   =  5.91329;
    coeffPerformance[ 7 ][ 9 ][ 2 ]   = 0.463384;
    coeffPerformance[ 8 ][ 9 ][ 2 ]   = 0.734540;
    coeffPerformance[ 9 ][ 9 ][ 2 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 2 ]  =  0.00000;
    powerMin[ 9 ][ 2 ]                = 0.962163;
    powerMax[ 9 ][ 2 ]                =  1.92047;
    coeffPower[ 0 ][ 9 ][ 2 ]         =  1.32387;
    coeffPower[ 1 ][ 9 ][ 2 ]         = 0.995384;
    coeffPower[ 2 ][ 9 ][ 2 ]         = -.926231;
    coeffPower[ 3 ][ 9 ][ 2 ]         = 0.663238;
    coeffPower[ 4 ][ 9 ][ 2 ]         = -1.35088;
    coeffPower[ 5 ][ 9 ][ 2 ]         = -4.36042;
    coeffPower[ 6 ][ 9 ][ 2 ]         =  1.82110;
    coeffPower[ 7 ][ 9 ][ 2 ]         =  1.94058;
    coeffPower[ 8 ][ 9 ][ 2 ]         = -.821867;
    coeffPower[ 9 ][ 9 ][ 2 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 2 ]        =  0.00000;
    energyMin[ 10 ][ 2 ]              = 0.731234;
    energyMax[ 10 ][ 2 ]              =  1.56346;
    coeffEnergy[ 0 ][ 10 ][ 2 ]       = 0.906218;
    coeffEnergy[ 1 ][ 10 ][ 2 ]       = -14.2857;
    coeffEnergy[ 2 ][ 10 ][ 2 ]       = -2.52981;
    coeffEnergy[ 3 ][ 10 ][ 2 ]       =  1.90797;
    coeffEnergy[ 4 ][ 10 ][ 2 ]       =  19.9480;
    coeffEnergy[ 5 ][ 10 ][ 2 ]       =  10.1300;
    coeffEnergy[ 6 ][ 10 ][ 2 ]       = -3.90721;
    coeffEnergy[ 7 ][ 10 ][ 2 ]       =  1.02098;
    coeffEnergy[ 8 ][ 10 ][ 2 ]       = -1.17526;
    coeffEnergy[ 9 ][ 10 ][ 2 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 2 ]      =  0.00000;
    performanceMin[ 10 ][ 2 ]         = 0.866431;
    performanceMax[ 10 ][ 2 ]         =  1.91350;
    coeffPerformance[ 0 ][ 10 ][ 2 ]  =  1.52039;
    coeffPerformance[ 1 ][ 10 ][ 2 ]  =  21.5510;
    coeffPerformance[ 2 ][ 10 ][ 2 ]  =  2.37144;
    coeffPerformance[ 3 ][ 10 ][ 2 ]  = -1.82284;
    coeffPerformance[ 4 ][ 10 ][ 2 ]  = -30.0494;
    coeffPerformance[ 5 ][ 10 ][ 2 ]  = -17.3698;
    coeffPerformance[ 6 ][ 10 ][ 2 ]  =  6.91304;
    coeffPerformance[ 7 ][ 10 ][ 2 ]  = 0.577071;
    coeffPerformance[ 8 ][ 10 ][ 2 ]  = 0.739537;
    coeffPerformance[ 9 ][ 10 ][ 2 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 2 ] =  0.00000;
    powerMin[ 10 ][ 2 ]               = 0.989407;
    powerMax[ 10 ][ 2 ]               =  2.04949;
    coeffPower[ 0 ][ 10 ][ 2 ]        =  1.38919;
    coeffPower[ 1 ][ 10 ][ 2 ]        =  2.13581;
    coeffPower[ 2 ][ 10 ][ 2 ]        = -.901741;
    coeffPower[ 3 ][ 10 ][ 2 ]        = 0.639166;
    coeffPower[ 4 ][ 10 ][ 2 ]        = -2.93938;
    coeffPower[ 5 ][ 10 ][ 2 ]        = -5.44816;
    coeffPower[ 6 ][ 10 ][ 2 ]        =  2.25079;
    coeffPower[ 7 ][ 10 ][ 2 ]        =  2.14048;
    coeffPower[ 8 ][ 10 ][ 2 ]        = -.785836;
    coeffPower[ 9 ][ 10 ][ 2 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 2 ]       =  0.00000;
    energyMin[ 11 ][ 2 ]              = 0.732630;
    energyMax[ 11 ][ 2 ]              =  1.63234;
    coeffEnergy[ 0 ][ 11 ][ 2 ]       = 0.914474;
    coeffEnergy[ 1 ][ 11 ][ 2 ]       = -16.9824;
    coeffEnergy[ 2 ][ 11 ][ 2 ]       = -2.88250;
    coeffEnergy[ 3 ][ 11 ][ 2 ]       =  2.16954;
    coeffEnergy[ 4 ][ 11 ][ 2 ]       =  23.7112;
    coeffEnergy[ 5 ][ 11 ][ 2 ]       =  11.5248;
    coeffEnergy[ 6 ][ 11 ][ 2 ]       = -4.49976;
    coeffEnergy[ 7 ][ 11 ][ 2 ]       = 0.884652;
    coeffEnergy[ 8 ][ 11 ][ 2 ]       = -1.10332;
    coeffEnergy[ 9 ][ 11 ][ 2 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 2 ]      =  0.00000;
    performanceMin[ 11 ][ 2 ]         = 0.871475;
    performanceMax[ 11 ][ 2 ]         =  1.99616;
    coeffPerformance[ 0 ][ 11 ][ 2 ]  =  1.58082;
    coeffPerformance[ 1 ][ 11 ][ 2 ]  =  26.5583;
    coeffPerformance[ 2 ][ 11 ][ 2 ]  =  2.91925;
    coeffPerformance[ 3 ][ 11 ][ 2 ]  = -2.23257;
    coeffPerformance[ 4 ][ 11 ][ 2 ]  = -37.0342;
    coeffPerformance[ 5 ][ 11 ][ 2 ]  = -19.9597;
    coeffPerformance[ 6 ][ 11 ][ 2 ]  =  8.00096;
    coeffPerformance[ 7 ][ 11 ][ 2 ]  = 0.812990;
    coeffPerformance[ 8 ][ 11 ][ 2 ]  = 0.739983;
    coeffPerformance[ 9 ][ 11 ][ 2 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 2 ] =  0.00000;
    powerMin[ 11 ][ 2 ]               =  1.02289;
    powerMax[ 11 ][ 2 ]               =  2.15863;
    coeffPower[ 0 ][ 11 ][ 2 ]        =  1.45280;
    coeffPower[ 1 ][ 11 ][ 2 ]        =  3.47144;
    coeffPower[ 2 ][ 11 ][ 2 ]        = -.849920;
    coeffPower[ 3 ][ 11 ][ 2 ]        = 0.597636;
    coeffPower[ 4 ][ 11 ][ 2 ]        = -4.79793;
    coeffPower[ 5 ][ 11 ][ 2 ]        = -6.40959;
    coeffPower[ 6 ][ 11 ][ 2 ]        =  2.65549;
    coeffPower[ 7 ][ 11 ][ 2 ]        =  2.37332;
    coeffPower[ 8 ][ 11 ][ 2 ]        = -.796390;
    coeffPower[ 9 ][ 11 ][ 2 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 2 ]       =  0.00000;
    energyMin[ 12 ][ 2 ]              = 0.734242;
    energyMax[ 12 ][ 2 ]              =  1.67914;
    coeffEnergy[ 0 ][ 12 ][ 2 ]       = 0.928729;
    coeffEnergy[ 1 ][ 12 ][ 2 ]       = -19.7898;
    coeffEnergy[ 2 ][ 12 ][ 2 ]       = -3.22121;
    coeffEnergy[ 3 ][ 12 ][ 2 ]       =  2.42030;
    coeffEnergy[ 4 ][ 12 ][ 2 ]       =  27.6266;
    coeffEnergy[ 5 ][ 12 ][ 2 ]       =  12.6987;
    coeffEnergy[ 6 ][ 12 ][ 2 ]       = -4.94254;
    coeffEnergy[ 7 ][ 12 ][ 2 ]       = 0.753007;
    coeffEnergy[ 8 ][ 12 ][ 2 ]       = -1.14181;
    coeffEnergy[ 9 ][ 12 ][ 2 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 2 ]      =  0.00000;
    performanceMin[ 12 ][ 2 ]         = 0.872085;
    performanceMax[ 12 ][ 2 ]         =  2.08560;
    coeffPerformance[ 0 ][ 12 ][ 2 ]  =  1.64072;
    coeffPerformance[ 1 ][ 12 ][ 2 ]  =  31.3888;
    coeffPerformance[ 2 ][ 12 ][ 2 ]  =  3.48648;
    coeffPerformance[ 3 ][ 12 ][ 2 ]  = -2.65753;
    coeffPerformance[ 4 ][ 12 ][ 2 ]  = -43.7711;
    coeffPerformance[ 5 ][ 12 ][ 2 ]  = -22.3673;
    coeffPerformance[ 6 ][ 12 ][ 2 ]  =  8.92312;
    coeffPerformance[ 7 ][ 12 ][ 2 ]  = 0.896667;
    coeffPerformance[ 8 ][ 12 ][ 2 ]  = 0.908918;
    coeffPerformance[ 9 ][ 12 ][ 2 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 2 ] =  0.00000;
    powerMin[ 12 ][ 2 ]               =  1.05221;
    powerMax[ 12 ][ 2 ]               =  2.24487;
    coeffPower[ 0 ][ 12 ][ 2 ]        =  1.53020;
    coeffPower[ 1 ][ 12 ][ 2 ]        =  4.52993;
    coeffPower[ 2 ][ 12 ][ 2 ]        = -.753962;
    coeffPower[ 3 ][ 12 ][ 2 ]        = 0.519797;
    coeffPower[ 4 ][ 12 ][ 2 ]        = -6.27388;
    coeffPower[ 5 ][ 12 ][ 2 ]        = -7.55416;
    coeffPower[ 6 ][ 12 ][ 2 ]        =  3.08398;
    coeffPower[ 7 ][ 12 ][ 2 ]        =  2.36901;
    coeffPower[ 8 ][ 12 ][ 2 ]        = -.680273;
    coeffPower[ 9 ][ 12 ][ 2 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 2 ]       =  0.00000;
    energyMin[ 13 ][ 2 ]              = 0.742793;
    energyMax[ 13 ][ 2 ]              =  1.73553;
    coeffEnergy[ 0 ][ 13 ][ 2 ]       = 0.926700;
    coeffEnergy[ 1 ][ 13 ][ 2 ]       = -20.9582;
    coeffEnergy[ 2 ][ 13 ][ 2 ]       = -3.45708;
    coeffEnergy[ 3 ][ 13 ][ 2 ]       =  2.60354;
    coeffEnergy[ 4 ][ 13 ][ 2 ]       =  29.2602;
    coeffEnergy[ 5 ][ 13 ][ 2 ]       =  14.0198;
    coeffEnergy[ 6 ][ 13 ][ 2 ]       = -5.43975;
    coeffEnergy[ 7 ][ 13 ][ 2 ]       =  1.03102;
    coeffEnergy[ 8 ][ 13 ][ 2 ]       = -1.37863;
    coeffEnergy[ 9 ][ 13 ][ 2 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 2 ]      =  0.00000;
    performanceMin[ 13 ][ 2 ]         = 0.875147;
    performanceMax[ 13 ][ 2 ]         =  2.17038;
    coeffPerformance[ 0 ][ 13 ][ 2 ]  =  1.70281;
    coeffPerformance[ 1 ][ 13 ][ 2 ]  =  34.4737;
    coeffPerformance[ 2 ][ 13 ][ 2 ]  =  3.81570;
    coeffPerformance[ 3 ][ 13 ][ 2 ]  = -2.91270;
    coeffPerformance[ 4 ][ 13 ][ 2 ]  = -48.0721;
    coeffPerformance[ 5 ][ 13 ][ 2 ]  = -24.8117;
    coeffPerformance[ 6 ][ 13 ][ 2 ]  =  9.84201;
    coeffPerformance[ 7 ][ 13 ][ 2 ]  = 0.763172;
    coeffPerformance[ 8 ][ 13 ][ 2 ]  =  1.17876;
    coeffPerformance[ 9 ][ 13 ][ 2 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 2 ] =  0.00000;
    powerMin[ 13 ][ 2 ]               =  1.08736;
    powerMax[ 13 ][ 2 ]               =  2.33817;
    coeffPower[ 0 ][ 13 ][ 2 ]        =  1.58859;
    coeffPower[ 1 ][ 13 ][ 2 ]        =  5.95912;
    coeffPower[ 2 ][ 13 ][ 2 ]        = -.723710;
    coeffPower[ 3 ][ 13 ][ 2 ]        = 0.495778;
    coeffPower[ 4 ][ 13 ][ 2 ]        = -8.25845;
    coeffPower[ 5 ][ 13 ][ 2 ]        = -8.54712;
    coeffPower[ 6 ][ 13 ][ 2 ]        =  3.40621;
    coeffPower[ 7 ][ 13 ][ 2 ]        =  2.68420;
    coeffPower[ 8 ][ 13 ][ 2 ]        = -.689558;
    coeffPower[ 9 ][ 13 ][ 2 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 2 ]       =  0.00000;
    energyMin[ 14 ][ 2 ]              = 0.744677;
    energyMax[ 14 ][ 2 ]              =  1.79305;
    coeffEnergy[ 0 ][ 14 ][ 2 ]       = 0.933079;
    coeffEnergy[ 1 ][ 14 ][ 2 ]       = -22.8612;
    coeffEnergy[ 2 ][ 14 ][ 2 ]       = -3.87097;
    coeffEnergy[ 3 ][ 14 ][ 2 ]       =  2.91498;
    coeffEnergy[ 4 ][ 14 ][ 2 ]       =  31.9177;
    coeffEnergy[ 5 ][ 14 ][ 2 ]       =  15.6621;
    coeffEnergy[ 6 ][ 14 ][ 2 ]       = -6.15565;
    coeffEnergy[ 7 ][ 14 ][ 2 ]       =  1.06170;
    coeffEnergy[ 8 ][ 14 ][ 2 ]       = -1.53080;
    coeffEnergy[ 9 ][ 14 ][ 2 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 2 ]      =  0.00000;
    performanceMin[ 14 ][ 2 ]         = 0.878445;
    performanceMax[ 14 ][ 2 ]         =  2.26110;
    coeffPerformance[ 0 ][ 14 ][ 2 ]  =  1.76883;
    coeffPerformance[ 1 ][ 14 ][ 2 ]  =  39.0749;
    coeffPerformance[ 2 ][ 14 ][ 2 ]  =  4.34689;
    coeffPerformance[ 3 ][ 14 ][ 2 ]  = -3.31317;
    coeffPerformance[ 4 ][ 14 ][ 2 ]  = -54.4925;
    coeffPerformance[ 5 ][ 14 ][ 2 ]  = -27.5068;
    coeffPerformance[ 6 ][ 14 ][ 2 ]  =  10.9567;
    coeffPerformance[ 7 ][ 14 ][ 2 ]  = 0.871166;
    coeffPerformance[ 8 ][ 14 ][ 2 ]  =  1.27961;
    coeffPerformance[ 9 ][ 14 ][ 2 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 2 ] =  0.00000;
    powerMin[ 14 ][ 2 ]               =  1.12209;
    powerMax[ 14 ][ 2 ]               =  2.44924;
    coeffPower[ 0 ][ 14 ][ 2 ]        =  1.66445;
    coeffPower[ 1 ][ 14 ][ 2 ]        =  8.25303;
    coeffPower[ 2 ][ 14 ][ 2 ]        = -.687964;
    coeffPower[ 3 ][ 14 ][ 2 ]        = 0.467332;
    coeffPower[ 4 ][ 14 ][ 2 ]        = -11.4551;
    coeffPower[ 5 ][ 14 ][ 2 ]        = -9.54310;
    coeffPower[ 6 ][ 14 ][ 2 ]        =  3.76030;
    coeffPower[ 7 ][ 14 ][ 2 ]        =  2.95710;
    coeffPower[ 8 ][ 14 ][ 2 ]        = -.805451;
    coeffPower[ 9 ][ 14 ][ 2 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 2 ]       =  0.00000;
    energyMin[ 15 ][ 2 ]              = 0.748547;
    energyMax[ 15 ][ 2 ]              =  1.84979;
    coeffEnergy[ 0 ][ 15 ][ 2 ]       = 0.945442;
    coeffEnergy[ 1 ][ 15 ][ 2 ]       = -24.1335;
    coeffEnergy[ 2 ][ 15 ][ 2 ]       = -3.84070;
    coeffEnergy[ 3 ][ 15 ][ 2 ]       =  2.90593;
    coeffEnergy[ 4 ][ 15 ][ 2 ]       =  33.6916;
    coeffEnergy[ 5 ][ 15 ][ 2 ]       =  17.0669;
    coeffEnergy[ 6 ][ 15 ][ 2 ]       = -6.63375;
    coeffEnergy[ 7 ][ 15 ][ 2 ]       =  1.19386;
    coeffEnergy[ 8 ][ 15 ][ 2 ]       = -1.79352;
    coeffEnergy[ 9 ][ 15 ][ 2 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 2 ]      =  0.00000;
    performanceMin[ 15 ][ 2 ]         = 0.879152;
    performanceMax[ 15 ][ 2 ]         =  2.34444;
    coeffPerformance[ 0 ][ 15 ][ 2 ]  =  1.82746;
    coeffPerformance[ 1 ][ 15 ][ 2 ]  =  41.8661;
    coeffPerformance[ 2 ][ 15 ][ 2 ]  =  4.41475;
    coeffPerformance[ 3 ][ 15 ][ 2 ]  = -3.38190;
    coeffPerformance[ 4 ][ 15 ][ 2 ]  = -58.3793;
    coeffPerformance[ 5 ][ 15 ][ 2 ]  = -30.3096;
    coeffPerformance[ 6 ][ 15 ][ 2 ]  =  12.0483;
    coeffPerformance[ 7 ][ 15 ][ 2 ]  = 0.878907;
    coeffPerformance[ 8 ][ 15 ][ 2 ]  =  1.53327;
    coeffPerformance[ 9 ][ 15 ][ 2 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 2 ] =  0.00000;
    powerMin[ 15 ][ 2 ]               =  1.15807;
    powerMax[ 15 ][ 2 ]               =  2.58777;
    coeffPower[ 0 ][ 15 ][ 2 ]        =  1.73585;
    coeffPower[ 1 ][ 15 ][ 2 ]        =  9.93474;
    coeffPower[ 2 ][ 15 ][ 2 ]        = -.573209;
    coeffPower[ 3 ][ 15 ][ 2 ]        = 0.381798;
    coeffPower[ 4 ][ 15 ][ 2 ]        = -13.7921;
    coeffPower[ 5 ][ 15 ][ 2 ]        = -10.8744;
    coeffPower[ 6 ][ 15 ][ 2 ]        =  4.37458;
    coeffPower[ 7 ][ 15 ][ 2 ]        =  3.36765;
    coeffPower[ 8 ][ 15 ][ 2 ]        = -1.01776;
    coeffPower[ 9 ][ 15 ][ 2 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 2 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 1.50;
    energyMin[ 0 ][ 3 ]               = 0.697617;
    energyMax[ 0 ][ 3 ]               =  1.33297;
    coeffEnergy[ 0 ][ 0 ][ 3 ]        =  1.08476;
    coeffEnergy[ 1 ][ 0 ][ 3 ]        =  5.65643;
    coeffEnergy[ 2 ][ 0 ][ 3 ]        = 0.127365;
    coeffEnergy[ 3 ][ 0 ][ 3 ]        = -.113437;
    coeffEnergy[ 4 ][ 0 ][ 3 ]        = -8.45944;
    coeffEnergy[ 5 ][ 0 ][ 3 ]        = -4.64404;
    coeffEnergy[ 6 ][ 0 ][ 3 ]        =  1.23348;
    coeffEnergy[ 7 ][ 0 ][ 3 ]        = -.413195;
    coeffEnergy[ 8 ][ 0 ][ 3 ]        = 0.605202;
    coeffEnergy[ 9 ][ 0 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 3 ]       =  0.00000;
    performanceMin[ 0 ][ 3 ]          = 0.630594;
    performanceMax[ 0 ][ 3 ]          =  1.10373;
    coeffPerformance[ 0 ][ 0 ][ 3 ]   = 0.781023;
    coeffPerformance[ 1 ][ 0 ][ 3 ]   = 0.833202E-01;
    coeffPerformance[ 2 ][ 0 ][ 3 ]   = 0.128705;
    coeffPerformance[ 3 ][ 0 ][ 3 ]   = -.522493E-01;
    coeffPerformance[ 4 ][ 0 ][ 3 ]   = -.122736;
    coeffPerformance[ 5 ][ 0 ][ 3 ]   =  4.80908;
    coeffPerformance[ 6 ][ 0 ][ 3 ]   = -2.16834;
    coeffPerformance[ 7 ][ 0 ][ 3 ]   = -.532738E-01;
    coeffPerformance[ 8 ][ 0 ][ 3 ]   = -.237629;
    coeffPerformance[ 9 ][ 0 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 3 ]  =  0.00000;
    powerMin[ 0 ][ 3 ]                = 0.577808;
    powerMax[ 0 ][ 3 ]                =  1.09380;
    coeffPower[ 0 ][ 0 ][ 3 ]         = 0.850654;
    coeffPower[ 1 ][ 0 ][ 3 ]         =  4.50883;
    coeffPower[ 2 ][ 0 ][ 3 ]         = 0.191022;
    coeffPower[ 3 ][ 0 ][ 3 ]         = -.117404;
    coeffPower[ 4 ][ 0 ][ 3 ]         = -6.74177;
    coeffPower[ 5 ][ 0 ][ 3 ]         = 0.822861;
    coeffPower[ 6 ][ 0 ][ 3 ]         = -1.09913;
    coeffPower[ 7 ][ 0 ][ 3 ]         = -.386456;
    coeffPower[ 8 ][ 0 ][ 3 ]         = 0.259241;
    coeffPower[ 9 ][ 0 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 3 ]        =  0.00000;
    energyMin[ 1 ][ 3 ]               = 0.730000;
    energyMax[ 1 ][ 3 ]               =  1.32807;
    coeffEnergy[ 0 ][ 1 ][ 3 ]        =  1.09377;
    coeffEnergy[ 1 ][ 1 ][ 3 ]        = 0.278177;
    coeffEnergy[ 2 ][ 1 ][ 3 ]        = -.287073;
    coeffEnergy[ 3 ][ 1 ][ 3 ]        = 0.160692;
    coeffEnergy[ 4 ][ 1 ][ 3 ]        = -.431691;
    coeffEnergy[ 5 ][ 1 ][ 3 ]        = -3.40735;
    coeffEnergy[ 6 ][ 1 ][ 3 ]        = 0.804702;
    coeffEnergy[ 7 ][ 1 ][ 3 ]        = -.566668;
    coeffEnergy[ 8 ][ 1 ][ 3 ]        = 0.765113;
    coeffEnergy[ 9 ][ 1 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 3 ]       =  0.00000;
    performanceMin[ 1 ][ 3 ]          = 0.661137;
    performanceMax[ 1 ][ 3 ]          =  1.14718;
    coeffPerformance[ 0 ][ 1 ][ 3 ]   = 0.845456;
    coeffPerformance[ 1 ][ 1 ][ 3 ]   = 0.602582E-01;
    coeffPerformance[ 2 ][ 1 ][ 3 ]   = 0.133033;
    coeffPerformance[ 3 ][ 1 ][ 3 ]   = -.607018E-01;
    coeffPerformance[ 4 ][ 1 ][ 3 ]   = -.859591E-01;
    coeffPerformance[ 5 ][ 1 ][ 3 ]   =  3.34272;
    coeffPerformance[ 6 ][ 1 ][ 3 ]   = -1.27804;
    coeffPerformance[ 7 ][ 1 ][ 3 ]   = 0.149401;
    coeffPerformance[ 8 ][ 1 ][ 3 ]   = -.466455;
    coeffPerformance[ 9 ][ 1 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 3 ]  =  0.00000;
    powerMin[ 1 ][ 3 ]                = 0.641146;
    powerMax[ 1 ][ 3 ]                =  1.14385;
    coeffPower[ 0 ][ 1 ][ 3 ]         = 0.928478;
    coeffPower[ 1 ][ 1 ][ 3 ]         = 0.217879;
    coeffPower[ 2 ][ 1 ][ 3 ]         = -.135025;
    coeffPower[ 3 ][ 1 ][ 3 ]         = 0.908274E-01;
    coeffPower[ 4 ][ 1 ][ 3 ]         = -.335866;
    coeffPower[ 5 ][ 1 ][ 3 ]         = 0.264533;
    coeffPower[ 6 ][ 1 ][ 3 ]         = -.547334;
    coeffPower[ 7 ][ 1 ][ 3 ]         = -.350552;
    coeffPower[ 8 ][ 1 ][ 3 ]         = 0.205593;
    coeffPower[ 9 ][ 1 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 3 ]        =  0.00000;
    energyMin[ 2 ][ 3 ]               = 0.731336;
    energyMax[ 2 ][ 3 ]               =  1.29956;
    coeffEnergy[ 0 ][ 2 ][ 3 ]        =  1.05223;
    coeffEnergy[ 1 ][ 2 ][ 3 ]        = -1.45244;
    coeffEnergy[ 2 ][ 2 ][ 3 ]        = -.960100;
    coeffEnergy[ 3 ][ 2 ][ 3 ]        = 0.622719;
    coeffEnergy[ 4 ][ 2 ][ 3 ]        =  2.16136;
    coeffEnergy[ 5 ][ 2 ][ 3 ]        = -1.66711;
    coeffEnergy[ 6 ][ 2 ][ 3 ]        = 0.410638;
    coeffEnergy[ 7 ][ 2 ][ 3 ]        = -.499439;
    coeffEnergy[ 8 ][ 2 ][ 3 ]        = 0.652222;
    coeffEnergy[ 9 ][ 2 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 3 ]       =  0.00000;
    performanceMin[ 2 ][ 3 ]          = 0.716795;
    performanceMax[ 2 ][ 3 ]          =  1.18300;
    coeffPerformance[ 0 ][ 2 ][ 3 ]   = 0.919613;
    coeffPerformance[ 1 ][ 2 ][ 3 ]   = -.188817;
    coeffPerformance[ 2 ][ 2 ][ 3 ]   = 0.166087;
    coeffPerformance[ 3 ][ 2 ][ 3 ]   = -.944860E-01;
    coeffPerformance[ 4 ][ 2 ][ 3 ]   = 0.286681;
    coeffPerformance[ 5 ][ 2 ][ 3 ]   =  1.78255;
    coeffPerformance[ 6 ][ 2 ][ 3 ]   = -.635436;
    coeffPerformance[ 7 ][ 2 ][ 3 ]   = 0.144723;
    coeffPerformance[ 8 ][ 2 ][ 3 ]   = -.357059;
    coeffPerformance[ 9 ][ 2 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 3 ]  =  0.00000;
    powerMin[ 2 ][ 3 ]                = 0.704798;
    powerMax[ 2 ][ 3 ]                =  1.17555;
    coeffPower[ 0 ][ 2 ][ 3 ]         = 0.968853;
    coeffPower[ 1 ][ 2 ][ 3 ]         = -1.56312;
    coeffPower[ 2 ][ 2 ][ 3 ]         = -.747156;
    coeffPower[ 3 ][ 2 ][ 3 ]         = 0.498115;
    coeffPower[ 4 ][ 2 ][ 3 ]         =  2.33167;
    coeffPower[ 5 ][ 2 ][ 3 ]         = 0.193725;
    coeffPower[ 6 ][ 2 ][ 3 ]         = -.236601;
    coeffPower[ 7 ][ 2 ][ 3 ]         = -.321213;
    coeffPower[ 8 ][ 2 ][ 3 ]         = 0.245885;
    coeffPower[ 9 ][ 2 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 3 ]        =  0.00000;
    energyMin[ 3 ][ 3 ]               = 0.800000;
    energyMax[ 3 ][ 3 ]               =  1.20000;
    coeffEnergy[ 0 ][ 3 ][ 3 ]        =  1.00000;
    coeffEnergy[ 1 ][ 3 ][ 3 ]        = -.112666E-12;
    coeffEnergy[ 2 ][ 3 ][ 3 ]        = 0.228376E-12;
    coeffEnergy[ 3 ][ 3 ][ 3 ]        = -.153368E-12;
    coeffEnergy[ 4 ][ 3 ][ 3 ]        = 0.167040E-12;
    coeffEnergy[ 5 ][ 3 ][ 3 ]        = -.659233E-12;
    coeffEnergy[ 6 ][ 3 ][ 3 ]        = 0.245874E-12;
    coeffEnergy[ 7 ][ 3 ][ 3 ]        = 0.100374E-12;
    coeffEnergy[ 8 ][ 3 ][ 3 ]        = -.680483E-13;
    coeffEnergy[ 9 ][ 3 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 3 ]       =  0.00000;
    performanceMin[ 3 ][ 3 ]          = 0.800000;
    performanceMax[ 3 ][ 3 ]          =  1.20000;
    coeffPerformance[ 0 ][ 3 ][ 3 ]   =  1.00000;
    coeffPerformance[ 1 ][ 3 ][ 3 ]   = 0.214039E-13;
    coeffPerformance[ 2 ][ 3 ][ 3 ]   = -.179314E-13;
    coeffPerformance[ 3 ][ 3 ][ 3 ]   = 0.120462E-13;
    coeffPerformance[ 4 ][ 3 ][ 3 ]   = -.321666E-13;
    coeffPerformance[ 5 ][ 3 ][ 3 ]   = -.157418E-13;
    coeffPerformance[ 6 ][ 3 ][ 3 ]   = 0.645891E-14;
    coeffPerformance[ 7 ][ 3 ][ 3 ]   = 0.291680E-14;
    coeffPerformance[ 8 ][ 3 ][ 3 ]   = -.254372E-14;
    coeffPerformance[ 9 ][ 3 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 3 ]  =  0.00000;
    powerMin[ 3 ][ 3 ]                = 0.800000;
    powerMax[ 3 ][ 3 ]                =  1.20000;
    coeffPower[ 0 ][ 3 ][ 3 ]         =  1.00000;
    coeffPower[ 1 ][ 3 ][ 3 ]         = 0.401826E-12;
    coeffPower[ 2 ][ 3 ][ 3 ]         = -.130667E-12;
    coeffPower[ 3 ][ 3 ][ 3 ]         = 0.102378E-12;
    coeffPower[ 4 ][ 3 ][ 3 ]         = -.587610E-12;
    coeffPower[ 5 ][ 3 ][ 3 ]         = 0.879319E-12;
    coeffPower[ 6 ][ 3 ][ 3 ]         = -.473720E-12;
    coeffPower[ 7 ][ 3 ][ 3 ]         = 0.250297E-12;
    coeffPower[ 8 ][ 3 ][ 3 ]         = -.246085E-12;
    coeffPower[ 9 ][ 3 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 3 ]        =  0.00000;
    energyMin[ 4 ][ 3 ]               = 0.746932;
    energyMax[ 4 ][ 3 ]               =  1.30358;
    coeffEnergy[ 0 ][ 4 ][ 3 ]        = 0.976943;
    coeffEnergy[ 1 ][ 4 ][ 3 ]        = -.283233;
    coeffEnergy[ 2 ][ 4 ][ 3 ]        = -.175277;
    coeffEnergy[ 3 ][ 4 ][ 3 ]        = 0.129340;
    coeffEnergy[ 4 ][ 4 ][ 3 ]        = 0.422529;
    coeffEnergy[ 5 ][ 4 ][ 3 ]        =  2.10320;
    coeffEnergy[ 6 ][ 4 ][ 3 ]        = -1.00469;
    coeffEnergy[ 7 ][ 4 ][ 3 ]        = 0.121465;
    coeffEnergy[ 8 ][ 4 ][ 3 ]        = -.639806E-01;
    coeffEnergy[ 9 ][ 4 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 3 ]       =  0.00000;
    performanceMin[ 4 ][ 3 ]          = 0.778003;
    performanceMax[ 4 ][ 3 ]          =  1.35721;
    coeffPerformance[ 0 ][ 4 ][ 3 ]   =  1.04991;
    coeffPerformance[ 1 ][ 4 ][ 3 ]   = 0.273531;
    coeffPerformance[ 2 ][ 4 ][ 3 ]   = -.455126E-01;
    coeffPerformance[ 3 ][ 4 ][ 3 ]   = 0.244963E-01;
    coeffPerformance[ 4 ][ 4 ][ 3 ]   = -.398004;
    coeffPerformance[ 5 ][ 4 ][ 3 ]   = -1.79720;
    coeffPerformance[ 6 ][ 4 ][ 3 ]   = 0.834315;
    coeffPerformance[ 7 ][ 4 ][ 3 ]   = 0.223175;
    coeffPerformance[ 8 ][ 4 ][ 3 ]   = -.171258;
    coeffPerformance[ 9 ][ 4 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 3 ]  =  0.00000;
    powerMin[ 4 ][ 3 ]                = 0.820960;
    powerMax[ 4 ][ 3 ]                =  1.33121;
    coeffPower[ 0 ][ 4 ][ 3 ]         =  1.02587;
    coeffPower[ 1 ][ 4 ][ 3 ]         = -.130102E-02;
    coeffPower[ 2 ][ 4 ][ 3 ]         = -.207194;
    coeffPower[ 3 ][ 4 ][ 3 ]         = 0.145431;
    coeffPower[ 4 ][ 4 ][ 3 ]         = 0.115143E-01;
    coeffPower[ 5 ][ 4 ][ 3 ]         = 0.373074;
    coeffPower[ 6 ][ 4 ][ 3 ]         = -.194829;
    coeffPower[ 7 ][ 4 ][ 3 ]         = 0.369325;
    coeffPower[ 8 ][ 4 ][ 3 ]         = -.262968;
    coeffPower[ 9 ][ 4 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 3 ]        =  0.00000;
    energyMin[ 5 ][ 3 ]               = 0.736408;
    energyMax[ 5 ][ 3 ]               =  1.32576;
    coeffEnergy[ 0 ][ 5 ][ 3 ]        = 0.968970;
    coeffEnergy[ 1 ][ 5 ][ 3 ]        = -2.68150;
    coeffEnergy[ 2 ][ 5 ][ 3 ]        = -.335929;
    coeffEnergy[ 3 ][ 5 ][ 3 ]        = 0.249097;
    coeffEnergy[ 4 ][ 5 ][ 3 ]        =  4.00571;
    coeffEnergy[ 5 ][ 5 ][ 3 ]        =  3.12101;
    coeffEnergy[ 6 ][ 5 ][ 3 ]        = -1.36948;
    coeffEnergy[ 7 ][ 5 ][ 3 ]        = 0.349916;
    coeffEnergy[ 8 ][ 5 ][ 3 ]        = -.410569;
    coeffEnergy[ 9 ][ 5 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 3 ]       =  0.00000;
    performanceMin[ 5 ][ 3 ]          = 0.819518;
    performanceMax[ 5 ][ 3 ]          =  1.44340;
    coeffPerformance[ 0 ][ 5 ][ 3 ]   =  1.11773;
    coeffPerformance[ 1 ][ 5 ][ 3 ]   =  1.51132;
    coeffPerformance[ 2 ][ 5 ][ 3 ]   = -.436761E-01;
    coeffPerformance[ 3 ][ 5 ][ 3 ]   = 0.631048E-02;
    coeffPerformance[ 4 ][ 5 ][ 3 ]   = -2.24626;
    coeffPerformance[ 5 ][ 5 ][ 3 ]   = -3.72484;
    coeffPerformance[ 6 ][ 5 ][ 3 ]   =  1.50294;
    coeffPerformance[ 7 ][ 5 ][ 3 ]   = 0.976838E-01;
    coeffPerformance[ 8 ][ 5 ][ 3 ]   = 0.176115;
    coeffPerformance[ 9 ][ 5 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 3 ]  =  0.00000;
    powerMin[ 5 ][ 3 ]                = 0.843393;
    powerMax[ 5 ][ 3 ]                =  1.44845;
    coeffPower[ 0 ][ 5 ][ 3 ]         =  1.08454;
    coeffPower[ 1 ][ 5 ][ 3 ]         = -1.45904;
    coeffPower[ 2 ][ 5 ][ 3 ]         = -.392665;
    coeffPower[ 3 ][ 5 ][ 3 ]         = 0.265864;
    coeffPower[ 4 ][ 5 ][ 3 ]         =  2.19011;
    coeffPower[ 5 ][ 5 ][ 3 ]         = -.401587;
    coeffPower[ 6 ][ 5 ][ 3 ]         = 0.416818E-01;
    coeffPower[ 7 ][ 5 ][ 3 ]         = 0.489114;
    coeffPower[ 8 ][ 5 ][ 3 ]         = -.279085;
    coeffPower[ 9 ][ 5 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 3 ]        =  0.00000;
    energyMin[ 6 ][ 3 ]               = 0.728814;
    energyMax[ 6 ][ 3 ]               =  1.35852;
    coeffEnergy[ 0 ][ 6 ][ 3 ]        = 0.970981;
    coeffEnergy[ 1 ][ 6 ][ 3 ]        = -5.12899;
    coeffEnergy[ 2 ][ 6 ][ 3 ]        = -.433276;
    coeffEnergy[ 3 ][ 6 ][ 3 ]        = 0.325345;
    coeffEnergy[ 4 ][ 6 ][ 3 ]        =  7.66057;
    coeffEnergy[ 5 ][ 6 ][ 3 ]        =  3.73852;
    coeffEnergy[ 6 ][ 6 ][ 3 ]        = -1.48005;
    coeffEnergy[ 7 ][ 6 ][ 3 ]        = 0.563420;
    coeffEnergy[ 8 ][ 6 ][ 3 ]        = -.816328;
    coeffEnergy[ 9 ][ 6 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 3 ]       =  0.00000;
    performanceMin[ 6 ][ 3 ]          = 0.828473;
    performanceMax[ 6 ][ 3 ]          =  1.53080;
    coeffPerformance[ 0 ][ 6 ][ 3 ]   =  1.17587;
    coeffPerformance[ 1 ][ 6 ][ 3 ]   =  3.02456;
    coeffPerformance[ 2 ][ 6 ][ 3 ]   = -.172701;
    coeffPerformance[ 3 ][ 6 ][ 3 ]   = 0.750123E-01;
    coeffPerformance[ 4 ][ 6 ][ 3 ]   = -4.50158;
    coeffPerformance[ 5 ][ 6 ][ 3 ]   = -5.50632;
    coeffPerformance[ 6 ][ 6 ][ 3 ]   =  2.09303;
    coeffPerformance[ 7 ][ 6 ][ 3 ]   = -.120332;
    coeffPerformance[ 8 ][ 6 ][ 3 ]   = 0.673493;
    coeffPerformance[ 9 ][ 6 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 3 ]  =  0.00000;
    powerMin[ 6 ][ 3 ]                = 0.865884;
    powerMax[ 6 ][ 3 ]                =  1.52564;
    coeffPower[ 0 ][ 6 ][ 3 ]         =  1.14341;
    coeffPower[ 1 ][ 6 ][ 3 ]         = -2.86075;
    coeffPower[ 2 ][ 6 ][ 3 ]         = -.641175;
    coeffPower[ 3 ][ 6 ][ 3 ]         = 0.427251;
    coeffPower[ 4 ][ 6 ][ 3 ]         =  4.28760;
    coeffPower[ 5 ][ 6 ][ 3 ]         = -1.44630;
    coeffPower[ 6 ][ 6 ][ 3 ]         = 0.477819;
    coeffPower[ 7 ][ 6 ][ 3 ]         = 0.535025;
    coeffPower[ 8 ][ 6 ][ 3 ]         = -.245535;
    coeffPower[ 9 ][ 6 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 3 ]        =  0.00000;
    energyMin[ 7 ][ 3 ]               = 0.727561;
    energyMax[ 7 ][ 3 ]               =  1.41137;
    coeffEnergy[ 0 ][ 7 ][ 3 ]        = 0.976493;
    coeffEnergy[ 1 ][ 7 ][ 3 ]        = -7.53509;
    coeffEnergy[ 2 ][ 7 ][ 3 ]        = -.667000;
    coeffEnergy[ 3 ][ 7 ][ 3 ]        = 0.485713;
    coeffEnergy[ 4 ][ 7 ][ 3 ]        =  11.2552;
    coeffEnergy[ 5 ][ 7 ][ 3 ]        =  5.21079;
    coeffEnergy[ 6 ][ 7 ][ 3 ]        = -2.30505;
    coeffEnergy[ 7 ][ 7 ][ 3 ]        = 0.370578;
    coeffEnergy[ 8 ][ 7 ][ 3 ]        = -.516881;
    coeffEnergy[ 9 ][ 7 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 3 ]       =  0.00000;
    performanceMin[ 7 ][ 3 ]          = 0.833065;
    performanceMax[ 7 ][ 3 ]          =  1.61578;
    coeffPerformance[ 0 ][ 7 ][ 3 ]   =  1.21831;
    coeffPerformance[ 1 ][ 7 ][ 3 ]   =  6.20894;
    coeffPerformance[ 2 ][ 7 ][ 3 ]   = 0.148577;
    coeffPerformance[ 3 ][ 7 ][ 3 ]   = -.145905;
    coeffPerformance[ 4 ][ 7 ][ 3 ]   = -9.25319;
    coeffPerformance[ 5 ][ 7 ][ 3 ]   = -7.91285;
    coeffPerformance[ 6 ][ 7 ][ 3 ]   =  3.40254;
    coeffPerformance[ 7 ][ 7 ][ 3 ]   = 0.371113;
    coeffPerformance[ 8 ][ 7 ][ 3 ]   = 0.192429;
    coeffPerformance[ 9 ][ 7 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 3 ]  =  0.00000;
    powerMin[ 7 ][ 3 ]                = 0.891036;
    powerMax[ 7 ][ 3 ]                =  1.62491;
    coeffPower[ 0 ][ 7 ][ 3 ]         =  1.18917;
    coeffPower[ 1 ][ 7 ][ 3 ]         = -2.64629;
    coeffPower[ 2 ][ 7 ][ 3 ]         = -.605500;
    coeffPower[ 3 ][ 7 ][ 3 ]         = 0.402921;
    coeffPower[ 4 ][ 7 ][ 3 ]         =  3.97321;
    coeffPower[ 5 ][ 7 ][ 3 ]         = -2.17365;
    coeffPower[ 6 ][ 7 ][ 3 ]         = 0.854038;
    coeffPower[ 7 ][ 7 ][ 3 ]         = 0.870410;
    coeffPower[ 8 ][ 7 ][ 3 ]         = -.437095;
    coeffPower[ 9 ][ 7 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 3 ]        =  0.00000;
    energyMin[ 8 ][ 3 ]               = 0.723492;
    energyMax[ 8 ][ 3 ]               =  1.44663;
    coeffEnergy[ 0 ][ 8 ][ 3 ]        = 0.975714;
    coeffEnergy[ 1 ][ 8 ][ 3 ]        = -9.94975;
    coeffEnergy[ 2 ][ 8 ][ 3 ]        = -1.40581;
    coeffEnergy[ 3 ][ 8 ][ 3 ]        = 0.988694;
    coeffEnergy[ 4 ][ 8 ][ 3 ]        =  14.8668;
    coeffEnergy[ 5 ][ 8 ][ 3 ]        =  6.17660;
    coeffEnergy[ 6 ][ 8 ][ 3 ]        = -2.70930;
    coeffEnergy[ 7 ][ 8 ][ 3 ]        = 0.351410;
    coeffEnergy[ 8 ][ 8 ][ 3 ]        = -.488645;
    coeffEnergy[ 9 ][ 8 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 3 ]       =  0.00000;
    performanceMin[ 8 ][ 3 ]          = 0.839265;
    performanceMax[ 8 ][ 3 ]          =  1.70197;
    coeffPerformance[ 0 ][ 8 ][ 3 ]   =  1.27626;
    coeffPerformance[ 1 ][ 8 ][ 3 ]   =  9.38836;
    coeffPerformance[ 2 ][ 8 ][ 3 ]   = 0.606697;
    coeffPerformance[ 3 ][ 8 ][ 3 ]   = -.467757;
    coeffPerformance[ 4 ][ 8 ][ 3 ]   = -14.0045;
    coeffPerformance[ 5 ][ 8 ][ 3 ]   = -10.1308;
    coeffPerformance[ 6 ][ 8 ][ 3 ]   =  4.35347;
    coeffPerformance[ 7 ][ 8 ][ 3 ]   = 0.485304;
    coeffPerformance[ 8 ][ 8 ][ 3 ]   = 0.261095;
    coeffPerformance[ 9 ][ 8 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 3 ]  =  0.00000;
    powerMin[ 8 ][ 3 ]                = 0.914300;
    powerMax[ 8 ][ 3 ]                =  1.74495;
    coeffPower[ 0 ][ 8 ][ 3 ]         =  1.24173;
    coeffPower[ 1 ][ 8 ][ 3 ]         = -2.54098;
    coeffPower[ 2 ][ 8 ][ 3 ]         = -.964538;
    coeffPower[ 3 ][ 8 ][ 3 ]         = 0.638930;
    coeffPower[ 4 ][ 8 ][ 3 ]         =  3.82044;
    coeffPower[ 5 ][ 8 ][ 3 ]         = -3.20987;
    coeffPower[ 6 ][ 8 ][ 3 ]         =  1.30914;
    coeffPower[ 7 ][ 8 ][ 3 ]         =  1.03353;
    coeffPower[ 8 ][ 8 ][ 3 ]         = -.385574;
    coeffPower[ 9 ][ 8 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 3 ]        =  0.00000;
    energyMin[ 9 ][ 3 ]               = 0.727101;
    energyMax[ 9 ][ 3 ]               =  1.49093;
    coeffEnergy[ 0 ][ 9 ][ 3 ]        = 0.986275;
    coeffEnergy[ 1 ][ 9 ][ 3 ]        = -11.5447;
    coeffEnergy[ 2 ][ 9 ][ 3 ]        = -1.42057;
    coeffEnergy[ 3 ][ 9 ][ 3 ]        =  1.00454;
    coeffEnergy[ 4 ][ 9 ][ 3 ]        =  17.2450;
    coeffEnergy[ 5 ][ 9 ][ 3 ]        =  7.22637;
    coeffEnergy[ 6 ][ 9 ][ 3 ]        = -3.14412;
    coeffEnergy[ 7 ][ 9 ][ 3 ]        = 0.449555;
    coeffEnergy[ 8 ][ 9 ][ 3 ]        = -.546063;
    coeffEnergy[ 9 ][ 9 ][ 3 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 3 ]       =  0.00000;
    performanceMin[ 9 ][ 3 ]          = 0.842250;
    performanceMax[ 9 ][ 3 ]          =  1.78513;
    coeffPerformance[ 0 ][ 9 ][ 3 ]   =  1.30729;
    coeffPerformance[ 1 ][ 9 ][ 3 ]   =  12.0537;
    coeffPerformance[ 2 ][ 9 ][ 3 ]   = 0.548221;
    coeffPerformance[ 3 ][ 9 ][ 3 ]   = -.437036;
    coeffPerformance[ 4 ][ 9 ][ 3 ]   = -17.9714;
    coeffPerformance[ 5 ][ 9 ][ 3 ]   = -11.7185;
    coeffPerformance[ 6 ][ 9 ][ 3 ]   =  4.96448;
    coeffPerformance[ 7 ][ 9 ][ 3 ]   = 0.484426;
    coeffPerformance[ 8 ][ 9 ][ 3 ]   = 0.386161;
    coeffPerformance[ 9 ][ 9 ][ 3 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 3 ]  =  0.00000;
    powerMin[ 9 ][ 3 ]                = 0.942015;
    powerMax[ 9 ][ 3 ]                =  1.81709;
    coeffPower[ 0 ][ 9 ][ 3 ]         =  1.28228;
    coeffPower[ 1 ][ 9 ][ 3 ]         = -2.02221;
    coeffPower[ 2 ][ 9 ][ 3 ]         = -1.07953;
    coeffPower[ 3 ][ 9 ][ 3 ]         = 0.715314;
    coeffPower[ 4 ][ 9 ][ 3 ]         =  3.05512;
    coeffPower[ 5 ][ 9 ][ 3 ]         = -3.57383;
    coeffPower[ 6 ][ 9 ][ 3 ]         =  1.39952;
    coeffPower[ 7 ][ 9 ][ 3 ]         =  1.23093;
    coeffPower[ 8 ][ 9 ][ 3 ]         = -.373931;
    coeffPower[ 9 ][ 9 ][ 3 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 3 ]        =  0.00000;
    energyMin[ 10 ][ 3 ]              = 0.727984;
    energyMax[ 10 ][ 3 ]              =  1.55578;
    coeffEnergy[ 0 ][ 10 ][ 3 ]       = 0.995331;
    coeffEnergy[ 1 ][ 10 ][ 3 ]       = -13.3339;
    coeffEnergy[ 2 ][ 10 ][ 3 ]       = -1.95144;
    coeffEnergy[ 3 ][ 10 ][ 3 ]       =  1.36624;
    coeffEnergy[ 4 ][ 10 ][ 3 ]       =  19.9177;
    coeffEnergy[ 5 ][ 10 ][ 3 ]       =  8.16209;
    coeffEnergy[ 6 ][ 10 ][ 3 ]       = -3.58366;
    coeffEnergy[ 7 ][ 10 ][ 3 ]       = 0.468678;
    coeffEnergy[ 8 ][ 10 ][ 3 ]       = -.510219;
    coeffEnergy[ 9 ][ 10 ][ 3 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 3 ]      =  0.00000;
    performanceMin[ 10 ][ 3 ]         = 0.844547;
    performanceMax[ 10 ][ 3 ]         =  1.86829;
    coeffPerformance[ 0 ][ 10 ][ 3 ]  =  1.35673;
    coeffPerformance[ 1 ][ 10 ][ 3 ]  =  14.9868;
    coeffPerformance[ 2 ][ 10 ][ 3 ]  =  1.00827;
    coeffPerformance[ 3 ][ 10 ][ 3 ]  = -.758061;
    coeffPerformance[ 4 ][ 10 ][ 3 ]  = -22.3489;
    coeffPerformance[ 5 ][ 10 ][ 3 ]  = -13.7638;
    coeffPerformance[ 6 ][ 10 ][ 3 ]  =  5.88028;
    coeffPerformance[ 7 ][ 10 ][ 3 ]  = 0.545624;
    coeffPerformance[ 8 ][ 10 ][ 3 ]  = 0.433758;
    coeffPerformance[ 9 ][ 10 ][ 3 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 3 ] =  0.00000;
    powerMin[ 10 ][ 3 ]               = 0.968213;
    powerMax[ 10 ][ 3 ]               =  1.93917;
    coeffPower[ 0 ][ 10 ][ 3 ]        =  1.34277;
    coeffPower[ 1 ][ 10 ][ 3 ]        = -1.47062;
    coeffPower[ 2 ][ 10 ][ 3 ]        = -1.20262;
    coeffPower[ 3 ][ 10 ][ 3 ]        = 0.791797;
    coeffPower[ 4 ][ 10 ][ 3 ]        =  2.23479;
    coeffPower[ 5 ][ 10 ][ 3 ]        = -4.57655;
    coeffPower[ 6 ][ 10 ][ 3 ]        =  1.81087;
    coeffPower[ 7 ][ 10 ][ 3 ]        =  1.37040;
    coeffPower[ 8 ][ 10 ][ 3 ]        = -.302923;
    coeffPower[ 9 ][ 10 ][ 3 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 3 ]       =  0.00000;
    energyMin[ 11 ][ 3 ]              = 0.732666;
    energyMax[ 11 ][ 3 ]              =  1.62433;
    coeffEnergy[ 0 ][ 11 ][ 3 ]       =  1.01207;
    coeffEnergy[ 1 ][ 11 ][ 3 ]       = -15.3577;
    coeffEnergy[ 2 ][ 11 ][ 3 ]       = -1.96772;
    coeffEnergy[ 3 ][ 11 ][ 3 ]       =  1.38314;
    coeffEnergy[ 4 ][ 11 ][ 3 ]       =  22.9390;
    coeffEnergy[ 5 ][ 11 ][ 3 ]       =  9.58665;
    coeffEnergy[ 6 ][ 11 ][ 3 ]       = -4.24266;
    coeffEnergy[ 7 ][ 11 ][ 3 ]       = 0.307144;
    coeffEnergy[ 8 ][ 11 ][ 3 ]       = -.411001;
    coeffEnergy[ 9 ][ 11 ][ 3 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 3 ]      =  0.00000;
    performanceMin[ 11 ][ 3 ]         = 0.849598;
    performanceMax[ 11 ][ 3 ]         =  1.95751;
    coeffPerformance[ 0 ][ 11 ][ 3 ]  =  1.40124;
    coeffPerformance[ 1 ][ 11 ][ 3 ]  =  18.2030;
    coeffPerformance[ 2 ][ 11 ][ 3 ]  =  1.10415;
    coeffPerformance[ 3 ][ 11 ][ 3 ]  = -.835155;
    coeffPerformance[ 4 ][ 11 ][ 3 ]  = -27.1473;
    coeffPerformance[ 5 ][ 11 ][ 3 ]  = -16.2227;
    coeffPerformance[ 6 ][ 11 ][ 3 ]  =  6.99290;
    coeffPerformance[ 7 ][ 11 ][ 3 ]  = 0.747631;
    coeffPerformance[ 8 ][ 11 ][ 3 ]  = 0.441164;
    coeffPerformance[ 9 ][ 11 ][ 3 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 3 ] =  0.00000;
    powerMin[ 11 ][ 3 ]               = 0.999975;
    powerMax[ 11 ][ 3 ]               =  2.04244;
    coeffPower[ 0 ][ 11 ][ 3 ]        =  1.40208;
    coeffPower[ 1 ][ 11 ][ 3 ]        = -.928101;
    coeffPower[ 2 ][ 11 ][ 3 ]        = -1.16716;
    coeffPower[ 3 ][ 11 ][ 3 ]        = 0.763427;
    coeffPower[ 4 ][ 11 ][ 3 ]        =  1.43049;
    coeffPower[ 5 ][ 11 ][ 3 ]        = -5.45554;
    coeffPower[ 6 ][ 11 ][ 3 ]        =  2.19571;
    coeffPower[ 7 ][ 11 ][ 3 ]        =  1.52150;
    coeffPower[ 8 ][ 11 ][ 3 ]        = -.259559;
    coeffPower[ 9 ][ 11 ][ 3 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 3 ]       =  0.00000;
    energyMin[ 12 ][ 3 ]              = 0.735877;
    energyMax[ 12 ][ 3 ]              =  1.66618;
    coeffEnergy[ 0 ][ 12 ][ 3 ]       =  1.03243;
    coeffEnergy[ 1 ][ 12 ][ 3 ]       = -17.8012;
    coeffEnergy[ 2 ][ 12 ][ 3 ]       = -2.24979;
    coeffEnergy[ 3 ][ 12 ][ 3 ]       =  1.57848;
    coeffEnergy[ 4 ][ 12 ][ 3 ]       =  26.5863;
    coeffEnergy[ 5 ][ 12 ][ 3 ]       =  10.6830;
    coeffEnergy[ 6 ][ 12 ][ 3 ]       = -4.68803;
    coeffEnergy[ 7 ][ 12 ][ 3 ]       = 0.197427;
    coeffEnergy[ 8 ][ 12 ][ 3 ]       = -.463177;
    coeffEnergy[ 9 ][ 12 ][ 3 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 3 ]      =  0.00000;
    performanceMin[ 12 ][ 3 ]         = 0.850057;
    performanceMax[ 12 ][ 3 ]         =  2.04431;
    coeffPerformance[ 0 ][ 12 ][ 3 ]  =  1.44779;
    coeffPerformance[ 1 ][ 12 ][ 3 ]  =  21.7983;
    coeffPerformance[ 2 ][ 12 ][ 3 ]  =  1.36825;
    coeffPerformance[ 3 ][ 12 ][ 3 ]  = -1.02675;
    coeffPerformance[ 4 ][ 12 ][ 3 ]  = -32.5128;
    coeffPerformance[ 5 ][ 12 ][ 3 ]  = -18.4188;
    coeffPerformance[ 6 ][ 12 ][ 3 ]  =  7.88069;
    coeffPerformance[ 7 ][ 12 ][ 3 ]  = 0.790771;
    coeffPerformance[ 8 ][ 12 ][ 3 ]  = 0.635653;
    coeffPerformance[ 9 ][ 12 ][ 3 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 3 ] =  0.00000;
    powerMin[ 12 ][ 3 ]               =  1.03078;
    powerMax[ 12 ][ 3 ]               =  2.12404;
    coeffPower[ 0 ][ 12 ][ 3 ]        =  1.47385;
    coeffPower[ 1 ][ 12 ][ 3 ]        = -.454981;
    coeffPower[ 2 ][ 12 ][ 3 ]        = -1.26482;
    coeffPower[ 3 ][ 12 ][ 3 ]        = 0.820924;
    coeffPower[ 4 ][ 12 ][ 3 ]        = 0.725741;
    coeffPower[ 5 ][ 12 ][ 3 ]        = -6.52275;
    coeffPower[ 6 ][ 12 ][ 3 ]        =  2.60738;
    coeffPower[ 7 ][ 12 ][ 3 ]        =  1.48983;
    coeffPower[ 8 ][ 12 ][ 3 ]        = -.125630;
    coeffPower[ 9 ][ 12 ][ 3 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 3 ]       =  0.00000;
    energyMin[ 13 ][ 3 ]              = 0.744508;
    energyMax[ 13 ][ 3 ]              =  1.72226;
    coeffEnergy[ 0 ][ 13 ][ 3 ]       =  1.03521;
    coeffEnergy[ 1 ][ 13 ][ 3 ]       = -18.4386;
    coeffEnergy[ 2 ][ 13 ][ 3 ]       = -2.13802;
    coeffEnergy[ 3 ][ 13 ][ 3 ]       =  1.51568;
    coeffEnergy[ 4 ][ 13 ][ 3 ]       =  27.5400;
    coeffEnergy[ 5 ][ 13 ][ 3 ]       =  11.9835;
    coeffEnergy[ 6 ][ 13 ][ 3 ]       = -5.19707;
    coeffEnergy[ 7 ][ 13 ][ 3 ]       = 0.469159;
    coeffEnergy[ 8 ][ 13 ][ 3 ]       = -.706389;
    coeffEnergy[ 9 ][ 13 ][ 3 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 3 ]      =  0.00000;
    performanceMin[ 13 ][ 3 ]         = 0.853042;
    performanceMax[ 13 ][ 3 ]         =  2.12625;
    coeffPerformance[ 0 ][ 13 ][ 3 ]  =  1.49916;
    coeffPerformance[ 1 ][ 13 ][ 3 ]  =  23.5398;
    coeffPerformance[ 2 ][ 13 ][ 3 ]  =  1.45096;
    coeffPerformance[ 3 ][ 13 ][ 3 ]  = -1.09863;
    coeffPerformance[ 4 ][ 13 ][ 3 ]  = -35.1080;
    coeffPerformance[ 5 ][ 13 ][ 3 ]  = -20.7039;
    coeffPerformance[ 6 ][ 13 ][ 3 ]  =  8.79019;
    coeffPerformance[ 7 ][ 13 ][ 3 ]  = 0.638688;
    coeffPerformance[ 8 ][ 13 ][ 3 ]  = 0.925905;
    coeffPerformance[ 9 ][ 13 ][ 3 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 3 ] =  0.00000;
    powerMin[ 13 ][ 3 ]               =  1.06380;
    powerMax[ 13 ][ 3 ]               =  2.21232;
    coeffPower[ 0 ][ 13 ][ 3 ]        =  1.52884;
    coeffPower[ 1 ][ 13 ][ 3 ]        = 0.235296;
    coeffPower[ 2 ][ 13 ][ 3 ]        = -1.04638;
    coeffPower[ 3 ][ 13 ][ 3 ]        = 0.671328;
    coeffPower[ 4 ][ 13 ][ 3 ]        = -.295263;
    coeffPower[ 5 ][ 13 ][ 3 ]        = -7.43070;
    coeffPower[ 6 ][ 13 ][ 3 ]        =  2.92830;
    coeffPower[ 7 ][ 13 ][ 3 ]        =  1.72372;
    coeffPower[ 8 ][ 13 ][ 3 ]        = -.896353E-01;
    coeffPower[ 9 ][ 13 ][ 3 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 3 ]       =  0.00000;
    energyMin[ 14 ][ 3 ]              = 0.752527;
    energyMax[ 14 ][ 3 ]              =  1.78172;
    coeffEnergy[ 0 ][ 14 ][ 3 ]       =  1.04826;
    coeffEnergy[ 1 ][ 14 ][ 3 ]       = -20.5513;
    coeffEnergy[ 2 ][ 14 ][ 3 ]       = -2.54831;
    coeffEnergy[ 3 ][ 14 ][ 3 ]       =  1.80206;
    coeffEnergy[ 4 ][ 14 ][ 3 ]       =  30.6981;
    coeffEnergy[ 5 ][ 14 ][ 3 ]       =  13.4858;
    coeffEnergy[ 6 ][ 14 ][ 3 ]       = -5.89907;
    coeffEnergy[ 7 ][ 14 ][ 3 ]       = 0.435892;
    coeffEnergy[ 8 ][ 14 ][ 3 ]       = -.794563;
    coeffEnergy[ 9 ][ 14 ][ 3 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 3 ]      =  0.00000;
    performanceMin[ 14 ][ 3 ]         = 0.856257;
    performanceMax[ 14 ][ 3 ]         =  2.21305;
    coeffPerformance[ 0 ][ 14 ][ 3 ]  =  1.55193;
    coeffPerformance[ 1 ][ 14 ][ 3 ]  =  28.3241;
    coeffPerformance[ 2 ][ 14 ][ 3 ]  =  2.09564;
    coeffPerformance[ 3 ][ 14 ][ 3 ]  = -1.54557;
    coeffPerformance[ 4 ][ 14 ][ 3 ]  = -42.2562;
    coeffPerformance[ 5 ][ 14 ][ 3 ]  = -23.0077;
    coeffPerformance[ 6 ][ 14 ][ 3 ]  =  9.80627;
    coeffPerformance[ 7 ][ 14 ][ 3 ]  = 0.789430;
    coeffPerformance[ 8 ][ 14 ][ 3 ]  = 0.971832;
    coeffPerformance[ 9 ][ 14 ][ 3 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 3 ] =  0.00000;
    powerMin[ 14 ][ 3 ]               =  1.09708;
    powerMax[ 14 ][ 3 ]               =  2.31740;
    coeffPower[ 0 ][ 14 ][ 3 ]        =  1.59889;
    coeffPower[ 1 ][ 14 ][ 3 ]        =  2.19781;
    coeffPower[ 2 ][ 14 ][ 3 ]        = -.929561;
    coeffPower[ 3 ][ 14 ][ 3 ]        = 0.590235;
    coeffPower[ 4 ][ 14 ][ 3 ]        = -3.22314;
    coeffPower[ 5 ][ 14 ][ 3 ]        = -8.29872;
    coeffPower[ 6 ][ 14 ][ 3 ]        =  3.25319;
    coeffPower[ 7 ][ 14 ][ 3 ]        =  1.93359;
    coeffPower[ 8 ][ 14 ][ 3 ]        = -.162789;
    coeffPower[ 9 ][ 14 ][ 3 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 3 ]       =  0.00000;
    energyMin[ 15 ][ 3 ]              = 0.764436;
    energyMax[ 15 ][ 3 ]              =  1.83271;
    coeffEnergy[ 0 ][ 15 ][ 3 ]       =  1.06737;
    coeffEnergy[ 1 ][ 15 ][ 3 ]       = -19.5766;
    coeffEnergy[ 2 ][ 15 ][ 3 ]       = -1.89228;
    coeffEnergy[ 3 ][ 15 ][ 3 ]       =  1.37450;
    coeffEnergy[ 4 ][ 15 ][ 3 ]       =  29.2339;
    coeffEnergy[ 5 ][ 15 ][ 3 ]       =  15.1573;
    coeffEnergy[ 6 ][ 15 ][ 3 ]       = -6.55009;
    coeffEnergy[ 7 ][ 15 ][ 3 ]       = 0.592032;
    coeffEnergy[ 8 ][ 15 ][ 3 ]       = -1.09944;
    coeffEnergy[ 9 ][ 15 ][ 3 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 3 ]      =  0.00000;
    performanceMin[ 15 ][ 3 ]         = 0.856946;
    performanceMax[ 15 ][ 3 ]         =  2.29621;
    coeffPerformance[ 0 ][ 15 ][ 3 ]  =  1.59640;
    coeffPerformance[ 1 ][ 15 ][ 3 ]  =  26.9022;
    coeffPerformance[ 2 ][ 15 ][ 3 ]  =  1.00207;
    coeffPerformance[ 3 ][ 15 ][ 3 ]  = -.830780;
    coeffPerformance[ 4 ][ 15 ][ 3 ]  = -40.1139;
    coeffPerformance[ 5 ][ 15 ][ 3 ]  = -26.0535;
    coeffPerformance[ 6 ][ 15 ][ 3 ]  =  11.0994;
    coeffPerformance[ 7 ][ 15 ][ 3 ]  = 0.691666;
    coeffPerformance[ 8 ][ 15 ][ 3 ]  =  1.30623;
    coeffPerformance[ 9 ][ 15 ][ 3 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 3 ] =  0.00000;
    powerMin[ 15 ][ 3 ]               =  1.13289;
    powerMax[ 15 ][ 3 ]               =  2.44848;
    coeffPower[ 0 ][ 15 ][ 3 ]        =  1.66462;
    coeffPower[ 1 ][ 15 ][ 3 ]        =  2.47451;
    coeffPower[ 2 ][ 15 ][ 3 ]        = -1.22783;
    coeffPower[ 3 ][ 15 ][ 3 ]        = 0.786768;
    coeffPower[ 4 ][ 15 ][ 3 ]        = -3.62479;
    coeffPower[ 5 ][ 15 ][ 3 ]        = -9.56970;
    coeffPower[ 6 ][ 15 ][ 3 ]        =  3.84732;
    coeffPower[ 7 ][ 15 ][ 3 ]        =  2.19897;
    coeffPower[ 8 ][ 15 ][ 3 ]        = -.269060;
    coeffPower[ 9 ][ 15 ][ 3 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 3 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 1.60;
    energyMin[ 0 ][ 4 ]               = 0.687557;
    energyMax[ 0 ][ 4 ]               =  1.35623;
    coeffEnergy[ 0 ][ 0 ][ 4 ]        =  1.10665;
    coeffEnergy[ 1 ][ 0 ][ 4 ]        =  3.66856;
    coeffEnergy[ 2 ][ 0 ][ 4 ]        = -.315820;
    coeffEnergy[ 3 ][ 0 ][ 4 ]        = 0.161130;
    coeffEnergy[ 4 ][ 0 ][ 4 ]        = -5.85023;
    coeffEnergy[ 5 ][ 0 ][ 4 ]        = -6.59758;
    coeffEnergy[ 6 ][ 0 ][ 4 ]        =  2.25180;
    coeffEnergy[ 7 ][ 0 ][ 4 ]        = -.481649;
    coeffEnergy[ 8 ][ 0 ][ 4 ]        = 0.621341;
    coeffEnergy[ 9 ][ 0 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 4 ]       =  0.00000;
    performanceMin[ 0 ][ 4 ]          = 0.591346;
    performanceMax[ 0 ][ 4 ]          =  1.08289;
    coeffPerformance[ 0 ][ 0 ][ 4 ]   = 0.745027;
    coeffPerformance[ 1 ][ 0 ][ 4 ]   = 0.535141;
    coeffPerformance[ 2 ][ 0 ][ 4 ]   = 0.299280E-01;
    coeffPerformance[ 3 ][ 0 ][ 4 ]   = 0.180307E-01;
    coeffPerformance[ 4 ][ 0 ][ 4 ]   = -.860892;
    coeffPerformance[ 5 ][ 0 ][ 4 ]   =  5.78509;
    coeffPerformance[ 6 ][ 0 ][ 4 ]   = -2.71742;
    coeffPerformance[ 7 ][ 0 ][ 4 ]   = -.176836;
    coeffPerformance[ 8 ][ 0 ][ 4 ]   = -.135013;
    coeffPerformance[ 9 ][ 0 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 4 ]  =  0.00000;
    powerMin[ 0 ][ 4 ]                = 0.555648;
    powerMax[ 0 ][ 4 ]                =  1.05767;
    coeffPower[ 0 ][ 0 ][ 4 ]         = 0.828151;
    coeffPower[ 1 ][ 0 ][ 4 ]         =  3.16383;
    coeffPower[ 2 ][ 0 ][ 4 ]         = -.279301;
    coeffPower[ 3 ][ 0 ][ 4 ]         = 0.182785;
    coeffPower[ 4 ][ 0 ][ 4 ]         = -5.05375;
    coeffPower[ 5 ][ 0 ][ 4 ]         = 0.364629;
    coeffPower[ 6 ][ 0 ][ 4 ]         = -.866110;
    coeffPower[ 7 ][ 0 ][ 4 ]         = -.534077;
    coeffPower[ 8 ][ 0 ][ 4 ]         = 0.339176;
    coeffPower[ 9 ][ 0 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 4 ]        =  0.00000;
    energyMin[ 1 ][ 4 ]               = 0.707155;
    energyMax[ 1 ][ 4 ]               =  1.29689;
    coeffEnergy[ 0 ][ 1 ][ 4 ]        =  1.11298;
    coeffEnergy[ 1 ][ 1 ][ 4 ]        = 0.719089E-01;
    coeffEnergy[ 2 ][ 1 ][ 4 ]        = -.555172;
    coeffEnergy[ 3 ][ 1 ][ 4 ]        = 0.308356;
    coeffEnergy[ 4 ][ 1 ][ 4 ]        = -.127554;
    coeffEnergy[ 5 ][ 1 ][ 4 ]        = -5.25258;
    coeffEnergy[ 6 ][ 1 ][ 4 ]        =  1.73834;
    coeffEnergy[ 7 ][ 1 ][ 4 ]        = -.672209;
    coeffEnergy[ 8 ][ 1 ][ 4 ]        = 0.840579;
    coeffEnergy[ 9 ][ 1 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 4 ]       =  0.00000;
    performanceMin[ 1 ][ 4 ]          = 0.644007;
    performanceMax[ 1 ][ 4 ]          =  1.12702;
    coeffPerformance[ 0 ][ 1 ][ 4 ]   = 0.804970;
    coeffPerformance[ 1 ][ 1 ][ 4 ]   = 0.428984;
    coeffPerformance[ 2 ][ 1 ][ 4 ]   = -.616351E-01;
    coeffPerformance[ 3 ][ 1 ][ 4 ]   = 0.713285E-01;
    coeffPerformance[ 4 ][ 1 ][ 4 ]   = -.689511;
    coeffPerformance[ 5 ][ 1 ][ 4 ]   =  4.54153;
    coeffPerformance[ 6 ][ 1 ][ 4 ]   = -1.92146;
    coeffPerformance[ 7 ][ 1 ][ 4 ]   = 0.482114E-02;
    coeffPerformance[ 8 ][ 1 ][ 4 ]   = -.356016;
    coeffPerformance[ 9 ][ 1 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 4 ]  =  0.00000;
    powerMin[ 1 ][ 4 ]                = 0.616557;
    powerMax[ 1 ][ 4 ]                =  1.11020;
    coeffPower[ 0 ][ 1 ][ 4 ]         = 0.900573;
    coeffPower[ 1 ][ 1 ][ 4 ]         = 0.318070;
    coeffPower[ 2 ][ 1 ][ 4 ]         = -.570661;
    coeffPower[ 3 ][ 1 ][ 4 ]         = 0.356497;
    coeffPower[ 4 ][ 1 ][ 4 ]         = -.524199;
    coeffPower[ 5 ][ 1 ][ 4 ]         = -.194995E-01;
    coeffPower[ 6 ][ 1 ][ 4 ]         = -.424037;
    coeffPower[ 7 ][ 1 ][ 4 ]         = -.568123;
    coeffPower[ 8 ][ 1 ][ 4 ]         = 0.368088;
    coeffPower[ 9 ][ 1 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 4 ]        =  0.00000;
    energyMin[ 2 ][ 4 ]               = 0.720857;
    energyMax[ 2 ][ 4 ]               =  1.25983;
    coeffEnergy[ 0 ][ 2 ][ 4 ]        =  1.07727;
    coeffEnergy[ 1 ][ 2 ][ 4 ]        = 0.714737;
    coeffEnergy[ 2 ][ 2 ][ 4 ]        = 0.564472E-01;
    coeffEnergy[ 3 ][ 2 ][ 4 ]        = -.664816E-01;
    coeffEnergy[ 4 ][ 2 ][ 4 ]        = -1.15152;
    coeffEnergy[ 5 ][ 2 ][ 4 ]        = -3.33909;
    coeffEnergy[ 6 ][ 2 ][ 4 ]        =  1.29879;
    coeffEnergy[ 7 ][ 2 ][ 4 ]        = -.492779;
    coeffEnergy[ 8 ][ 2 ][ 4 ]        = 0.614983;
    coeffEnergy[ 9 ][ 2 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 4 ]       =  0.00000;
    performanceMin[ 2 ][ 4 ]          = 0.688360;
    performanceMax[ 2 ][ 4 ]          =  1.15324;
    coeffPerformance[ 0 ][ 2 ][ 4 ]   = 0.875004;
    coeffPerformance[ 1 ][ 2 ][ 4 ]   = -.414060;
    coeffPerformance[ 2 ][ 2 ][ 4 ]   = -.920097E-01;
    coeffPerformance[ 3 ][ 2 ][ 4 ]   = 0.789445E-01;
    coeffPerformance[ 4 ][ 2 ][ 4 ]   = 0.655717;
    coeffPerformance[ 5 ][ 2 ][ 4 ]   =  3.09372;
    coeffPerformance[ 6 ][ 2 ][ 4 ]   = -1.30726;
    coeffPerformance[ 7 ][ 2 ][ 4 ]   = -.612649E-01;
    coeffPerformance[ 8 ][ 2 ][ 4 ]   = -.183427;
    coeffPerformance[ 9 ][ 2 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 4 ]  =  0.00000;
    powerMin[ 2 ][ 4 ]                = 0.677969;
    powerMax[ 2 ][ 4 ]                =  1.14098;
    coeffPower[ 0 ][ 2 ][ 4 ]         = 0.944842;
    coeffPower[ 1 ][ 2 ][ 4 ]         = 0.151696;
    coeffPower[ 2 ][ 2 ][ 4 ]         = -.467128E-01;
    coeffPower[ 3 ][ 2 ][ 4 ]         = 0.221752E-01;
    coeffPower[ 4 ][ 2 ][ 4 ]         = -.257417;
    coeffPower[ 5 ][ 2 ][ 4 ]         = 0.317670E-01;
    coeffPower[ 6 ][ 2 ][ 4 ]         = -.120399;
    coeffPower[ 7 ][ 2 ][ 4 ]         = -.509676;
    coeffPower[ 8 ][ 2 ][ 4 ]         = 0.379407;
    coeffPower[ 9 ][ 2 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 4 ]        =  0.00000;
    energyMin[ 3 ][ 4 ]               = 0.736432;
    energyMax[ 3 ][ 4 ]               =  1.28526;
    coeffEnergy[ 0 ][ 3 ][ 4 ]        =  1.02609;
    coeffEnergy[ 1 ][ 3 ][ 4 ]        =  1.60025;
    coeffEnergy[ 2 ][ 3 ][ 4 ]        = 0.671398;
    coeffEnergy[ 3 ][ 3 ][ 4 ]        = -.433221;
    coeffEnergy[ 4 ][ 3 ][ 4 ]        = -2.55369;
    coeffEnergy[ 5 ][ 3 ][ 4 ]        = -1.82480;
    coeffEnergy[ 6 ][ 3 ][ 4 ]        = 0.939739;
    coeffEnergy[ 7 ][ 3 ][ 4 ]        = -.236459E-01;
    coeffEnergy[ 8 ][ 3 ][ 4 ]        = -.232001E-01;
    coeffEnergy[ 9 ][ 3 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 4 ]       =  0.00000;
    performanceMin[ 3 ][ 4 ]          = 0.707335;
    performanceMax[ 3 ][ 4 ]          =  1.23393;
    coeffPerformance[ 0 ][ 3 ][ 4 ]   = 0.949380;
    coeffPerformance[ 1 ][ 3 ][ 4 ]   = -1.04365;
    coeffPerformance[ 2 ][ 3 ][ 4 ]   = -.577171;
    coeffPerformance[ 3 ][ 3 ][ 4 ]   = 0.368600;
    coeffPerformance[ 4 ][ 3 ][ 4 ]   =  1.65673;
    coeffPerformance[ 5 ][ 3 ][ 4 ]   =  1.47280;
    coeffPerformance[ 6 ][ 3 ][ 4 ]   = -.753339;
    coeffPerformance[ 7 ][ 3 ][ 4 ]   = -.266809;
    coeffPerformance[ 8 ][ 3 ][ 4 ]   = 0.234486;
    coeffPerformance[ 9 ][ 3 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 4 ]  =  0.00000;
    powerMin[ 3 ][ 4 ]                = 0.721146;
    powerMax[ 3 ][ 4 ]                =  1.16936;
    coeffPower[ 0 ][ 3 ][ 4 ]         = 0.974425;
    coeffPower[ 1 ][ 3 ][ 4 ]         = 0.442419;
    coeffPower[ 2 ][ 3 ][ 4 ]         = 0.783437E-01;
    coeffPower[ 3 ][ 3 ][ 4 ]         = -.541194E-01;
    coeffPower[ 4 ][ 3 ][ 4 ]         = -.715084;
    coeffPower[ 5 ][ 3 ][ 4 ]         = -.308645;
    coeffPower[ 6 ][ 3 ][ 4 ]         = 0.170926;
    coeffPower[ 7 ][ 3 ][ 4 ]         = -.277190;
    coeffPower[ 8 ][ 3 ][ 4 ]         = 0.194716;
    coeffPower[ 9 ][ 3 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 4 ]        =  0.00000;
    energyMin[ 4 ][ 4 ]               = 0.800000;
    energyMax[ 4 ][ 4 ]               =  1.20000;
    coeffEnergy[ 0 ][ 4 ][ 4 ]        =  1.00000;
    coeffEnergy[ 1 ][ 4 ][ 4 ]        = -.456077E-12;
    coeffEnergy[ 2 ][ 4 ][ 4 ]        = -.112823E-12;
    coeffEnergy[ 3 ][ 4 ][ 4 ]        = 0.691506E-13;
    coeffEnergy[ 4 ][ 4 ][ 4 ]        = 0.729348E-12;
    coeffEnergy[ 5 ][ 4 ][ 4 ]        = -.143902E-12;
    coeffEnergy[ 6 ][ 4 ][ 4 ]        = 0.184188E-12;
    coeffEnergy[ 7 ][ 4 ][ 4 ]        = 0.135735E-13;
    coeffEnergy[ 8 ][ 4 ][ 4 ]        = -.646561E-14;
    coeffEnergy[ 9 ][ 4 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 4 ]       =  0.00000;
    performanceMin[ 4 ][ 4 ]          = 0.800000;
    performanceMax[ 4 ][ 4 ]          =  1.20000;
    coeffPerformance[ 0 ][ 4 ][ 4 ]   =  1.00000;
    coeffPerformance[ 1 ][ 4 ][ 4 ]   = 0.136649E-12;
    coeffPerformance[ 2 ][ 4 ][ 4 ]   = -.591053E-13;
    coeffPerformance[ 3 ][ 4 ][ 4 ]   = 0.377732E-13;
    coeffPerformance[ 4 ][ 4 ][ 4 ]   = -.219000E-12;
    coeffPerformance[ 5 ][ 4 ][ 4 ]   = -.190522E-13;
    coeffPerformance[ 6 ][ 4 ][ 4 ]   = 0.480619E-14;
    coeffPerformance[ 7 ][ 4 ][ 4 ]   = 0.220070E-13;
    coeffPerformance[ 8 ][ 4 ][ 4 ]   = -.450630E-13;
    coeffPerformance[ 9 ][ 4 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 4 ]  =  0.00000;
    powerMin[ 4 ][ 4 ]                = 0.800000;
    powerMax[ 4 ][ 4 ]                =  1.20000;
    coeffPower[ 0 ][ 4 ][ 4 ]         =  1.00000;
    coeffPower[ 1 ][ 4 ][ 4 ]         = 0.448588E-13;
    coeffPower[ 2 ][ 4 ][ 4 ]         = 0.361283E-13;
    coeffPower[ 3 ][ 4 ][ 4 ]         = -.228177E-13;
    coeffPower[ 4 ][ 4 ][ 4 ]         = -.716023E-13;
    coeffPower[ 5 ][ 4 ][ 4 ]         = 0.370525E-13;
    coeffPower[ 6 ][ 4 ][ 4 ]         = -.248839E-13;
    coeffPower[ 7 ][ 4 ][ 4 ]         = -.111451E-13;
    coeffPower[ 8 ][ 4 ][ 4 ]         = 0.104980E-13;
    coeffPower[ 9 ][ 4 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 4 ]        =  0.00000;
    energyMin[ 5 ][ 4 ]               = 0.768890;
    energyMax[ 5 ][ 4 ]               =  1.30280;
    coeffEnergy[ 0 ][ 5 ][ 4 ]        = 0.992952;
    coeffEnergy[ 1 ][ 5 ][ 4 ]        = -1.03728;
    coeffEnergy[ 2 ][ 5 ][ 4 ]        = 0.211311;
    coeffEnergy[ 3 ][ 5 ][ 4 ]        = -.121472;
    coeffEnergy[ 4 ][ 5 ][ 4 ]        =  1.65058;
    coeffEnergy[ 5 ][ 5 ][ 4 ]        =  1.11804;
    coeffEnergy[ 6 ][ 5 ][ 4 ]        = -.422620;
    coeffEnergy[ 7 ][ 5 ][ 4 ]        = 0.223674;
    coeffEnergy[ 8 ][ 5 ][ 4 ]        = -.340885;
    coeffEnergy[ 9 ][ 5 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 4 ]       =  0.00000;
    performanceMin[ 5 ][ 4 ]          = 0.807212;
    performanceMax[ 5 ][ 4 ]          =  1.30484;
    coeffPerformance[ 0 ][ 5 ][ 4 ]   =  1.06486;
    coeffPerformance[ 1 ][ 5 ][ 4 ]   = 0.508115;
    coeffPerformance[ 2 ][ 5 ][ 4 ]   = -.808216E-01;
    coeffPerformance[ 3 ][ 5 ][ 4 ]   = 0.350570E-01;
    coeffPerformance[ 4 ][ 5 ][ 4 ]   = -.808397;
    coeffPerformance[ 5 ][ 5 ][ 4 ]   = -1.76734;
    coeffPerformance[ 6 ][ 5 ][ 4 ]   = 0.620853;
    coeffPerformance[ 7 ][ 5 ][ 4 ]   = -.137332;
    coeffPerformance[ 8 ][ 5 ][ 4 ]   = 0.350815;
    coeffPerformance[ 9 ][ 5 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 4 ]  =  0.00000;
    powerMin[ 5 ][ 4 ]                = 0.819477;
    powerMax[ 5 ][ 4 ]                =  1.33472;
    coeffPower[ 0 ][ 5 ][ 4 ]         =  1.05747;
    coeffPower[ 1 ][ 5 ][ 4 ]         = -.580384;
    coeffPower[ 2 ][ 5 ][ 4 ]         = 0.135821;
    coeffPower[ 3 ][ 5 ][ 4 ]         = -.894008E-01;
    coeffPower[ 4 ][ 5 ][ 4 ]         = 0.923625;
    coeffPower[ 5 ][ 5 ][ 4 ]         = -.620311;
    coeffPower[ 6 ][ 5 ][ 4 ]         = 0.187040;
    coeffPower[ 7 ][ 5 ][ 4 ]         = 0.965614E-01;
    coeffPower[ 8 ][ 5 ][ 4 ]         = -.448709E-02;
    coeffPower[ 9 ][ 5 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 4 ]        =  0.00000;
    energyMin[ 6 ][ 4 ]               = 0.752259;
    energyMax[ 6 ][ 4 ]               =  1.34010;
    coeffEnergy[ 0 ][ 6 ][ 4 ]        = 0.996356;
    coeffEnergy[ 1 ][ 6 ][ 4 ]        = -2.30398;
    coeffEnergy[ 2 ][ 6 ][ 4 ]        = 0.564304;
    coeffEnergy[ 3 ][ 6 ][ 4 ]        = -.333670;
    coeffEnergy[ 4 ][ 6 ][ 4 ]        =  3.66530;
    coeffEnergy[ 5 ][ 6 ][ 4 ]        =  1.74913;
    coeffEnergy[ 6 ][ 6 ][ 4 ]        = -.526360;
    coeffEnergy[ 7 ][ 6 ][ 4 ]        = 0.442207;
    coeffEnergy[ 8 ][ 6 ][ 4 ]        = -.743415;
    coeffEnergy[ 9 ][ 6 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 4 ]       =  0.00000;
    performanceMin[ 6 ][ 4 ]          = 0.814773;
    performanceMax[ 6 ][ 4 ]          =  1.38097;
    coeffPerformance[ 0 ][ 6 ][ 4 ]   =  1.12042;
    coeffPerformance[ 1 ][ 6 ][ 4 ]   =  1.48530;
    coeffPerformance[ 2 ][ 6 ][ 4 ]   = -.297686;
    coeffPerformance[ 3 ][ 6 ][ 4 ]   = 0.155426;
    coeffPerformance[ 4 ][ 6 ][ 4 ]   = -2.36070;
    coeffPerformance[ 5 ][ 6 ][ 4 ]   = -3.32343;
    coeffPerformance[ 6 ][ 6 ][ 4 ]   =  1.11981;
    coeffPerformance[ 7 ][ 6 ][ 4 ]   = -.344108;
    coeffPerformance[ 8 ][ 6 ][ 4 ]   = 0.828136;
    coeffPerformance[ 9 ][ 6 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 4 ]  =  0.00000;
    powerMin[ 6 ][ 4 ]                = 0.841426;
    powerMax[ 6 ][ 4 ]                =  1.43663;
    coeffPower[ 0 ][ 6 ][ 4 ]         =  1.11551;
    coeffPower[ 1 ][ 6 ][ 4 ]         = -1.01025;
    coeffPower[ 2 ][ 6 ][ 4 ]         = 0.300161;
    coeffPower[ 3 ][ 6 ][ 4 ]         = -.197912;
    coeffPower[ 4 ][ 6 ][ 4 ]         =  1.60949;
    coeffPower[ 5 ][ 6 ][ 4 ]         = -1.49440;
    coeffPower[ 6 ][ 6 ][ 4 ]         = 0.576762;
    coeffPower[ 7 ][ 6 ][ 4 ]         = 0.147925;
    coeffPower[ 8 ][ 6 ][ 4 ]         = 0.167732E-01;
    coeffPower[ 9 ][ 6 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 4 ]        =  0.00000;
    energyMin[ 7 ][ 4 ]               = 0.766886;
    energyMax[ 7 ][ 4 ]               =  1.39195;
    coeffEnergy[ 0 ][ 7 ][ 4 ]        =  1.00029;
    coeffEnergy[ 1 ][ 7 ][ 4 ]        = -4.37694;
    coeffEnergy[ 2 ][ 7 ][ 4 ]        = 0.365553;
    coeffEnergy[ 3 ][ 7 ][ 4 ]        = -.205712;
    coeffEnergy[ 4 ][ 7 ][ 4 ]        =  6.96955;
    coeffEnergy[ 5 ][ 7 ][ 4 ]        =  3.13146;
    coeffEnergy[ 6 ][ 7 ][ 4 ]        = -1.33816;
    coeffEnergy[ 7 ][ 7 ][ 4 ]        = 0.206608;
    coeffEnergy[ 8 ][ 7 ][ 4 ]        = -.385351;
    coeffEnergy[ 9 ][ 7 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 4 ]       =  0.00000;
    performanceMin[ 7 ][ 4 ]          = 0.819417;
    performanceMax[ 7 ][ 4 ]          =  1.45376;
    coeffPerformance[ 0 ][ 7 ][ 4 ]   =  1.16337;
    coeffPerformance[ 1 ][ 7 ][ 4 ]   =  3.63603;
    coeffPerformance[ 2 ][ 7 ][ 4 ]   = 0.213068;
    coeffPerformance[ 3 ][ 7 ][ 4 ]   = -.171234;
    coeffPerformance[ 4 ][ 7 ][ 4 ]   = -5.78304;
    coeffPerformance[ 5 ][ 7 ][ 4 ]   = -5.54769;
    coeffPerformance[ 6 ][ 7 ][ 4 ]   =  2.41397;
    coeffPerformance[ 7 ][ 7 ][ 4 ]   = 0.142638;
    coeffPerformance[ 8 ][ 7 ][ 4 ]   = 0.308794;
    coeffPerformance[ 9 ][ 7 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 4 ]  =  0.00000;
    powerMin[ 7 ][ 4 ]                = 0.865105;
    powerMax[ 7 ][ 4 ]                =  1.50440;
    coeffPower[ 0 ][ 7 ][ 4 ]         =  1.16140;
    coeffPower[ 1 ][ 7 ][ 4 ]         = -1.26015;
    coeffPower[ 2 ][ 7 ][ 4 ]         = 0.545959;
    coeffPower[ 3 ][ 7 ][ 4 ]         = -.354621;
    coeffPower[ 4 ][ 7 ][ 4 ]         =  2.01388;
    coeffPower[ 5 ][ 7 ][ 4 ]         = -2.20876;
    coeffPower[ 6 ][ 7 ][ 4 ]         = 0.971834;
    coeffPower[ 7 ][ 7 ][ 4 ]         = 0.390206;
    coeffPower[ 8 ][ 7 ][ 4 ]         = -.105161;
    coeffPower[ 9 ][ 7 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 4 ]        =  0.00000;
    energyMin[ 8 ][ 4 ]               = 0.763550;
    energyMax[ 8 ][ 4 ]               =  1.42673;
    coeffEnergy[ 0 ][ 8 ][ 4 ]        = 0.998633;
    coeffEnergy[ 1 ][ 8 ][ 4 ]        = -5.31215;
    coeffEnergy[ 2 ][ 8 ][ 4 ]        = 0.142351;
    coeffEnergy[ 3 ][ 8 ][ 4 ]        = -.572614E-01;
    coeffEnergy[ 4 ][ 8 ][ 4 ]        =  8.46187;
    coeffEnergy[ 5 ][ 8 ][ 4 ]        =  4.27981;
    coeffEnergy[ 6 ][ 8 ][ 4 ]        = -1.84216;
    coeffEnergy[ 7 ][ 8 ][ 4 ]        = 0.224275;
    coeffEnergy[ 8 ][ 8 ][ 4 ]        = -.393528;
    coeffEnergy[ 9 ][ 8 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 4 ]       =  0.00000;
    performanceMin[ 8 ][ 4 ]          = 0.825000;
    performanceMax[ 8 ][ 4 ]          =  1.53287;
    coeffPerformance[ 0 ][ 8 ][ 4 ]   =  1.22074;
    coeffPerformance[ 1 ][ 8 ][ 4 ]   =  5.06259;
    coeffPerformance[ 2 ][ 8 ][ 4 ]   = 0.689444;
    coeffPerformance[ 3 ][ 8 ][ 4 ]   = -.485992;
    coeffPerformance[ 4 ][ 8 ][ 4 ]   = -8.05603;
    coeffPerformance[ 5 ][ 8 ][ 4 ]   = -7.74752;
    coeffPerformance[ 6 ][ 8 ][ 4 ]   =  3.42997;
    coeffPerformance[ 7 ][ 8 ][ 4 ]   = 0.225153;
    coeffPerformance[ 8 ][ 8 ][ 4 ]   = 0.387909;
    coeffPerformance[ 9 ][ 8 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 4 ]  =  0.00000;
    powerMin[ 8 ][ 4 ]                = 0.888627;
    powerMax[ 8 ][ 4 ]                =  1.59625;
    coeffPower[ 0 ][ 8 ][ 4 ]         =  1.21505;
    coeffPower[ 1 ][ 8 ][ 4 ]         = -.975027;
    coeffPower[ 2 ][ 8 ][ 4 ]         = 0.802566;
    coeffPower[ 3 ][ 8 ][ 4 ]         = -.521887;
    coeffPower[ 4 ][ 8 ][ 4 ]         =  1.56233;
    coeffPower[ 5 ][ 8 ][ 4 ]         = -3.10544;
    coeffPower[ 6 ][ 8 ][ 4 ]         =  1.40765;
    coeffPower[ 7 ][ 8 ][ 4 ]         = 0.524914;
    coeffPower[ 8 ][ 8 ][ 4 ]         = -.476201E-01;
    coeffPower[ 9 ][ 8 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 4 ]        =  0.00000;
    energyMin[ 9 ][ 4 ]               = 0.763226;
    energyMax[ 9 ][ 4 ]               =  1.47043;
    coeffEnergy[ 0 ][ 9 ][ 4 ]        =  1.01129;
    coeffEnergy[ 1 ][ 9 ][ 4 ]        = -7.01916;
    coeffEnergy[ 2 ][ 9 ][ 4 ]        = 0.407723;
    coeffEnergy[ 3 ][ 9 ][ 4 ]        = -.221044;
    coeffEnergy[ 4 ][ 9 ][ 4 ]        =  11.1779;
    coeffEnergy[ 5 ][ 9 ][ 4 ]        =  5.13900;
    coeffEnergy[ 6 ][ 9 ][ 4 ]        = -2.18162;
    coeffEnergy[ 7 ][ 9 ][ 4 ]        = 0.245497;
    coeffEnergy[ 8 ][ 9 ][ 4 ]        = -.360844;
    coeffEnergy[ 9 ][ 9 ][ 4 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 4 ]       =  0.00000;
    performanceMin[ 9 ][ 4 ]          = 0.830000;
    performanceMax[ 9 ][ 4 ]          =  1.61336;
    coeffPerformance[ 0 ][ 9 ][ 4 ]   =  1.25191;
    coeffPerformance[ 1 ][ 9 ][ 4 ]   =  7.67029;
    coeffPerformance[ 2 ][ 9 ][ 4 ]   = 0.726555;
    coeffPerformance[ 3 ][ 9 ][ 4 ]   = -.515555;
    coeffPerformance[ 4 ][ 9 ][ 4 ]   = -12.2000;
    coeffPerformance[ 5 ][ 9 ][ 4 ]   = -9.03449;
    coeffPerformance[ 6 ][ 9 ][ 4 ]   =  3.92888;
    coeffPerformance[ 7 ][ 9 ][ 4 ]   = 0.309763;
    coeffPerformance[ 8 ][ 9 ][ 4 ]   = 0.398823;
    coeffPerformance[ 9 ][ 9 ][ 4 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 4 ]  =  0.00000;
    powerMin[ 9 ][ 4 ]                = 0.914837;
    powerMax[ 9 ][ 4 ]                =  1.69861;
    coeffPower[ 0 ][ 9 ][ 4 ]         =  1.25706;
    coeffPower[ 1 ][ 9 ][ 4 ]         = -.453209;
    coeffPower[ 2 ][ 9 ][ 4 ]         =  1.06710;
    coeffPower[ 3 ][ 9 ][ 4 ]         = -.690107;
    coeffPower[ 4 ][ 9 ][ 4 ]         = 0.738669;
    coeffPower[ 5 ][ 9 ][ 4 ]         = -3.41487;
    coeffPower[ 6 ][ 9 ][ 4 ]         =  1.50424;
    coeffPower[ 7 ][ 9 ][ 4 ]         = 0.690799;
    coeffPower[ 8 ][ 9 ][ 4 ]         = -.297766E-01;
    coeffPower[ 9 ][ 9 ][ 4 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 4 ]        =  0.00000;
    energyMin[ 10 ][ 4 ]              = 0.764781;
    energyMax[ 10 ][ 4 ]              =  1.53439;
    coeffEnergy[ 0 ][ 10 ][ 4 ]       =  1.02017;
    coeffEnergy[ 1 ][ 10 ][ 4 ]       = -8.07363;
    coeffEnergy[ 2 ][ 10 ][ 4 ]       = 0.819522E-01;
    coeffEnergy[ 3 ][ 10 ][ 4 ]       = -.106749E-01;
    coeffEnergy[ 4 ][ 10 ][ 4 ]       =  12.8571;
    coeffEnergy[ 5 ][ 10 ][ 4 ]       =  6.09616;
    coeffEnergy[ 6 ][ 10 ][ 4 ]       = -2.65275;
    coeffEnergy[ 7 ][ 10 ][ 4 ]       = 0.254274;
    coeffEnergy[ 8 ][ 10 ][ 4 ]       = -.314758;
    coeffEnergy[ 9 ][ 10 ][ 4 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 4 ]      =  0.00000;
    performanceMin[ 10 ][ 4 ]         = 0.832362;
    performanceMax[ 10 ][ 4 ]         =  1.68748;
    coeffPerformance[ 0 ][ 10 ][ 4 ]  =  1.30266;
    coeffPerformance[ 1 ][ 10 ][ 4 ]  =  9.85704;
    coeffPerformance[ 2 ][ 10 ][ 4 ]  =  1.39099;
    coeffPerformance[ 3 ][ 10 ][ 4 ]  = -.945587;
    coeffPerformance[ 4 ][ 10 ][ 4 ]  = -15.6820;
    coeffPerformance[ 5 ][ 10 ][ 4 ]  = -10.9497;
    coeffPerformance[ 6 ][ 10 ][ 4 ]  =  4.85911;
    coeffPerformance[ 7 ][ 10 ][ 4 ]  = 0.411203;
    coeffPerformance[ 8 ][ 10 ][ 4 ]  = 0.382831;
    coeffPerformance[ 9 ][ 10 ][ 4 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 4 ] =  0.00000;
    powerMin[ 10 ][ 4 ]               = 0.940740;
    powerMax[ 10 ][ 4 ]               =  1.82277;
    coeffPower[ 0 ][ 10 ][ 4 ]        =  1.31869;
    coeffPower[ 1 ][ 10 ][ 4 ]        = 0.320095;
    coeffPower[ 2 ][ 10 ][ 4 ]        =  1.38262;
    coeffPower[ 3 ][ 10 ][ 4 ]        = -.895185;
    coeffPower[ 4 ][ 10 ][ 4 ]        = -.492262;
    coeffPower[ 5 ][ 10 ][ 4 ]        = -4.30895;
    coeffPower[ 6 ][ 10 ][ 4 ]        =  1.91108;
    coeffPower[ 7 ][ 10 ][ 4 ]        = 0.821106;
    coeffPower[ 8 ][ 10 ][ 4 ]        = 0.247907E-01;
    coeffPower[ 9 ][ 10 ][ 4 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 4 ]       =  0.00000;
    energyMin[ 11 ][ 4 ]              = 0.766241;
    energyMax[ 11 ][ 4 ]              =  1.60199;
    coeffEnergy[ 0 ][ 11 ][ 4 ]       =  1.03658;
    coeffEnergy[ 1 ][ 11 ][ 4 ]       = -9.41384;
    coeffEnergy[ 2 ][ 11 ][ 4 ]       = 0.151554;
    coeffEnergy[ 3 ][ 11 ][ 4 ]       = -.489639E-01;
    coeffEnergy[ 4 ][ 11 ][ 4 ]       =  14.9900;
    coeffEnergy[ 5 ][ 11 ][ 4 ]       =  7.39300;
    coeffEnergy[ 6 ][ 11 ][ 4 ]       = -3.26452;
    coeffEnergy[ 7 ][ 11 ][ 4 ]       = 0.104347;
    coeffEnergy[ 8 ][ 11 ][ 4 ]       = -.208693;
    coeffEnergy[ 9 ][ 11 ][ 4 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 4 ]      =  0.00000;
    performanceMin[ 11 ][ 4 ]         = 0.835909;
    performanceMax[ 11 ][ 4 ]         =  1.76361;
    coeffPerformance[ 0 ][ 11 ][ 4 ]  =  1.34713;
    coeffPerformance[ 1 ][ 11 ][ 4 ]  =  11.9394;
    coeffPerformance[ 2 ][ 11 ][ 4 ]  =  1.58798;
    coeffPerformance[ 3 ][ 11 ][ 4 ]  = -1.08167;
    coeffPerformance[ 4 ][ 11 ][ 4 ]  = -18.9944;
    coeffPerformance[ 5 ][ 11 ][ 4 ]  = -13.1903;
    coeffPerformance[ 6 ][ 11 ][ 4 ]  =  5.92197;
    coeffPerformance[ 7 ][ 11 ][ 4 ]  = 0.607136;
    coeffPerformance[ 8 ][ 11 ][ 4 ]  = 0.362537;
    coeffPerformance[ 9 ][ 11 ][ 4 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 4 ] =  0.00000;
    powerMin[ 11 ][ 4 ]               = 0.971896;
    powerMax[ 11 ][ 4 ]               =  1.91557;
    coeffPower[ 0 ][ 11 ][ 4 ]        =  1.37844;
    coeffPower[ 1 ][ 11 ][ 4 ]        = 0.813075;
    coeffPower[ 2 ][ 11 ][ 4 ]        =  1.65656;
    coeffPower[ 3 ][ 11 ][ 4 ]        = -1.07279;
    coeffPower[ 4 ][ 11 ][ 4 ]        = -1.27321;
    coeffPower[ 5 ][ 11 ][ 4 ]        = -5.13507;
    coeffPower[ 6 ][ 11 ][ 4 ]        =  2.30525;
    coeffPower[ 7 ][ 11 ][ 4 ]        = 0.941155;
    coeffPower[ 8 ][ 11 ][ 4 ]        = 0.771629E-01;
    coeffPower[ 9 ][ 11 ][ 4 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 4 ]       =  0.00000;
    energyMin[ 12 ][ 4 ]              = 0.767926;
    energyMax[ 12 ][ 4 ]              =  1.64326;
    coeffEnergy[ 0 ][ 12 ][ 4 ]       =  1.05758;
    coeffEnergy[ 1 ][ 12 ][ 4 ]       = -10.2015;
    coeffEnergy[ 2 ][ 12 ][ 4 ]       = 0.185640;
    coeffEnergy[ 3 ][ 12 ][ 4 ]       = -.638270E-01;
    coeffEnergy[ 4 ][ 12 ][ 4 ]       =  16.2388;
    coeffEnergy[ 5 ][ 12 ][ 4 ]       =  8.56916;
    coeffEnergy[ 6 ][ 12 ][ 4 ]       = -3.76265;
    coeffEnergy[ 7 ][ 12 ][ 4 ]       = 0.440789E-01;
    coeffEnergy[ 8 ][ 12 ][ 4 ]       = -.299934;
    coeffEnergy[ 9 ][ 12 ][ 4 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 4 ]      =  0.00000;
    performanceMin[ 12 ][ 4 ]         = 0.837794;
    performanceMax[ 12 ][ 4 ]         =  1.84174;
    coeffPerformance[ 0 ][ 12 ][ 4 ]  =  1.39308;
    coeffPerformance[ 1 ][ 12 ][ 4 ]  =  13.7314;
    coeffPerformance[ 2 ][ 12 ][ 4 ]  =  1.74790;
    coeffPerformance[ 3 ][ 12 ][ 4 ]  = -1.19643;
    coeffPerformance[ 4 ][ 12 ][ 4 ]  = -21.8431;
    coeffPerformance[ 5 ][ 12 ][ 4 ]  = -15.3216;
    coeffPerformance[ 6 ][ 12 ][ 4 ]  =  6.83239;
    coeffPerformance[ 7 ][ 12 ][ 4 ]  = 0.635376;
    coeffPerformance[ 8 ][ 12 ][ 4 ]  = 0.544818;
    coeffPerformance[ 9 ][ 12 ][ 4 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 4 ] =  0.00000;
    powerMin[ 12 ][ 4 ]               =  1.00046;
    powerMax[ 12 ][ 4 ]               =  1.98430;
    coeffPower[ 0 ][ 12 ][ 4 ]        =  1.44961;
    coeffPower[ 1 ][ 12 ][ 4 ]        =  1.63749;
    coeffPower[ 2 ][ 12 ][ 4 ]        =  1.82924;
    coeffPower[ 3 ][ 12 ][ 4 ]        = -1.18895;
    coeffPower[ 4 ][ 12 ][ 4 ]        = -2.58720;
    coeffPower[ 5 ][ 12 ][ 4 ]        = -6.05800;
    coeffPower[ 6 ][ 12 ][ 4 ]        =  2.68093;
    coeffPower[ 7 ][ 12 ][ 4 ]        = 0.930553;
    coeffPower[ 8 ][ 12 ][ 4 ]        = 0.176582;
    coeffPower[ 9 ][ 12 ][ 4 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 4 ]       =  0.00000;
    energyMin[ 13 ][ 4 ]              = 0.776870;
    energyMax[ 13 ][ 4 ]              =  1.69857;
    coeffEnergy[ 0 ][ 13 ][ 4 ]       =  1.05980;
    coeffEnergy[ 1 ][ 13 ][ 4 ]       = -11.4478;
    coeffEnergy[ 2 ][ 13 ][ 4 ]       = 0.499001E-01;
    coeffEnergy[ 3 ][ 13 ][ 4 ]       = 0.319421E-01;
    coeffEnergy[ 4 ][ 13 ][ 4 ]       =  18.2285;
    coeffEnergy[ 5 ][ 13 ][ 4 ]       =  9.70811;
    coeffEnergy[ 6 ][ 13 ][ 4 ]       = -4.23690;
    coeffEnergy[ 7 ][ 13 ][ 4 ]       = 0.211098;
    coeffEnergy[ 8 ][ 13 ][ 4 ]       = -.439419;
    coeffEnergy[ 9 ][ 13 ][ 4 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 4 ]      =  0.00000;
    performanceMin[ 13 ][ 4 ]         = 0.840736;
    performanceMax[ 13 ][ 4 ]         =  1.91853;
    coeffPerformance[ 0 ][ 13 ][ 4 ]  =  1.44419;
    coeffPerformance[ 1 ][ 13 ][ 4 ]  =  15.4948;
    coeffPerformance[ 2 ][ 13 ][ 4 ]  =  1.95808;
    coeffPerformance[ 3 ][ 13 ][ 4 ]  = -1.34313;
    coeffPerformance[ 4 ][ 13 ][ 4 ]  = -24.6494;
    coeffPerformance[ 5 ][ 13 ][ 4 ]  = -17.3552;
    coeffPerformance[ 6 ][ 13 ][ 4 ]  =  7.67441;
    coeffPerformance[ 7 ][ 13 ][ 4 ]  = 0.556161;
    coeffPerformance[ 8 ][ 13 ][ 4 ]  = 0.750142;
    coeffPerformance[ 9 ][ 13 ][ 4 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 4 ] =  0.00000;
    powerMin[ 13 ][ 4 ]               =  1.03388;
    powerMax[ 13 ][ 4 ]               =  2.05764;
    coeffPower[ 0 ][ 13 ][ 4 ]        =  1.50391;
    coeffPower[ 1 ][ 13 ][ 4 ]        =  1.79772;
    coeffPower[ 2 ][ 13 ][ 4 ]        =  1.88269;
    coeffPower[ 3 ][ 13 ][ 4 ]        = -1.22627;
    coeffPower[ 4 ][ 13 ][ 4 ]        = -2.83261;
    coeffPower[ 5 ][ 13 ][ 4 ]        = -6.94759;
    coeffPower[ 6 ][ 13 ][ 4 ]        =  3.00339;
    coeffPower[ 7 ][ 13 ][ 4 ]        =  1.08656;
    coeffPower[ 8 ][ 13 ][ 4 ]        = 0.260911;
    coeffPower[ 9 ][ 13 ][ 4 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 4 ]       =  0.00000;
    energyMin[ 14 ][ 4 ]              = 0.778841;
    energyMax[ 14 ][ 4 ]              =  1.75722;
    coeffEnergy[ 0 ][ 14 ][ 4 ]       =  1.07325;
    coeffEnergy[ 1 ][ 14 ][ 4 ]       = -13.0877;
    coeffEnergy[ 2 ][ 14 ][ 4 ]       = -.214097E-01;
    coeffEnergy[ 3 ][ 14 ][ 4 ]       = 0.864275E-01;
    coeffEnergy[ 4 ][ 14 ][ 4 ]       =  20.8433;
    coeffEnergy[ 5 ][ 14 ][ 4 ]       =  11.0755;
    coeffEnergy[ 6 ][ 14 ][ 4 ]       = -4.88268;
    coeffEnergy[ 7 ][ 14 ][ 4 ]       = 0.161186;
    coeffEnergy[ 8 ][ 14 ][ 4 ]       = -.497249;
    coeffEnergy[ 9 ][ 14 ][ 4 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 4 ]      =  0.00000;
    performanceMin[ 14 ][ 4 ]         = 0.841364;
    performanceMax[ 14 ][ 4 ]         =  1.99466;
    coeffPerformance[ 0 ][ 14 ][ 4 ]  =  1.49775;
    coeffPerformance[ 1 ][ 14 ][ 4 ]  =  18.7089;
    coeffPerformance[ 2 ][ 14 ][ 4 ]  =  2.49779;
    coeffPerformance[ 3 ][ 14 ][ 4 ]  = -1.69643;
    coeffPerformance[ 4 ][ 14 ][ 4 ]  = -29.7724;
    coeffPerformance[ 5 ][ 14 ][ 4 ]  = -19.5165;
    coeffPerformance[ 6 ][ 14 ][ 4 ]  =  8.68360;
    coeffPerformance[ 7 ][ 14 ][ 4 ]  = 0.719781;
    coeffPerformance[ 8 ][ 14 ][ 4 ]  = 0.745034;
    coeffPerformance[ 9 ][ 14 ][ 4 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 4 ] =  0.00000;
    powerMin[ 14 ][ 4 ]               =  1.06627;
    powerMax[ 14 ][ 4 ]               =  2.14683;
    coeffPower[ 0 ][ 14 ][ 4 ]        =  1.57502;
    coeffPower[ 1 ][ 14 ][ 4 ]        =  2.96066;
    coeffPower[ 2 ][ 14 ][ 4 ]        =  2.28028;
    coeffPower[ 3 ][ 14 ][ 4 ]        = -1.48069;
    coeffPower[ 4 ][ 14 ][ 4 ]        = -4.68239;
    coeffPower[ 5 ][ 14 ][ 4 ]        = -7.82818;
    coeffPower[ 6 ][ 14 ][ 4 ]        =  3.38272;
    coeffPower[ 7 ][ 14 ][ 4 ]        =  1.24984;
    coeffPower[ 8 ][ 14 ][ 4 ]        = 0.206534;
    coeffPower[ 9 ][ 14 ][ 4 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 4 ]       =  0.00000;
    energyMin[ 15 ][ 4 ]              = 0.782888;
    energyMax[ 15 ][ 4 ]              =  1.80750;
    coeffEnergy[ 0 ][ 15 ][ 4 ]       =  1.09296;
    coeffEnergy[ 1 ][ 15 ][ 4 ]       = -13.5144;
    coeffEnergy[ 2 ][ 15 ][ 4 ]       = 0.438457;
    coeffEnergy[ 3 ][ 15 ][ 4 ]       = -.193270;
    coeffEnergy[ 4 ][ 15 ][ 4 ]       =  21.5190;
    coeffEnergy[ 5 ][ 15 ][ 4 ]       =  12.3811;
    coeffEnergy[ 6 ][ 15 ][ 4 ]       = -5.35788;
    coeffEnergy[ 7 ][ 15 ][ 4 ]       = 0.243840;
    coeffEnergy[ 8 ][ 15 ][ 4 ]       = -.721699;
    coeffEnergy[ 9 ][ 15 ][ 4 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 4 ]      =  0.00000;
    performanceMin[ 15 ][ 4 ]         = 0.844545;
    performanceMax[ 15 ][ 4 ]         =  2.07212;
    coeffPerformance[ 0 ][ 15 ][ 4 ]  =  1.54088;
    coeffPerformance[ 1 ][ 15 ][ 4 ]  =  18.8127;
    coeffPerformance[ 2 ][ 15 ][ 4 ]  =  1.99312;
    coeffPerformance[ 3 ][ 15 ][ 4 ]  = -1.39485;
    coeffPerformance[ 4 ][ 15 ][ 4 ]  = -29.9245;
    coeffPerformance[ 5 ][ 15 ][ 4 ]  = -22.0067;
    coeffPerformance[ 6 ][ 15 ][ 4 ]  =  9.74108;
    coeffPerformance[ 7 ][ 15 ][ 4 ]  = 0.682937;
    coeffPerformance[ 8 ][ 15 ][ 4 ]  =  1.01059;
    coeffPerformance[ 9 ][ 15 ][ 4 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 4 ] =  0.00000;
    powerMin[ 15 ][ 4 ]               =  1.10108;
    powerMax[ 15 ][ 4 ]               =  2.23982;
    coeffPower[ 0 ][ 15 ][ 4 ]        =  1.63991;
    coeffPower[ 1 ][ 15 ][ 4 ]        =  2.78101;
    coeffPower[ 2 ][ 15 ][ 4 ]        =  2.28067;
    coeffPower[ 3 ][ 15 ][ 4 ]        = -1.48567;
    coeffPower[ 4 ][ 15 ][ 4 ]        = -4.38456;
    coeffPower[ 5 ][ 15 ][ 4 ]        = -9.04150;
    coeffPower[ 6 ][ 15 ][ 4 ]        =  3.98662;
    coeffPower[ 7 ][ 15 ][ 4 ]        =  1.44537;
    coeffPower[ 8 ][ 15 ][ 4 ]        = 0.146336;
    coeffPower[ 9 ][ 15 ][ 4 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 4 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 1.70;
    energyMin[ 0 ][ 5 ]               = 0.671315;
    energyMax[ 0 ][ 5 ]               =  1.38848;
    coeffEnergy[ 0 ][ 0 ][ 5 ]        =  1.11485;
    coeffEnergy[ 1 ][ 0 ][ 5 ]        =  5.27055;
    coeffEnergy[ 2 ][ 0 ][ 5 ]        = 0.318922;
    coeffEnergy[ 3 ][ 0 ][ 5 ]        = -.238444;
    coeffEnergy[ 4 ][ 0 ][ 5 ]        = -8.92496;
    coeffEnergy[ 5 ][ 0 ][ 5 ]        = -7.48504;
    coeffEnergy[ 6 ][ 0 ][ 5 ]        =  2.80497;
    coeffEnergy[ 7 ][ 0 ][ 5 ]        = -.694066;
    coeffEnergy[ 8 ][ 0 ][ 5 ]        = 0.992607;
    coeffEnergy[ 9 ][ 0 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 5 ]       =  0.00000;
    performanceMin[ 0 ][ 5 ]          = 0.556696;
    performanceMax[ 0 ][ 5 ]          =  1.07257;
    coeffPerformance[ 0 ][ 0 ][ 5 ]   = 0.690356;
    coeffPerformance[ 1 ][ 0 ][ 5 ]   = 0.162694;
    coeffPerformance[ 2 ][ 0 ][ 5 ]   = -1.09329;
    coeffPerformance[ 3 ][ 0 ][ 5 ]   = 0.696928;
    coeffPerformance[ 4 ][ 0 ][ 5 ]   = -.281386;
    coeffPerformance[ 5 ][ 0 ][ 5 ]   =  6.81985;
    coeffPerformance[ 6 ][ 0 ][ 5 ]   = -3.21197;
    coeffPerformance[ 7 ][ 0 ][ 5 ]   = -.419942E-01;
    coeffPerformance[ 8 ][ 0 ][ 5 ]   = -.421938;
    coeffPerformance[ 9 ][ 0 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 5 ]  =  0.00000;
    powerMin[ 0 ][ 5 ]                = 0.535784;
    powerMax[ 0 ][ 5 ]                =  1.01476;
    coeffPower[ 0 ][ 0 ][ 5 ]         = 0.776904;
    coeffPower[ 1 ][ 0 ][ 5 ]         =  3.72073;
    coeffPower[ 2 ][ 0 ][ 5 ]         = -.921578;
    coeffPower[ 3 ][ 0 ][ 5 ]         = 0.556622;
    coeffPower[ 4 ][ 0 ][ 5 ]         = -6.30770;
    coeffPower[ 5 ][ 0 ][ 5 ]         = 0.845196;
    coeffPower[ 6 ][ 0 ][ 5 ]         = -.991532;
    coeffPower[ 7 ][ 0 ][ 5 ]         = -.553184;
    coeffPower[ 8 ][ 0 ][ 5 ]         = 0.338603;
    coeffPower[ 9 ][ 0 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 5 ]        =  0.00000;
    energyMin[ 1 ][ 5 ]               = 0.693875;
    energyMax[ 1 ][ 5 ]               =  1.32298;
    coeffEnergy[ 0 ][ 1 ][ 5 ]        =  1.12090;
    coeffEnergy[ 1 ][ 1 ][ 5 ]        =  1.44539;
    coeffEnergy[ 2 ][ 1 ][ 5 ]        = -.131593;
    coeffEnergy[ 3 ][ 1 ][ 5 ]        = 0.261395E-01;
    coeffEnergy[ 4 ][ 1 ][ 5 ]        = -2.45798;
    coeffEnergy[ 5 ][ 1 ][ 5 ]        = -6.27132;
    coeffEnergy[ 6 ][ 1 ][ 5 ]        =  2.31403;
    coeffEnergy[ 7 ][ 1 ][ 5 ]        = -.818767;
    coeffEnergy[ 8 ][ 1 ][ 5 ]        =  1.14734;
    coeffEnergy[ 9 ][ 1 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 5 ]       =  0.00000;
    performanceMin[ 1 ][ 5 ]          = 0.599266;
    performanceMax[ 1 ][ 5 ]          =  1.11628;
    coeffPerformance[ 0 ][ 1 ][ 5 ]   = 0.749804;
    coeffPerformance[ 1 ][ 1 ][ 5 ]   = -.419636E-01;
    coeffPerformance[ 2 ][ 1 ][ 5 ]   = -.799275;
    coeffPerformance[ 3 ][ 1 ][ 5 ]   = 0.518108;
    coeffPerformance[ 4 ][ 1 ][ 5 ]   = 0.663825E-01;
    coeffPerformance[ 5 ][ 1 ][ 5 ]   =  5.67447;
    coeffPerformance[ 6 ][ 1 ][ 5 ]   = -2.41096;
    coeffPerformance[ 7 ][ 1 ][ 5 ]   = 0.121674;
    coeffPerformance[ 8 ][ 1 ][ 5 ]   = -.641534;
    coeffPerformance[ 9 ][ 1 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 5 ]  =  0.00000;
    powerMin[ 1 ][ 5 ]                = 0.586230;
    powerMax[ 1 ][ 5 ]                =  1.08381;
    coeffPower[ 0 ][ 1 ][ 5 ]         = 0.848431;
    coeffPower[ 1 ][ 1 ][ 5 ]         = 0.812620;
    coeffPower[ 2 ][ 1 ][ 5 ]         = -.970129;
    coeffPower[ 3 ][ 1 ][ 5 ]         = 0.575980;
    coeffPower[ 4 ][ 1 ][ 5 ]         = -1.39011;
    coeffPower[ 5 ][ 1 ][ 5 ]         = 0.379383;
    coeffPower[ 6 ][ 1 ][ 5 ]         = -.484635;
    coeffPower[ 7 ][ 1 ][ 5 ]         = -.554192;
    coeffPower[ 8 ][ 1 ][ 5 ]         = 0.325299;
    coeffPower[ 9 ][ 1 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 5 ]        =  0.00000;
    energyMin[ 2 ][ 5 ]               = 0.702768;
    energyMax[ 2 ][ 5 ]               =  1.28489;
    coeffEnergy[ 0 ][ 2 ][ 5 ]        =  1.08209;
    coeffEnergy[ 1 ][ 2 ][ 5 ]        =  1.41285;
    coeffEnergy[ 2 ][ 2 ][ 5 ]        = -.135235;
    coeffEnergy[ 3 ][ 2 ][ 5 ]        = 0.384925E-01;
    coeffEnergy[ 4 ][ 2 ][ 5 ]        = -2.40000;
    coeffEnergy[ 5 ][ 2 ][ 5 ]        = -4.41095;
    coeffEnergy[ 6 ][ 2 ][ 5 ]        =  1.81658;
    coeffEnergy[ 7 ][ 2 ][ 5 ]        = -.702082;
    coeffEnergy[ 8 ][ 2 ][ 5 ]        = 0.984974;
    coeffEnergy[ 9 ][ 2 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 5 ]       =  0.00000;
    performanceMin[ 2 ][ 5 ]          = 0.649028;
    performanceMax[ 2 ][ 5 ]          =  1.14186;
    coeffPerformance[ 0 ][ 2 ][ 5 ]   = 0.817914;
    coeffPerformance[ 1 ][ 2 ][ 5 ]   = -.727551;
    coeffPerformance[ 2 ][ 2 ][ 5 ]   = -.581973;
    coeffPerformance[ 3 ][ 2 ][ 5 ]   = 0.379120;
    coeffPerformance[ 4 ][ 2 ][ 5 ]   =  1.22748;
    coeffPerformance[ 5 ][ 2 ][ 5 ]   =  4.37874;
    coeffPerformance[ 6 ][ 2 ][ 5 ]   = -1.82964;
    coeffPerformance[ 7 ][ 2 ][ 5 ]   = 0.867718E-01;
    coeffPerformance[ 8 ][ 2 ][ 5 ]   = -.515394;
    coeffPerformance[ 9 ][ 2 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 5 ]  =  0.00000;
    powerMin[ 2 ][ 5 ]                = 0.610505;
    powerMax[ 2 ][ 5 ]                =  1.11386;
    coeffPower[ 0 ][ 2 ][ 5 ]         = 0.889127;
    coeffPower[ 1 ][ 2 ][ 5 ]         = 0.298246;
    coeffPower[ 2 ][ 2 ][ 5 ]         = -.735852;
    coeffPower[ 3 ][ 2 ][ 5 ]         = 0.433371;
    coeffPower[ 4 ][ 2 ][ 5 ]         = -.516499;
    coeffPower[ 5 ][ 2 ][ 5 ]         = 0.445860;
    coeffPower[ 6 ][ 2 ][ 5 ]         = -.224021;
    coeffPower[ 7 ][ 2 ][ 5 ]         = -.525684;
    coeffPower[ 8 ][ 2 ][ 5 ]         = 0.358130;
    coeffPower[ 9 ][ 2 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 5 ]        =  0.00000;
    energyMin[ 3 ][ 5 ]               = 0.724113;
    energyMax[ 3 ][ 5 ]               =  1.30363;
    coeffEnergy[ 0 ][ 3 ][ 5 ]        =  1.03038;
    coeffEnergy[ 1 ][ 3 ][ 5 ]        =  2.31150;
    coeffEnergy[ 2 ][ 3 ][ 5 ]        = 0.359512;
    coeffEnergy[ 3 ][ 3 ][ 5 ]        = -.234639;
    coeffEnergy[ 4 ][ 3 ][ 5 ]        = -3.91229;
    coeffEnergy[ 5 ][ 3 ][ 5 ]        = -2.86291;
    coeffEnergy[ 6 ][ 3 ][ 5 ]        =  1.38471;
    coeffEnergy[ 7 ][ 3 ][ 5 ]        = -.269580;
    coeffEnergy[ 8 ][ 3 ][ 5 ]        = 0.366128;
    coeffEnergy[ 9 ][ 3 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 5 ]       =  0.00000;
    performanceMin[ 3 ][ 5 ]          = 0.665097;
    performanceMax[ 3 ][ 5 ]          =  1.17142;
    coeffPerformance[ 0 ][ 3 ][ 5 ]   = 0.892428;
    coeffPerformance[ 1 ][ 3 ][ 5 ]   = -1.16274;
    coeffPerformance[ 2 ][ 3 ][ 5 ]   = -.425139;
    coeffPerformance[ 3 ][ 3 ][ 5 ]   = 0.270713;
    coeffPerformance[ 4 ][ 3 ][ 5 ]   =  1.96020;
    coeffPerformance[ 5 ][ 3 ][ 5 ]   =  2.87944;
    coeffPerformance[ 6 ][ 3 ][ 5 ]   = -1.25365;
    coeffPerformance[ 7 ][ 3 ][ 5 ]   = -.853581E-01;
    coeffPerformance[ 8 ][ 3 ][ 5 ]   = -.136061;
    coeffPerformance[ 9 ][ 3 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 5 ]  =  0.00000;
    powerMin[ 3 ][ 5 ]                = 0.662777;
    powerMax[ 3 ][ 5 ]                =  1.13826;
    coeffPower[ 0 ][ 3 ][ 5 ]         = 0.920841;
    coeffPower[ 1 ][ 3 ][ 5 ]         = 0.875207;
    coeffPower[ 2 ][ 3 ][ 5 ]         = -.967172E-01;
    coeffPower[ 3 ][ 3 ][ 5 ]         = 0.558532E-01;
    coeffPower[ 4 ][ 3 ][ 5 ]         = -1.48967;
    coeffPower[ 5 ][ 3 ][ 5 ]         = 0.181880;
    coeffPower[ 6 ][ 3 ][ 5 ]         = 0.465921E-01;
    coeffPower[ 7 ][ 3 ][ 5 ]         = -.329365;
    coeffPower[ 8 ][ 3 ][ 5 ]         = 0.198547;
    coeffPower[ 9 ][ 3 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 5 ]        =  0.00000;
    energyMin[ 4 ][ 5 ]               = 0.736877;
    energyMax[ 4 ][ 5 ]               =  1.24855;
    coeffEnergy[ 0 ][ 4 ][ 5 ]        =  1.00860;
    coeffEnergy[ 1 ][ 4 ][ 5 ]        =  1.18759;
    coeffEnergy[ 2 ][ 4 ][ 5 ]        = 0.142574;
    coeffEnergy[ 3 ][ 4 ][ 5 ]        = -.966221E-01;
    coeffEnergy[ 4 ][ 4 ][ 5 ]        = -2.00868;
    coeffEnergy[ 5 ][ 4 ][ 5 ]        = -1.10331;
    coeffEnergy[ 6 ][ 4 ][ 5 ]        = 0.473745;
    coeffEnergy[ 7 ][ 4 ][ 5 ]        = -.212310;
    coeffEnergy[ 8 ][ 4 ][ 5 ]        = 0.353920;
    coeffEnergy[ 9 ][ 4 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 5 ]       =  0.00000;
    performanceMin[ 4 ][ 5 ]          = 0.735722;
    performanceMax[ 4 ][ 5 ]          =  1.18928;
    coeffPerformance[ 0 ][ 4 ][ 5 ]   = 0.938096;
    coeffPerformance[ 1 ][ 4 ][ 5 ]   = -.407572;
    coeffPerformance[ 2 ][ 4 ][ 5 ]   = -.172792;
    coeffPerformance[ 3 ][ 4 ][ 5 ]   = 0.117313;
    coeffPerformance[ 4 ][ 4 ][ 5 ]   = 0.688791;
    coeffPerformance[ 5 ][ 4 ][ 5 ]   =  1.62002;
    coeffPerformance[ 6 ][ 4 ][ 5 ]   = -.610015;
    coeffPerformance[ 7 ][ 4 ][ 5 ]   = 0.129207;
    coeffPerformance[ 8 ][ 4 ][ 5 ]   = -.339891;
    coeffPerformance[ 9 ][ 4 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 5 ]  =  0.00000;
    powerMin[ 4 ][ 5 ]                = 0.719253;
    powerMax[ 4 ][ 5 ]                =  1.17148;
    coeffPower[ 0 ][ 4 ][ 5 ]         = 0.946384;
    coeffPower[ 1 ][ 4 ][ 5 ]         = 0.729722;
    coeffPower[ 2 ][ 4 ][ 5 ]         = -.314398E-01;
    coeffPower[ 3 ][ 4 ][ 5 ]         = 0.217785E-01;
    coeffPower[ 4 ][ 4 ][ 5 ]         = -1.23491;
    coeffPower[ 5 ][ 4 ][ 5 ]         = 0.544822;
    coeffPower[ 6 ][ 4 ][ 5 ]         = -.148663;
    coeffPower[ 7 ][ 4 ][ 5 ]         = -.738856E-01;
    coeffPower[ 8 ][ 4 ][ 5 ]         = -.239871E-03;
    coeffPower[ 9 ][ 4 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 5 ]        =  0.00000;
    energyMin[ 5 ][ 5 ]               = 0.800000;
    energyMax[ 5 ][ 5 ]               =  1.20000;
    coeffEnergy[ 0 ][ 5 ][ 5 ]        =  1.00000;
    coeffEnergy[ 1 ][ 5 ][ 5 ]        = -.186156E-11;
    coeffEnergy[ 2 ][ 5 ][ 5 ]        = -.115609E-11;
    coeffEnergy[ 3 ][ 5 ][ 5 ]        = 0.686220E-12;
    coeffEnergy[ 4 ][ 5 ][ 5 ]        = 0.316938E-11;
    coeffEnergy[ 5 ][ 5 ][ 5 ]        = 0.536896E-13;
    coeffEnergy[ 6 ][ 5 ][ 5 ]        = -.365449E-12;
    coeffEnergy[ 7 ][ 5 ][ 5 ]        = -.266984E-12;
    coeffEnergy[ 8 ][ 5 ][ 5 ]        = 0.517238E-12;
    coeffEnergy[ 9 ][ 5 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 5 ]       =  0.00000;
    performanceMin[ 5 ][ 5 ]          = 0.800000;
    performanceMax[ 5 ][ 5 ]          =  1.20000;
    coeffPerformance[ 0 ][ 5 ][ 5 ]   =  1.00000;
    coeffPerformance[ 1 ][ 5 ][ 5 ]   = -.106876E-12;
    coeffPerformance[ 2 ][ 5 ][ 5 ]   = -.115931E-12;
    coeffPerformance[ 3 ][ 5 ][ 5 ]   = 0.696346E-13;
    coeffPerformance[ 4 ][ 5 ][ 5 ]   = 0.180514E-12;
    coeffPerformance[ 5 ][ 5 ][ 5 ]   = 0.974853E-14;
    coeffPerformance[ 6 ][ 5 ][ 5 ]   = -.152719E-14;
    coeffPerformance[ 7 ][ 5 ][ 5 ]   = 0.341108E-14;
    coeffPerformance[ 8 ][ 5 ][ 5 ]   = -.496063E-13;
    coeffPerformance[ 9 ][ 5 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 5 ]  =  0.00000;
    powerMin[ 5 ][ 5 ]                = 0.800000;
    powerMax[ 5 ][ 5 ]                =  1.20000;
    coeffPower[ 0 ][ 5 ][ 5 ]         =  1.00000;
    coeffPower[ 1 ][ 5 ][ 5 ]         = -.279176E-13;
    coeffPower[ 2 ][ 5 ][ 5 ]         = 0.247094E-13;
    coeffPower[ 3 ][ 5 ][ 5 ]         = -.146239E-13;
    coeffPower[ 4 ][ 5 ][ 5 ]         = 0.471137E-13;
    coeffPower[ 5 ][ 5 ][ 5 ]         = -.682605E-14;
    coeffPower[ 6 ][ 5 ][ 5 ]         = -.368060E-13;
    coeffPower[ 7 ][ 5 ][ 5 ]         = -.685510E-14;
    coeffPower[ 8 ][ 5 ][ 5 ]         = 0.196613E-13;
    coeffPower[ 9 ][ 5 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 5 ]        =  0.00000;
    energyMin[ 6 ][ 5 ]               = 0.759373;
    energyMax[ 6 ][ 5 ]               =  1.27918;
    coeffEnergy[ 0 ][ 6 ][ 5 ]        =  1.00110;
    coeffEnergy[ 1 ][ 6 ][ 5 ]        = -1.57300;
    coeffEnergy[ 2 ][ 6 ][ 5 ]        = -.109211;
    coeffEnergy[ 3 ][ 6 ][ 5 ]        = 0.753259E-01;
    coeffEnergy[ 4 ][ 6 ][ 5 ]        =  2.66047;
    coeffEnergy[ 5 ][ 6 ][ 5 ]        = 0.557203;
    coeffEnergy[ 6 ][ 6 ][ 5 ]        = -.114928;
    coeffEnergy[ 7 ][ 6 ][ 5 ]        = 0.221383;
    coeffEnergy[ 8 ][ 6 ][ 5 ]        = -.418200;
    coeffEnergy[ 9 ][ 6 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 5 ]       =  0.00000;
    performanceMin[ 6 ][ 5 ]          = 0.798628;
    performanceMax[ 6 ][ 5 ]          =  1.32696;
    coeffPerformance[ 0 ][ 6 ][ 5 ]   =  1.05332;
    coeffPerformance[ 1 ][ 6 ][ 5 ]   =  1.02172;
    coeffPerformance[ 2 ][ 6 ][ 5 ]   = 0.107975;
    coeffPerformance[ 3 ][ 6 ][ 5 ]   = -.792594E-01;
    coeffPerformance[ 4 ][ 6 ][ 5 ]   = -1.72556;
    coeffPerformance[ 5 ][ 6 ][ 5 ]   = -1.39230;
    coeffPerformance[ 6 ][ 6 ][ 5 ]   = 0.485757;
    coeffPerformance[ 7 ][ 6 ][ 5 ]   = -.192752;
    coeffPerformance[ 8 ][ 6 ][ 5 ]   = 0.460353;
    coeffPerformance[ 9 ][ 6 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 5 ]  =  0.00000;
    powerMin[ 6 ][ 5 ]                = 0.812213;
    powerMax[ 6 ][ 5 ]                =  1.32840;
    coeffPower[ 0 ][ 6 ][ 5 ]         =  1.05404;
    coeffPower[ 1 ][ 6 ][ 5 ]         = -.595420;
    coeffPower[ 2 ][ 6 ][ 5 ]         = -.330259E-02;
    coeffPower[ 3 ][ 6 ][ 5 ]         = -.226273E-02;
    coeffPower[ 4 ][ 6 ][ 5 ]         =  1.00959;
    coeffPower[ 5 ][ 6 ][ 5 ]         = -.820169;
    coeffPower[ 6 ][ 6 ][ 5 ]         = 0.373198;
    coeffPower[ 7 ][ 6 ][ 5 ]         = 0.418008E-01;
    coeffPower[ 8 ][ 6 ][ 5 ]         = 0.176303E-01;
    coeffPower[ 9 ][ 6 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 5 ]        =  0.00000;
    energyMin[ 7 ][ 5 ]               = 0.775297;
    energyMax[ 7 ][ 5 ]               =  1.32664;
    coeffEnergy[ 0 ][ 7 ][ 5 ]        =  1.00371;
    coeffEnergy[ 1 ][ 7 ][ 5 ]        = -3.54841;
    coeffEnergy[ 2 ][ 7 ][ 5 ]        = -.825732;
    coeffEnergy[ 3 ][ 7 ][ 5 ]        = 0.503869;
    coeffEnergy[ 4 ][ 7 ][ 5 ]        =  6.00535;
    coeffEnergy[ 5 ][ 7 ][ 5 ]        =  1.84632;
    coeffEnergy[ 6 ][ 7 ][ 5 ]        = -.934011;
    coeffEnergy[ 7 ][ 7 ][ 5 ]        = 0.351453E-01;
    coeffEnergy[ 8 ][ 7 ][ 5 ]        = -.103664;
    coeffEnergy[ 9 ][ 7 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 5 ]       =  0.00000;
    performanceMin[ 7 ][ 5 ]          = 0.804194;
    performanceMax[ 7 ][ 5 ]          =  1.37308;
    coeffPerformance[ 0 ][ 7 ][ 5 ]   =  1.09262;
    coeffPerformance[ 1 ][ 7 ][ 5 ]   =  2.97249;
    coeffPerformance[ 2 ][ 7 ][ 5 ]   = 0.550408;
    coeffPerformance[ 3 ][ 7 ][ 5 ]   = -.346135;
    coeffPerformance[ 4 ][ 7 ][ 5 ]   = -5.02269;
    coeffPerformance[ 5 ][ 7 ][ 5 ]   = -3.34382;
    coeffPerformance[ 6 ][ 7 ][ 5 ]   =  1.66768;
    coeffPerformance[ 7 ][ 7 ][ 5 ]   = 0.201838;
    coeffPerformance[ 8 ][ 7 ][ 5 ]   = 0.139095E-01;
    coeffPerformance[ 9 ][ 7 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 5 ]  =  0.00000;
    powerMin[ 7 ][ 5 ]                = 0.844544;
    powerMax[ 7 ][ 5 ]                =  1.39106;
    coeffPower[ 0 ][ 7 ][ 5 ]         =  1.09514;
    coeffPower[ 1 ][ 7 ][ 5 ]         = -.790519;
    coeffPower[ 2 ][ 7 ][ 5 ]         = -.310113;
    coeffPower[ 3 ][ 7 ][ 5 ]         = 0.179140;
    coeffPower[ 4 ][ 7 ][ 5 ]         =  1.34620;
    coeffPower[ 5 ][ 7 ][ 5 ]         = -1.43757;
    coeffPower[ 6 ][ 7 ][ 5 ]         = 0.708136;
    coeffPower[ 7 ][ 7 ][ 5 ]         = 0.262421;
    coeffPower[ 8 ][ 7 ][ 5 ]         = -.111956;
    coeffPower[ 9 ][ 7 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 5 ]        =  0.00000;
    energyMin[ 8 ][ 5 ]               = 0.774026;
    energyMax[ 8 ][ 5 ]               =  1.37669;
    coeffEnergy[ 0 ][ 8 ][ 5 ]        =  1.00162;
    coeffEnergy[ 1 ][ 8 ][ 5 ]        = -4.70457;
    coeffEnergy[ 2 ][ 8 ][ 5 ]        = -1.23803;
    coeffEnergy[ 3 ][ 8 ][ 5 ]        = 0.755717;
    coeffEnergy[ 4 ][ 8 ][ 5 ]        =  7.96533;
    coeffEnergy[ 5 ][ 8 ][ 5 ]        =  2.89612;
    coeffEnergy[ 6 ][ 8 ][ 5 ]        = -1.40871;
    coeffEnergy[ 7 ][ 8 ][ 5 ]        = 0.535251E-01;
    coeffEnergy[ 8 ][ 8 ][ 5 ]        = -.112226;
    coeffEnergy[ 9 ][ 8 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 5 ]       =  0.00000;
    performanceMin[ 8 ][ 5 ]          = 0.808834;
    performanceMax[ 8 ][ 5 ]          =  1.44467;
    coeffPerformance[ 0 ][ 8 ][ 5 ]   =  1.14501;
    coeffPerformance[ 1 ][ 8 ][ 5 ]   =  4.38877;
    coeffPerformance[ 2 ][ 8 ][ 5 ]   = 0.905498;
    coeffPerformance[ 3 ][ 8 ][ 5 ]   = -.569607;
    coeffPerformance[ 4 ][ 8 ][ 5 ]   = -7.41971;
    coeffPerformance[ 5 ][ 8 ][ 5 ]   = -5.28415;
    coeffPerformance[ 6 ][ 8 ][ 5 ]   =  2.58048;
    coeffPerformance[ 7 ][ 8 ][ 5 ]   = 0.257145;
    coeffPerformance[ 8 ][ 8 ][ 5 ]   = 0.108639;
    coeffPerformance[ 9 ][ 8 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 5 ]  =  0.00000;
    powerMin[ 8 ][ 5 ]                = 0.866842;
    powerMax[ 8 ][ 5 ]                =  1.47146;
    coeffPower[ 0 ][ 8 ][ 5 ]         =  1.14411;
    coeffPower[ 1 ][ 8 ][ 5 ]         = -.693862;
    coeffPower[ 2 ][ 8 ][ 5 ]         = -.387560;
    coeffPower[ 3 ][ 8 ][ 5 ]         = 0.220324;
    coeffPower[ 4 ][ 8 ][ 5 ]         =  1.18631;
    coeffPower[ 5 ][ 8 ][ 5 ]         = -2.25291;
    coeffPower[ 6 ][ 8 ][ 5 ]         =  1.11015;
    coeffPower[ 7 ][ 8 ][ 5 ]         = 0.364995;
    coeffPower[ 8 ][ 8 ][ 5 ]         = -.433106E-01;
    coeffPower[ 9 ][ 8 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 5 ]        =  0.00000;
    energyMin[ 9 ][ 5 ]               = 0.775373;
    energyMax[ 9 ][ 5 ]               =  1.41366;
    coeffEnergy[ 0 ][ 9 ][ 5 ]        =  1.01074;
    coeffEnergy[ 1 ][ 9 ][ 5 ]        = -6.35972;
    coeffEnergy[ 2 ][ 9 ][ 5 ]        = -1.64952;
    coeffEnergy[ 3 ][ 9 ][ 5 ]        =  1.00481;
    coeffEnergy[ 4 ][ 9 ][ 5 ]        =  10.7639;
    coeffEnergy[ 5 ][ 9 ][ 5 ]        =  3.75215;
    coeffEnergy[ 6 ][ 9 ][ 5 ]        = -1.81679;
    coeffEnergy[ 7 ][ 9 ][ 5 ]        = 0.113148;
    coeffEnergy[ 8 ][ 9 ][ 5 ]        = -.125716;
    coeffEnergy[ 9 ][ 9 ][ 5 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 5 ]       =  0.00000;
    performanceMin[ 9 ][ 5 ]          = 0.812804;
    performanceMax[ 9 ][ 5 ]          =  1.51627;
    coeffPerformance[ 0 ][ 9 ][ 5 ]   =  1.17469;
    coeffPerformance[ 1 ][ 9 ][ 5 ]   =  6.73133;
    coeffPerformance[ 2 ][ 9 ][ 5 ]   =  1.27290;
    coeffPerformance[ 3 ][ 9 ][ 5 ]   = -.794172;
    coeffPerformance[ 4 ][ 9 ][ 5 ]   = -11.3741;
    coeffPerformance[ 5 ][ 9 ][ 5 ]   = -6.40414;
    coeffPerformance[ 6 ][ 9 ][ 5 ]   =  3.05159;
    coeffPerformance[ 7 ][ 9 ][ 5 ]   = 0.281986;
    coeffPerformance[ 8 ][ 9 ][ 5 ]   = 0.181178;
    coeffPerformance[ 9 ][ 9 ][ 5 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 5 ]  =  0.00000;
    powerMin[ 9 ][ 5 ]                = 0.893093;
    powerMax[ 9 ][ 5 ]                =  1.57064;
    coeffPower[ 0 ][ 9 ][ 5 ]         =  1.18098;
    coeffPower[ 1 ][ 9 ][ 5 ]         = -.241194;
    coeffPower[ 2 ][ 9 ][ 5 ]         = -.462793;
    coeffPower[ 3 ][ 9 ][ 5 ]         = 0.264455;
    coeffPower[ 4 ][ 9 ][ 5 ]         = 0.428580;
    coeffPower[ 5 ][ 9 ][ 5 ]         = -2.43217;
    coeffPower[ 6 ][ 9 ][ 5 ]         =  1.13076;
    coeffPower[ 7 ][ 9 ][ 5 ]         = 0.501150;
    coeffPower[ 8 ][ 9 ][ 5 ]         = -.175049E-01;
    coeffPower[ 9 ][ 9 ][ 5 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 5 ]        =  0.00000;
    energyMin[ 10 ][ 5 ]              = 0.775085;
    energyMax[ 10 ][ 5 ]              =  1.44862;
    coeffEnergy[ 0 ][ 10 ][ 5 ]       =  1.02146;
    coeffEnergy[ 1 ][ 10 ][ 5 ]       = -7.25813;
    coeffEnergy[ 2 ][ 10 ][ 5 ]       = -1.75189;
    coeffEnergy[ 3 ][ 10 ][ 5 ]       =  1.07013;
    coeffEnergy[ 4 ][ 10 ][ 5 ]       =  12.2827;
    coeffEnergy[ 5 ][ 10 ][ 5 ]       =  4.66296;
    coeffEnergy[ 6 ][ 10 ][ 5 ]       = -2.26994;
    coeffEnergy[ 7 ][ 10 ][ 5 ]       = 0.136110;
    coeffEnergy[ 8 ][ 10 ][ 5 ]       = -.961840E-01;
    coeffEnergy[ 9 ][ 10 ][ 5 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 5 ]      =  0.00000;
    performanceMin[ 10 ][ 5 ]         = 0.824433;
    performanceMax[ 10 ][ 5 ]         =  1.59012;
    coeffPerformance[ 0 ][ 10 ][ 5 ]  =  1.21873;
    coeffPerformance[ 1 ][ 10 ][ 5 ]  =  8.48647;
    coeffPerformance[ 2 ][ 10 ][ 5 ]  =  1.50464;
    coeffPerformance[ 3 ][ 10 ][ 5 ]  = -.941656;
    coeffPerformance[ 4 ][ 10 ][ 5 ]  = -14.3408;
    coeffPerformance[ 5 ][ 10 ][ 5 ]  = -8.09776;
    coeffPerformance[ 6 ][ 10 ][ 5 ]  =  3.87515;
    coeffPerformance[ 7 ][ 10 ][ 5 ]  = 0.325358;
    coeffPerformance[ 8 ][ 10 ][ 5 ]  = 0.220058;
    coeffPerformance[ 9 ][ 10 ][ 5 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 5 ] =  0.00000;
    powerMin[ 10 ][ 5 ]               = 0.917957;
    powerMax[ 10 ][ 5 ]               =  1.68545;
    coeffPower[ 0 ][ 10 ][ 5 ]        =  1.23727;
    coeffPower[ 1 ][ 10 ][ 5 ]        = 0.458452;
    coeffPower[ 2 ][ 10 ][ 5 ]        = -.353997;
    coeffPower[ 3 ][ 10 ][ 5 ]        = 0.194686;
    coeffPower[ 4 ][ 10 ][ 5 ]        = -.753653;
    coeffPower[ 5 ][ 10 ][ 5 ]        = -3.16511;
    coeffPower[ 6 ][ 10 ][ 5 ]        =  1.46137;
    coeffPower[ 7 ][ 10 ][ 5 ]        = 0.593758;
    coeffPower[ 8 ][ 10 ][ 5 ]        = 0.561942E-01;
    coeffPower[ 9 ][ 10 ][ 5 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 5 ]       =  0.00000;
    energyMin[ 11 ][ 5 ]              = 0.782759;
    energyMax[ 11 ][ 5 ]              =  1.51244;
    coeffEnergy[ 0 ][ 11 ][ 5 ]       =  1.03611;
    coeffEnergy[ 1 ][ 11 ][ 5 ]       = -8.95436;
    coeffEnergy[ 2 ][ 11 ][ 5 ]       = -2.04532;
    coeffEnergy[ 3 ][ 11 ][ 5 ]       =  1.24960;
    coeffEnergy[ 4 ][ 11 ][ 5 ]       =  15.1529;
    coeffEnergy[ 5 ][ 11 ][ 5 ]       =  5.82668;
    coeffEnergy[ 6 ][ 11 ][ 5 ]       = -2.86918;
    coeffEnergy[ 7 ][ 11 ][ 5 ]       = 0.154502E-02;
    coeffEnergy[ 8 ][ 11 ][ 5 ]       = 0.119334E-01;
    coeffEnergy[ 9 ][ 11 ][ 5 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 5 ]      =  0.00000;
    performanceMin[ 11 ][ 5 ]         = 0.822822;
    performanceMax[ 11 ][ 5 ]         =  1.66096;
    coeffPerformance[ 0 ][ 11 ][ 5 ]  =  1.26088;
    coeffPerformance[ 1 ][ 11 ][ 5 ]  =  10.8080;
    coeffPerformance[ 2 ][ 11 ][ 5 ]  =  1.89770;
    coeffPerformance[ 3 ][ 11 ][ 5 ]  = -1.18583;
    coeffPerformance[ 4 ][ 11 ][ 5 ]  = -18.2661;
    coeffPerformance[ 5 ][ 11 ][ 5 ]  = -10.0364;
    coeffPerformance[ 6 ][ 11 ][ 5 ]  =  4.83972;
    coeffPerformance[ 7 ][ 11 ][ 5 ]  = 0.477082;
    coeffPerformance[ 8 ][ 11 ][ 5 ]  = 0.228889;
    coeffPerformance[ 9 ][ 11 ][ 5 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 5 ] =  0.00000;
    powerMin[ 11 ][ 5 ]               = 0.948070;
    powerMax[ 11 ][ 5 ]               =  1.77126;
    coeffPower[ 0 ][ 11 ][ 5 ]        =  1.29229;
    coeffPower[ 1 ][ 11 ][ 5 ]        = 0.780963;
    coeffPower[ 2 ][ 11 ][ 5 ]        = -.283504;
    coeffPower[ 3 ][ 11 ][ 5 ]        = 0.148594;
    coeffPower[ 4 ][ 11 ][ 5 ]        = -1.29423;
    coeffPower[ 5 ][ 11 ][ 5 ]        = -3.90004;
    coeffPower[ 6 ][ 11 ][ 5 ]        =  1.82001;
    coeffPower[ 7 ][ 11 ][ 5 ]        = 0.683972;
    coeffPower[ 8 ][ 11 ][ 5 ]        = 0.121133;
    coeffPower[ 9 ][ 11 ][ 5 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 5 ]       =  0.00000;
    energyMin[ 12 ][ 5 ]              = 0.785609;
    energyMax[ 12 ][ 5 ]              =  1.55141;
    coeffEnergy[ 0 ][ 12 ][ 5 ]       =  1.05687;
    coeffEnergy[ 1 ][ 12 ][ 5 ]       = -9.72075;
    coeffEnergy[ 2 ][ 12 ][ 5 ]       = -2.12000;
    coeffEnergy[ 3 ][ 12 ][ 5 ]       =  1.30024;
    coeffEnergy[ 4 ][ 12 ][ 5 ]       =  16.4439;
    coeffEnergy[ 5 ][ 12 ][ 5 ]       =  6.95913;
    coeffEnergy[ 6 ][ 12 ][ 5 ]       = -3.38328;
    coeffEnergy[ 7 ][ 12 ][ 5 ]       = -.609763E-01;
    coeffEnergy[ 8 ][ 12 ][ 5 ]       = -.734610E-01;
    coeffEnergy[ 9 ][ 12 ][ 5 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 5 ]      =  0.00000;
    performanceMin[ 12 ][ 5 ]         = 0.829812;
    performanceMax[ 12 ][ 5 ]         =  1.73205;
    coeffPerformance[ 0 ][ 12 ][ 5 ]  =  1.30367;
    coeffPerformance[ 1 ][ 12 ][ 5 ]  =  12.4523;
    coeffPerformance[ 2 ][ 12 ][ 5 ]  =  2.17452;
    coeffPerformance[ 3 ][ 12 ][ 5 ]  = -1.36311;
    coeffPerformance[ 4 ][ 12 ][ 5 ]  = -21.0428;
    coeffPerformance[ 5 ][ 12 ][ 5 ]  = -11.9903;
    coeffPerformance[ 6 ][ 12 ][ 5 ]  =  5.72325;
    coeffPerformance[ 7 ][ 12 ][ 5 ]  = 0.484483;
    coeffPerformance[ 8 ][ 12 ][ 5 ]  = 0.423652;
    coeffPerformance[ 9 ][ 12 ][ 5 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 5 ] =  0.00000;
    powerMin[ 12 ][ 5 ]               = 0.976679;
    powerMax[ 12 ][ 5 ]               =  1.83481;
    coeffPower[ 0 ][ 12 ][ 5 ]        =  1.35926;
    coeffPower[ 1 ][ 12 ][ 5 ]        =  1.56986;
    coeffPower[ 2 ][ 12 ][ 5 ]        = -.776306E-01;
    coeffPower[ 3 ][ 12 ][ 5 ]        = 0.196627E-01;
    coeffPower[ 4 ][ 12 ][ 5 ]        = -2.62962;
    coeffPower[ 5 ][ 12 ][ 5 ]        = -4.70750;
    coeffPower[ 6 ][ 12 ][ 5 ]        =  2.16469;
    coeffPower[ 7 ][ 12 ][ 5 ]        = 0.651169;
    coeffPower[ 8 ][ 12 ][ 5 ]        = 0.238516;
    coeffPower[ 9 ][ 12 ][ 5 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 5 ]       =  0.00000;
    energyMin[ 13 ][ 5 ]              = 0.792628;
    energyMax[ 13 ][ 5 ]              =  1.60363;
    coeffEnergy[ 0 ][ 13 ][ 5 ]       =  1.06008;
    coeffEnergy[ 1 ][ 13 ][ 5 ]       = -10.9048;
    coeffEnergy[ 2 ][ 13 ][ 5 ]       = -2.20733;
    coeffEnergy[ 3 ][ 13 ][ 5 ]       =  1.36194;
    coeffEnergy[ 4 ][ 13 ][ 5 ]       =  18.4516;
    coeffEnergy[ 5 ][ 13 ][ 5 ]       =  8.00741;
    coeffEnergy[ 6 ][ 13 ][ 5 ]       = -3.82401;
    coeffEnergy[ 7 ][ 13 ][ 5 ]       = 0.128912;
    coeffEnergy[ 8 ][ 13 ][ 5 ]       = -.249535;
    coeffEnergy[ 9 ][ 13 ][ 5 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 5 ]      =  0.00000;
    performanceMin[ 13 ][ 5 ]         = 0.832612;
    performanceMax[ 13 ][ 5 ]         =  1.80691;
    coeffPerformance[ 0 ][ 13 ][ 5 ]  =  1.35097;
    coeffPerformance[ 1 ][ 13 ][ 5 ]  =  14.0459;
    coeffPerformance[ 2 ][ 13 ][ 5 ]  =  2.38126;
    coeffPerformance[ 3 ][ 13 ][ 5 ]  = -1.49909;
    coeffPerformance[ 4 ][ 13 ][ 5 ]  = -23.7367;
    coeffPerformance[ 5 ][ 13 ][ 5 ]  = -13.8369;
    coeffPerformance[ 6 ][ 13 ][ 5 ]  =  6.51580;
    coeffPerformance[ 7 ][ 13 ][ 5 ]  = 0.381725;
    coeffPerformance[ 8 ][ 13 ][ 5 ]  = 0.657116;
    coeffPerformance[ 9 ][ 13 ][ 5 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 5 ] =  0.00000;
    powerMin[ 13 ][ 5 ]               =  1.00858;
    powerMax[ 13 ][ 5 ]               =  1.90262;
    coeffPower[ 0 ][ 13 ][ 5 ]        =  1.41100;
    coeffPower[ 1 ][ 13 ][ 5 ]        =  1.68702;
    coeffPower[ 2 ][ 13 ][ 5 ]        = 0.158049E-01;
    coeffPower[ 3 ][ 13 ][ 5 ]        = -.390813E-01;
    coeffPower[ 4 ][ 13 ][ 5 ]        = -2.81842;
    coeffPower[ 5 ][ 13 ][ 5 ]        = -5.52918;
    coeffPower[ 6 ][ 13 ][ 5 ]        =  2.48893;
    coeffPower[ 7 ][ 13 ][ 5 ]        = 0.788014;
    coeffPower[ 8 ][ 13 ][ 5 ]        = 0.316704;
    coeffPower[ 9 ][ 13 ][ 5 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 5 ]       =  0.00000;
    energyMin[ 14 ][ 5 ]              = 0.797360;
    energyMax[ 14 ][ 5 ]              =  1.65953;
    coeffEnergy[ 0 ][ 14 ][ 5 ]       =  1.07415;
    coeffEnergy[ 1 ][ 14 ][ 5 ]       = -12.3252;
    coeffEnergy[ 2 ][ 14 ][ 5 ]       = -2.34809;
    coeffEnergy[ 3 ][ 14 ][ 5 ]       =  1.45494;
    coeffEnergy[ 4 ][ 14 ][ 5 ]       =  20.8572;
    coeffEnergy[ 5 ][ 14 ][ 5 ]       =  9.29877;
    coeffEnergy[ 6 ][ 14 ][ 5 ]       = -4.46779;
    coeffEnergy[ 7 ][ 14 ][ 5 ]       = 0.117027;
    coeffEnergy[ 8 ][ 14 ][ 5 ]       = -.343705;
    coeffEnergy[ 9 ][ 14 ][ 5 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 5 ]      =  0.00000;
    performanceMin[ 14 ][ 5 ]         = 0.832612;
    performanceMax[ 14 ][ 5 ]         =  1.88001;
    coeffPerformance[ 0 ][ 14 ][ 5 ]  =  1.39887;
    coeffPerformance[ 1 ][ 14 ][ 5 ]  =  16.7834;
    coeffPerformance[ 2 ][ 14 ][ 5 ]  =  2.74386;
    coeffPerformance[ 3 ][ 14 ][ 5 ]  = -1.72680;
    coeffPerformance[ 4 ][ 14 ][ 5 ]  = -28.3702;
    coeffPerformance[ 5 ][ 14 ][ 5 ]  = -15.7571;
    coeffPerformance[ 6 ][ 14 ][ 5 ]  =  7.43062;
    coeffPerformance[ 7 ][ 14 ][ 5 ]  = 0.453433;
    coeffPerformance[ 8 ][ 14 ][ 5 ]  = 0.742898;
    coeffPerformance[ 9 ][ 14 ][ 5 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 5 ] =  0.00000;
    powerMin[ 14 ][ 5 ]               =  1.04013;
    powerMax[ 14 ][ 5 ]               =  1.98510;
    coeffPower[ 0 ][ 14 ][ 5 ]        =  1.47653;
    coeffPower[ 1 ][ 14 ][ 5 ]        =  2.76089;
    coeffPower[ 2 ][ 14 ][ 5 ]        = 0.184968;
    coeffPower[ 3 ][ 14 ][ 5 ]        = -.142620;
    coeffPower[ 4 ][ 14 ][ 5 ]        = -4.63228;
    coeffPower[ 5 ][ 14 ][ 5 ]        = -6.26206;
    coeffPower[ 6 ][ 14 ][ 5 ]        =  2.79874;
    coeffPower[ 7 ][ 14 ][ 5 ]        = 0.903712;
    coeffPower[ 8 ][ 14 ][ 5 ]        = 0.295224;
    coeffPower[ 9 ][ 14 ][ 5 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 5 ]       =  0.00000;
    energyMin[ 15 ][ 5 ]              = 0.801503;
    energyMax[ 15 ][ 5 ]              =  1.75954;
    coeffEnergy[ 0 ][ 15 ][ 5 ]       =  1.09046;
    coeffEnergy[ 1 ][ 15 ][ 5 ]       = -12.3751;
    coeffEnergy[ 2 ][ 15 ][ 5 ]       = -2.34525;
    coeffEnergy[ 3 ][ 15 ][ 5 ]       =  1.46434;
    coeffEnergy[ 4 ][ 15 ][ 5 ]       =  20.9373;
    coeffEnergy[ 5 ][ 15 ][ 5 ]       =  10.6955;
    coeffEnergy[ 6 ][ 15 ][ 5 ]       = -5.06240;
    coeffEnergy[ 7 ][ 15 ][ 5 ]       = 0.211597;
    coeffEnergy[ 8 ][ 15 ][ 5 ]       = -.579202;
    coeffEnergy[ 9 ][ 15 ][ 5 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 5 ]      =  0.00000;
    performanceMin[ 15 ][ 5 ]         = 0.835760;
    performanceMax[ 15 ][ 5 ]         =  1.94959;
    coeffPerformance[ 0 ][ 15 ][ 5 ]  =  1.44313;
    coeffPerformance[ 1 ][ 15 ][ 5 ]  =  16.7267;
    coeffPerformance[ 2 ][ 15 ][ 5 ]  =  2.72146;
    coeffPerformance[ 3 ][ 15 ][ 5 ]  = -1.72988;
    coeffPerformance[ 4 ][ 15 ][ 5 ]  = -28.2626;
    coeffPerformance[ 5 ][ 15 ][ 5 ]  = -18.2042;
    coeffPerformance[ 6 ][ 15 ][ 5 ]  =  8.57373;
    coeffPerformance[ 7 ][ 15 ][ 5 ]  = 0.425790;
    coeffPerformance[ 8 ][ 15 ][ 5 ]  = 0.987976;
    coeffPerformance[ 9 ][ 15 ][ 5 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 5 ] =  0.00000;
    powerMin[ 15 ][ 5 ]               =  1.07408;
    powerMax[ 15 ][ 5 ]               =  2.09831;
    coeffPower[ 0 ][ 15 ][ 5 ]        =  1.53869;
    coeffPower[ 1 ][ 15 ][ 5 ]        =  2.94282;
    coeffPower[ 2 ][ 15 ][ 5 ]        = 0.253503;
    coeffPower[ 3 ][ 15 ][ 5 ]        = -.187144;
    coeffPower[ 4 ][ 15 ][ 5 ]        = -4.93033;
    coeffPower[ 5 ][ 15 ][ 5 ]        = -7.31799;
    coeffPower[ 6 ][ 15 ][ 5 ]        =  3.36283;
    coeffPower[ 7 ][ 15 ][ 5 ]        =  1.09477;
    coeffPower[ 8 ][ 15 ][ 5 ]        = 0.213065;
    coeffPower[ 9 ][ 15 ][ 5 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 5 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 1.80;
    energyMin[ 0 ][ 6 ]               = 0.653226;
    energyMax[ 0 ][ 6 ]               =  1.39489;
    coeffEnergy[ 0 ][ 0 ][ 6 ]        =  1.10209;
    coeffEnergy[ 1 ][ 0 ][ 6 ]        =  6.36527;
    coeffEnergy[ 2 ][ 0 ][ 6 ]        =  1.01998;
    coeffEnergy[ 3 ][ 0 ][ 6 ]        = -.624619;
    coeffEnergy[ 4 ][ 0 ][ 6 ]        = -11.4053;
    coeffEnergy[ 5 ][ 0 ][ 6 ]        = -7.69641;
    coeffEnergy[ 6 ][ 0 ][ 6 ]        =  2.81888;
    coeffEnergy[ 7 ][ 0 ][ 6 ]        = -.734583;
    coeffEnergy[ 8 ][ 0 ][ 6 ]        =  1.27575;
    coeffEnergy[ 9 ][ 0 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 6 ]       =  0.00000;
    performanceMin[ 0 ][ 6 ]          = 0.527831;
    performanceMax[ 0 ][ 6 ]          =  1.06098;
    coeffPerformance[ 0 ][ 0 ][ 6 ]   = 0.664637;
    coeffPerformance[ 1 ][ 0 ][ 6 ]   = -1.16237;
    coeffPerformance[ 2 ][ 0 ][ 6 ]   = -.967493;
    coeffPerformance[ 3 ][ 0 ][ 6 ]   = 0.593230;
    coeffPerformance[ 4 ][ 0 ][ 6 ]   =  2.07395;
    coeffPerformance[ 5 ][ 0 ][ 6 ]   =  6.89011;
    coeffPerformance[ 6 ][ 0 ][ 6 ]   = -3.09970;
    coeffPerformance[ 7 ][ 0 ][ 6 ]   = 0.357341E-01;
    coeffPerformance[ 8 ][ 0 ][ 6 ]   = -.664415;
    coeffPerformance[ 9 ][ 0 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 6 ]  =  0.00000;
    powerMin[ 0 ][ 6 ]                = 0.514638;
    powerMax[ 0 ][ 6 ]                = 0.988285;
    coeffPower[ 0 ][ 0 ][ 6 ]         = 0.739004;
    coeffPower[ 1 ][ 0 ][ 6 ]         =  3.10291;
    coeffPower[ 2 ][ 0 ][ 6 ]         = -.231232;
    coeffPower[ 3 ][ 0 ][ 6 ]         = 0.140115;
    coeffPower[ 4 ][ 0 ][ 6 ]         = -5.57020;
    coeffPower[ 5 ][ 0 ][ 6 ]         = 0.897832;
    coeffPower[ 6 ][ 0 ][ 6 ]         = -.922214;
    coeffPower[ 7 ][ 0 ][ 6 ]         = -.476755;
    coeffPower[ 8 ][ 0 ][ 6 ]         = 0.276156;
    coeffPower[ 9 ][ 0 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 6 ]        =  0.00000;
    energyMin[ 1 ][ 6 ]               = 0.678295;
    energyMax[ 1 ][ 6 ]               =  1.32908;
    coeffEnergy[ 0 ][ 1 ][ 6 ]        =  1.11339;
    coeffEnergy[ 1 ][ 1 ][ 6 ]        =  2.35254;
    coeffEnergy[ 2 ][ 1 ][ 6 ]        = 0.496803;
    coeffEnergy[ 3 ][ 1 ][ 6 ]        = -.336457;
    coeffEnergy[ 4 ][ 1 ][ 6 ]        = -4.22185;
    coeffEnergy[ 5 ][ 1 ][ 6 ]        = -6.64089;
    coeffEnergy[ 6 ][ 1 ][ 6 ]        =  2.39871;
    coeffEnergy[ 7 ][ 1 ][ 6 ]        = -.932553;
    coeffEnergy[ 8 ][ 1 ][ 6 ]        =  1.51187;
    coeffEnergy[ 9 ][ 1 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 6 ]       =  0.00000;
    performanceMin[ 1 ][ 6 ]          = 0.560397;
    performanceMax[ 1 ][ 6 ]          =  1.10421;
    coeffPerformance[ 0 ][ 1 ][ 6 ]   = 0.719616;
    coeffPerformance[ 1 ][ 1 ][ 6 ]   = -1.00958;
    coeffPerformance[ 2 ][ 1 ][ 6 ]   = -.738488;
    coeffPerformance[ 3 ][ 1 ][ 6 ]   = 0.462526;
    coeffPerformance[ 4 ][ 1 ][ 6 ]   =  1.80051;
    coeffPerformance[ 5 ][ 1 ][ 6 ]   =  6.06764;
    coeffPerformance[ 6 ][ 1 ][ 6 ]   = -2.47262;
    coeffPerformance[ 7 ][ 1 ][ 6 ]   = 0.199114;
    coeffPerformance[ 8 ][ 1 ][ 6 ]   = -.903264;
    coeffPerformance[ 9 ][ 1 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 6 ]  =  0.00000;
    powerMin[ 1 ][ 6 ]                = 0.556676;
    powerMax[ 1 ][ 6 ]                =  1.05554;
    coeffPower[ 0 ][ 1 ][ 6 ]         = 0.809122;
    coeffPower[ 1 ][ 1 ][ 6 ]         = 0.568289;
    coeffPower[ 2 ][ 1 ][ 6 ]         = -.366896;
    coeffPower[ 3 ][ 1 ][ 6 ]         = 0.207035;
    coeffPower[ 4 ][ 1 ][ 6 ]         = -1.03315;
    coeffPower[ 5 ][ 1 ][ 6 ]         = 0.599931;
    coeffPower[ 6 ][ 1 ][ 6 ]         = -.520357;
    coeffPower[ 7 ][ 1 ][ 6 ]         = -.528832;
    coeffPower[ 8 ][ 1 ][ 6 ]         = 0.305079;
    coeffPower[ 9 ][ 1 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 6 ]        =  0.00000;
    energyMin[ 2 ][ 6 ]               = 0.690652;
    energyMax[ 2 ][ 6 ]               =  1.29728;
    coeffEnergy[ 0 ][ 2 ][ 6 ]        =  1.07432;
    coeffEnergy[ 1 ][ 2 ][ 6 ]        =  2.52806;
    coeffEnergy[ 2 ][ 2 ][ 6 ]        = 0.301390;
    coeffEnergy[ 3 ][ 2 ][ 6 ]        = -.216729;
    coeffEnergy[ 4 ][ 2 ][ 6 ]        = -4.53424;
    coeffEnergy[ 5 ][ 2 ][ 6 ]        = -4.82144;
    coeffEnergy[ 6 ][ 2 ][ 6 ]        =  1.90205;
    coeffEnergy[ 7 ][ 2 ][ 6 ]        = -.800699;
    coeffEnergy[ 8 ][ 2 ][ 6 ]        =  1.32432;
    coeffEnergy[ 9 ][ 2 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 6 ]       =  0.00000;
    performanceMin[ 2 ][ 6 ]          = 0.607796;
    performanceMax[ 2 ][ 6 ]          =  1.13101;
    coeffPerformance[ 0 ][ 2 ][ 6 ]   = 0.784419;
    coeffPerformance[ 1 ][ 2 ][ 6 ]   = -1.60660;
    coeffPerformance[ 2 ][ 2 ][ 6 ]   = -.574794;
    coeffPerformance[ 3 ][ 2 ][ 6 ]   = 0.362243;
    coeffPerformance[ 4 ][ 2 ][ 6 ]   =  2.87066;
    coeffPerformance[ 5 ][ 2 ][ 6 ]   =  4.98212;
    coeffPerformance[ 6 ][ 2 ][ 6 ]   = -1.98828;
    coeffPerformance[ 7 ][ 2 ][ 6 ]   = 0.161737;
    coeffPerformance[ 8 ][ 2 ][ 6 ]   = -.790626;
    coeffPerformance[ 9 ][ 2 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 6 ]  =  0.00000;
    powerMin[ 2 ][ 6 ]                = 0.579728;
    powerMax[ 2 ][ 6 ]                =  1.08480;
    coeffPower[ 0 ][ 2 ][ 6 ]         = 0.846388;
    coeffPower[ 1 ][ 2 ][ 6 ]         = 0.355110;
    coeffPower[ 2 ][ 2 ][ 6 ]         = -.334314;
    coeffPower[ 3 ][ 2 ][ 6 ]         = 0.186296;
    coeffPower[ 4 ][ 2 ][ 6 ]         = -.648666;
    coeffPower[ 5 ][ 2 ][ 6 ]         = 0.791297;
    coeffPower[ 6 ][ 2 ][ 6 ]         = -.343869;
    coeffPower[ 7 ][ 2 ][ 6 ]         = -.498696;
    coeffPower[ 8 ][ 2 ][ 6 ]         = 0.325233;
    coeffPower[ 9 ][ 2 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 6 ]        =  0.00000;
    energyMin[ 3 ][ 6 ]               = 0.706650;
    energyMax[ 3 ][ 6 ]               =  1.31721;
    coeffEnergy[ 0 ][ 3 ][ 6 ]        =  1.02106;
    coeffEnergy[ 1 ][ 3 ][ 6 ]        =  3.58999;
    coeffEnergy[ 2 ][ 3 ][ 6 ]        = 0.525258;
    coeffEnergy[ 3 ][ 3 ][ 6 ]        = -.321738;
    coeffEnergy[ 4 ][ 3 ][ 6 ]        = -6.42892;
    coeffEnergy[ 5 ][ 3 ][ 6 ]        = -3.21424;
    coeffEnergy[ 6 ][ 3 ][ 6 ]        =  1.41523;
    coeffEnergy[ 7 ][ 3 ][ 6 ]        = -.381025;
    coeffEnergy[ 8 ][ 3 ][ 6 ]        = 0.689948;
    coeffEnergy[ 9 ][ 3 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 6 ]       =  0.00000;
    performanceMin[ 3 ][ 6 ]          = 0.627121;
    performanceMax[ 3 ][ 6 ]          =  1.15876;
    coeffPerformance[ 0 ][ 3 ][ 6 ]   = 0.854139;
    coeffPerformance[ 1 ][ 3 ][ 6 ]   = -2.06643;
    coeffPerformance[ 2 ][ 3 ][ 6 ]   = -.476031;
    coeffPerformance[ 3 ][ 3 ][ 6 ]   = 0.293693;
    coeffPerformance[ 4 ][ 3 ][ 6 ]   =  3.69131;
    coeffPerformance[ 5 ][ 3 ][ 6 ]   =  3.65784;
    coeffPerformance[ 6 ][ 3 ][ 6 ]   = -1.47865;
    coeffPerformance[ 7 ][ 3 ][ 6 ]   = 0.167487E-01;
    coeffPerformance[ 8 ][ 3 ][ 6 ]   = -.454912;
    coeffPerformance[ 9 ][ 3 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 6 ]  =  0.00000;
    powerMin[ 3 ][ 6 ]                = 0.629244;
    powerMax[ 3 ][ 6 ]                =  1.10869;
    coeffPower[ 0 ][ 3 ][ 6 ]         = 0.873096;
    coeffPower[ 1 ][ 3 ][ 6 ]         = 0.994208;
    coeffPower[ 2 ][ 3 ][ 6 ]         = -.184676E-01;
    coeffPower[ 3 ][ 3 ][ 6 ]         = 0.120576E-01;
    coeffPower[ 4 ][ 3 ][ 6 ]         = -1.79013;
    coeffPower[ 5 ][ 3 ][ 6 ]         = 0.693455;
    coeffPower[ 6 ][ 3 ][ 6 ]         = -.183509;
    coeffPower[ 7 ][ 3 ][ 6 ]         = -.316962;
    coeffPower[ 8 ][ 3 ][ 6 ]         = 0.168421;
    coeffPower[ 9 ][ 3 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 6 ]        =  0.00000;
    energyMin[ 4 ][ 6 ]               = 0.716367;
    energyMax[ 4 ][ 6 ]               =  1.27616;
    coeffEnergy[ 0 ][ 4 ][ 6 ]        =  1.00247;
    coeffEnergy[ 1 ][ 4 ][ 6 ]        =  2.21943;
    coeffEnergy[ 2 ][ 4 ][ 6 ]        = 0.823119E-01;
    coeffEnergy[ 3 ][ 4 ][ 6 ]        = -.661937E-01;
    coeffEnergy[ 4 ][ 4 ][ 6 ]        = -3.97157;
    coeffEnergy[ 5 ][ 4 ][ 6 ]        = -1.67424;
    coeffEnergy[ 6 ][ 4 ][ 6 ]        = 0.604992;
    coeffEnergy[ 7 ][ 4 ][ 6 ]        = -.355862;
    coeffEnergy[ 8 ][ 4 ][ 6 ]        = 0.713543;
    coeffEnergy[ 9 ][ 4 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 6 ]       =  0.00000;
    performanceMin[ 4 ][ 6 ]          = 0.695164;
    performanceMax[ 4 ][ 6 ]          =  1.17824;
    coeffPerformance[ 0 ][ 4 ][ 6 ]   = 0.895492;
    coeffPerformance[ 1 ][ 4 ][ 6 ]   = -1.38005;
    coeffPerformance[ 2 ][ 4 ][ 6 ]   = -.266810;
    coeffPerformance[ 3 ][ 4 ][ 6 ]   = 0.174387;
    coeffPerformance[ 4 ][ 4 ][ 6 ]   =  2.46797;
    coeffPerformance[ 5 ][ 4 ][ 6 ]   =  2.61914;
    coeffPerformance[ 6 ][ 4 ][ 6 ]   = -.939181;
    coeffPerformance[ 7 ][ 4 ][ 6 ]   = 0.230404;
    coeffPerformance[ 8 ][ 4 ][ 6 ]   = -.680399;
    coeffPerformance[ 9 ][ 4 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 6 ]  =  0.00000;
    powerMin[ 4 ][ 6 ]                = 0.668232;
    powerMax[ 4 ][ 6 ]                =  1.14092;
    coeffPower[ 0 ][ 4 ][ 6 ]         = 0.896977;
    coeffPower[ 1 ][ 4 ][ 6 ]         = 0.662151;
    coeffPower[ 2 ][ 4 ][ 6 ]         = -.199268;
    coeffPower[ 3 ][ 4 ][ 6 ]         = 0.117718;
    coeffPower[ 4 ][ 4 ][ 6 ]         = -1.18631;
    coeffPower[ 5 ][ 4 ][ 6 ]         =  1.02211;
    coeffPower[ 6 ][ 4 ][ 6 ]         = -.357359;
    coeffPower[ 7 ][ 4 ][ 6 ]         = -.887313E-01;
    coeffPower[ 8 ][ 4 ][ 6 ]         = -.266694E-01;
    coeffPower[ 9 ][ 4 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 6 ]        =  0.00000;
    energyMin[ 5 ][ 6 ]               = 0.750480;
    energyMax[ 5 ][ 6 ]               =  1.26420;
    coeffEnergy[ 0 ][ 5 ][ 6 ]        = 0.995929;
    coeffEnergy[ 1 ][ 5 ][ 6 ]        =  1.16469;
    coeffEnergy[ 2 ][ 5 ][ 6 ]        = 0.304575E-01;
    coeffEnergy[ 3 ][ 5 ][ 6 ]        = -.264315E-01;
    coeffEnergy[ 4 ][ 5 ][ 6 ]        = -2.08342;
    coeffEnergy[ 5 ][ 5 ][ 6 ]        = -.639150;
    coeffEnergy[ 6 ][ 5 ][ 6 ]        = 0.173153;
    coeffEnergy[ 7 ][ 5 ][ 6 ]        = -.163300;
    coeffEnergy[ 8 ][ 5 ][ 6 ]        = 0.374672;
    coeffEnergy[ 9 ][ 5 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 6 ]       =  0.00000;
    performanceMin[ 5 ][ 6 ]          = 0.723459;
    performanceMax[ 5 ][ 6 ]          =  1.20206;
    coeffPerformance[ 0 ][ 5 ][ 6 ]   = 0.953144;
    coeffPerformance[ 1 ][ 5 ][ 6 ]   = -.809615;
    coeffPerformance[ 2 ][ 5 ][ 6 ]   = 0.177702E-01;
    coeffPerformance[ 3 ][ 5 ][ 6 ]   = 0.245235E-02;
    coeffPerformance[ 4 ][ 5 ][ 6 ]   =  1.44614;
    coeffPerformance[ 5 ][ 5 ][ 6 ]   =  1.26647;
    coeffPerformance[ 6 ][ 5 ][ 6 ]   = -.452046;
    coeffPerformance[ 7 ][ 5 ][ 6 ]   = 0.127065;
    coeffPerformance[ 8 ][ 5 ][ 6 ]   = -.377051;
    coeffPerformance[ 9 ][ 5 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 6 ]  =  0.00000;
    powerMin[ 5 ][ 6 ]                = 0.722674;
    powerMax[ 5 ][ 6 ]                =  1.18196;
    coeffPower[ 0 ][ 5 ][ 6 ]         = 0.948771;
    coeffPower[ 1 ][ 5 ][ 6 ]         = 0.331633;
    coeffPower[ 2 ][ 5 ][ 6 ]         = 0.371704E-01;
    coeffPower[ 3 ][ 5 ][ 6 ]         = -.173745E-01;
    coeffPower[ 4 ][ 5 ][ 6 ]         = -.595377;
    coeffPower[ 5 ][ 5 ][ 6 ]         = 0.646774;
    coeffPower[ 6 ][ 5 ][ 6 ]         = -.280294;
    coeffPower[ 7 ][ 5 ][ 6 ]         = -.256533E-01;
    coeffPower[ 8 ][ 5 ][ 6 ]         = -.247250E-01;
    coeffPower[ 9 ][ 5 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 6 ]        =  0.00000;
    energyMin[ 6 ][ 6 ]               = 0.800000;
    energyMax[ 6 ][ 6 ]               =  1.20000;
    coeffEnergy[ 0 ][ 6 ][ 6 ]        =  1.00000;
    coeffEnergy[ 1 ][ 6 ][ 6 ]        = -.172699E-12;
    coeffEnergy[ 2 ][ 6 ][ 6 ]        = -.105777E-11;
    coeffEnergy[ 3 ][ 6 ][ 6 ]        = 0.589661E-12;
    coeffEnergy[ 4 ][ 6 ][ 6 ]        = 0.305581E-12;
    coeffEnergy[ 5 ][ 6 ][ 6 ]        = -.477058E-12;
    coeffEnergy[ 6 ][ 6 ][ 6 ]        = 0.119718E-12;
    coeffEnergy[ 7 ][ 6 ][ 6 ]        = -.160868E-12;
    coeffEnergy[ 8 ][ 6 ][ 6 ]        = 0.171311E-12;
    coeffEnergy[ 9 ][ 6 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 6 ]       =  0.00000;
    performanceMin[ 6 ][ 6 ]          = 0.800000;
    performanceMax[ 6 ][ 6 ]          =  1.20000;
    coeffPerformance[ 0 ][ 6 ][ 6 ]   =  1.00000;
    coeffPerformance[ 1 ][ 6 ][ 6 ]   = 0.122259E-12;
    coeffPerformance[ 2 ][ 6 ][ 6 ]   = 0.613150E-13;
    coeffPerformance[ 3 ][ 6 ][ 6 ]   = -.362872E-13;
    coeffPerformance[ 4 ][ 6 ][ 6 ]   = -.220629E-12;
    coeffPerformance[ 5 ][ 6 ][ 6 ]   = 0.806058E-14;
    coeffPerformance[ 6 ][ 6 ][ 6 ]   = -.517067E-14;
    coeffPerformance[ 7 ][ 6 ][ 6 ]   = -.543844E-13;
    coeffPerformance[ 8 ][ 6 ][ 6 ]   = 0.690982E-13;
    coeffPerformance[ 9 ][ 6 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 6 ]  =  0.00000;
    powerMin[ 6 ][ 6 ]                = 0.800000;
    powerMax[ 6 ][ 6 ]                =  1.20000;
    coeffPower[ 0 ][ 6 ][ 6 ]         =  1.00000;
    coeffPower[ 1 ][ 6 ][ 6 ]         = -.527762E-13;
    coeffPower[ 2 ][ 6 ][ 6 ]         = -.983789E-13;
    coeffPower[ 3 ][ 6 ][ 6 ]         = 0.549485E-13;
    coeffPower[ 4 ][ 6 ][ 6 ]         = 0.946597E-13;
    coeffPower[ 5 ][ 6 ][ 6 ]         = -.192249E-13;
    coeffPower[ 6 ][ 6 ][ 6 ]         = 0.224290E-13;
    coeffPower[ 7 ][ 6 ][ 6 ]         = 0.261497E-14;
    coeffPower[ 8 ][ 6 ][ 6 ]         = -.683580E-14;
    coeffPower[ 9 ][ 6 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 6 ]        =  0.00000;
    energyMin[ 7 ][ 6 ]               = 0.763170;
    energyMax[ 7 ][ 6 ]               =  1.30520;
    coeffEnergy[ 0 ][ 7 ][ 6 ]        =  1.00897;
    coeffEnergy[ 1 ][ 7 ][ 6 ]        = -1.97849;
    coeffEnergy[ 2 ][ 7 ][ 6 ]        = -.251364;
    coeffEnergy[ 3 ][ 7 ][ 6 ]        = 0.141632;
    coeffEnergy[ 4 ][ 7 ][ 6 ]        =  3.54563;
    coeffEnergy[ 5 ][ 7 ][ 6 ]        =  1.10865;
    coeffEnergy[ 6 ][ 7 ][ 6 ]        = -.722034;
    coeffEnergy[ 7 ][ 7 ][ 6 ]        = -.217277;
    coeffEnergy[ 8 ][ 7 ][ 6 ]        = 0.375032;
    coeffEnergy[ 9 ][ 7 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 6 ]       =  0.00000;
    performanceMin[ 7 ][ 6 ]          = 0.762684;
    performanceMax[ 7 ][ 6 ]          =  1.34227;
    coeffPerformance[ 0 ][ 7 ][ 6 ]   =  1.03184;
    coeffPerformance[ 1 ][ 7 ][ 6 ]   =  1.84171;
    coeffPerformance[ 2 ][ 7 ][ 6 ]   = 0.193824;
    coeffPerformance[ 3 ][ 7 ][ 6 ]   = -.110236;
    coeffPerformance[ 4 ][ 7 ][ 6 ]   = -3.29498;
    coeffPerformance[ 5 ][ 7 ][ 6 ]   = -1.64673;
    coeffPerformance[ 6 ][ 7 ][ 6 ]   =  1.02065;
    coeffPerformance[ 7 ][ 7 ][ 6 ]   = 0.407226;
    coeffPerformance[ 8 ][ 7 ][ 6 ]   = -.487751;
    coeffPerformance[ 9 ][ 7 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 6 ]  =  0.00000;
    powerMin[ 7 ][ 6 ]                = 0.821002;
    powerMax[ 7 ][ 6 ]                =  1.31991;
    coeffPower[ 0 ][ 7 ][ 6 ]         =  1.04013;
    coeffPower[ 1 ][ 7 ][ 6 ]         = -.176455;
    coeffPower[ 2 ][ 7 ][ 6 ]         = -.618666E-01;
    coeffPower[ 3 ][ 7 ][ 6 ]         = 0.341429E-01;
    coeffPower[ 4 ][ 7 ][ 6 ]         = 0.322007;
    coeffPower[ 5 ][ 7 ][ 6 ]         = -.513893;
    coeffPower[ 6 ][ 7 ][ 6 ]         = 0.292820;
    coeffPower[ 7 ][ 7 ][ 6 ]         = 0.197960;
    coeffPower[ 8 ][ 7 ][ 6 ]         = -.125598;
    coeffPower[ 9 ][ 7 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 6 ]        =  0.00000;
    energyMin[ 8 ][ 6 ]               = 0.766591;
    energyMax[ 8 ][ 6 ]               =  1.36913;
    coeffEnergy[ 0 ][ 8 ][ 6 ]        =  1.01035;
    coeffEnergy[ 1 ][ 8 ][ 6 ]        = -3.77857;
    coeffEnergy[ 2 ][ 8 ][ 6 ]        = -.634999;
    coeffEnergy[ 3 ][ 8 ][ 6 ]        = 0.361201;
    coeffEnergy[ 4 ][ 8 ][ 6 ]        =  6.77599;
    coeffEnergy[ 5 ][ 8 ][ 6 ]        =  1.93887;
    coeffEnergy[ 6 ][ 8 ][ 6 ]        = -1.09420;
    coeffEnergy[ 7 ][ 8 ][ 6 ]        = -.261356;
    coeffEnergy[ 8 ][ 8 ][ 6 ]        = 0.443103;
    coeffEnergy[ 9 ][ 8 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 6 ]       =  0.00000;
    performanceMin[ 8 ][ 6 ]          = 0.759228;
    performanceMax[ 8 ][ 6 ]          =  1.41134;
    coeffPerformance[ 0 ][ 8 ][ 6 ]   =  1.07665;
    coeffPerformance[ 1 ][ 8 ][ 6 ]   =  3.69341;
    coeffPerformance[ 2 ][ 8 ][ 6 ]   = 0.501243;
    coeffPerformance[ 3 ][ 8 ][ 6 ]   = -.291504;
    coeffPerformance[ 4 ][ 8 ][ 6 ]   = -6.61384;
    coeffPerformance[ 5 ][ 8 ][ 6 ]   = -3.20595;
    coeffPerformance[ 6 ][ 8 ][ 6 ]   =  1.74719;
    coeffPerformance[ 7 ][ 8 ][ 6 ]   = 0.521900;
    coeffPerformance[ 8 ][ 8 ][ 6 ]   = -.474151;
    coeffPerformance[ 9 ][ 8 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 6 ]  =  0.00000;
    powerMin[ 8 ][ 6 ]                = 0.844421;
    powerMax[ 8 ][ 6 ]                =  1.40655;
    coeffPower[ 0 ][ 8 ][ 6 ]         =  1.08580;
    coeffPower[ 1 ][ 8 ][ 6 ]         = -.214423;
    coeffPower[ 2 ][ 8 ][ 6 ]         = -.142001;
    coeffPower[ 3 ][ 8 ][ 6 ]         = 0.750722E-01;
    coeffPower[ 4 ][ 8 ][ 6 ]         = 0.394208;
    coeffPower[ 5 ][ 8 ][ 6 ]         = -1.21072;
    coeffPower[ 6 ][ 8 ][ 6 ]         = 0.637064;
    coeffPower[ 7 ][ 8 ][ 6 ]         = 0.286650;
    coeffPower[ 8 ][ 8 ][ 6 ]         = -.610173E-01;
    coeffPower[ 9 ][ 8 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 6 ]        =  0.00000;
    energyMin[ 9 ][ 6 ]               = 0.784903;
    energyMax[ 9 ][ 6 ]               =  1.39240;
    coeffEnergy[ 0 ][ 9 ][ 6 ]        =  1.02409;
    coeffEnergy[ 1 ][ 9 ][ 6 ]        = -4.76772;
    coeffEnergy[ 2 ][ 9 ][ 6 ]        = -.727180;
    coeffEnergy[ 3 ][ 9 ][ 6 ]        = 0.416521;
    coeffEnergy[ 4 ][ 9 ][ 6 ]        =  8.54264;
    coeffEnergy[ 5 ][ 9 ][ 6 ]        =  2.78807;
    coeffEnergy[ 6 ][ 9 ][ 6 ]        = -1.49422;
    coeffEnergy[ 7 ][ 9 ][ 6 ]        = -.222932;
    coeffEnergy[ 8 ][ 9 ][ 6 ]        = 0.453232;
    coeffEnergy[ 9 ][ 9 ][ 6 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 6 ]       =  0.00000;
    performanceMin[ 9 ][ 6 ]          = 0.776417;
    performanceMax[ 9 ][ 6 ]          =  1.45052;
    coeffPerformance[ 0 ][ 9 ][ 6 ]   =  1.09902;
    coeffPerformance[ 1 ][ 9 ][ 6 ]   =  5.18011;
    coeffPerformance[ 2 ][ 9 ][ 6 ]   = 0.484218;
    coeffPerformance[ 3 ][ 9 ][ 6 ]   = -.286557;
    coeffPerformance[ 4 ][ 9 ][ 6 ]   = -9.26471;
    coeffPerformance[ 5 ][ 9 ][ 6 ]   = -4.28117;
    coeffPerformance[ 6 ][ 9 ][ 6 ]   =  2.20549;
    coeffPerformance[ 7 ][ 9 ][ 6 ]   = 0.581443;
    coeffPerformance[ 8 ][ 9 ][ 6 ]   = -.452179;
    coeffPerformance[ 9 ][ 9 ][ 6 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 6 ]  =  0.00000;
    powerMin[ 9 ][ 6 ]                = 0.869796;
    powerMax[ 9 ][ 6 ]                =  1.47349;
    coeffPower[ 0 ][ 9 ][ 6 ]         =  1.12028;
    coeffPower[ 1 ][ 9 ][ 6 ]         = 0.180669;
    coeffPower[ 2 ][ 9 ][ 6 ]         = -.270781;
    coeffPower[ 3 ][ 9 ][ 6 ]         = 0.147072;
    coeffPower[ 4 ][ 9 ][ 6 ]         = -.305678;
    coeffPower[ 5 ][ 9 ][ 6 ]         = -1.35854;
    coeffPower[ 6 ][ 9 ][ 6 ]         = 0.652214;
    coeffPower[ 7 ][ 9 ][ 6 ]         = 0.414393;
    coeffPower[ 8 ][ 9 ][ 6 ]         = -.448170E-01;
    coeffPower[ 9 ][ 9 ][ 6 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 6 ]        =  0.00000;
    energyMin[ 10 ][ 6 ]              = 0.776429;
    energyMax[ 10 ][ 6 ]              =  1.47419;
    coeffEnergy[ 0 ][ 10 ][ 6 ]       =  1.03667;
    coeffEnergy[ 1 ][ 10 ][ 6 ]       = -5.87164;
    coeffEnergy[ 2 ][ 10 ][ 6 ]       = -.903809;
    coeffEnergy[ 3 ][ 10 ][ 6 ]       = 0.518396;
    coeffEnergy[ 4 ][ 10 ][ 6 ]       =  10.5196;
    coeffEnergy[ 5 ][ 10 ][ 6 ]       =  3.51775;
    coeffEnergy[ 6 ][ 10 ][ 6 ]       = -1.85754;
    coeffEnergy[ 7 ][ 10 ][ 6 ]       = -.225595;
    coeffEnergy[ 8 ][ 10 ][ 6 ]       = 0.523879;
    coeffEnergy[ 9 ][ 10 ][ 6 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 6 ]      =  0.00000;
    performanceMin[ 10 ][ 6 ]         = 0.780499;
    performanceMax[ 10 ][ 6 ]         =  1.55464;
    coeffPerformance[ 0 ][ 10 ][ 6 ]  =  1.13704;
    coeffPerformance[ 1 ][ 10 ][ 6 ]  =  6.92109;
    coeffPerformance[ 2 ][ 10 ][ 6 ]  = 0.656559;
    coeffPerformance[ 3 ][ 10 ][ 6 ]  = -.390493;
    coeffPerformance[ 4 ][ 10 ][ 6 ]  = -12.3806;
    coeffPerformance[ 5 ][ 10 ][ 6 ]  = -5.71018;
    coeffPerformance[ 6 ][ 10 ][ 6 ]  =  2.89490;
    coeffPerformance[ 7 ][ 10 ][ 6 ]  = 0.657864;
    coeffPerformance[ 8 ][ 10 ][ 6 ]  = -.458432;
    coeffPerformance[ 9 ][ 10 ][ 6 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 6 ] =  0.00000;
    powerMin[ 10 ][ 6 ]               = 0.894214;
    powerMax[ 10 ][ 6 ]               =  1.55215;
    coeffPower[ 0 ][ 10 ][ 6 ]        =  1.17202;
    coeffPower[ 1 ][ 10 ][ 6 ]        = 0.693849;
    coeffPower[ 2 ][ 10 ][ 6 ]        = -.291114;
    coeffPower[ 3 ][ 10 ][ 6 ]        = 0.154212;
    coeffPower[ 4 ][ 10 ][ 6 ]        = -1.22266;
    coeffPower[ 5 ][ 10 ][ 6 ]        = -2.01859;
    coeffPower[ 6 ][ 10 ][ 6 ]        = 0.954489;
    coeffPower[ 7 ][ 10 ][ 6 ]        = 0.503185;
    coeffPower[ 8 ][ 10 ][ 6 ]        = 0.161842E-01;
    coeffPower[ 9 ][ 10 ][ 6 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 6 ]       =  0.00000;
    energyMin[ 11 ][ 6 ]              = 0.783895;
    energyMax[ 11 ][ 6 ]              =  1.52745;
    coeffEnergy[ 0 ][ 11 ][ 6 ]       =  1.05397;
    coeffEnergy[ 1 ][ 11 ][ 6 ]       = -7.28277;
    coeffEnergy[ 2 ][ 11 ][ 6 ]       = -1.34228;
    coeffEnergy[ 3 ][ 11 ][ 6 ]       = 0.768202;
    coeffEnergy[ 4 ][ 11 ][ 6 ]       =  13.0463;
    coeffEnergy[ 5 ][ 11 ][ 6 ]       =  4.65144;
    coeffEnergy[ 6 ][ 11 ][ 6 ]       = -2.46644;
    coeffEnergy[ 7 ][ 11 ][ 6 ]       = -.398219;
    coeffEnergy[ 8 ][ 11 ][ 6 ]       = 0.675659;
    coeffEnergy[ 9 ][ 11 ][ 6 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 6 ]      =  0.00000;
    performanceMin[ 11 ][ 6 ]         = 0.772358;
    performanceMax[ 11 ][ 6 ]         =  1.62577;
    coeffPerformance[ 0 ][ 11 ][ 6 ]  =  1.17116;
    coeffPerformance[ 1 ][ 11 ][ 6 ]  =  8.80948;
    coeffPerformance[ 2 ][ 11 ][ 6 ]  =  1.00704;
    coeffPerformance[ 3 ][ 11 ][ 6 ]  = -.594798;
    coeffPerformance[ 4 ][ 11 ][ 6 ]  = -15.7587;
    coeffPerformance[ 5 ][ 11 ][ 6 ]  = -7.45679;
    coeffPerformance[ 6 ][ 11 ][ 6 ]  =  3.79035;
    coeffPerformance[ 7 ][ 11 ][ 6 ]  = 0.862207;
    coeffPerformance[ 8 ][ 11 ][ 6 ]  = -.529694;
    coeffPerformance[ 9 ][ 11 ][ 6 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 6 ] =  0.00000;
    powerMin[ 11 ][ 6 ]               = 0.923548;
    powerMax[ 11 ][ 6 ]               =  1.62295;
    coeffPower[ 0 ][ 11 ][ 6 ]        =  1.22223;
    coeffPower[ 1 ][ 11 ][ 6 ]        = 0.988337;
    coeffPower[ 2 ][ 11 ][ 6 ]        = -.383309;
    coeffPower[ 3 ][ 11 ][ 6 ]        = 0.202848;
    coeffPower[ 4 ][ 11 ][ 6 ]        = -1.74482;
    coeffPower[ 5 ][ 11 ][ 6 ]        = -2.60660;
    coeffPower[ 6 ][ 11 ][ 6 ]        =  1.23492;
    coeffPower[ 7 ][ 11 ][ 6 ]        = 0.588992;
    coeffPower[ 8 ][ 11 ][ 6 ]        = 0.665111E-01;
    coeffPower[ 9 ][ 11 ][ 6 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 6 ]       =  0.00000;
    energyMin[ 12 ][ 6 ]              = 0.789815;
    energyMax[ 12 ][ 6 ]              =  1.55321;
    coeffEnergy[ 0 ][ 12 ][ 6 ]       =  1.07548;
    coeffEnergy[ 1 ][ 12 ][ 6 ]       = -7.95073;
    coeffEnergy[ 2 ][ 12 ][ 6 ]       = -1.46861;
    coeffEnergy[ 3 ][ 12 ][ 6 ]       = 0.844360;
    coeffEnergy[ 4 ][ 12 ][ 6 ]       =  14.2369;
    coeffEnergy[ 5 ][ 12 ][ 6 ]       =  5.70358;
    coeffEnergy[ 6 ][ 12 ][ 6 ]       = -2.94771;
    coeffEnergy[ 7 ][ 12 ][ 6 ]       = -.467301;
    coeffEnergy[ 8 ][ 12 ][ 6 ]       = 0.607845;
    coeffEnergy[ 9 ][ 12 ][ 6 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 6 ]      =  0.00000;
    performanceMin[ 12 ][ 6 ]         = 0.792744;
    performanceMax[ 12 ][ 6 ]         =  1.69381;
    coeffPerformance[ 0 ][ 12 ][ 6 ]  =  1.20772;
    coeffPerformance[ 1 ][ 12 ][ 6 ]  =  10.1678;
    coeffPerformance[ 2 ][ 12 ][ 6 ]  =  1.21623;
    coeffPerformance[ 3 ][ 12 ][ 6 ]  = -.722487;
    coeffPerformance[ 4 ][ 12 ][ 6 ]  = -18.1855;
    coeffPerformance[ 5 ][ 12 ][ 6 ]  = -9.19266;
    coeffPerformance[ 6 ][ 12 ][ 6 ]  =  4.57449;
    coeffPerformance[ 7 ][ 12 ][ 6 ]  = 0.900220;
    coeffPerformance[ 8 ][ 12 ][ 6 ]  = -.381245;
    coeffPerformance[ 9 ][ 12 ][ 6 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 6 ] =  0.00000;
    powerMin[ 12 ][ 6 ]               = 0.951201;
    powerMax[ 12 ][ 6 ]               =  1.69077;
    coeffPower[ 0 ][ 12 ][ 6 ]        =  1.28321;
    coeffPower[ 1 ][ 12 ][ 6 ]        =  1.66187;
    coeffPower[ 2 ][ 12 ][ 6 ]        = -.281619;
    coeffPower[ 3 ][ 12 ][ 6 ]        = 0.140606;
    coeffPower[ 4 ][ 12 ][ 6 ]        = -2.95112;
    coeffPower[ 5 ][ 12 ][ 6 ]        = -3.27870;
    coeffPower[ 6 ][ 12 ][ 6 ]        =  1.51524;
    coeffPower[ 7 ][ 12 ][ 6 ]        = 0.572658;
    coeffPower[ 8 ][ 12 ][ 6 ]        = 0.160033;
    coeffPower[ 9 ][ 12 ][ 6 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 6 ]       =  0.00000;
    energyMin[ 13 ][ 6 ]              = 0.799014;
    energyMax[ 13 ][ 6 ]              =  1.55467;
    coeffEnergy[ 0 ][ 13 ][ 6 ]       =  1.08124;
    coeffEnergy[ 1 ][ 13 ][ 6 ]       = -9.15673;
    coeffEnergy[ 2 ][ 13 ][ 6 ]       = -1.48136;
    coeffEnergy[ 3 ][ 13 ][ 6 ]       = 0.859612;
    coeffEnergy[ 4 ][ 13 ][ 6 ]       =  16.4017;
    coeffEnergy[ 5 ][ 13 ][ 6 ]       =  6.65079;
    coeffEnergy[ 6 ][ 13 ][ 6 ]       = -3.34123;
    coeffEnergy[ 7 ][ 13 ][ 6 ]       = -.319828;
    coeffEnergy[ 8 ][ 13 ][ 6 ]       = 0.476385;
    coeffEnergy[ 9 ][ 13 ][ 6 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 6 ]      =  0.00000;
    performanceMin[ 13 ][ 6 ]         = 0.823725;
    performanceMax[ 13 ][ 6 ]         =  1.76392;
    coeffPerformance[ 0 ][ 13 ][ 6 ]  =  1.24859;
    coeffPerformance[ 1 ][ 13 ][ 6 ]  =  11.5662;
    coeffPerformance[ 2 ][ 13 ][ 6 ]  =  1.31058;
    coeffPerformance[ 3 ][ 13 ][ 6 ]  = -.785926;
    coeffPerformance[ 4 ][ 13 ][ 6 ]  = -20.6872;
    coeffPerformance[ 5 ][ 13 ][ 6 ]  = -10.8219;
    coeffPerformance[ 6 ][ 13 ][ 6 ]  =  5.26448;
    coeffPerformance[ 7 ][ 13 ][ 6 ]  = 0.845015;
    coeffPerformance[ 8 ][ 13 ][ 6 ]  = -.204836;
    coeffPerformance[ 9 ][ 13 ][ 6 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 6 ] =  0.00000;
    powerMin[ 13 ][ 6 ]               = 0.982495;
    powerMax[ 13 ][ 6 ]               =  1.80055;
    coeffPower[ 0 ][ 13 ][ 6 ]        =  1.33160;
    coeffPower[ 1 ][ 13 ][ 6 ]        =  1.63772;
    coeffPower[ 2 ][ 13 ][ 6 ]        = -.205278;
    coeffPower[ 3 ][ 13 ][ 6 ]        = 0.951441E-01;
    coeffPower[ 4 ][ 13 ][ 6 ]        = -2.89815;
    coeffPower[ 5 ][ 13 ][ 6 ]        = -3.97510;
    coeffPower[ 6 ][ 13 ][ 6 ]        =  1.78193;
    coeffPower[ 7 ][ 13 ][ 6 ]        = 0.687238;
    coeffPower[ 8 ][ 13 ][ 6 ]        = 0.239981;
    coeffPower[ 9 ][ 13 ][ 6 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 6 ]       =  0.00000;
    energyMin[ 14 ][ 6 ]              = 0.801041;
    energyMax[ 14 ][ 6 ]              =  1.60882;
    coeffEnergy[ 0 ][ 14 ][ 6 ]       =  1.09732;
    coeffEnergy[ 1 ][ 14 ][ 6 ]       = -9.68274;
    coeffEnergy[ 2 ][ 14 ][ 6 ]       = -1.60871;
    coeffEnergy[ 3 ][ 14 ][ 6 ]       = 0.939890;
    coeffEnergy[ 4 ][ 14 ][ 6 ]       =  17.3426;
    coeffEnergy[ 5 ][ 14 ][ 6 ]       =  8.03249;
    coeffEnergy[ 6 ][ 14 ][ 6 ]       = -4.05317;
    coeffEnergy[ 7 ][ 14 ][ 6 ]       = -.337738;
    coeffEnergy[ 8 ][ 14 ][ 6 ]       = 0.393890;
    coeffEnergy[ 9 ][ 14 ][ 6 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 6 ]      =  0.00000;
    performanceMin[ 14 ][ 6 ]         = 0.826109;
    performanceMax[ 14 ][ 6 ]         =  1.83505;
    coeffPerformance[ 0 ][ 14 ][ 6 ]  =  1.28900;
    coeffPerformance[ 1 ][ 14 ][ 6 ]  =  13.0811;
    coeffPerformance[ 2 ][ 14 ][ 6 ]  =  1.56664;
    coeffPerformance[ 3 ][ 14 ][ 6 ]  = -.940184;
    coeffPerformance[ 4 ][ 14 ][ 6 ]  = -23.3979;
    coeffPerformance[ 5 ][ 14 ][ 6 ]  = -12.7195;
    coeffPerformance[ 6 ][ 14 ][ 6 ]  =  6.19362;
    coeffPerformance[ 7 ][ 14 ][ 6 ]  = 0.931741;
    coeffPerformance[ 8 ][ 14 ][ 6 ]  = -.148151;
    coeffPerformance[ 9 ][ 14 ][ 6 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 6 ] =  0.00000;
    powerMin[ 14 ][ 6 ]               =  1.01323;
    powerMax[ 14 ][ 6 ]               =  1.88521;
    coeffPower[ 0 ][ 14 ][ 6 ]        =  1.39156;
    coeffPower[ 1 ][ 14 ][ 6 ]        =  2.67313;
    coeffPower[ 2 ][ 14 ][ 6 ]        = -.231038E-01;
    coeffPower[ 3 ][ 14 ][ 6 ]        = -.879893E-02;
    coeffPower[ 4 ][ 14 ][ 6 ]        = -4.74969;
    coeffPower[ 5 ][ 14 ][ 6 ]        = -4.54813;
    coeffPower[ 6 ][ 14 ][ 6 ]        =  2.01772;
    coeffPower[ 7 ][ 14 ][ 6 ]        = 0.809990;
    coeffPower[ 8 ][ 14 ][ 6 ]        = 0.197805;
    coeffPower[ 9 ][ 14 ][ 6 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 6 ]       =  0.00000;
    energyMin[ 15 ][ 6 ]              = 0.805203;
    energyMax[ 15 ][ 6 ]              =  1.70038;
    coeffEnergy[ 0 ][ 15 ][ 6 ]       =  1.11531;
    coeffEnergy[ 1 ][ 15 ][ 6 ]       = -10.3961;
    coeffEnergy[ 2 ][ 15 ][ 6 ]       = -1.68495;
    coeffEnergy[ 3 ][ 15 ][ 6 ]       = 0.991307;
    coeffEnergy[ 4 ][ 15 ][ 6 ]       =  18.6185;
    coeffEnergy[ 5 ][ 15 ][ 6 ]       =  9.23144;
    coeffEnergy[ 6 ][ 15 ][ 6 ]       = -4.55686;
    coeffEnergy[ 7 ][ 15 ][ 6 ]       = -.315828;
    coeffEnergy[ 8 ][ 15 ][ 6 ]       = 0.231123;
    coeffEnergy[ 9 ][ 15 ][ 6 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 6 ]      =  0.00000;
    performanceMin[ 15 ][ 6 ]         = 0.827494;
    performanceMax[ 15 ][ 6 ]         =  1.90928;
    coeffPerformance[ 0 ][ 15 ][ 6 ]  =  1.32722;
    coeffPerformance[ 1 ][ 15 ][ 6 ]  =  14.0225;
    coeffPerformance[ 2 ][ 15 ][ 6 ]  =  1.67766;
    coeffPerformance[ 3 ][ 15 ][ 6 ]  = -1.01418;
    coeffPerformance[ 4 ][ 15 ][ 6 ]  = -25.0760;
    coeffPerformance[ 5 ][ 15 ][ 6 ]  = -14.6907;
    coeffPerformance[ 6 ][ 15 ][ 6 ]  =  7.11897;
    coeffPerformance[ 7 ][ 15 ][ 6 ]  =  1.00288;
    coeffPerformance[ 8 ][ 15 ][ 6 ]  = -.356501E-01;
    coeffPerformance[ 9 ][ 15 ][ 6 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 6 ] =  0.00000;
    powerMin[ 15 ][ 6 ]               =  1.04630;
    powerMax[ 15 ][ 6 ]               =  1.98606;
    coeffPower[ 0 ][ 15 ][ 6 ]        =  1.44917;
    coeffPower[ 1 ][ 15 ][ 6 ]        =  2.89571;
    coeffPower[ 2 ][ 15 ][ 6 ]        = 0.786279E-02;
    coeffPower[ 3 ][ 15 ][ 6 ]        = -.288414E-01;
    coeffPower[ 4 ][ 15 ][ 6 ]        = -5.13896;
    coeffPower[ 5 ][ 15 ][ 6 ]        = -5.36826;
    coeffPower[ 6 ][ 15 ][ 6 ]        =  2.45522;
    coeffPower[ 7 ][ 15 ][ 6 ]        = 0.976422;
    coeffPower[ 8 ][ 15 ][ 6 ]        = 0.119646;
    coeffPower[ 9 ][ 15 ][ 6 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 6 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 1.90;
    energyMin[ 0 ][ 7 ]               = 0.639197;
    energyMax[ 0 ][ 7 ]               =  1.40475;
    coeffEnergy[ 0 ][ 0 ][ 7 ]        =  1.12402;
    coeffEnergy[ 1 ][ 0 ][ 7 ]        =  8.50591;
    coeffEnergy[ 2 ][ 0 ][ 7 ]        =  2.21598;
    coeffEnergy[ 3 ][ 0 ][ 7 ]        = -1.23329;
    coeffEnergy[ 4 ][ 0 ][ 7 ]        = -16.1077;
    coeffEnergy[ 5 ][ 0 ][ 7 ]        = -8.82685;
    coeffEnergy[ 6 ][ 0 ][ 7 ]        =  3.59549;
    coeffEnergy[ 7 ][ 0 ][ 7 ]        = -.627703;
    coeffEnergy[ 8 ][ 0 ][ 7 ]        = 0.987407;
    coeffEnergy[ 9 ][ 0 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 7 ]       =  0.00000;
    performanceMin[ 0 ][ 7 ]          = 0.500977;
    performanceMax[ 0 ][ 7 ]          =  1.05513;
    coeffPerformance[ 0 ][ 0 ][ 7 ]   = 0.649554;
    coeffPerformance[ 1 ][ 0 ][ 7 ]   = -1.02750;
    coeffPerformance[ 2 ][ 0 ][ 7 ]   = 0.262638;
    coeffPerformance[ 3 ][ 0 ][ 7 ]   = -.909100E-01;
    coeffPerformance[ 4 ][ 0 ][ 7 ]   =  1.92730;
    coeffPerformance[ 5 ][ 0 ][ 7 ]   =  7.63878;
    coeffPerformance[ 6 ][ 0 ][ 7 ]   = -3.54461;
    coeffPerformance[ 7 ][ 0 ][ 7 ]   = -.160621;
    coeffPerformance[ 8 ][ 0 ][ 7 ]   = -.382915;
    coeffPerformance[ 9 ][ 0 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 7 ]  =  0.00000;
    powerMin[ 0 ][ 7 ]                = 0.497237;
    powerMax[ 0 ][ 7 ]                = 0.961234;
    coeffPower[ 0 ][ 0 ][ 7 ]         = 0.732486;
    coeffPower[ 1 ][ 0 ][ 7 ]         =  4.13637;
    coeffPower[ 2 ][ 0 ][ 7 ]         =  1.81178;
    coeffPower[ 3 ][ 0 ][ 7 ]         = -.955817;
    coeffPower[ 4 ][ 0 ][ 7 ]         = -7.85151;
    coeffPower[ 5 ][ 0 ][ 7 ]         = 0.883555;
    coeffPower[ 6 ][ 0 ][ 7 ]         = -.804443;
    coeffPower[ 7 ][ 0 ][ 7 ]         = -.562489;
    coeffPower[ 8 ][ 0 ][ 7 ]         = 0.328751;
    coeffPower[ 9 ][ 0 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 7 ]        =  0.00000;
    energyMin[ 1 ][ 7 ]               = 0.661753;
    energyMax[ 1 ][ 7 ]               =  1.33848;
    coeffEnergy[ 0 ][ 1 ][ 7 ]        =  1.12067;
    coeffEnergy[ 1 ][ 1 ][ 7 ]        =  5.00110;
    coeffEnergy[ 2 ][ 1 ][ 7 ]        =  1.33486;
    coeffEnergy[ 3 ][ 1 ][ 7 ]        = -.766758;
    coeffEnergy[ 4 ][ 1 ][ 7 ]        = -9.47899;
    coeffEnergy[ 5 ][ 1 ][ 7 ]        = -7.51545;
    coeffEnergy[ 6 ][ 1 ][ 7 ]        =  3.03148;
    coeffEnergy[ 7 ][ 1 ][ 7 ]        = -.743601;
    coeffEnergy[ 8 ][ 1 ][ 7 ]        =  1.15903;
    coeffEnergy[ 9 ][ 1 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 7 ]       =  0.00000;
    performanceMin[ 1 ][ 7 ]          = 0.539612;
    performanceMax[ 1 ][ 7 ]          =  1.09813;
    coeffPerformance[ 0 ][ 1 ][ 7 ]   = 0.699184;
    coeffPerformance[ 1 ][ 1 ][ 7 ]   = -1.53062;
    coeffPerformance[ 2 ][ 1 ][ 7 ]   = 0.156005;
    coeffPerformance[ 3 ][ 1 ][ 7 ]   = -.360343E-01;
    coeffPerformance[ 4 ][ 1 ][ 7 ]   =  2.88251;
    coeffPerformance[ 5 ][ 1 ][ 7 ]   =  6.89523;
    coeffPerformance[ 6 ][ 1 ][ 7 ]   = -2.96650;
    coeffPerformance[ 7 ][ 1 ][ 7 ]   = -.211770E-01;
    coeffPerformance[ 8 ][ 1 ][ 7 ]   = -.603964;
    coeffPerformance[ 9 ][ 1 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 7 ]  =  0.00000;
    powerMin[ 1 ][ 7 ]                = 0.527884;
    powerMax[ 1 ][ 7 ]                =  1.02665;
    coeffPower[ 0 ][ 1 ][ 7 ]         = 0.788985;
    coeffPower[ 1 ][ 1 ][ 7 ]         =  1.65696;
    coeffPower[ 2 ][ 1 ][ 7 ]         =  1.15045;
    coeffPower[ 3 ][ 1 ][ 7 ]         = -.610805;
    coeffPower[ 4 ][ 1 ][ 7 ]         = -3.16058;
    coeffPower[ 5 ][ 1 ][ 7 ]         = 0.788423;
    coeffPower[ 6 ][ 1 ][ 7 ]         = -.536383;
    coeffPower[ 7 ][ 1 ][ 7 ]         = -.580675;
    coeffPower[ 8 ][ 1 ][ 7 ]         = 0.333476;
    coeffPower[ 9 ][ 1 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 7 ]        =  0.00000;
    energyMin[ 2 ][ 7 ]               = 0.674462;
    energyMax[ 2 ][ 7 ]               =  1.29995;
    coeffEnergy[ 0 ][ 2 ][ 7 ]        =  1.08423;
    coeffEnergy[ 1 ][ 2 ][ 7 ]        =  5.18698;
    coeffEnergy[ 2 ][ 2 ][ 7 ]        =  1.41631;
    coeffEnergy[ 3 ][ 2 ][ 7 ]        = -.800815;
    coeffEnergy[ 4 ][ 2 ][ 7 ]        = -9.82943;
    coeffEnergy[ 5 ][ 2 ][ 7 ]        = -5.77313;
    coeffEnergy[ 6 ][ 2 ][ 7 ]        =  2.57312;
    coeffEnergy[ 7 ][ 2 ][ 7 ]        = -.620363;
    coeffEnergy[ 8 ][ 2 ][ 7 ]        = 0.977727;
    coeffEnergy[ 9 ][ 2 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 7 ]       =  0.00000;
    performanceMin[ 2 ][ 7 ]          = 0.581519;
    performanceMax[ 2 ][ 7 ]          =  1.12485;
    coeffPerformance[ 0 ][ 2 ][ 7 ]   = 0.756571;
    coeffPerformance[ 1 ][ 2 ][ 7 ]   = -2.48843;
    coeffPerformance[ 2 ][ 2 ][ 7 ]   = -.106559;
    coeffPerformance[ 3 ][ 2 ][ 7 ]   = 0.963736E-01;
    coeffPerformance[ 4 ][ 2 ][ 7 ]   =  4.69779;
    coeffPerformance[ 5 ][ 2 ][ 7 ]   =  5.96836;
    coeffPerformance[ 6 ][ 2 ][ 7 ]   = -2.58152;
    coeffPerformance[ 7 ][ 2 ][ 7 ]   = -.637345E-01;
    coeffPerformance[ 8 ][ 2 ][ 7 ]   = -.478936;
    coeffPerformance[ 9 ][ 2 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 7 ]  =  0.00000;
    powerMin[ 2 ][ 7 ]                = 0.549743;
    powerMax[ 2 ][ 7 ]                =  1.05511;
    coeffPower[ 0 ][ 2 ][ 7 ]         = 0.822904;
    coeffPower[ 1 ][ 2 ][ 7 ]         =  1.35885;
    coeffPower[ 2 ][ 2 ][ 7 ]         =  1.06560;
    coeffPower[ 3 ][ 2 ][ 7 ]         = -.567637;
    coeffPower[ 4 ][ 2 ][ 7 ]         = -2.59331;
    coeffPower[ 5 ][ 2 ][ 7 ]         =  1.01971;
    coeffPower[ 6 ][ 2 ][ 7 ]         = -.394865;
    coeffPower[ 7 ][ 2 ][ 7 ]         = -.554609;
    coeffPower[ 8 ][ 2 ][ 7 ]         = 0.350766;
    coeffPower[ 9 ][ 2 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 7 ]        =  0.00000;
    energyMin[ 3 ][ 7 ]               = 0.680192;
    energyMax[ 3 ][ 7 ]               =  1.31948;
    coeffEnergy[ 0 ][ 3 ][ 7 ]        =  1.03583;
    coeffEnergy[ 1 ][ 3 ][ 7 ]        =  6.62397;
    coeffEnergy[ 2 ][ 3 ][ 7 ]        =  1.24107;
    coeffEnergy[ 3 ][ 3 ][ 7 ]        = -.688663;
    coeffEnergy[ 4 ][ 3 ][ 7 ]        = -12.5438;
    coeffEnergy[ 5 ][ 3 ][ 7 ]        = -4.24020;
    coeffEnergy[ 6 ][ 3 ][ 7 ]        =  2.06910;
    coeffEnergy[ 7 ][ 3 ][ 7 ]        = -.230786;
    coeffEnergy[ 8 ][ 3 ][ 7 ]        = 0.355933;
    coeffEnergy[ 9 ][ 3 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 7 ]       =  0.00000;
    performanceMin[ 3 ][ 7 ]          = 0.594140;
    performanceMax[ 3 ][ 7 ]          =  1.15237;
    coeffPerformance[ 0 ][ 3 ][ 7 ]   = 0.819466;
    coeffPerformance[ 1 ][ 3 ][ 7 ]   = -3.35731;
    coeffPerformance[ 2 ][ 3 ][ 7 ]   = -.414640;
    coeffPerformance[ 3 ][ 3 ][ 7 ]   = 0.248174;
    coeffPerformance[ 4 ][ 3 ][ 7 ]   =  6.34117;
    coeffPerformance[ 5 ][ 3 ][ 7 ]   =  4.80972;
    coeffPerformance[ 6 ][ 3 ][ 7 ]   = -2.18462;
    coeffPerformance[ 7 ][ 3 ][ 7 ]   = -.228611;
    coeffPerformance[ 8 ][ 3 ][ 7 ]   = -.106748;
    coeffPerformance[ 9 ][ 3 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 7 ]  =  0.00000;
    powerMin[ 3 ][ 7 ]                = 0.590801;
    powerMax[ 3 ][ 7 ]                =  1.07740;
    coeffPower[ 0 ][ 3 ][ 7 ]         = 0.848372;
    coeffPower[ 1 ][ 3 ][ 7 ]         =  2.14338;
    coeffPower[ 2 ][ 3 ][ 7 ]         = 0.645848;
    coeffPower[ 3 ][ 3 ][ 7 ]         = -.341513;
    coeffPower[ 4 ][ 3 ][ 7 ]         = -4.07551;
    coeffPower[ 5 ][ 3 ][ 7 ]         = 0.969019;
    coeffPower[ 6 ][ 3 ][ 7 ]         = -.319647;
    coeffPower[ 7 ][ 3 ][ 7 ]         = -.398948;
    coeffPower[ 8 ][ 3 ][ 7 ]         = 0.195096;
    coeffPower[ 9 ][ 3 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 7 ]        =  0.00000;
    energyMin[ 4 ][ 7 ]               = 0.689678;
    energyMax[ 4 ][ 7 ]               =  1.25182;
    coeffEnergy[ 0 ][ 4 ][ 7 ]        =  1.01340;
    coeffEnergy[ 1 ][ 4 ][ 7 ]        =  4.97832;
    coeffEnergy[ 2 ][ 4 ][ 7 ]        = 0.909030;
    coeffEnergy[ 3 ][ 4 ][ 7 ]        = -.505183;
    coeffEnergy[ 4 ][ 4 ][ 7 ]        = -9.42569;
    coeffEnergy[ 5 ][ 4 ][ 7 ]        = -2.75346;
    coeffEnergy[ 6 ][ 4 ][ 7 ]        =  1.29885;
    coeffEnergy[ 7 ][ 4 ][ 7 ]        = -.201877;
    coeffEnergy[ 8 ][ 4 ][ 7 ]        = 0.382869;
    coeffEnergy[ 9 ][ 4 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 7 ]       =  0.00000;
    performanceMin[ 4 ][ 7 ]          = 0.660358;
    performanceMax[ 4 ][ 7 ]          =  1.17156;
    coeffPerformance[ 0 ][ 4 ][ 7 ]   = 0.861046;
    coeffPerformance[ 1 ][ 4 ][ 7 ]   = -2.64657;
    coeffPerformance[ 2 ][ 4 ][ 7 ]   = -.220918;
    coeffPerformance[ 3 ][ 4 ][ 7 ]   = 0.143553;
    coeffPerformance[ 4 ][ 4 ][ 7 ]   =  5.00121;
    coeffPerformance[ 5 ][ 4 ][ 7 ]   =  3.91128;
    coeffPerformance[ 6 ][ 4 ][ 7 ]   = -1.71910;
    coeffPerformance[ 7 ][ 4 ][ 7 ]   = -.393405E-01;
    coeffPerformance[ 8 ][ 4 ][ 7 ]   = -.323517;
    coeffPerformance[ 9 ][ 4 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 7 ]  =  0.00000;
    powerMin[ 4 ][ 7 ]                = 0.638130;
    powerMax[ 4 ][ 7 ]                =  1.10969;
    coeffPower[ 0 ][ 4 ][ 7 ]         = 0.871644;
    coeffPower[ 1 ][ 4 ][ 7 ]         =  1.80427;
    coeffPower[ 2 ][ 4 ][ 7 ]         = 0.609490;
    coeffPower[ 3 ][ 4 ][ 7 ]         = -.318476;
    coeffPower[ 4 ][ 4 ][ 7 ]         = -3.42545;
    coeffPower[ 5 ][ 4 ][ 7 ]         =  1.33470;
    coeffPower[ 6 ][ 4 ][ 7 ]         = -.512672;
    coeffPower[ 7 ][ 4 ][ 7 ]         = -.211473;
    coeffPower[ 8 ][ 4 ][ 7 ]         = 0.362746E-01;
    coeffPower[ 9 ][ 4 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 7 ]        =  0.00000;
    energyMin[ 5 ][ 7 ]               = 0.723634;
    energyMax[ 5 ][ 7 ]               =  1.23824;
    coeffEnergy[ 0 ][ 5 ][ 7 ]        =  1.00144;
    coeffEnergy[ 1 ][ 5 ][ 7 ]        =  3.57000;
    coeffEnergy[ 2 ][ 5 ][ 7 ]        = 0.487374;
    coeffEnergy[ 3 ][ 5 ][ 7 ]        = -.270586;
    coeffEnergy[ 4 ][ 5 ][ 7 ]        = -6.75938;
    coeffEnergy[ 5 ][ 5 ][ 7 ]        = -1.74583;
    coeffEnergy[ 6 ][ 5 ][ 7 ]        = 0.869303;
    coeffEnergy[ 7 ][ 5 ][ 7 ]        = -.154740E-01;
    coeffEnergy[ 8 ][ 5 ][ 7 ]        = 0.520255E-01;
    coeffEnergy[ 9 ][ 5 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 7 ]       =  0.00000;
    performanceMin[ 5 ][ 7 ]          = 0.699158;
    performanceMax[ 5 ][ 7 ]          =  1.19374;
    coeffPerformance[ 0 ][ 5 ][ 7 ]   = 0.915537;
    coeffPerformance[ 1 ][ 5 ][ 7 ]   = -2.57123;
    coeffPerformance[ 2 ][ 5 ][ 7 ]   = -.311975;
    coeffPerformance[ 3 ][ 5 ][ 7 ]   = 0.180109;
    coeffPerformance[ 4 ][ 5 ][ 7 ]   =  4.86030;
    coeffPerformance[ 5 ][ 5 ][ 7 ]   =  2.64053;
    coeffPerformance[ 6 ][ 5 ][ 7 ]   = -1.29942;
    coeffPerformance[ 7 ][ 5 ][ 7 ]   = -.175754;
    coeffPerformance[ 8 ][ 5 ][ 7 ]   = 0.215459E-01;
    coeffPerformance[ 9 ][ 5 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 7 ]  =  0.00000;
    powerMin[ 5 ][ 7 ]                = 0.690120;
    powerMax[ 5 ][ 7 ]                =  1.13671;
    coeffPower[ 0 ][ 5 ][ 7 ]         = 0.915544;
    coeffPower[ 1 ][ 5 ][ 7 ]         = 0.772647;
    coeffPower[ 2 ][ 5 ][ 7 ]         = 0.140853;
    coeffPower[ 3 ][ 5 ][ 7 ]         = -.715213E-01;
    coeffPower[ 4 ][ 5 ][ 7 ]         = -1.47052;
    coeffPower[ 5 ][ 5 ][ 7 ]         = 0.954207;
    coeffPower[ 6 ][ 5 ][ 7 ]         = -.455288;
    coeffPower[ 7 ][ 5 ][ 7 ]         = -.173434;
    coeffPower[ 8 ][ 5 ][ 7 ]         = 0.585811E-01;
    coeffPower[ 9 ][ 5 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 7 ]        =  0.00000;
    energyMin[ 6 ][ 7 ]               = 0.735521;
    energyMax[ 6 ][ 7 ]               =  1.25791;
    coeffEnergy[ 0 ][ 6 ][ 7 ]        = 0.999118;
    coeffEnergy[ 1 ][ 6 ][ 7 ]        =  2.07769;
    coeffEnergy[ 2 ][ 6 ][ 7 ]        = 0.375218;
    coeffEnergy[ 3 ][ 6 ][ 7 ]        = -.201298;
    coeffEnergy[ 4 ][ 6 ][ 7 ]        = -3.93540;
    coeffEnergy[ 5 ][ 6 ][ 7 ]        = -1.15233;
    coeffEnergy[ 6 ][ 6 ][ 7 ]        = 0.737949;
    coeffEnergy[ 7 ][ 6 ][ 7 ]        = 0.183792;
    coeffEnergy[ 8 ][ 6 ][ 7 ]        = -.349664;
    coeffEnergy[ 9 ][ 6 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 7 ]       =  0.00000;
    performanceMin[ 6 ][ 7 ]          = 0.715207;
    performanceMax[ 6 ][ 7 ]          =  1.25871;
    coeffPerformance[ 0 ][ 6 ][ 7 ]   = 0.962878;
    coeffPerformance[ 1 ][ 6 ][ 7 ]   = -2.00230;
    coeffPerformance[ 2 ][ 6 ][ 7 ]   = -.417559;
    coeffPerformance[ 3 ][ 6 ][ 7 ]   = 0.223906;
    coeffPerformance[ 4 ][ 6 ][ 7 ]   =  3.78755;
    coeffPerformance[ 5 ][ 6 ][ 7 ]   =  1.49042;
    coeffPerformance[ 6 ][ 6 ][ 7 ]   = -.934672;
    coeffPerformance[ 7 ][ 6 ][ 7 ]   = -.347906;
    coeffPerformance[ 8 ][ 6 ][ 7 ]   = 0.453385;
    coeffPerformance[ 9 ][ 6 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 7 ]  =  0.00000;
    powerMin[ 6 ][ 7 ]                = 0.727322;
    powerMax[ 6 ][ 7 ]                =  1.16930;
    coeffPower[ 0 ][ 6 ][ 7 ]         = 0.961204;
    coeffPower[ 1 ][ 6 ][ 7 ]         = 0.216319E-01;
    coeffPower[ 2 ][ 6 ][ 7 ]         = -.455073E-01;
    coeffPower[ 3 ][ 6 ][ 7 ]         = 0.245851E-01;
    coeffPower[ 4 ][ 6 ][ 7 ]         = -.457686E-01;
    coeffPower[ 5 ][ 6 ][ 7 ]         = 0.362194;
    coeffPower[ 6 ][ 6 ][ 7 ]         = -.202308;
    coeffPower[ 7 ][ 6 ][ 7 ]         = -.157120;
    coeffPower[ 8 ][ 6 ][ 7 ]         = 0.923045E-01;
    coeffPower[ 9 ][ 6 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 7 ]        =  0.00000;
    energyMin[ 7 ][ 7 ]               = 0.800000;
    energyMax[ 7 ][ 7 ]               =  1.20000;
    coeffEnergy[ 0 ][ 7 ][ 7 ]        =  1.00000;
    coeffEnergy[ 1 ][ 7 ][ 7 ]        = -.401277E-13;
    coeffEnergy[ 2 ][ 7 ][ 7 ]        = -.184255E-12;
    coeffEnergy[ 3 ][ 7 ][ 7 ]        = 0.909804E-13;
    coeffEnergy[ 4 ][ 7 ][ 7 ]        = 0.722411E-13;
    coeffEnergy[ 5 ][ 7 ][ 7 ]        = -.386716E-12;
    coeffEnergy[ 6 ][ 7 ][ 7 ]        = 0.646528E-12;
    coeffEnergy[ 7 ][ 7 ][ 7 ]        = 0.100681E-12;
    coeffEnergy[ 8 ][ 7 ][ 7 ]        = 0.810406E-14;
    coeffEnergy[ 9 ][ 7 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 7 ]       =  0.00000;
    performanceMin[ 7 ][ 7 ]          = 0.800000;
    performanceMax[ 7 ][ 7 ]          =  1.20000;
    coeffPerformance[ 0 ][ 7 ][ 7 ]   =  1.00000;
    coeffPerformance[ 1 ][ 7 ][ 7 ]   = 0.131122E-11;
    coeffPerformance[ 2 ][ 7 ][ 7 ]   = 0.785652E-12;
    coeffPerformance[ 3 ][ 7 ][ 7 ]   = -.431269E-12;
    coeffPerformance[ 4 ][ 7 ][ 7 ]   = -.249933E-11;
    coeffPerformance[ 5 ][ 7 ][ 7 ]   = -.105150E-11;
    coeffPerformance[ 6 ][ 7 ][ 7 ]   = 0.330892E-12;
    coeffPerformance[ 7 ][ 7 ][ 7 ]   = -.370600E-12;
    coeffPerformance[ 8 ][ 7 ][ 7 ]   = 0.724820E-12;
    coeffPerformance[ 9 ][ 7 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 7 ]  =  0.00000;
    powerMin[ 7 ][ 7 ]                = 0.800000;
    powerMax[ 7 ][ 7 ]                =  1.20000;
    coeffPower[ 0 ][ 7 ][ 7 ]         =  1.00000;
    coeffPower[ 1 ][ 7 ][ 7 ]         = 0.385723E-14;
    coeffPower[ 2 ][ 7 ][ 7 ]         = 0.181150E-13;
    coeffPower[ 3 ][ 7 ][ 7 ]         = -.968652E-14;
    coeffPower[ 4 ][ 7 ][ 7 ]         = -.729094E-14;
    coeffPower[ 5 ][ 7 ][ 7 ]         = 0.454025E-14;
    coeffPower[ 6 ][ 7 ][ 7 ]         = -.327597E-14;
    coeffPower[ 7 ][ 7 ][ 7 ]         = 0.239925E-14;
    coeffPower[ 8 ][ 7 ][ 7 ]         = 0.100646E-15;
    coeffPower[ 9 ][ 7 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 7 ]        =  0.00000;
    energyMin[ 8 ][ 7 ]               = 0.787126;
    energyMax[ 8 ][ 7 ]               =  1.33305;
    coeffEnergy[ 0 ][ 8 ][ 7 ]        = 0.993913;
    coeffEnergy[ 1 ][ 8 ][ 7 ]        = -2.06113;
    coeffEnergy[ 2 ][ 8 ][ 7 ]        = -.473140;
    coeffEnergy[ 3 ][ 8 ][ 7 ]        = 0.256661;
    coeffEnergy[ 4 ][ 8 ][ 7 ]        =  3.90886;
    coeffEnergy[ 5 ][ 8 ][ 7 ]        = 0.885462;
    coeffEnergy[ 6 ][ 8 ][ 7 ]        = -.401486;
    coeffEnergy[ 7 ][ 8 ][ 7 ]        = -.227957E-01;
    coeffEnergy[ 8 ][ 8 ][ 7 ]        = 0.575074E-01;
    coeffEnergy[ 9 ][ 8 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 7 ]       =  0.00000;
    performanceMin[ 8 ][ 7 ]          = 0.751590;
    performanceMax[ 8 ][ 7 ]          =  1.27453;
    coeffPerformance[ 0 ][ 8 ][ 7 ]   =  1.04849;
    coeffPerformance[ 1 ][ 8 ][ 7 ]   =  1.92653;
    coeffPerformance[ 2 ][ 8 ][ 7 ]   = 0.306451;
    coeffPerformance[ 3 ][ 8 ][ 7 ]   = -.171691;
    coeffPerformance[ 4 ][ 8 ][ 7 ]   = -3.64934;
    coeffPerformance[ 5 ][ 8 ][ 7 ]   = -1.44030;
    coeffPerformance[ 6 ][ 8 ][ 7 ]   = 0.648044;
    coeffPerformance[ 7 ][ 8 ][ 7 ]   = 0.703869E-01;
    coeffPerformance[ 8 ][ 8 ][ 7 ]   = 0.417970E-01;
    coeffPerformance[ 9 ][ 8 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 7 ]  =  0.00000;
    powerMin[ 8 ][ 7 ]                = 0.820888;
    powerMax[ 8 ][ 7 ]                =  1.29490;
    coeffPower[ 0 ][ 8 ][ 7 ]         =  1.04285;
    coeffPower[ 1 ][ 8 ][ 7 ]         = -.132396;
    coeffPower[ 2 ][ 8 ][ 7 ]         = -.161508;
    coeffPower[ 3 ][ 8 ][ 7 ]         = 0.822477E-01;
    coeffPower[ 4 ][ 8 ][ 7 ]         = 0.254952;
    coeffPower[ 5 ][ 8 ][ 7 ]         = -.556230;
    coeffPower[ 6 ][ 8 ][ 7 ]         = 0.250561;
    coeffPower[ 7 ][ 8 ][ 7 ]         = 0.542766E-01;
    coeffPower[ 8 ][ 8 ][ 7 ]         = 0.920779E-01;
    coeffPower[ 9 ][ 8 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 7 ]        =  0.00000;
    energyMin[ 9 ][ 7 ]               = 0.790016;
    energyMax[ 9 ][ 7 ]               =  1.35801;
    coeffEnergy[ 0 ][ 9 ][ 7 ]        =  1.00479;
    coeffEnergy[ 1 ][ 9 ][ 7 ]        = -2.78102;
    coeffEnergy[ 2 ][ 9 ][ 7 ]        = -.615252;
    coeffEnergy[ 3 ][ 9 ][ 7 ]        = 0.336184;
    coeffEnergy[ 4 ][ 9 ][ 7 ]        =  5.26551;
    coeffEnergy[ 5 ][ 9 ][ 7 ]        =  1.75702;
    coeffEnergy[ 6 ][ 9 ][ 7 ]        = -.815582;
    coeffEnergy[ 7 ][ 9 ][ 7 ]        = 0.304543E-01;
    coeffEnergy[ 8 ][ 9 ][ 7 ]        = 0.547602E-01;
    coeffEnergy[ 9 ][ 9 ][ 7 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 7 ]       =  0.00000;
    performanceMin[ 9 ][ 7 ]          = 0.800796;
    performanceMax[ 9 ][ 7 ]          =  1.33832;
    coeffPerformance[ 0 ][ 9 ][ 7 ]   =  1.07446;
    coeffPerformance[ 1 ][ 9 ][ 7 ]   =  3.05359;
    coeffPerformance[ 2 ][ 9 ][ 7 ]   = 0.380344;
    coeffPerformance[ 3 ][ 9 ][ 7 ]   = -.216304;
    coeffPerformance[ 4 ][ 9 ][ 7 ]   = -5.77046;
    coeffPerformance[ 5 ][ 9 ][ 7 ]   = -2.47844;
    coeffPerformance[ 6 ][ 9 ][ 7 ]   =  1.07950;
    coeffPerformance[ 7 ][ 9 ][ 7 ]   = 0.813727E-01;
    coeffPerformance[ 8 ][ 9 ][ 7 ]   = 0.108368;
    coeffPerformance[ 9 ][ 9 ][ 7 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 7 ]  =  0.00000;
    powerMin[ 9 ][ 7 ]                = 0.845771;
    powerMax[ 9 ][ 7 ]                =  1.37193;
    coeffPower[ 0 ][ 9 ][ 7 ]         =  1.07813;
    coeffPower[ 1 ][ 9 ][ 7 ]         = 0.165453;
    coeffPower[ 2 ][ 9 ][ 7 ]         = -.250834;
    coeffPower[ 3 ][ 9 ][ 7 ]         = 0.128814;
    coeffPower[ 4 ][ 9 ][ 7 ]         = -.301625;
    coeffPower[ 5 ][ 9 ][ 7 ]         = -.670674;
    coeffPower[ 6 ][ 9 ][ 7 ]         = 0.235420;
    coeffPower[ 7 ][ 9 ][ 7 ]         = 0.130313;
    coeffPower[ 8 ][ 9 ][ 7 ]         = 0.154290;
    coeffPower[ 9 ][ 9 ][ 7 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 7 ]        =  0.00000;
    energyMin[ 10 ][ 7 ]              = 0.792142;
    energyMax[ 10 ][ 7 ]              =  1.37859;
    coeffEnergy[ 0 ][ 10 ][ 7 ]       =  1.01362;
    coeffEnergy[ 1 ][ 10 ][ 7 ]       = -4.12499;
    coeffEnergy[ 2 ][ 10 ][ 7 ]       = -.782624;
    coeffEnergy[ 3 ][ 10 ][ 7 ]       = 0.427959;
    coeffEnergy[ 4 ][ 10 ][ 7 ]       =  7.80992;
    coeffEnergy[ 5 ][ 10 ][ 7 ]       =  2.46461;
    coeffEnergy[ 6 ][ 10 ][ 7 ]       = -1.15396;
    coeffEnergy[ 7 ][ 10 ][ 7 ]       = 0.275480E-01;
    coeffEnergy[ 8 ][ 10 ][ 7 ]       = 0.127711;
    coeffEnergy[ 9 ][ 10 ][ 7 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 7 ]      =  0.00000;
    performanceMin[ 10 ][ 7 ]         = 0.811025;
    performanceMax[ 10 ][ 7 ]         =  1.40211;
    coeffPerformance[ 0 ][ 10 ][ 7 ]  =  1.11674;
    coeffPerformance[ 1 ][ 10 ][ 7 ]  =  4.94053;
    coeffPerformance[ 2 ][ 10 ][ 7 ]  = 0.623053;
    coeffPerformance[ 3 ][ 10 ][ 7 ]  = -.352594;
    coeffPerformance[ 4 ][ 10 ][ 7 ]  = -9.34084;
    coeffPerformance[ 5 ][ 10 ][ 7 ]  = -3.79833;
    coeffPerformance[ 6 ][ 10 ][ 7 ]  =  1.69536;
    coeffPerformance[ 7 ][ 10 ][ 7 ]  = 0.122705;
    coeffPerformance[ 8 ][ 10 ][ 7 ]  = 0.124719;
    coeffPerformance[ 9 ][ 10 ][ 7 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 7 ] =  0.00000;
    powerMin[ 10 ][ 7 ]               = 0.869293;
    powerMax[ 10 ][ 7 ]               =  1.45395;
    coeffPower[ 0 ][ 10 ][ 7 ]        =  1.12988;
    coeffPower[ 1 ][ 10 ][ 7 ]        = 0.638252;
    coeffPower[ 2 ][ 10 ][ 7 ]        = -.186822;
    coeffPower[ 3 ][ 10 ][ 7 ]        = 0.903911E-01;
    coeffPower[ 4 ][ 10 ][ 7 ]        = -1.19474;
    coeffPower[ 5 ][ 10 ][ 7 ]        = -1.25994;
    coeffPower[ 6 ][ 10 ][ 7 ]        = 0.496646;
    coeffPower[ 7 ][ 10 ][ 7 ]        = 0.179586;
    coeffPower[ 8 ][ 10 ][ 7 ]        = 0.245615;
    coeffPower[ 9 ][ 10 ][ 7 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 7 ]       =  0.00000;
    energyMin[ 11 ][ 7 ]              = 0.793654;
    energyMax[ 11 ][ 7 ]              =  1.41259;
    coeffEnergy[ 0 ][ 11 ][ 7 ]       =  1.02625;
    coeffEnergy[ 1 ][ 11 ][ 7 ]       = -5.21004;
    coeffEnergy[ 2 ][ 11 ][ 7 ]       = -1.20801;
    coeffEnergy[ 3 ][ 11 ][ 7 ]       = 0.658826;
    coeffEnergy[ 4 ][ 11 ][ 7 ]       =  9.86209;
    coeffEnergy[ 5 ][ 11 ][ 7 ]       =  3.59740;
    coeffEnergy[ 6 ][ 11 ][ 7 ]       = -1.76124;
    coeffEnergy[ 7 ][ 11 ][ 7 ]       = -.873895E-01;
    coeffEnergy[ 8 ][ 11 ][ 7 ]       = 0.235049;
    coeffEnergy[ 9 ][ 11 ][ 7 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 7 ]      =  0.00000;
    performanceMin[ 11 ][ 7 ]         = 0.808776;
    performanceMax[ 11 ][ 7 ]         =  1.46474;
    coeffPerformance[ 0 ][ 11 ][ 7 ]  =  1.15501;
    coeffPerformance[ 1 ][ 11 ][ 7 ]  =  6.67924;
    coeffPerformance[ 2 ][ 11 ][ 7 ]  =  1.01039;
    coeffPerformance[ 3 ][ 11 ][ 7 ]  = -.566604;
    coeffPerformance[ 4 ][ 11 ][ 7 ]  = -12.6277;
    coeffPerformance[ 5 ][ 11 ][ 7 ]  = -5.41291;
    coeffPerformance[ 6 ][ 11 ][ 7 ]  =  2.50828;
    coeffPerformance[ 7 ][ 11 ][ 7 ]  = 0.260079;
    coeffPerformance[ 8 ][ 11 ][ 7 ]  = 0.104091;
    coeffPerformance[ 9 ][ 11 ][ 7 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 7 ] =  0.00000;
    powerMin[ 11 ][ 7 ]               = 0.897809;
    powerMax[ 11 ][ 7 ]               =  1.53874;
    coeffPower[ 0 ][ 11 ][ 7 ]        =  1.17990;
    coeffPower[ 1 ][ 11 ][ 7 ]        =  1.14181;
    coeffPower[ 2 ][ 11 ][ 7 ]        = -.236495;
    coeffPower[ 3 ][ 11 ][ 7 ]        = 0.113886;
    coeffPower[ 4 ][ 11 ][ 7 ]        = -2.14403;
    coeffPower[ 5 ][ 11 ][ 7 ]        = -1.71913;
    coeffPower[ 6 ][ 11 ][ 7 ]        = 0.692709;
    coeffPower[ 7 ][ 11 ][ 7 ]        = 0.233655;
    coeffPower[ 8 ][ 11 ][ 7 ]        = 0.318293;
    coeffPower[ 9 ][ 11 ][ 7 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 7 ]       =  0.00000;
    energyMin[ 12 ][ 7 ]              = 0.795400;
    energyMax[ 12 ][ 7 ]              =  1.45863;
    coeffEnergy[ 0 ][ 12 ][ 7 ]       =  1.04287;
    coeffEnergy[ 1 ][ 12 ][ 7 ]       = -6.54740;
    coeffEnergy[ 2 ][ 12 ][ 7 ]       = -1.38883;
    coeffEnergy[ 3 ][ 12 ][ 7 ]       = 0.759917;
    coeffEnergy[ 4 ][ 12 ][ 7 ]       =  12.3907;
    coeffEnergy[ 5 ][ 12 ][ 7 ]       =  4.49074;
    coeffEnergy[ 6 ][ 12 ][ 7 ]       = -2.13668;
    coeffEnergy[ 7 ][ 12 ][ 7 ]       = -.138287;
    coeffEnergy[ 8 ][ 12 ][ 7 ]       = 0.157037;
    coeffEnergy[ 9 ][ 12 ][ 7 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 7 ]      =  0.00000;
    performanceMin[ 12 ][ 7 ]         = 0.816318;
    performanceMax[ 12 ][ 7 ]         =  1.52716;
    coeffPerformance[ 0 ][ 12 ][ 7 ]  =  1.19510;
    coeffPerformance[ 1 ][ 12 ][ 7 ]  =  8.35840;
    coeffPerformance[ 2 ][ 12 ][ 7 ]  =  1.18531;
    coeffPerformance[ 3 ][ 12 ][ 7 ]  = -.669554;
    coeffPerformance[ 4 ][ 12 ][ 7 ]  = -15.8020;
    coeffPerformance[ 5 ][ 12 ][ 7 ]  = -6.95700;
    coeffPerformance[ 6 ][ 12 ][ 7 ]  =  3.16403;
    coeffPerformance[ 7 ][ 12 ][ 7 ]  = 0.261661;
    coeffPerformance[ 8 ][ 12 ][ 7 ]  = 0.279401;
    coeffPerformance[ 9 ][ 12 ][ 7 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 7 ] =  0.00000;
    powerMin[ 12 ][ 7 ]               = 0.925166;
    powerMax[ 12 ][ 7 ]               =  1.59707;
    coeffPower[ 0 ][ 12 ][ 7 ]        =  1.23881;
    coeffPower[ 1 ][ 12 ][ 7 ]        =  1.40984;
    coeffPower[ 2 ][ 12 ][ 7 ]        = -.254201;
    coeffPower[ 3 ][ 12 ][ 7 ]        = 0.118041;
    coeffPower[ 4 ][ 12 ][ 7 ]        = -2.64986;
    coeffPower[ 5 ][ 12 ][ 7 ]        = -2.37917;
    coeffPower[ 6 ][ 12 ][ 7 ]        = 0.962367;
    coeffPower[ 7 ][ 12 ][ 7 ]        = 0.190023;
    coeffPower[ 8 ][ 12 ][ 7 ]        = 0.433162;
    coeffPower[ 9 ][ 12 ][ 7 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 7 ]       =  0.00000;
    energyMin[ 13 ][ 7 ]              = 0.804664;
    energyMax[ 13 ][ 7 ]              =  1.50289;
    coeffEnergy[ 0 ][ 13 ][ 7 ]       =  1.04432;
    coeffEnergy[ 1 ][ 13 ][ 7 ]       = -7.90424;
    coeffEnergy[ 2 ][ 13 ][ 7 ]       = -1.57182;
    coeffEnergy[ 3 ][ 13 ][ 7 ]       = 0.865090;
    coeffEnergy[ 4 ][ 13 ][ 7 ]       =  14.9642;
    coeffEnergy[ 5 ][ 13 ][ 7 ]       =  5.44854;
    coeffEnergy[ 6 ][ 13 ][ 7 ]       = -2.54404;
    coeffEnergy[ 7 ][ 13 ][ 7 ]       = -.160628E-02;
    coeffEnergy[ 8 ][ 13 ][ 7 ]       = 0.404917E-01;
    coeffEnergy[ 9 ][ 13 ][ 7 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 7 ]      =  0.00000;
    performanceMin[ 13 ][ 7 ]         = 0.819184;
    performanceMax[ 13 ][ 7 ]         =  1.59347;
    coeffPerformance[ 0 ][ 13 ][ 7 ]  =  1.23918;
    coeffPerformance[ 1 ][ 13 ][ 7 ]  =  10.0502;
    coeffPerformance[ 2 ][ 13 ][ 7 ]  =  1.33612;
    coeffPerformance[ 3 ][ 13 ][ 7 ]  = -.759656;
    coeffPerformance[ 4 ][ 13 ][ 7 ]  = -19.0030;
    coeffPerformance[ 5 ][ 13 ][ 7 ]  = -8.43734;
    coeffPerformance[ 6 ][ 13 ][ 7 ]  =  3.76020;
    coeffPerformance[ 7 ][ 13 ][ 7 ]  = 0.190642;
    coeffPerformance[ 8 ][ 13 ][ 7 ]  = 0.462796;
    coeffPerformance[ 9 ][ 13 ][ 7 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 7 ] =  0.00000;
    powerMin[ 13 ][ 7 ]               = 0.955114;
    powerMax[ 13 ][ 7 ]               =  1.70878;
    coeffPower[ 0 ][ 13 ][ 7 ]        =  1.28526;
    coeffPower[ 1 ][ 13 ][ 7 ]        =  1.59248;
    coeffPower[ 2 ][ 13 ][ 7 ]        = -.316813;
    coeffPower[ 3 ][ 13 ][ 7 ]        = 0.149182;
    coeffPower[ 4 ][ 13 ][ 7 ]        = -2.98729;
    coeffPower[ 5 ][ 13 ][ 7 ]        = -2.91483;
    coeffPower[ 6 ][ 13 ][ 7 ]        =  1.12700;
    coeffPower[ 7 ][ 13 ][ 7 ]        = 0.277450;
    coeffPower[ 8 ][ 13 ][ 7 ]        = 0.525149;
    coeffPower[ 9 ][ 13 ][ 7 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 7 ]       =  0.00000;
    energyMin[ 14 ][ 7 ]              = 0.806705;
    energyMax[ 14 ][ 7 ]              =  1.53958;
    coeffEnergy[ 0 ][ 14 ][ 7 ]       =  1.05701;
    coeffEnergy[ 1 ][ 14 ][ 7 ]       = -8.76451;
    coeffEnergy[ 2 ][ 14 ][ 7 ]       = -1.95192;
    coeffEnergy[ 3 ][ 14 ][ 7 ]       =  1.07547;
    coeffEnergy[ 4 ][ 14 ][ 7 ]       =  16.5930;
    coeffEnergy[ 5 ][ 14 ][ 7 ]       =  6.67885;
    coeffEnergy[ 6 ][ 14 ][ 7 ]       = -3.18101;
    coeffEnergy[ 7 ][ 14 ][ 7 ]       = -.472081E-02;
    coeffEnergy[ 8 ][ 14 ][ 7 ]       = -.540280E-01;
    coeffEnergy[ 9 ][ 14 ][ 7 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 7 ]      =  0.00000;
    performanceMin[ 14 ][ 7 ]         = 0.816764;
    performanceMax[ 14 ][ 7 ]         =  1.65663;
    coeffPerformance[ 0 ][ 14 ][ 7 ]  =  1.28262;
    coeffPerformance[ 1 ][ 14 ][ 7 ]  =  11.6096;
    coeffPerformance[ 2 ][ 14 ][ 7 ]  =  1.66120;
    coeffPerformance[ 3 ][ 14 ][ 7 ]  = -.942878;
    coeffPerformance[ 4 ][ 14 ][ 7 ]  = -21.9524;
    coeffPerformance[ 5 ][ 14 ][ 7 ]  = -10.1661;
    coeffPerformance[ 6 ][ 14 ][ 7 ]  =  4.58695;
    coeffPerformance[ 7 ][ 14 ][ 7 ]  = 0.231538;
    coeffPerformance[ 8 ][ 14 ][ 7 ]  = 0.555604;
    coeffPerformance[ 9 ][ 14 ][ 7 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 7 ] =  0.00000;
    powerMin[ 14 ][ 7 ]               = 0.984993;
    powerMax[ 14 ][ 7 ]               =  1.78913;
    coeffPower[ 0 ][ 14 ][ 7 ]        =  1.34480;
    coeffPower[ 1 ][ 14 ][ 7 ]        =  2.29841;
    coeffPower[ 2 ][ 14 ][ 7 ]        = -.343002;
    coeffPower[ 3 ][ 14 ][ 7 ]        = 0.160724;
    coeffPower[ 4 ][ 14 ][ 7 ]        = -4.31967;
    coeffPower[ 5 ][ 14 ][ 7 ]        = -3.47563;
    coeffPower[ 6 ][ 14 ][ 7 ]        =  1.33581;
    coeffPower[ 7 ][ 14 ][ 7 ]        = 0.344918;
    coeffPower[ 8 ][ 14 ][ 7 ]        = 0.526044;
    coeffPower[ 9 ][ 14 ][ 7 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 7 ]       =  0.00000;
    energyMin[ 15 ][ 7 ]              = 0.810896;
    energyMax[ 15 ][ 7 ]              =  1.61449;
    coeffEnergy[ 0 ][ 15 ][ 7 ]       =  1.07348;
    coeffEnergy[ 1 ][ 15 ][ 7 ]       = -8.96453;
    coeffEnergy[ 2 ][ 15 ][ 7 ]       = -1.92958;
    coeffEnergy[ 3 ][ 15 ][ 7 ]       =  1.07249;
    coeffEnergy[ 4 ][ 15 ][ 7 ]       =  16.9682;
    coeffEnergy[ 5 ][ 15 ][ 7 ]       =  7.84935;
    coeffEnergy[ 6 ][ 15 ][ 7 ]       = -3.66315;
    coeffEnergy[ 7 ][ 15 ][ 7 ]       = 0.626330E-01;
    coeffEnergy[ 8 ][ 15 ][ 7 ]       = -.257671;
    coeffEnergy[ 9 ][ 15 ][ 7 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 7 ]      =  0.00000;
    performanceMin[ 15 ][ 7 ]         = 0.822069;
    performanceMax[ 15 ][ 7 ]         =  1.71605;
    coeffPerformance[ 0 ][ 15 ][ 7 ]  =  1.32106;
    coeffPerformance[ 1 ][ 15 ][ 7 ]  =  12.3382;
    coeffPerformance[ 2 ][ 15 ][ 7 ]  =  1.59113;
    coeffPerformance[ 3 ][ 15 ][ 7 ]  = -.917012;
    coeffPerformance[ 4 ][ 15 ][ 7 ]  = -23.3233;
    coeffPerformance[ 5 ][ 15 ][ 7 ]  = -11.9387;
    coeffPerformance[ 6 ][ 15 ][ 7 ]  =  5.37741;
    coeffPerformance[ 7 ][ 15 ][ 7 ]  = 0.247660;
    coeffPerformance[ 8 ][ 15 ][ 7 ]  = 0.720551;
    coeffPerformance[ 9 ][ 15 ][ 7 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 7 ] =  0.00000;
    powerMin[ 15 ][ 7 ]               =  1.01714;
    powerMax[ 15 ][ 7 ]               =  1.88484;
    coeffPower[ 0 ][ 15 ][ 7 ]        =  1.40149;
    coeffPower[ 1 ][ 15 ][ 7 ]        =  2.95514;
    coeffPower[ 2 ][ 15 ][ 7 ]        = -.380427;
    coeffPower[ 3 ][ 15 ][ 7 ]        = 0.178615;
    coeffPower[ 4 ][ 15 ][ 7 ]        = -5.55571;
    coeffPower[ 5 ][ 15 ][ 7 ]        = -4.10497;
    coeffPower[ 6 ][ 15 ][ 7 ]        =  1.65171;
    coeffPower[ 7 ][ 15 ][ 7 ]        = 0.489482;
    coeffPower[ 8 ][ 15 ][ 7 ]        = 0.451101;
    coeffPower[ 9 ][ 15 ][ 7 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 7 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 2.00;
    energyMin[ 0 ][ 8 ]               = 0.622990;
    energyMax[ 0 ][ 8 ]               =  1.41686;
    coeffEnergy[ 0 ][ 0 ][ 8 ]        =  1.13318;
    coeffEnergy[ 1 ][ 0 ][ 8 ]        =  10.3967;
    coeffEnergy[ 2 ][ 0 ][ 8 ]        =  2.67741;
    coeffEnergy[ 3 ][ 0 ][ 8 ]        = -1.40997;
    coeffEnergy[ 4 ][ 0 ][ 8 ]        = -20.7362;
    coeffEnergy[ 5 ][ 0 ][ 8 ]        = -9.77048;
    coeffEnergy[ 6 ][ 0 ][ 8 ]        =  4.13294;
    coeffEnergy[ 7 ][ 0 ][ 8 ]        = -.553528;
    coeffEnergy[ 8 ][ 0 ][ 8 ]        = 0.892060;
    coeffEnergy[ 9 ][ 0 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 8 ]       =  0.00000;
    performanceMin[ 0 ][ 8 ]          = 0.473919;
    performanceMax[ 0 ][ 8 ]          =  1.04733;
    coeffPerformance[ 0 ][ 0 ][ 8 ]   = 0.622221;
    coeffPerformance[ 1 ][ 0 ][ 8 ]   = -2.01167;
    coeffPerformance[ 2 ][ 0 ][ 8 ]   = 0.617290;
    coeffPerformance[ 3 ][ 0 ][ 8 ]   = -.260689;
    coeffPerformance[ 4 ][ 0 ][ 8 ]   =  3.99298;
    coeffPerformance[ 5 ][ 0 ][ 8 ]   =  8.22020;
    coeffPerformance[ 6 ][ 0 ][ 8 ]   = -3.83271;
    coeffPerformance[ 7 ][ 0 ][ 8 ]   = -.195739;
    coeffPerformance[ 8 ][ 0 ][ 8 ]   = -.388469;
    coeffPerformance[ 9 ][ 0 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 8 ]  =  0.00000;
    powerMin[ 0 ][ 8 ]                = 0.470371;
    powerMax[ 0 ][ 8 ]                = 0.935261;
    coeffPower[ 0 ][ 0 ][ 8 ]         = 0.704986;
    coeffPower[ 1 ][ 0 ][ 8 ]         =  4.12916;
    coeffPower[ 2 ][ 0 ][ 8 ]         =  2.36646;
    coeffPower[ 3 ][ 0 ][ 8 ]         = -1.18624;
    coeffPower[ 4 ][ 0 ][ 8 ]         = -8.25398;
    coeffPower[ 5 ][ 0 ][ 8 ]         = 0.959085;
    coeffPower[ 6 ][ 0 ][ 8 ]         = -.795529;
    coeffPower[ 7 ][ 0 ][ 8 ]         = -.521890;
    coeffPower[ 8 ][ 0 ][ 8 ]         = 0.240843;
    coeffPower[ 9 ][ 0 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 8 ]        =  0.00000;
    energyMin[ 1 ][ 8 ]               = 0.645196;
    energyMax[ 1 ][ 8 ]               =  1.35002;
    coeffEnergy[ 0 ][ 1 ][ 8 ]        =  1.12827;
    coeffEnergy[ 1 ][ 1 ][ 8 ]        =  7.36968;
    coeffEnergy[ 2 ][ 1 ][ 8 ]        =  1.69338;
    coeffEnergy[ 3 ][ 1 ][ 8 ]        = -.913930;
    coeffEnergy[ 4 ][ 1 ][ 8 ]        = -14.7097;
    coeffEnergy[ 5 ][ 1 ][ 8 ]        = -8.30934;
    coeffEnergy[ 6 ][ 1 ][ 8 ]        =  3.46138;
    coeffEnergy[ 7 ][ 1 ][ 8 ]        = -.658887;
    coeffEnergy[ 8 ][ 1 ][ 8 ]        =  1.04338;
    coeffEnergy[ 9 ][ 1 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 8 ]       =  0.00000;
    performanceMin[ 1 ][ 8 ]          = 0.509318;
    performanceMax[ 1 ][ 8 ]          =  1.09001;
    coeffPerformance[ 0 ][ 1 ][ 8 ]   = 0.668944;
    coeffPerformance[ 1 ][ 1 ][ 8 ]   = -2.48642;
    coeffPerformance[ 2 ][ 1 ][ 8 ]   = 0.379235;
    coeffPerformance[ 3 ][ 1 ][ 8 ]   = -.141511;
    coeffPerformance[ 4 ][ 1 ][ 8 ]   =  4.94188;
    coeffPerformance[ 5 ][ 1 ][ 8 ]   =  7.61660;
    coeffPerformance[ 6 ][ 1 ][ 8 ]   = -3.32794;
    coeffPerformance[ 7 ][ 1 ][ 8 ]   = -.626685E-01;
    coeffPerformance[ 8 ][ 1 ][ 8 ]   = -.615920;
    coeffPerformance[ 9 ][ 1 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 8 ]  =  0.00000;
    powerMin[ 1 ][ 8 ]                = 0.494670;
    powerMax[ 1 ][ 8 ]                = 0.998910;
    coeffPower[ 0 ][ 1 ][ 8 ]         = 0.758872;
    coeffPower[ 1 ][ 1 ][ 8 ]         =  2.20506;
    coeffPower[ 2 ][ 1 ][ 8 ]         =  1.52688;
    coeffPower[ 3 ][ 1 ][ 8 ]         = -.767586;
    coeffPower[ 4 ][ 1 ][ 8 ]         = -4.42305;
    coeffPower[ 5 ][ 1 ][ 8 ]         =  1.03240;
    coeffPower[ 6 ][ 1 ][ 8 ]         = -.643438;
    coeffPower[ 7 ][ 1 ][ 8 ]         = -.536194;
    coeffPower[ 8 ][ 1 ][ 8 ]         = 0.224755;
    coeffPower[ 9 ][ 1 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 8 ]        =  0.00000;
    energyMin[ 2 ][ 8 ]               = 0.657183;
    energyMax[ 2 ][ 8 ]               =  1.31116;
    coeffEnergy[ 0 ][ 2 ][ 8 ]        =  1.08871;
    coeffEnergy[ 1 ][ 2 ][ 8 ]        =  6.87498;
    coeffEnergy[ 2 ][ 2 ][ 8 ]        =  1.27409;
    coeffEnergy[ 3 ][ 2 ][ 8 ]        = -.693666;
    coeffEnergy[ 4 ][ 2 ][ 8 ]        = -13.7194;
    coeffEnergy[ 5 ][ 2 ][ 8 ]        = -6.67347;
    coeffEnergy[ 6 ][ 2 ][ 8 ]        =  3.01724;
    coeffEnergy[ 7 ][ 2 ][ 8 ]        = -.555784;
    coeffEnergy[ 8 ][ 2 ][ 8 ]        = 0.882714;
    coeffEnergy[ 9 ][ 2 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 8 ]       =  0.00000;
    performanceMin[ 2 ][ 8 ]          = 0.552136;
    performanceMax[ 2 ][ 8 ]          =  1.11503;
    coeffPerformance[ 0 ][ 2 ][ 8 ]   = 0.723944;
    coeffPerformance[ 1 ][ 2 ][ 8 ]   = -3.29793;
    coeffPerformance[ 2 ][ 2 ][ 8 ]   = 0.663976E-01;
    coeffPerformance[ 3 ][ 2 ][ 8 ]   = 0.103071E-01;
    coeffPerformance[ 4 ][ 2 ][ 8 ]   =  6.56079;
    coeffPerformance[ 5 ][ 2 ][ 8 ]   =  6.85174;
    coeffPerformance[ 6 ][ 2 ][ 8 ]   = -3.02039;
    coeffPerformance[ 7 ][ 2 ][ 8 ]   = -.103572;
    coeffPerformance[ 8 ][ 2 ][ 8 ]   = -.501653;
    coeffPerformance[ 9 ][ 2 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 8 ]  =  0.00000;
    powerMin[ 2 ][ 8 ]                = 0.520547;
    powerMax[ 2 ][ 8 ]                =  1.02660;
    coeffPower[ 0 ][ 2 ][ 8 ]         = 0.789181;
    coeffPower[ 1 ][ 2 ][ 8 ]         =  1.64947;
    coeffPower[ 2 ][ 2 ][ 8 ]         = 0.995245;
    coeffPower[ 3 ][ 2 ][ 8 ]         = -.500812;
    coeffPower[ 4 ][ 2 ][ 8 ]         = -3.31173;
    coeffPower[ 5 ][ 2 ][ 8 ]         =  1.26784;
    coeffPower[ 6 ][ 2 ][ 8 ]         = -.535145;
    coeffPower[ 7 ][ 2 ][ 8 ]         = -.520993;
    coeffPower[ 8 ][ 2 ][ 8 ]         = 0.241594;
    coeffPower[ 9 ][ 2 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 8 ]        =  0.00000;
    energyMin[ 3 ][ 8 ]               = 0.663611;
    energyMax[ 3 ][ 8 ]               =  1.32690;
    coeffEnergy[ 0 ][ 3 ][ 8 ]        =  1.04298;
    coeffEnergy[ 1 ][ 3 ][ 8 ]        =  8.02622;
    coeffEnergy[ 2 ][ 3 ][ 8 ]        =  1.31916;
    coeffEnergy[ 3 ][ 3 ][ 8 ]        = -.699068;
    coeffEnergy[ 4 ][ 3 ][ 8 ]        = -16.0080;
    coeffEnergy[ 5 ][ 3 ][ 8 ]        = -5.28142;
    coeffEnergy[ 6 ][ 3 ][ 8 ]        =  2.59806;
    coeffEnergy[ 7 ][ 3 ][ 8 ]        = -.182876;
    coeffEnergy[ 8 ][ 3 ][ 8 ]        = 0.274549;
    coeffEnergy[ 9 ][ 3 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 8 ]       =  0.00000;
    performanceMin[ 3 ][ 8 ]          = 0.564051;
    performanceMax[ 3 ][ 8 ]          =  1.14386;
    coeffPerformance[ 0 ][ 3 ][ 8 ]   = 0.783535;
    coeffPerformance[ 1 ][ 3 ][ 8 ]   = -4.18878;
    coeffPerformance[ 2 ][ 3 ][ 8 ]   = -.258974;
    coeffPerformance[ 3 ][ 3 ][ 8 ]   = 0.163862;
    coeffPerformance[ 4 ][ 3 ][ 8 ]   =  8.33517;
    coeffPerformance[ 5 ][ 3 ][ 8 ]   =  5.85358;
    coeffPerformance[ 6 ][ 3 ][ 8 ]   = -2.69506;
    coeffPerformance[ 7 ][ 3 ][ 8 ]   = -.268043;
    coeffPerformance[ 8 ][ 3 ][ 8 ]   = -.134026;
    coeffPerformance[ 9 ][ 3 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 8 ]  =  0.00000;
    powerMin[ 3 ][ 8 ]                = 0.550160;
    powerMax[ 3 ][ 8 ]                =  1.04998;
    coeffPower[ 0 ][ 3 ][ 8 ]         = 0.814719;
    coeffPower[ 1 ][ 3 ][ 8 ]         =  2.28629;
    coeffPower[ 2 ][ 3 ][ 8 ]         = 0.789144;
    coeffPower[ 3 ][ 3 ][ 8 ]         = -.394119;
    coeffPower[ 4 ][ 3 ][ 8 ]         = -4.57829;
    coeffPower[ 5 ][ 3 ][ 8 ]         =  1.19548;
    coeffPower[ 6 ][ 3 ][ 8 ]         = -.420629;
    coeffPower[ 7 ][ 3 ][ 8 ]         = -.374907;
    coeffPower[ 8 ][ 3 ][ 8 ]         = 0.824652E-01;
    coeffPower[ 9 ][ 3 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 8 ]        =  0.00000;
    energyMin[ 4 ][ 8 ]               = 0.672865;
    energyMax[ 4 ][ 8 ]               =  1.25728;
    coeffEnergy[ 0 ][ 4 ][ 8 ]        =  1.02166;
    coeffEnergy[ 1 ][ 4 ][ 8 ]        =  6.93070;
    coeffEnergy[ 2 ][ 4 ][ 8 ]        =  1.15528;
    coeffEnergy[ 3 ][ 4 ][ 8 ]        = -.609129;
    coeffEnergy[ 4 ][ 4 ][ 8 ]        = -13.8234;
    coeffEnergy[ 5 ][ 4 ][ 8 ]        = -3.73171;
    coeffEnergy[ 6 ][ 4 ][ 8 ]        =  1.78684;
    coeffEnergy[ 7 ][ 4 ][ 8 ]        = -.143925;
    coeffEnergy[ 8 ][ 4 ][ 8 ]        = 0.280901;
    coeffEnergy[ 9 ][ 4 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 8 ]       =  0.00000;
    performanceMin[ 4 ][ 8 ]          = 0.626277;
    performanceMax[ 4 ][ 8 ]          =  1.16364;
    coeffPerformance[ 0 ][ 4 ][ 8 ]   = 0.819952;
    coeffPerformance[ 1 ][ 4 ][ 8 ]   = -4.32682;
    coeffPerformance[ 2 ][ 4 ][ 8 ]   = -.400063;
    coeffPerformance[ 3 ][ 4 ][ 8 ]   = 0.233490;
    coeffPerformance[ 4 ][ 4 ][ 8 ]   =  8.61879;
    coeffPerformance[ 5 ][ 4 ][ 8 ]   =  4.98133;
    coeffPerformance[ 6 ][ 4 ][ 8 ]   = -2.23990;
    coeffPerformance[ 7 ][ 4 ][ 8 ]   = -.110604;
    coeffPerformance[ 8 ][ 4 ][ 8 ]   = -.322660;
    coeffPerformance[ 9 ][ 4 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 8 ]  =  0.00000;
    powerMin[ 4 ][ 8 ]                = 0.601411;
    powerMax[ 4 ][ 8 ]                =  1.08032;
    coeffPower[ 0 ][ 4 ][ 8 ]         = 0.835841;
    coeffPower[ 1 ][ 4 ][ 8 ]         =  1.68033;
    coeffPower[ 2 ][ 4 ][ 8 ]         = 0.590709;
    coeffPower[ 3 ][ 4 ][ 8 ]         = -.290582;
    coeffPower[ 4 ][ 4 ][ 8 ]         = -3.36171;
    coeffPower[ 5 ][ 4 ][ 8 ]         =  1.55796;
    coeffPower[ 6 ][ 4 ][ 8 ]         = -.620837;
    coeffPower[ 7 ][ 4 ][ 8 ]         = -.218999;
    coeffPower[ 8 ][ 4 ][ 8 ]         = -.547556E-01;
    coeffPower[ 9 ][ 4 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 8 ]        =  0.00000;
    energyMin[ 5 ][ 8 ]               = 0.697323;
    energyMax[ 5 ][ 8 ]               =  1.24027;
    coeffEnergy[ 0 ][ 5 ][ 8 ]        =  1.00953;
    coeffEnergy[ 1 ][ 5 ][ 8 ]        =  5.48470;
    coeffEnergy[ 2 ][ 5 ][ 8 ]        = 0.932499;
    coeffEnergy[ 3 ][ 5 ][ 8 ]        = -.486950;
    coeffEnergy[ 4 ][ 5 ][ 8 ]        = -10.9405;
    coeffEnergy[ 5 ][ 5 ][ 8 ]        = -2.68879;
    coeffEnergy[ 6 ][ 5 ][ 8 ]        =  1.33322;
    coeffEnergy[ 7 ][ 5 ][ 8 ]        = 0.127746E-01;
    coeffEnergy[ 8 ][ 5 ][ 8 ]        = -.118837E-01;
    coeffEnergy[ 9 ][ 5 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 8 ]       =  0.00000;
    performanceMin[ 5 ][ 8 ]          = 0.664511;
    performanceMax[ 5 ][ 8 ]          =  1.18689;
    coeffPerformance[ 0 ][ 5 ][ 8 ]   = 0.871089;
    coeffPerformance[ 1 ][ 5 ][ 8 ]   = -4.38487;
    coeffPerformance[ 2 ][ 5 ][ 8 ]   = -.585167;
    coeffPerformance[ 3 ][ 5 ][ 8 ]   = 0.316363;
    coeffPerformance[ 4 ][ 5 ][ 8 ]   =  8.73661;
    coeffPerformance[ 5 ][ 5 ][ 8 ]   =  3.82429;
    coeffPerformance[ 6 ][ 5 ][ 8 ]   = -1.86235;
    coeffPerformance[ 7 ][ 5 ][ 8 ]   = -.235908;
    coeffPerformance[ 8 ][ 5 ][ 8 ]   = 0.160418E-02;
    coeffPerformance[ 9 ][ 5 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 8 ]  =  0.00000;
    powerMin[ 5 ][ 8 ]                = 0.652411;
    powerMax[ 5 ][ 8 ]                =  1.10747;
    coeffPower[ 0 ][ 5 ][ 8 ]         = 0.877335;
    coeffPower[ 1 ][ 5 ][ 8 ]         = 0.636363;
    coeffPower[ 2 ][ 5 ][ 8 ]         = 0.265146;
    coeffPower[ 3 ][ 5 ][ 8 ]         = -.127987;
    coeffPower[ 4 ][ 5 ][ 8 ]         = -1.27867;
    coeffPower[ 5 ][ 5 ][ 8 ]         =  1.27173;
    coeffPower[ 6 ][ 5 ][ 8 ]         = -.594234;
    coeffPower[ 7 ][ 5 ][ 8 ]         = -.192898;
    coeffPower[ 8 ][ 5 ][ 8 ]         = -.287259E-01;
    coeffPower[ 9 ][ 5 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 8 ]        =  0.00000;
    energyMin[ 6 ][ 8 ]               = 0.701177;
    energyMax[ 6 ][ 8 ]               =  1.25230;
    coeffEnergy[ 0 ][ 6 ][ 8 ]        =  1.00557;
    coeffEnergy[ 1 ][ 6 ][ 8 ]        =  4.04754;
    coeffEnergy[ 2 ][ 6 ][ 8 ]        = 0.635241;
    coeffEnergy[ 3 ][ 6 ][ 8 ]        = -.327445;
    coeffEnergy[ 4 ][ 6 ][ 8 ]        = -8.07654;
    coeffEnergy[ 5 ][ 6 ][ 8 ]        = -2.05684;
    coeffEnergy[ 6 ][ 6 ][ 8 ]        =  1.15825;
    coeffEnergy[ 7 ][ 6 ][ 8 ]        = 0.206199;
    coeffEnergy[ 8 ][ 6 ][ 8 ]        = -.408201;
    coeffEnergy[ 9 ][ 6 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 8 ]       =  0.00000;
    performanceMin[ 6 ][ 8 ]          = 0.680205;
    performanceMax[ 6 ][ 8 ]          =  1.26444;
    coeffPerformance[ 0 ][ 6 ][ 8 ]   = 0.916884;
    coeffPerformance[ 1 ][ 6 ][ 8 ]   = -3.91974;
    coeffPerformance[ 2 ][ 6 ][ 8 ]   = -.490535;
    coeffPerformance[ 3 ][ 6 ][ 8 ]   = 0.257174;
    coeffPerformance[ 4 ][ 6 ][ 8 ]   =  7.81361;
    coeffPerformance[ 5 ][ 6 ][ 8 ]   =  2.76578;
    coeffPerformance[ 6 ][ 6 ][ 8 ]   = -1.51524;
    coeffPerformance[ 7 ][ 6 ][ 8 ]   = -.404051;
    coeffPerformance[ 8 ][ 6 ][ 8 ]   = 0.428301;
    coeffPerformance[ 9 ][ 6 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 8 ]  =  0.00000;
    powerMin[ 6 ][ 8 ]                = 0.682521;
    powerMax[ 6 ][ 8 ]                =  1.13687;
    coeffPower[ 0 ][ 6 ][ 8 ]         = 0.920865;
    coeffPower[ 1 ][ 6 ][ 8 ]         = -.829439E-03;
    coeffPower[ 2 ][ 6 ][ 8 ]         = 0.116270;
    coeffPower[ 3 ][ 6 ][ 8 ]         = -.552342E-01;
    coeffPower[ 4 ][ 6 ][ 8 ]         = -.601750E-02;
    coeffPower[ 5 ][ 6 ][ 8 ]         = 0.776437;
    coeffPower[ 6 ][ 6 ][ 8 ]         = -.382037;
    coeffPower[ 7 ][ 6 ][ 8 ]         = -.177760;
    coeffPower[ 8 ][ 6 ][ 8 ]         = -.375123E-02;
    coeffPower[ 9 ][ 6 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 8 ]        =  0.00000;
    energyMin[ 7 ][ 8 ]               = 0.720152;
    energyMax[ 7 ][ 8 ]               =  1.21963;
    coeffEnergy[ 0 ][ 7 ][ 8 ]        =  1.00627;
    coeffEnergy[ 1 ][ 7 ][ 8 ]        =  2.18492;
    coeffEnergy[ 2 ][ 7 ][ 8 ]        = 0.383633;
    coeffEnergy[ 3 ][ 7 ][ 8 ]        = -.198512;
    coeffEnergy[ 4 ][ 7 ][ 8 ]        = -4.36216;
    coeffEnergy[ 5 ][ 7 ][ 8 ]        = -.864596;
    coeffEnergy[ 6 ][ 7 ][ 8 ]        = 0.391568;
    coeffEnergy[ 7 ][ 7 ][ 8 ]        = 0.262390E-01;
    coeffEnergy[ 8 ][ 7 ][ 8 ]        = -.584404E-01;
    coeffEnergy[ 9 ][ 7 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 8 ]       =  0.00000;
    performanceMin[ 7 ][ 8 ]          = 0.753221;
    performanceMax[ 7 ][ 8 ]          =  1.27729;
    coeffPerformance[ 0 ][ 7 ][ 8 ]   = 0.951535;
    coeffPerformance[ 1 ][ 7 ][ 8 ]   = -2.21354;
    coeffPerformance[ 2 ][ 7 ][ 8 ]   = -.352079;
    coeffPerformance[ 3 ][ 7 ][ 8 ]   = 0.185674;
    coeffPerformance[ 4 ][ 7 ][ 8 ]   =  4.41623;
    coeffPerformance[ 5 ][ 7 ][ 8 ]   =  1.33349;
    coeffPerformance[ 6 ][ 7 ][ 8 ]   = -.609930;
    coeffPerformance[ 7 ][ 7 ][ 8 ]   = -.776868E-01;
    coeffPerformance[ 8 ][ 7 ][ 8 ]   = -.209751E-01;
    coeffPerformance[ 9 ][ 7 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 8 ]  =  0.00000;
    powerMin[ 7 ][ 8 ]                = 0.741372;
    powerMax[ 7 ][ 8 ]                =  1.16947;
    coeffPower[ 0 ][ 7 ][ 8 ]         = 0.958306;
    coeffPower[ 1 ][ 7 ][ 8 ]         = 0.486933E-02;
    coeffPower[ 2 ][ 7 ][ 8 ]         = 0.428700E-01;
    coeffPower[ 3 ][ 7 ][ 8 ]         = -.185002E-01;
    coeffPower[ 4 ][ 7 ][ 8 ]         = -.131757E-01;
    coeffPower[ 5 ][ 7 ][ 8 ]         = 0.472746;
    coeffPower[ 6 ][ 7 ][ 8 ]         = -.217698;
    coeffPower[ 7 ][ 7 ][ 8 ]         = -.450348E-01;
    coeffPower[ 8 ][ 7 ][ 8 ]         = -.866970E-01;
    coeffPower[ 9 ][ 7 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 8 ]        =  0.00000;
    energyMin[ 8 ][ 8 ]               = 0.800000;
    energyMax[ 8 ][ 8 ]               =  1.20000;
    coeffEnergy[ 0 ][ 8 ][ 8 ]        =  1.00000;
    coeffEnergy[ 1 ][ 8 ][ 8 ]        = 0.290525E-12;
    coeffEnergy[ 2 ][ 8 ][ 8 ]        = -.115607E-12;
    coeffEnergy[ 3 ][ 8 ][ 8 ]        = 0.529187E-13;
    coeffEnergy[ 4 ][ 8 ][ 8 ]        = -.582643E-12;
    coeffEnergy[ 5 ][ 8 ][ 8 ]        = -.216688E-12;
    coeffEnergy[ 6 ][ 8 ][ 8 ]        = 0.370376E-12;
    coeffEnergy[ 7 ][ 8 ][ 8 ]        = -.130287E-12;
    coeffEnergy[ 8 ][ 8 ][ 8 ]        = 0.143142E-12;
    coeffEnergy[ 9 ][ 8 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 8 ]       =  0.00000;
    performanceMin[ 8 ][ 8 ]          = 0.800000;
    performanceMax[ 8 ][ 8 ]          =  1.20000;
    coeffPerformance[ 0 ][ 8 ][ 8 ]   =  1.00000;
    coeffPerformance[ 1 ][ 8 ][ 8 ]   = -.434358E-12;
    coeffPerformance[ 2 ][ 8 ][ 8 ]   = -.203795E-12;
    coeffPerformance[ 3 ][ 8 ][ 8 ]   = 0.101294E-12;
    coeffPerformance[ 4 ][ 8 ][ 8 ]   = 0.870003E-12;
    coeffPerformance[ 5 ][ 8 ][ 8 ]   = -.177570E-12;
    coeffPerformance[ 6 ][ 8 ][ 8 ]   = 0.193191E-12;
    coeffPerformance[ 7 ][ 8 ][ 8 ]   = -.350223E-13;
    coeffPerformance[ 8 ][ 8 ][ 8 ]   = 0.815922E-13;
    coeffPerformance[ 9 ][ 8 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 8 ]  =  0.00000;
    powerMin[ 8 ][ 8 ]                = 0.800000;
    powerMax[ 8 ][ 8 ]                =  1.20000;
    coeffPower[ 0 ][ 8 ][ 8 ]         =  1.00000;
    coeffPower[ 1 ][ 8 ][ 8 ]         = -.156343E-13;
    coeffPower[ 2 ][ 8 ][ 8 ]         = 0.890733E-14;
    coeffPower[ 3 ][ 8 ][ 8 ]         = -.439739E-14;
    coeffPower[ 4 ][ 8 ][ 8 ]         = 0.313315E-13;
    coeffPower[ 5 ][ 8 ][ 8 ]         = -.295146E-14;
    coeffPower[ 6 ][ 8 ][ 8 ]         = 0.213573E-14;
    coeffPower[ 7 ][ 8 ][ 8 ]         = 0.231488E-14;
    coeffPower[ 8 ][ 8 ][ 8 ]         = -.312031E-14;
    coeffPower[ 9 ][ 8 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 8 ]        =  0.00000;
    energyMin[ 9 ][ 8 ]               = 0.715760;
    energyMax[ 9 ][ 8 ]               =  1.27868;
    coeffEnergy[ 0 ][ 9 ][ 8 ]        =  1.01165;
    coeffEnergy[ 1 ][ 9 ][ 8 ]        = -.908559E-01;
    coeffEnergy[ 2 ][ 9 ][ 8 ]        = 0.199938;
    coeffEnergy[ 3 ][ 9 ][ 8 ]        = -.967147E-01;
    coeffEnergy[ 4 ][ 9 ][ 8 ]        = 0.173610;
    coeffEnergy[ 5 ][ 9 ][ 8 ]        = 0.961834;
    coeffEnergy[ 6 ][ 9 ][ 8 ]        = -.467481;
    coeffEnergy[ 7 ][ 9 ][ 8 ]        = 0.585455E-01;
    coeffEnergy[ 8 ][ 9 ][ 8 ]        = -.614973E-02;
    coeffEnergy[ 9 ][ 9 ][ 8 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 8 ]       =  0.00000;
    performanceMin[ 9 ][ 8 ]          = 0.781119;
    performanceMax[ 9 ][ 8 ]          =  1.41441;
    coeffPerformance[ 0 ][ 9 ][ 8 ]   =  1.02148;
    coeffPerformance[ 1 ][ 9 ][ 8 ]   = 0.227576;
    coeffPerformance[ 2 ][ 9 ][ 8 ]   = -.546356E-01;
    coeffPerformance[ 3 ][ 9 ][ 8 ]   = 0.224948E-01;
    coeffPerformance[ 4 ][ 9 ][ 8 ]   = -.438078;
    coeffPerformance[ 5 ][ 9 ][ 8 ]   = -1.04416;
    coeffPerformance[ 6 ][ 9 ][ 8 ]   = 0.455684;
    coeffPerformance[ 7 ][ 9 ][ 8 ]   = -.475328E-02;
    coeffPerformance[ 8 ][ 9 ][ 8 ]   = 0.832920E-01;
    coeffPerformance[ 9 ][ 9 ][ 8 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 8 ]  =  0.00000;
    powerMin[ 9 ][ 8 ]                = 0.820653;
    powerMax[ 9 ][ 8 ]                =  1.29134;
    coeffPower[ 0 ][ 9 ][ 8 ]         =  1.03473;
    coeffPower[ 1 ][ 9 ][ 8 ]         = 0.295934;
    coeffPower[ 2 ][ 9 ][ 8 ]         = 0.188105;
    coeffPower[ 3 ][ 9 ][ 8 ]         = -.957663E-01;
    coeffPower[ 4 ][ 9 ][ 8 ]         = -.583230;
    coeffPower[ 5 ][ 9 ][ 8 ]         = -.827719E-01;
    coeffPower[ 6 ][ 9 ][ 8 ]         = -.910941E-02;
    coeffPower[ 7 ][ 9 ][ 8 ]         = 0.662508E-01;
    coeffPower[ 8 ][ 9 ][ 8 ]         = 0.595767E-01;
    coeffPower[ 9 ][ 9 ][ 8 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 8 ]        =  0.00000;
    energyMin[ 10 ][ 8 ]              = 0.717368;
    energyMax[ 10 ][ 8 ]              =  1.32597;
    coeffEnergy[ 0 ][ 10 ][ 8 ]       =  1.01995;
    coeffEnergy[ 1 ][ 10 ][ 8 ]       = -1.31520;
    coeffEnergy[ 2 ][ 10 ][ 8 ]       = 0.133659;
    coeffEnergy[ 3 ][ 10 ][ 8 ]       = -.605140E-01;
    coeffEnergy[ 4 ][ 10 ][ 8 ]       =  2.61417;
    coeffEnergy[ 5 ][ 10 ][ 8 ]       =  1.70414;
    coeffEnergy[ 6 ][ 10 ][ 8 ]       = -.831051;
    coeffEnergy[ 7 ][ 10 ][ 8 ]       = 0.476117E-01;
    coeffEnergy[ 8 ][ 10 ][ 8 ]       = 0.759392E-01;
    coeffEnergy[ 9 ][ 10 ][ 8 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 8 ]      =  0.00000;
    performanceMin[ 10 ][ 8 ]         = 0.805034;
    performanceMax[ 10 ][ 8 ]         =  1.48079;
    coeffPerformance[ 0 ][ 10 ][ 8 ]  =  1.06126;
    coeffPerformance[ 1 ][ 10 ][ 8 ]  =  1.69367;
    coeffPerformance[ 2 ][ 10 ][ 8 ]  = 0.553237E-01;
    coeffPerformance[ 3 ][ 10 ][ 8 ]  = -.398147E-01;
    coeffPerformance[ 4 ][ 10 ][ 8 ]  = -3.35769;
    coeffPerformance[ 5 ][ 10 ][ 8 ]  = -2.35268;
    coeffPerformance[ 6 ][ 10 ][ 8 ]  =  1.08646;
    coeffPerformance[ 7 ][ 10 ][ 8 ]  = 0.363499E-01;
    coeffPerformance[ 8 ][ 10 ][ 8 ]  = 0.915687E-01;
    coeffPerformance[ 9 ][ 10 ][ 8 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 8 ] =  0.00000;
    powerMin[ 10 ][ 8 ]               = 0.846436;
    powerMax[ 10 ][ 8 ]               =  1.37451;
    coeffPower[ 0 ][ 10 ][ 8 ]        =  1.08377;
    coeffPower[ 1 ][ 10 ][ 8 ]        = 0.545994;
    coeffPower[ 2 ][ 10 ][ 8 ]        = 0.233490;
    coeffPower[ 3 ][ 10 ][ 8 ]        = -.122747;
    coeffPower[ 4 ][ 10 ][ 8 ]        = -1.07924;
    coeffPower[ 5 ][ 10 ][ 8 ]        = -.635830;
    coeffPower[ 6 ][ 10 ][ 8 ]        = 0.246061;
    coeffPower[ 7 ][ 10 ][ 8 ]        = 0.101932;
    coeffPower[ 8 ][ 10 ][ 8 ]        = 0.151466;
    coeffPower[ 9 ][ 10 ][ 8 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 8 ]       =  0.00000;
    energyMin[ 11 ][ 8 ]              = 0.722693;
    energyMax[ 11 ][ 8 ]              =  1.37413;
    coeffEnergy[ 0 ][ 11 ][ 8 ]       =  1.03244;
    coeffEnergy[ 1 ][ 11 ][ 8 ]       = -2.27593;
    coeffEnergy[ 2 ][ 11 ][ 8 ]       = 0.288698E-01;
    coeffEnergy[ 3 ][ 11 ][ 8 ]       = -.287540E-02;
    coeffEnergy[ 4 ][ 11 ][ 8 ]       =  4.52719;
    coeffEnergy[ 5 ][ 11 ][ 8 ]       =  2.80640;
    coeffEnergy[ 6 ][ 11 ][ 8 ]       = -1.40456;
    coeffEnergy[ 7 ][ 11 ][ 8 ]       = -.402482E-01;
    coeffEnergy[ 8 ][ 11 ][ 8 ]       = 0.158248;
    coeffEnergy[ 9 ][ 11 ][ 8 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 8 ]      =  0.00000;
    performanceMin[ 11 ][ 8 ]         = 0.801629;
    performanceMax[ 11 ][ 8 ]         =  1.54760;
    coeffPerformance[ 0 ][ 11 ][ 8 ]  =  1.09681;
    coeffPerformance[ 1 ][ 11 ][ 8 ]  =  3.03691;
    coeffPerformance[ 2 ][ 11 ][ 8 ]  = 0.265410;
    coeffPerformance[ 3 ][ 11 ][ 8 ]  = -.153547;
    coeffPerformance[ 4 ][ 11 ][ 8 ]  = -6.02954;
    coeffPerformance[ 5 ][ 11 ][ 8 ]  = -3.89713;
    coeffPerformance[ 6 ][ 11 ][ 8 ]  =  1.86932;
    coeffPerformance[ 7 ][ 11 ][ 8 ]  = 0.148811;
    coeffPerformance[ 8 ][ 11 ][ 8 ]  = 0.902001E-01;
    coeffPerformance[ 9 ][ 11 ][ 8 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 8 ] =  0.00000;
    powerMin[ 11 ][ 8 ]               = 0.874964;
    powerMax[ 11 ][ 8 ]               =  1.45910;
    coeffPower[ 0 ][ 11 ][ 8 ]        =  1.13195;
    coeffPower[ 1 ][ 11 ][ 8 ]        = 0.912494;
    coeffPower[ 2 ][ 11 ][ 8 ]        = 0.345927;
    coeffPower[ 3 ][ 11 ][ 8 ]        = -.182163;
    coeffPower[ 4 ][ 11 ][ 8 ]        = -1.80581;
    coeffPower[ 5 ][ 11 ][ 8 ]        = -1.06385;
    coeffPower[ 6 ][ 11 ][ 8 ]        = 0.449929;
    coeffPower[ 7 ][ 11 ][ 8 ]        = 0.148489;
    coeffPower[ 8 ][ 11 ][ 8 ]        = 0.218106;
    coeffPower[ 9 ][ 11 ][ 8 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 8 ]       =  0.00000;
    energyMin[ 12 ][ 8 ]              = 0.725404;
    energyMax[ 12 ][ 8 ]              =  1.42916;
    coeffEnergy[ 0 ][ 12 ][ 8 ]       =  1.04824;
    coeffEnergy[ 1 ][ 12 ][ 8 ]       = -3.53839;
    coeffEnergy[ 2 ][ 12 ][ 8 ]       = -.103120;
    coeffEnergy[ 3 ][ 12 ][ 8 ]       = 0.684330E-01;
    coeffEnergy[ 4 ][ 12 ][ 8 ]       =  7.04072;
    coeffEnergy[ 5 ][ 12 ][ 8 ]       =  3.70634;
    coeffEnergy[ 6 ][ 12 ][ 8 ]       = -1.79824;
    coeffEnergy[ 7 ][ 12 ][ 8 ]       = -.961735E-01;
    coeffEnergy[ 8 ][ 12 ][ 8 ]       = 0.956170E-01;
    coeffEnergy[ 9 ][ 12 ][ 8 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 8 ]      =  0.00000;
    performanceMin[ 12 ][ 8 ]         = 0.806448;
    performanceMax[ 12 ][ 8 ]         =  1.61703;
    coeffPerformance[ 0 ][ 12 ][ 8 ]  =  1.13502;
    coeffPerformance[ 1 ][ 12 ][ 8 ]  =  4.51445;
    coeffPerformance[ 2 ][ 12 ][ 8 ]  = 0.404900;
    coeffPerformance[ 3 ][ 12 ][ 8 ]  = -.233057;
    coeffPerformance[ 4 ][ 12 ][ 8 ]  = -8.96999;
    coeffPerformance[ 5 ][ 12 ][ 8 ]  = -5.38724;
    coeffPerformance[ 6 ][ 12 ][ 8 ]  =  2.52344;
    coeffPerformance[ 7 ][ 12 ][ 8 ]  = 0.158194;
    coeffPerformance[ 8 ][ 12 ][ 8 ]  = 0.244234;
    coeffPerformance[ 9 ][ 12 ][ 8 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 8 ] =  0.00000;
    powerMin[ 12 ][ 8 ]               = 0.900167;
    powerMax[ 12 ][ 8 ]               =  1.50445;
    coeffPower[ 0 ][ 12 ][ 8 ]        =  1.18829;
    coeffPower[ 1 ][ 12 ][ 8 ]        =  1.13183;
    coeffPower[ 2 ][ 12 ][ 8 ]        = 0.354262;
    coeffPower[ 3 ][ 12 ][ 8 ]        = -.191068;
    coeffPower[ 4 ][ 12 ][ 8 ]        = -2.24154;
    coeffPower[ 5 ][ 12 ][ 8 ]        = -1.66693;
    coeffPower[ 6 ][ 12 ][ 8 ]        = 0.703528;
    coeffPower[ 7 ][ 12 ][ 8 ]        = 0.106211;
    coeffPower[ 8 ][ 12 ][ 8 ]        = 0.323018;
    coeffPower[ 9 ][ 12 ][ 8 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 8 ]       =  0.00000;
    energyMin[ 13 ][ 8 ]              = 0.732628;
    energyMax[ 13 ][ 8 ]              =  1.47236;
    coeffEnergy[ 0 ][ 13 ][ 8 ]       =  1.05196;
    coeffEnergy[ 1 ][ 13 ][ 8 ]       = -4.21083;
    coeffEnergy[ 2 ][ 13 ][ 8 ]       = 0.268494E-01;
    coeffEnergy[ 3 ][ 13 ][ 8 ]       = 0.106059E-01;
    coeffEnergy[ 4 ][ 13 ][ 8 ]       =  8.38352;
    coeffEnergy[ 5 ][ 13 ][ 8 ]       =  4.74007;
    coeffEnergy[ 6 ][ 13 ][ 8 ]       = -2.25528;
    coeffEnergy[ 7 ][ 13 ][ 8 ]       = 0.400080E-01;
    coeffEnergy[ 8 ][ 13 ][ 8 ]       = -.258231E-01;
    coeffEnergy[ 9 ][ 13 ][ 8 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 8 ]      =  0.00000;
    performanceMin[ 13 ][ 8 ]         = 0.813133;
    performanceMax[ 13 ][ 8 ]         =  1.68297;
    coeffPerformance[ 0 ][ 13 ][ 8 ]  =  1.17545;
    coeffPerformance[ 1 ][ 13 ][ 8 ]  =  5.55480;
    coeffPerformance[ 2 ][ 13 ][ 8 ]  = 0.377669;
    coeffPerformance[ 3 ][ 13 ][ 8 ]  = -.228738;
    coeffPerformance[ 4 ][ 13 ][ 8 ]  = -11.0399;
    coeffPerformance[ 5 ][ 13 ][ 8 ]  = -6.86650;
    coeffPerformance[ 6 ][ 13 ][ 8 ]  =  3.14336;
    coeffPerformance[ 7 ][ 13 ][ 8 ]  = 0.862621E-01;
    coeffPerformance[ 8 ][ 13 ][ 8 ]  = 0.426800;
    coeffPerformance[ 9 ][ 13 ][ 8 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 8 ] =  0.00000;
    powerMin[ 13 ][ 8 ]               = 0.930235;
    powerMax[ 13 ][ 8 ]               =  1.61072;
    coeffPower[ 0 ][ 13 ][ 8 ]        =  1.23376;
    coeffPower[ 1 ][ 13 ][ 8 ]        =  1.42549;
    coeffPower[ 2 ][ 13 ][ 8 ]        = 0.434412;
    coeffPower[ 3 ][ 13 ][ 8 ]        = -.233283;
    coeffPower[ 4 ][ 13 ][ 8 ]        = -2.81969;
    coeffPower[ 5 ][ 13 ][ 8 ]        = -2.12819;
    coeffPower[ 6 ][ 13 ][ 8 ]        = 0.849930;
    coeffPower[ 7 ][ 13 ][ 8 ]        = 0.186664;
    coeffPower[ 8 ][ 13 ][ 8 ]        = 0.400470;
    coeffPower[ 9 ][ 13 ][ 8 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 8 ]       =  0.00000;
    energyMin[ 14 ][ 8 ]              = 0.741018;
    energyMax[ 14 ][ 8 ]              =  1.50848;
    coeffEnergy[ 0 ][ 14 ][ 8 ]       =  1.06637;
    coeffEnergy[ 1 ][ 14 ][ 8 ]       = -4.70024;
    coeffEnergy[ 2 ][ 14 ][ 8 ]       = 0.149937;
    coeffEnergy[ 3 ][ 14 ][ 8 ]       = -.435262E-01;
    coeffEnergy[ 4 ][ 14 ][ 8 ]       =  9.35803;
    coeffEnergy[ 5 ][ 14 ][ 8 ]       =  5.95273;
    coeffEnergy[ 6 ][ 14 ][ 8 ]       = -2.86514;
    coeffEnergy[ 7 ][ 14 ][ 8 ]       = 0.541731E-01;
    coeffEnergy[ 8 ][ 14 ][ 8 ]       = -.135853;
    coeffEnergy[ 9 ][ 14 ][ 8 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 8 ]      =  0.00000;
    performanceMin[ 14 ][ 8 ]         = 0.815451;
    performanceMax[ 14 ][ 8 ]         =  1.75109;
    coeffPerformance[ 0 ][ 14 ][ 8 ]  =  1.21513;
    coeffPerformance[ 1 ][ 14 ][ 8 ]  =  6.64965;
    coeffPerformance[ 2 ][ 14 ][ 8 ]  = 0.321757;
    coeffPerformance[ 3 ][ 14 ][ 8 ]  = -.210250;
    coeffPerformance[ 4 ][ 14 ][ 8 ]  = -13.2183;
    coeffPerformance[ 5 ][ 14 ][ 8 ]  = -8.53267;
    coeffPerformance[ 6 ][ 14 ][ 8 ]  =  3.93900;
    coeffPerformance[ 7 ][ 14 ][ 8 ]  = 0.113196;
    coeffPerformance[ 8 ][ 14 ][ 8 ]  = 0.526550;
    coeffPerformance[ 9 ][ 14 ][ 8 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 8 ] =  0.00000;
    powerMin[ 14 ][ 8 ]               = 0.959929;
    powerMax[ 14 ][ 8 ]               =  1.68537;
    coeffPower[ 0 ][ 14 ][ 8 ]        =  1.29161;
    coeffPower[ 1 ][ 14 ][ 8 ]        =  2.13402;
    coeffPower[ 2 ][ 14 ][ 8 ]        = 0.501834;
    coeffPower[ 3 ][ 14 ][ 8 ]        = -.269410;
    coeffPower[ 4 ][ 14 ][ 8 ]        = -4.22867;
    coeffPower[ 5 ][ 14 ][ 8 ]        = -2.63984;
    coeffPower[ 6 ][ 14 ][ 8 ]        =  1.05048;
    coeffPower[ 7 ][ 14 ][ 8 ]        = 0.247428;
    coeffPower[ 8 ][ 14 ][ 8 ]        = 0.393784;
    coeffPower[ 9 ][ 14 ][ 8 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 8 ]       =  0.00000;
    energyMin[ 15 ][ 8 ]              = 0.756280;
    energyMax[ 15 ][ 8 ]              =  1.56453;
    coeffEnergy[ 0 ][ 15 ][ 8 ]       =  1.08291;
    coeffEnergy[ 1 ][ 15 ][ 8 ]       = -4.81158;
    coeffEnergy[ 2 ][ 15 ][ 8 ]       = 0.104763;
    coeffEnergy[ 3 ][ 15 ][ 8 ]       = -.123332E-01;
    coeffEnergy[ 4 ][ 15 ][ 8 ]       =  9.57621;
    coeffEnergy[ 5 ][ 15 ][ 8 ]       =  7.05086;
    coeffEnergy[ 6 ][ 15 ][ 8 ]       = -3.32706;
    coeffEnergy[ 7 ][ 15 ][ 8 ]       = 0.131789;
    coeffEnergy[ 8 ][ 15 ][ 8 ]       = -.350341;
    coeffEnergy[ 9 ][ 15 ][ 8 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 8 ]      =  0.00000;
    performanceMin[ 15 ][ 8 ]         = 0.816854;
    performanceMax[ 15 ][ 8 ]         =  1.81878;
    coeffPerformance[ 0 ][ 15 ][ 8 ]  =  1.25074;
    coeffPerformance[ 1 ][ 15 ][ 8 ]  =  7.02135;
    coeffPerformance[ 2 ][ 15 ][ 8 ]  = 0.325654;
    coeffPerformance[ 3 ][ 15 ][ 8 ]  = -.222806;
    coeffPerformance[ 4 ][ 15 ][ 8 ]  = -13.9498;
    coeffPerformance[ 5 ][ 15 ][ 8 ]  = -10.1936;
    coeffPerformance[ 6 ][ 15 ][ 8 ]  =  4.69727;
    coeffPerformance[ 7 ][ 15 ][ 8 ]  = 0.113256;
    coeffPerformance[ 8 ][ 15 ][ 8 ]  = 0.705886;
    coeffPerformance[ 9 ][ 15 ][ 8 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 8 ] =  0.00000;
    powerMin[ 15 ][ 8 ]               = 0.990726;
    powerMax[ 15 ][ 8 ]               =  1.78639;
    coeffPower[ 0 ][ 15 ][ 8 ]        =  1.34555;
    coeffPower[ 1 ][ 15 ][ 8 ]        =  2.54376;
    coeffPower[ 2 ][ 15 ][ 8 ]        = 0.500177;
    coeffPower[ 3 ][ 15 ][ 8 ]        = -.270313;
    coeffPower[ 4 ][ 15 ][ 8 ]        = -5.03794;
    coeffPower[ 5 ][ 15 ][ 8 ]        = -3.23310;
    coeffPower[ 6 ][ 15 ][ 8 ]        =  1.36481;
    coeffPower[ 7 ][ 15 ][ 8 ]        = 0.377070;
    coeffPower[ 8 ][ 15 ][ 8 ]        = 0.316678;
    coeffPower[ 9 ][ 15 ][ 8 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 8 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 2.10;
    energyMin[ 0 ][ 9 ]               = 0.600289;
    energyMax[ 0 ][ 9 ]               =  1.42158;
    coeffEnergy[ 0 ][ 0 ][ 9 ]        =  1.12434;
    coeffEnergy[ 1 ][ 0 ][ 9 ]        =  11.9537;
    coeffEnergy[ 2 ][ 0 ][ 9 ]        =  2.27117;
    coeffEnergy[ 3 ][ 0 ][ 9 ]        = -1.14905;
    coeffEnergy[ 4 ][ 0 ][ 9 ]        = -25.0288;
    coeffEnergy[ 5 ][ 0 ][ 9 ]        = -10.4976;
    coeffEnergy[ 6 ][ 0 ][ 9 ]        =  4.88210;
    coeffEnergy[ 7 ][ 0 ][ 9 ]        = -.206946;
    coeffEnergy[ 8 ][ 0 ][ 9 ]        = 0.414072;
    coeffEnergy[ 9 ][ 0 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 9 ]       =  0.00000;
    performanceMin[ 0 ][ 9 ]          = 0.452426;
    performanceMax[ 0 ][ 9 ]          =  1.04362;
    coeffPerformance[ 0 ][ 0 ][ 9 ]   = 0.603052;
    coeffPerformance[ 1 ][ 0 ][ 9 ]   = -2.68026;
    coeffPerformance[ 2 ][ 0 ][ 9 ]   = 0.152194E-01;
    coeffPerformance[ 3 ][ 0 ][ 9 ]   = 0.453137E-01;
    coeffPerformance[ 4 ][ 0 ][ 9 ]   =  5.58780;
    coeffPerformance[ 5 ][ 0 ][ 9 ]   =  8.81168;
    coeffPerformance[ 6 ][ 0 ][ 9 ]   = -4.35571;
    coeffPerformance[ 7 ][ 0 ][ 9 ]   = -.274689;
    coeffPerformance[ 8 ][ 0 ][ 9 ]   = -.339365;
    coeffPerformance[ 9 ][ 0 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 9 ]  =  0.00000;
    powerMin[ 0 ][ 9 ]                = 0.440670;
    powerMax[ 0 ][ 9 ]                = 0.908981;
    coeffPower[ 0 ][ 0 ][ 9 ]         = 0.675563;
    coeffPower[ 1 ][ 0 ][ 9 ]         =  4.21661;
    coeffPower[ 2 ][ 0 ][ 9 ]         =  1.16050;
    coeffPower[ 3 ][ 0 ][ 9 ]         = -.546779;
    coeffPower[ 4 ][ 0 ][ 9 ]         = -8.85152;
    coeffPower[ 5 ][ 0 ][ 9 ]         =  1.09438;
    coeffPower[ 6 ][ 0 ][ 9 ]         = -.854181;
    coeffPower[ 7 ][ 0 ][ 9 ]         = -.366788;
    coeffPower[ 8 ][ 0 ][ 9 ]         = -.226021E-01;
    coeffPower[ 9 ][ 0 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 9 ]        =  0.00000;
    energyMin[ 1 ][ 9 ]               = 0.624571;
    energyMax[ 1 ][ 9 ]               =  1.35451;
    coeffEnergy[ 0 ][ 1 ][ 9 ]        =  1.11764;
    coeffEnergy[ 1 ][ 1 ][ 9 ]        =  7.78255;
    coeffEnergy[ 2 ][ 1 ][ 9 ]        =  1.54990;
    coeffEnergy[ 3 ][ 1 ][ 9 ]        = -.805111;
    coeffEnergy[ 4 ][ 1 ][ 9 ]        = -16.3021;
    coeffEnergy[ 5 ][ 1 ][ 9 ]        = -9.23070;
    coeffEnergy[ 6 ][ 1 ][ 9 ]        =  4.26413;
    coeffEnergy[ 7 ][ 1 ][ 9 ]        = -.458726;
    coeffEnergy[ 8 ][ 1 ][ 9 ]        = 0.768831;
    coeffEnergy[ 9 ][ 1 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 9 ]       =  0.00000;
    performanceMin[ 1 ][ 9 ]          = 0.490909;
    performanceMax[ 1 ][ 9 ]          =  1.08615;
    coeffPerformance[ 0 ][ 1 ][ 9 ]   = 0.649024;
    coeffPerformance[ 1 ][ 1 ][ 9 ]   = -3.14680;
    coeffPerformance[ 2 ][ 1 ][ 9 ]   = -.330525;
    coeffPerformance[ 3 ][ 1 ][ 9 ]   = 0.210657;
    coeffPerformance[ 4 ][ 1 ][ 9 ]   =  6.56587;
    coeffPerformance[ 5 ][ 1 ][ 9 ]   =  8.25553;
    coeffPerformance[ 6 ][ 1 ][ 9 ]   = -3.87163;
    coeffPerformance[ 7 ][ 1 ][ 9 ]   = -.157518;
    coeffPerformance[ 8 ][ 1 ][ 9 ]   = -.557428;
    coeffPerformance[ 9 ][ 1 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 9 ]  =  0.00000;
    powerMin[ 1 ][ 9 ]                = 0.475029;
    powerMax[ 1 ][ 9 ]                = 0.970842;
    coeffPower[ 0 ][ 1 ][ 9 ]         = 0.727244;
    coeffPower[ 1 ][ 1 ][ 9 ]         =  1.60261;
    coeffPower[ 2 ][ 1 ][ 9 ]         = 0.508666;
    coeffPower[ 3 ][ 1 ][ 9 ]         = -.239812;
    coeffPower[ 4 ][ 1 ][ 9 ]         = -3.38268;
    coeffPower[ 5 ][ 1 ][ 9 ]         =  1.02737;
    coeffPower[ 6 ][ 1 ][ 9 ]         = -.638878;
    coeffPower[ 7 ][ 1 ][ 9 ]         = -.476998;
    coeffPower[ 8 ][ 1 ][ 9 ]         = 0.886199E-01;
    coeffPower[ 9 ][ 1 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 9 ]        =  0.00000;
    energyMin[ 2 ][ 9 ]               = 0.637402;
    energyMax[ 2 ][ 9 ]               =  1.31552;
    coeffEnergy[ 0 ][ 2 ][ 9 ]        =  1.07749;
    coeffEnergy[ 1 ][ 2 ][ 9 ]        =  7.93529;
    coeffEnergy[ 2 ][ 2 ][ 9 ]        =  1.21564;
    coeffEnergy[ 3 ][ 2 ][ 9 ]        = -.634213;
    coeffEnergy[ 4 ][ 2 ][ 9 ]        = -16.6192;
    coeffEnergy[ 5 ][ 2 ][ 9 ]        = -7.40948;
    coeffEnergy[ 6 ][ 2 ][ 9 ]        =  3.64393;
    coeffEnergy[ 7 ][ 2 ][ 9 ]        = -.325724;
    coeffEnergy[ 8 ][ 2 ][ 9 ]        = 0.558520;
    coeffEnergy[ 9 ][ 2 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 9 ]       =  0.00000;
    performanceMin[ 2 ][ 9 ]          = 0.526155;
    performanceMax[ 2 ][ 9 ]          =  1.11101;
    coeffPerformance[ 0 ][ 2 ][ 9 ]   = 0.703247;
    coeffPerformance[ 1 ][ 2 ][ 9 ]   = -4.05582;
    coeffPerformance[ 2 ][ 2 ][ 9 ]   = -.636906;
    coeffPerformance[ 3 ][ 2 ][ 9 ]   = 0.351935;
    coeffPerformance[ 4 ][ 2 ][ 9 ]   =  8.46910;
    coeffPerformance[ 5 ][ 2 ][ 9 ]   =  7.53098;
    coeffPerformance[ 6 ][ 2 ][ 9 ]   = -3.58041;
    coeffPerformance[ 7 ][ 2 ][ 9 ]   = -.225153;
    coeffPerformance[ 8 ][ 2 ][ 9 ]   = -.411970;
    coeffPerformance[ 9 ][ 2 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 9 ]  =  0.00000;
    powerMin[ 2 ][ 9 ]                = 0.499878;
    powerMax[ 2 ][ 9 ]                = 0.997752;
    coeffPower[ 0 ][ 2 ][ 9 ]         = 0.756081;
    coeffPower[ 1 ][ 2 ][ 9 ]         =  1.52907;
    coeffPower[ 2 ][ 2 ][ 9 ]         = 0.869687E-01;
    coeffPower[ 3 ][ 2 ][ 9 ]         = -.372645E-01;
    coeffPower[ 4 ][ 2 ][ 9 ]         = -3.22633;
    coeffPower[ 5 ][ 2 ][ 9 ]         =  1.40694;
    coeffPower[ 6 ][ 2 ][ 9 ]         = -.646173;
    coeffPower[ 7 ][ 2 ][ 9 ]         = -.448440;
    coeffPower[ 8 ][ 2 ][ 9 ]         = 0.747409E-01;
    coeffPower[ 9 ][ 2 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 9 ]        =  0.00000;
    energyMin[ 3 ][ 9 ]               = 0.643893;
    energyMax[ 3 ][ 9 ]               =  1.32031;
    coeffEnergy[ 0 ][ 3 ][ 9 ]        =  1.02997;
    coeffEnergy[ 1 ][ 3 ][ 9 ]        =  9.33740;
    coeffEnergy[ 2 ][ 3 ][ 9 ]        =  1.07737;
    coeffEnergy[ 3 ][ 3 ][ 9 ]        = -.549498;
    coeffEnergy[ 4 ][ 3 ][ 9 ]        = -19.5477;
    coeffEnergy[ 5 ][ 3 ][ 9 ]        = -5.90956;
    coeffEnergy[ 6 ][ 3 ][ 9 ]        =  3.11300;
    coeffEnergy[ 7 ][ 3 ][ 9 ]        = 0.761642E-01;
    coeffEnergy[ 8 ][ 3 ][ 9 ]        = -.105938;
    coeffEnergy[ 9 ][ 3 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 9 ]       =  0.00000;
    performanceMin[ 3 ][ 9 ]          = 0.537776;
    performanceMax[ 3 ][ 9 ]          =  1.13980;
    coeffPerformance[ 0 ][ 3 ][ 9 ]   = 0.760395;
    coeffPerformance[ 1 ][ 3 ][ 9 ]   = -5.31957;
    coeffPerformance[ 2 ][ 3 ][ 9 ]   = -1.18349;
    coeffPerformance[ 3 ][ 3 ][ 9 ]   = 0.604079;
    coeffPerformance[ 4 ][ 3 ][ 9 ]   =  11.1134;
    coeffPerformance[ 5 ][ 3 ][ 9 ]   =  6.50984;
    coeffPerformance[ 6 ][ 3 ][ 9 ]   = -3.24022;
    coeffPerformance[ 7 ][ 3 ][ 9 ]   = -.421939;
    coeffPerformance[ 8 ][ 3 ][ 9 ]   = 0.726059E-03;
    coeffPerformance[ 9 ][ 3 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 9 ]  =  0.00000;
    powerMin[ 3 ][ 9 ]                = 0.528316;
    powerMax[ 3 ][ 9 ]                =  1.01909;
    coeffPower[ 0 ][ 3 ][ 9 ]         = 0.778179;
    coeffPower[ 1 ][ 3 ][ 9 ]         =  2.03129;
    coeffPower[ 2 ][ 3 ][ 9 ]         = -.458476;
    coeffPower[ 3 ][ 3 ][ 9 ]         = 0.228234;
    coeffPower[ 4 ][ 3 ][ 9 ]         = -4.27392;
    coeffPower[ 5 ][ 3 ][ 9 ]         =  1.35462;
    coeffPower[ 6 ][ 3 ][ 9 ]         = -.573396;
    coeffPower[ 7 ][ 3 ][ 9 ]         = -.302098;
    coeffPower[ 8 ][ 3 ][ 9 ]         = -.971749E-01;
    coeffPower[ 9 ][ 3 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 9 ]        =  0.00000;
    energyMin[ 4 ][ 9 ]               = 0.652872;
    energyMax[ 4 ][ 9 ]               =  1.25782;
    coeffEnergy[ 0 ][ 4 ][ 9 ]        =  1.00868;
    coeffEnergy[ 1 ][ 4 ][ 9 ]        =  7.94142;
    coeffEnergy[ 2 ][ 4 ][ 9 ]        = 0.834726;
    coeffEnergy[ 3 ][ 4 ][ 9 ]        = -.426537;
    coeffEnergy[ 4 ][ 4 ][ 9 ]        = -16.6243;
    coeffEnergy[ 5 ][ 4 ][ 9 ]        = -4.39336;
    coeffEnergy[ 6 ][ 4 ][ 9 ]        =  2.24794;
    coeffEnergy[ 7 ][ 4 ][ 9 ]        = 0.539652E-01;
    coeffEnergy[ 8 ][ 4 ][ 9 ]        = -.207510E-01;
    coeffEnergy[ 9 ][ 4 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 9 ]       =  0.00000;
    performanceMin[ 4 ][ 9 ]          = 0.595033;
    performanceMax[ 4 ][ 9 ]          =  1.15663;
    coeffPerformance[ 0 ][ 4 ][ 9 ]   = 0.799527;
    coeffPerformance[ 1 ][ 4 ][ 9 ]   = -4.87638;
    coeffPerformance[ 2 ][ 4 ][ 9 ]   = -.959271;
    coeffPerformance[ 3 ][ 4 ][ 9 ]   = 0.495088;
    coeffPerformance[ 4 ][ 4 ][ 9 ]   =  10.1907;
    coeffPerformance[ 5 ][ 4 ][ 9 ]   =  5.75295;
    coeffPerformance[ 6 ][ 4 ][ 9 ]   = -2.80588;
    coeffPerformance[ 7 ][ 4 ][ 9 ]   = -.246775;
    coeffPerformance[ 8 ][ 4 ][ 9 ]   = -.222889;
    coeffPerformance[ 9 ][ 4 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 9 ]  =  0.00000;
    powerMin[ 4 ][ 9 ]                = 0.565169;
    powerMax[ 4 ][ 9 ]                =  1.04937;
    coeffPower[ 0 ][ 4 ][ 9 ]         = 0.801480;
    coeffPower[ 1 ][ 4 ][ 9 ]         =  1.87828;
    coeffPower[ 2 ][ 4 ][ 9 ]         = -.336481;
    coeffPower[ 3 ][ 4 ][ 9 ]         = 0.172774;
    coeffPower[ 4 ][ 4 ][ 9 ]         = -3.94756;
    coeffPower[ 5 ][ 4 ][ 9 ]         =  1.78368;
    coeffPower[ 6 ][ 4 ][ 9 ]         = -.818186;
    coeffPower[ 7 ][ 4 ][ 9 ]         = -.164474;
    coeffPower[ 8 ][ 4 ][ 9 ]         = -.224961;
    coeffPower[ 9 ][ 4 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 9 ]        =  0.00000;
    energyMin[ 5 ][ 9 ]               = 0.679088;
    energyMax[ 5 ][ 9 ]               =  1.23811;
    coeffEnergy[ 0 ][ 5 ][ 9 ]        = 0.998242;
    coeffEnergy[ 1 ][ 5 ][ 9 ]        =  6.37453;
    coeffEnergy[ 2 ][ 5 ][ 9 ]        = 0.820804;
    coeffEnergy[ 3 ][ 5 ][ 9 ]        = -.411603;
    coeffEnergy[ 4 ][ 5 ][ 9 ]        = -13.3443;
    coeffEnergy[ 5 ][ 5 ][ 9 ]        = -3.43844;
    coeffEnergy[ 6 ][ 5 ][ 9 ]        =  1.82731;
    coeffEnergy[ 7 ][ 5 ][ 9 ]        = 0.158268;
    coeffEnergy[ 8 ][ 5 ][ 9 ]        = -.246473;
    coeffEnergy[ 9 ][ 5 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 9 ]       =  0.00000;
    performanceMin[ 5 ][ 9 ]          = 0.633135;
    performanceMax[ 5 ][ 9 ]          =  1.18110;
    coeffPerformance[ 0 ][ 5 ][ 9 ]   = 0.849453;
    coeffPerformance[ 1 ][ 5 ][ 9 ]   = -5.01046;
    coeffPerformance[ 2 ][ 5 ][ 9 ]   = -1.19168;
    coeffPerformance[ 3 ][ 5 ][ 9 ]   = 0.596786;
    coeffPerformance[ 4 ][ 5 ][ 9 ]   =  10.4728;
    coeffPerformance[ 5 ][ 5 ][ 9 ]   =  4.63969;
    coeffPerformance[ 6 ][ 5 ][ 9 ]   = -2.43357;
    coeffPerformance[ 7 ][ 5 ][ 9 ]   = -.372283;
    coeffPerformance[ 8 ][ 5 ][ 9 ]   = 0.103740;
    coeffPerformance[ 9 ][ 5 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 9 ]  =  0.00000;
    powerMin[ 5 ][ 9 ]                = 0.611214;
    powerMax[ 5 ][ 9 ]                =  1.07492;
    coeffPower[ 0 ][ 5 ][ 9 ]         = 0.843304;
    coeffPower[ 1 ][ 5 ][ 9 ]         = 0.743552;
    coeffPower[ 2 ][ 5 ][ 9 ]         = -.475608;
    coeffPower[ 3 ][ 5 ][ 9 ]         = 0.237089;
    coeffPower[ 4 ][ 5 ][ 9 ]         = -1.57102;
    coeffPower[ 5 ][ 5 ][ 9 ]         =  1.42876;
    coeffPower[ 6 ][ 5 ][ 9 ]         = -.733705;
    coeffPower[ 7 ][ 5 ][ 9 ]         = -.178030;
    coeffPower[ 8 ][ 5 ][ 9 ]         = -.152674;
    coeffPower[ 9 ][ 5 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 9 ]        =  0.00000;
    energyMin[ 6 ][ 9 ]               = 0.689458;
    energyMax[ 6 ][ 9 ]               =  1.22308;
    coeffEnergy[ 0 ][ 6 ][ 9 ]        = 0.995027;
    coeffEnergy[ 1 ][ 6 ][ 9 ]        =  4.72030;
    coeffEnergy[ 2 ][ 6 ][ 9 ]        = 0.590459;
    coeffEnergy[ 3 ][ 6 ][ 9 ]        = -.292761;
    coeffEnergy[ 4 ][ 6 ][ 9 ]        = -9.88241;
    coeffEnergy[ 5 ][ 6 ][ 9 ]        = -2.91223;
    coeffEnergy[ 6 ][ 6 ][ 9 ]        =  1.70134;
    coeffEnergy[ 7 ][ 6 ][ 9 ]        = 0.297786;
    coeffEnergy[ 8 ][ 6 ][ 9 ]        = -.583274;
    coeffEnergy[ 9 ][ 6 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 9 ]       =  0.00000;
    performanceMin[ 6 ][ 9 ]          = 0.661834;
    performanceMax[ 6 ][ 9 ]          =  1.23645;
    coeffPerformance[ 0 ][ 6 ][ 9 ]   = 0.895823;
    coeffPerformance[ 1 ][ 6 ][ 9 ]   = -4.27368;
    coeffPerformance[ 2 ][ 6 ][ 9 ]   = -.981775;
    coeffPerformance[ 3 ][ 6 ][ 9 ]   = 0.485185;
    coeffPerformance[ 4 ][ 6 ][ 9 ]   =  8.93282;
    coeffPerformance[ 5 ][ 6 ][ 9 ]   =  3.65194;
    coeffPerformance[ 6 ][ 6 ][ 9 ]   = -2.08335;
    coeffPerformance[ 7 ][ 6 ][ 9 ]   = -.507362;
    coeffPerformance[ 8 ][ 6 ][ 9 ]   = 0.492864;
    coeffPerformance[ 9 ][ 6 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 9 ]  =  0.00000;
    powerMin[ 6 ][ 9 ]                = 0.651516;
    powerMax[ 6 ][ 9 ]                =  1.10371;
    coeffPower[ 0 ][ 6 ][ 9 ]         = 0.887815;
    coeffPower[ 1 ][ 6 ][ 9 ]         = 0.183203;
    coeffPower[ 2 ][ 6 ][ 9 ]         = -.432908;
    coeffPower[ 3 ][ 6 ][ 9 ]         = 0.213518;
    coeffPower[ 4 ][ 6 ][ 9 ]         = -.397004;
    coeffPower[ 5 ][ 6 ][ 9 ]         = 0.883374;
    coeffPower[ 6 ][ 6 ][ 9 ]         = -.457775;
    coeffPower[ 7 ][ 6 ][ 9 ]         = -.181876;
    coeffPower[ 8 ][ 6 ][ 9 ]         = -.108905;
    coeffPower[ 9 ][ 6 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 9 ]        =  0.00000;
    energyMin[ 7 ][ 9 ]               = 0.706914;
    energyMax[ 7 ][ 9 ]               =  1.21517;
    coeffEnergy[ 0 ][ 7 ][ 9 ]        = 0.996495;
    coeffEnergy[ 1 ][ 7 ][ 9 ]        =  2.81848;
    coeffEnergy[ 2 ][ 7 ][ 9 ]        = 0.359659;
    coeffEnergy[ 3 ][ 7 ][ 9 ]        = -.180691;
    coeffEnergy[ 4 ][ 7 ][ 9 ]        = -5.90051;
    coeffEnergy[ 5 ][ 7 ][ 9 ]        = -1.77730;
    coeffEnergy[ 6 ][ 7 ][ 9 ]        = 0.920022;
    coeffEnergy[ 7 ][ 7 ][ 9 ]        = 0.682588E-01;
    coeffEnergy[ 8 ][ 7 ][ 9 ]        = -.166601;
    coeffEnergy[ 9 ][ 7 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 9 ]       =  0.00000;
    performanceMin[ 7 ][ 9 ]          = 0.717320;
    performanceMax[ 7 ][ 9 ]          =  1.19881;
    coeffPerformance[ 0 ][ 7 ][ 9 ]   = 0.929079;
    coeffPerformance[ 1 ][ 7 ][ 9 ]   = -2.87015;
    coeffPerformance[ 2 ][ 7 ][ 9 ]   = -.698436;
    coeffPerformance[ 3 ][ 7 ][ 9 ]   = 0.347469;
    coeffPerformance[ 4 ][ 7 ][ 9 ]   =  5.99919;
    coeffPerformance[ 5 ][ 7 ][ 9 ]   =  2.25664;
    coeffPerformance[ 6 ][ 7 ][ 9 ]   = -1.12679;
    coeffPerformance[ 7 ][ 7 ][ 9 ]   = -.165035;
    coeffPerformance[ 8 ][ 7 ][ 9 ]   = 0.153041E-01;
    coeffPerformance[ 9 ][ 7 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 9 ]  =  0.00000;
    powerMin[ 7 ][ 9 ]                = 0.699744;
    powerMax[ 7 ][ 9 ]                =  1.13506;
    coeffPower[ 0 ][ 7 ][ 9 ]         = 0.924612;
    coeffPower[ 1 ][ 7 ][ 9 ]         = -.155219;
    coeffPower[ 2 ][ 7 ][ 9 ]         = -.352994;
    coeffPower[ 3 ][ 7 ][ 9 ]         = 0.173968;
    coeffPower[ 4 ][ 7 ][ 9 ]         = 0.315865;
    coeffPower[ 5 ][ 7 ][ 9 ]         = 0.531774;
    coeffPower[ 6 ][ 7 ][ 9 ]         = -.239738;
    coeffPower[ 7 ][ 7 ][ 9 ]         = -.865983E-01;
    coeffPower[ 8 ][ 7 ][ 9 ]         = -.152802;
    coeffPower[ 9 ][ 7 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 9 ]        =  0.00000;
    energyMin[ 8 ][ 9 ]               = 0.750776;
    energyMax[ 8 ][ 9 ]               =  1.34123;
    coeffEnergy[ 0 ][ 8 ][ 9 ]        = 0.990114;
    coeffEnergy[ 1 ][ 8 ][ 9 ]        =  1.01743;
    coeffEnergy[ 2 ][ 8 ][ 9 ]        = -.106112;
    coeffEnergy[ 3 ][ 8 ][ 9 ]        = 0.479476E-01;
    coeffEnergy[ 4 ][ 8 ][ 9 ]        = -2.12463;
    coeffEnergy[ 5 ][ 8 ][ 9 ]        = -.850655;
    coeffEnergy[ 6 ][ 8 ][ 9 ]        = 0.432056;
    coeffEnergy[ 7 ][ 8 ][ 9 ]        = -.165270E-03;
    coeffEnergy[ 8 ][ 8 ][ 9 ]        = -.554341E-01;
    coeffEnergy[ 9 ][ 8 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 9 ]       =  0.00000;
    performanceMin[ 8 ][ 9 ]          = 0.678728;
    performanceMax[ 8 ][ 9 ]          =  1.22901;
    coeffPerformance[ 0 ][ 8 ][ 9 ]   = 0.974597;
    coeffPerformance[ 1 ][ 8 ][ 9 ]   = -1.31562;
    coeffPerformance[ 2 ][ 8 ][ 9 ]   = -.152811;
    coeffPerformance[ 3 ][ 8 ][ 9 ]   = 0.774301E-01;
    coeffPerformance[ 4 ][ 8 ][ 9 ]   =  2.74369;
    coeffPerformance[ 5 ][ 8 ][ 9 ]   = 0.915177;
    coeffPerformance[ 6 ][ 8 ][ 9 ]   = -.426944;
    coeffPerformance[ 7 ][ 8 ][ 9 ]   = -.646805E-01;
    coeffPerformance[ 8 ][ 8 ][ 9 ]   = 0.925992E-02;
    coeffPerformance[ 9 ][ 8 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 9 ]  =  0.00000;
    powerMin[ 8 ][ 9 ]                = 0.743415;
    powerMax[ 8 ][ 9 ]                =  1.16980;
    coeffPower[ 0 ][ 8 ][ 9 ]         = 0.965841;
    coeffPower[ 1 ][ 8 ][ 9 ]         = -.292652;
    coeffPower[ 2 ][ 8 ][ 9 ]         = -.254688;
    coeffPower[ 3 ][ 8 ][ 9 ]         = 0.123266;
    coeffPower[ 4 ][ 8 ][ 9 ]         = 0.606630;
    coeffPower[ 5 ][ 8 ][ 9 ]         = 0.443731E-01;
    coeffPower[ 6 ][ 8 ][ 9 ]         = 0.187467E-01;
    coeffPower[ 7 ][ 8 ][ 9 ]         = -.576311E-01;
    coeffPower[ 8 ][ 8 ][ 9 ]         = -.566616E-01;
    coeffPower[ 9 ][ 8 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 9 ]        =  0.00000;
    energyMin[ 9 ][ 9 ]               = 0.800000;
    energyMax[ 9 ][ 9 ]               =  1.20000;
    coeffEnergy[ 0 ][ 9 ][ 9 ]        =  1.00000;
    coeffEnergy[ 1 ][ 9 ][ 9 ]        = -.443877E-13;
    coeffEnergy[ 2 ][ 9 ][ 9 ]        = -.485984E-13;
    coeffEnergy[ 3 ][ 9 ][ 9 ]        = 0.237752E-13;
    coeffEnergy[ 4 ][ 9 ][ 9 ]        = 0.954229E-13;
    coeffEnergy[ 5 ][ 9 ][ 9 ]        = 0.897310E-13;
    coeffEnergy[ 6 ][ 9 ][ 9 ]        = 0.942815E-13;
    coeffEnergy[ 7 ][ 9 ][ 9 ]        = 0.177889E-13;
    coeffEnergy[ 8 ][ 9 ][ 9 ]        = -.278465E-13;
    coeffEnergy[ 9 ][ 9 ][ 9 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 9 ]       =  0.00000;
    performanceMin[ 9 ][ 9 ]          = 0.800000;
    performanceMax[ 9 ][ 9 ]          =  1.20000;
    coeffPerformance[ 0 ][ 9 ][ 9 ]   =  1.00000;
    coeffPerformance[ 1 ][ 9 ][ 9 ]   = -.122268E-11;
    coeffPerformance[ 2 ][ 9 ][ 9 ]   = -.609014E-13;
    coeffPerformance[ 3 ][ 9 ][ 9 ]   = 0.312113E-13;
    coeffPerformance[ 4 ][ 9 ][ 9 ]   = 0.256389E-11;
    coeffPerformance[ 5 ][ 9 ][ 9 ]   = -.715823E-13;
    coeffPerformance[ 6 ][ 9 ][ 9 ]   = 0.212303E-13;
    coeffPerformance[ 7 ][ 9 ][ 9 ]   = 0.178839E-13;
    coeffPerformance[ 8 ][ 9 ][ 9 ]   = -.541091E-13;
    coeffPerformance[ 9 ][ 9 ][ 9 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 9 ]  =  0.00000;
    powerMin[ 9 ][ 9 ]                = 0.800000;
    powerMax[ 9 ][ 9 ]                =  1.20000;
    coeffPower[ 0 ][ 9 ][ 9 ]         =  1.00000;
    coeffPower[ 1 ][ 9 ][ 9 ]         = 0.517499E-14;
    coeffPower[ 2 ][ 9 ][ 9 ]         = 0.436568E-14;
    coeffPower[ 3 ][ 9 ][ 9 ]         = -.192109E-14;
    coeffPower[ 4 ][ 9 ][ 9 ]         = -.105931E-13;
    coeffPower[ 5 ][ 9 ][ 9 ]         = 0.187346E-13;
    coeffPower[ 6 ][ 9 ][ 9 ]         = -.155908E-13;
    coeffPower[ 7 ][ 9 ][ 9 ]         = 0.153629E-14;
    coeffPower[ 8 ][ 9 ][ 9 ]         = -.872584E-15;
    coeffPower[ 9 ][ 9 ][ 9 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 9 ]        =  0.00000;
    energyMin[ 10 ][ 9 ]              = 0.791363;
    energyMax[ 10 ][ 9 ]              =  1.28800;
    coeffEnergy[ 0 ][ 10 ][ 9 ]       =  1.01054;
    coeffEnergy[ 1 ][ 10 ][ 9 ]       = -1.01856;
    coeffEnergy[ 2 ][ 10 ][ 9 ]       = -.106935;
    coeffEnergy[ 3 ][ 10 ][ 9 ]       = 0.532679E-01;
    coeffEnergy[ 4 ][ 10 ][ 9 ]       =  2.13054;
    coeffEnergy[ 5 ][ 10 ][ 9 ]       = 0.692953;
    coeffEnergy[ 6 ][ 10 ][ 9 ]       = -.370644;
    coeffEnergy[ 7 ][ 10 ][ 9 ]       = -.485310E-01;
    coeffEnergy[ 8 ][ 10 ][ 9 ]       = 0.127978;
    coeffEnergy[ 9 ][ 10 ][ 9 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 9 ]      =  0.00000;
    performanceMin[ 10 ][ 9 ]         = 0.789744;
    performanceMax[ 10 ][ 9 ]         =  1.28614;
    coeffPerformance[ 0 ][ 10 ][ 9 ]  =  1.03846;
    coeffPerformance[ 1 ][ 10 ][ 9 ]  =  1.41064;
    coeffPerformance[ 2 ][ 10 ][ 9 ]  = 0.356706;
    coeffPerformance[ 3 ][ 10 ][ 9 ]  = -.177428;
    coeffPerformance[ 4 ][ 10 ][ 9 ]  = -2.95005;
    coeffPerformance[ 5 ][ 10 ][ 9 ]  = -1.22342;
    coeffPerformance[ 6 ][ 10 ][ 9 ]  = 0.652497;
    coeffPerformance[ 7 ][ 10 ][ 9 ]  = 0.842970E-01;
    coeffPerformance[ 8 ][ 10 ][ 9 ]  = -.476772E-01;
    coeffPerformance[ 9 ][ 10 ][ 9 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 9 ] =  0.00000;
    powerMin[ 10 ][ 9 ]               = 0.822248;
    powerMax[ 10 ][ 9 ]               =  1.28772;
    coeffPower[ 0 ][ 10 ][ 9 ]        =  1.04916;
    coeffPower[ 1 ][ 10 ][ 9 ]        = 0.392774;
    coeffPower[ 2 ][ 10 ][ 9 ]        = 0.251044;
    coeffPower[ 3 ][ 10 ][ 9 ]        = -.124723;
    coeffPower[ 4 ][ 10 ][ 9 ]        = -.820997;
    coeffPower[ 5 ][ 10 ][ 9 ]        = -.524754;
    coeffPower[ 6 ][ 10 ][ 9 ]        = 0.279302;
    coeffPower[ 7 ][ 10 ][ 9 ]        = 0.382105E-01;
    coeffPower[ 8 ][ 10 ][ 9 ]        = 0.776371E-01;
    coeffPower[ 9 ][ 10 ][ 9 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 9 ]       =  0.00000;
    energyMin[ 11 ][ 9 ]              = 0.798972;
    energyMax[ 11 ][ 9 ]              =  1.33042;
    coeffEnergy[ 0 ][ 11 ][ 9 ]       =  1.02217;
    coeffEnergy[ 1 ][ 11 ][ 9 ]       = -2.08498;
    coeffEnergy[ 2 ][ 11 ][ 9 ]       = -.275224;
    coeffEnergy[ 3 ][ 11 ][ 9 ]       = 0.138493;
    coeffEnergy[ 4 ][ 11 ][ 9 ]       =  4.36113;
    coeffEnergy[ 5 ][ 11 ][ 9 ]       =  1.73965;
    coeffEnergy[ 6 ][ 11 ][ 9 ]       = -.948103;
    coeffEnergy[ 7 ][ 11 ][ 9 ]       = -.160752;
    coeffEnergy[ 8 ][ 11 ][ 9 ]       = 0.238817;
    coeffEnergy[ 9 ][ 11 ][ 9 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 9 ]      =  0.00000;
    performanceMin[ 11 ][ 9 ]         = 0.794785;
    performanceMax[ 11 ][ 9 ]         =  1.34499;
    coeffPerformance[ 0 ][ 11 ][ 9 ]  =  1.07513;
    coeffPerformance[ 1 ][ 11 ][ 9 ]  =  2.93170;
    coeffPerformance[ 2 ][ 11 ][ 9 ]  = 0.801428;
    coeffPerformance[ 3 ][ 11 ][ 9 ]  = -.398530;
    coeffPerformance[ 4 ][ 11 ][ 9 ]  = -6.12985;
    coeffPerformance[ 5 ][ 11 ][ 9 ]  = -2.72133;
    coeffPerformance[ 6 ][ 11 ][ 9 ]  =  1.49224;
    coeffPerformance[ 7 ][ 11 ][ 9 ]  = 0.236281;
    coeffPerformance[ 8 ][ 11 ][ 9 ]  = -.103231;
    coeffPerformance[ 9 ][ 11 ][ 9 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 9 ] =  0.00000;
    powerMin[ 11 ][ 9 ]               = 0.849222;
    powerMax[ 11 ][ 9 ]               =  1.36423;
    coeffPower[ 0 ][ 11 ][ 9 ]        =  1.09778;
    coeffPower[ 1 ][ 11 ][ 9 ]        = 0.807872;
    coeffPower[ 2 ][ 11 ][ 9 ]        = 0.530399;
    coeffPower[ 3 ][ 11 ][ 9 ]        = -.262029;
    coeffPower[ 4 ][ 11 ][ 9 ]        = -1.68713;
    coeffPower[ 5 ][ 11 ][ 9 ]        = -.976783;
    coeffPower[ 6 ][ 11 ][ 9 ]        = 0.540122;
    coeffPower[ 7 ][ 11 ][ 9 ]        = 0.828051E-01;
    coeffPower[ 8 ][ 11 ][ 9 ]        = 0.136480;
    coeffPower[ 9 ][ 11 ][ 9 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 9 ]       =  0.00000;
    energyMin[ 12 ][ 9 ]              = 0.804927;
    energyMax[ 12 ][ 9 ]              =  1.38870;
    coeffEnergy[ 0 ][ 12 ][ 9 ]       =  1.03903;
    coeffEnergy[ 1 ][ 12 ][ 9 ]       = -3.21652;
    coeffEnergy[ 2 ][ 12 ][ 9 ]       = -.288483;
    coeffEnergy[ 3 ][ 12 ][ 9 ]       = 0.148888;
    coeffEnergy[ 4 ][ 12 ][ 9 ]       =  6.72588;
    coeffEnergy[ 5 ][ 12 ][ 9 ]       =  2.56010;
    coeffEnergy[ 6 ][ 12 ][ 9 ]       = -1.31322;
    coeffEnergy[ 7 ][ 12 ][ 9 ]       = -.228373;
    coeffEnergy[ 8 ][ 12 ][ 9 ]       = 0.195588;
    coeffEnergy[ 9 ][ 12 ][ 9 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 9 ]      =  0.00000;
    performanceMin[ 12 ][ 9 ]         = 0.803645;
    performanceMax[ 12 ][ 9 ]         =  1.40128;
    coeffPerformance[ 0 ][ 12 ][ 9 ]  =  1.11331;
    coeffPerformance[ 1 ][ 12 ][ 9 ]  =  4.52702;
    coeffPerformance[ 2 ][ 12 ][ 9 ]  =  1.05460;
    coeffPerformance[ 3 ][ 12 ][ 9 ]  = -.528595;
    coeffPerformance[ 4 ][ 12 ][ 9 ]  = -9.46551;
    coeffPerformance[ 5 ][ 12 ][ 9 ]  = -4.13163;
    coeffPerformance[ 6 ][ 12 ][ 9 ]  =  2.16102;
    coeffPerformance[ 7 ][ 12 ][ 9 ]  = 0.284817;
    coeffPerformance[ 8 ][ 12 ][ 9 ]  = 0.118361E-02;
    coeffPerformance[ 9 ][ 12 ][ 9 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 9 ] =  0.00000;
    powerMin[ 12 ][ 9 ]               = 0.874873;
    powerMax[ 12 ][ 9 ]               =  1.42725;
    coeffPower[ 0 ][ 12 ][ 9 ]        =  1.15453;
    coeffPower[ 1 ][ 12 ][ 9 ]        =  1.27845;
    coeffPower[ 2 ][ 12 ][ 9 ]        = 0.773250;
    coeffPower[ 3 ][ 12 ][ 9 ]        = -.383349;
    coeffPower[ 4 ][ 12 ][ 9 ]        = -2.67241;
    coeffPower[ 5 ][ 12 ][ 9 ]        = -1.58144;
    coeffPower[ 6 ][ 12 ][ 9 ]        = 0.843433;
    coeffPower[ 7 ][ 12 ][ 9 ]        = 0.620505E-01;
    coeffPower[ 8 ][ 12 ][ 9 ]        = 0.209838;
    coeffPower[ 9 ][ 12 ][ 9 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 9 ]       =  0.00000;
    energyMin[ 13 ][ 9 ]              = 0.810896;
    energyMax[ 13 ][ 9 ]              =  1.43067;
    coeffEnergy[ 0 ][ 13 ][ 9 ]       =  1.04239;
    coeffEnergy[ 1 ][ 13 ][ 9 ]       = -4.27019;
    coeffEnergy[ 2 ][ 13 ][ 9 ]       = -.416928;
    coeffEnergy[ 3 ][ 13 ][ 9 ]       = 0.217143;
    coeffEnergy[ 4 ][ 13 ][ 9 ]       =  8.93469;
    coeffEnergy[ 5 ][ 13 ][ 9 ]       =  3.51605;
    coeffEnergy[ 6 ][ 13 ][ 9 ]       = -1.77725;
    coeffEnergy[ 7 ][ 13 ][ 9 ]       = -.157452;
    coeffEnergy[ 8 ][ 13 ][ 9 ]       = 0.146634;
    coeffEnergy[ 9 ][ 13 ][ 9 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 9 ]      =  0.00000;
    performanceMin[ 13 ][ 9 ]         = 0.810251;
    performanceMax[ 13 ][ 9 ]         =  1.45928;
    coeffPerformance[ 0 ][ 13 ][ 9 ]  =  1.15409;
    coeffPerformance[ 1 ][ 13 ][ 9 ]  =  5.76834;
    coeffPerformance[ 2 ][ 13 ][ 9 ]  =  1.35610;
    coeffPerformance[ 3 ][ 13 ][ 9 ]  = -.682144;
    coeffPerformance[ 4 ][ 13 ][ 9 ]  = -12.0614;
    coeffPerformance[ 5 ][ 13 ][ 9 ]  = -5.56585;
    coeffPerformance[ 6 ][ 13 ][ 9 ]  =  2.83749;
    coeffPerformance[ 7 ][ 13 ][ 9 ]  = 0.268447;
    coeffPerformance[ 8 ][ 13 ][ 9 ]  = 0.116981;
    coeffPerformance[ 9 ][ 13 ][ 9 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 9 ] =  0.00000;
    powerMin[ 13 ][ 9 ]               = 0.903425;
    powerMax[ 13 ][ 9 ]               =  1.50599;
    coeffPower[ 0 ][ 13 ][ 9 ]        =  1.19987;
    coeffPower[ 1 ][ 13 ][ 9 ]        =  1.39333;
    coeffPower[ 2 ][ 13 ][ 9 ]        = 0.937161;
    coeffPower[ 3 ][ 13 ][ 9 ]        = -.464514;
    coeffPower[ 4 ][ 13 ][ 9 ]        = -2.90632;
    coeffPower[ 5 ][ 13 ][ 9 ]        = -2.08076;
    coeffPower[ 6 ][ 13 ][ 9 ]        =  1.04783;
    coeffPower[ 7 ][ 13 ][ 9 ]        = 0.121292;
    coeffPower[ 8 ][ 13 ][ 9 ]        = 0.300413;
    coeffPower[ 9 ][ 13 ][ 9 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 9 ]       =  0.00000;
    energyMin[ 14 ][ 9 ]              = 0.816367;
    energyMax[ 14 ][ 9 ]              =  1.46577;
    coeffEnergy[ 0 ][ 14 ][ 9 ]       =  1.05719;
    coeffEnergy[ 1 ][ 14 ][ 9 ]       = -4.71746;
    coeffEnergy[ 2 ][ 14 ][ 9 ]       = -.320324;
    coeffEnergy[ 3 ][ 14 ][ 9 ]       = 0.178027;
    coeffEnergy[ 4 ][ 14 ][ 9 ]       =  9.86959;
    coeffEnergy[ 5 ][ 14 ][ 9 ]       =  4.68152;
    coeffEnergy[ 6 ][ 14 ][ 9 ]       = -2.39607;
    coeffEnergy[ 7 ][ 14 ][ 9 ]       = -.161357;
    coeffEnergy[ 8 ][ 14 ][ 9 ]       = 0.578137E-01;
    coeffEnergy[ 9 ][ 14 ][ 9 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 9 ]      =  0.00000;
    performanceMin[ 14 ][ 9 ]         = 0.810953;
    performanceMax[ 14 ][ 9 ]         =  1.51812;
    coeffPerformance[ 0 ][ 14 ][ 9 ]  =  1.19484;
    coeffPerformance[ 1 ][ 14 ][ 9 ]  =  7.26470;
    coeffPerformance[ 2 ][ 14 ][ 9 ]  =  1.62242;
    coeffPerformance[ 3 ][ 14 ][ 9 ]  = -.818964;
    coeffPerformance[ 4 ][ 14 ][ 9 ]  = -15.1917;
    coeffPerformance[ 5 ][ 14 ][ 9 ]  = -7.13817;
    coeffPerformance[ 6 ][ 14 ][ 9 ]  =  3.65838;
    coeffPerformance[ 7 ][ 14 ][ 9 ]  = 0.347442;
    coeffPerformance[ 8 ][ 14 ][ 9 ]  = 0.149015;
    coeffPerformance[ 9 ][ 14 ][ 9 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 9 ] =  0.00000;
    powerMin[ 14 ][ 9 ]               = 0.931687;
    powerMax[ 14 ][ 9 ]               =  1.57675;
    coeffPower[ 0 ][ 14 ][ 9 ]        =  1.25850;
    coeffPower[ 1 ][ 14 ][ 9 ]        =  2.48812;
    coeffPower[ 2 ][ 14 ][ 9 ]        =  1.30967;
    coeffPower[ 3 ][ 14 ][ 9 ]        = -.645472;
    coeffPower[ 4 ][ 14 ][ 9 ]        = -5.19679;
    coeffPower[ 5 ][ 14 ][ 9 ]        = -2.54585;
    coeffPower[ 6 ][ 14 ][ 9 ]        =  1.26943;
    coeffPower[ 7 ][ 14 ][ 9 ]        = 0.206554;
    coeffPower[ 8 ][ 14 ][ 9 ]        = 0.253240;
    coeffPower[ 9 ][ 14 ][ 9 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 9 ]       =  0.00000;
    energyMin[ 15 ][ 9 ]              = 0.815016;
    energyMax[ 15 ][ 9 ]              =  1.51573;
    coeffEnergy[ 0 ][ 15 ][ 9 ]       =  1.07171;
    coeffEnergy[ 1 ][ 15 ][ 9 ]       = -4.90253;
    coeffEnergy[ 2 ][ 15 ][ 9 ]       = -.309668;
    coeffEnergy[ 3 ][ 15 ][ 9 ]       = 0.181352;
    coeffEnergy[ 4 ][ 15 ][ 9 ]       =  10.2543;
    coeffEnergy[ 5 ][ 15 ][ 9 ]       =  5.79386;
    coeffEnergy[ 6 ][ 15 ][ 9 ]       = -2.89045;
    coeffEnergy[ 7 ][ 15 ][ 9 ]       = -.878596E-01;
    coeffEnergy[ 8 ][ 15 ][ 9 ]       = -.159757;
    coeffEnergy[ 9 ][ 15 ][ 9 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 9 ]      =  0.00000;
    performanceMin[ 15 ][ 9 ]         = 0.813623;
    performanceMax[ 15 ][ 9 ]         =  1.57953;
    coeffPerformance[ 0 ][ 15 ][ 9 ]  =  1.23260;
    coeffPerformance[ 1 ][ 15 ][ 9 ]  =  7.86910;
    coeffPerformance[ 2 ][ 15 ][ 9 ]  =  1.71383;
    coeffPerformance[ 3 ][ 15 ][ 9 ]  = -.873427;
    coeffPerformance[ 4 ][ 15 ][ 9 ]  = -16.4498;
    coeffPerformance[ 5 ][ 15 ][ 9 ]  = -8.80133;
    coeffPerformance[ 6 ][ 15 ][ 9 ]  =  4.47964;
    coeffPerformance[ 7 ][ 15 ][ 9 ]  = 0.366642;
    coeffPerformance[ 8 ][ 15 ][ 9 ]  = 0.303845;
    coeffPerformance[ 9 ][ 15 ][ 9 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 9 ] =  0.00000;
    powerMin[ 15 ][ 9 ]               = 0.962096;
    powerMax[ 15 ][ 9 ]               =  1.69610;
    coeffPower[ 0 ][ 15 ][ 9 ]        =  1.31278;
    coeffPower[ 1 ][ 15 ][ 9 ]        =  3.12926;
    coeffPower[ 2 ][ 15 ][ 9 ]        =  1.45403;
    coeffPower[ 3 ][ 15 ][ 9 ]        = -.716602;
    coeffPower[ 4 ][ 15 ][ 9 ]        = -6.53332;
    coeffPower[ 5 ][ 15 ][ 9 ]        = -3.10691;
    coeffPower[ 6 ][ 15 ][ 9 ]        =  1.59857;
    coeffPower[ 7 ][ 15 ][ 9 ]        = 0.338132;
    coeffPower[ 8 ][ 15 ][ 9 ]        = 0.159410;
    coeffPower[ 9 ][ 15 ][ 9 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 9 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 2.20;
    energyMin[ 0 ][ 10 ]               = 0.578571;
    energyMax[ 0 ][ 10 ]               =  1.41869;
    coeffEnergy[ 0 ][ 0 ][ 10 ]        =  1.09891;
    coeffEnergy[ 1 ][ 0 ][ 10 ]        =  11.0550;
    coeffEnergy[ 2 ][ 0 ][ 10 ]        =  1.89094;
    coeffEnergy[ 3 ][ 0 ][ 10 ]        = -.923390;
    coeffEnergy[ 4 ][ 0 ][ 10 ]        = -24.2427;
    coeffEnergy[ 5 ][ 0 ][ 10 ]        = -10.4595;
    coeffEnergy[ 6 ][ 0 ][ 10 ]        =  4.86503;
    coeffEnergy[ 7 ][ 0 ][ 10 ]        = -.366591;
    coeffEnergy[ 8 ][ 0 ][ 10 ]        = 0.532972;
    coeffEnergy[ 9 ][ 0 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 10 ]       =  0.00000;
    performanceMin[ 0 ][ 10 ]          = 0.432049;
    performanceMax[ 0 ][ 10 ]          =  1.04078;
    coeffPerformance[ 0 ][ 0 ][ 10 ]   = 0.585435;
    coeffPerformance[ 1 ][ 0 ][ 10 ]   = -1.91126;
    coeffPerformance[ 2 ][ 0 ][ 10 ]   = 0.204024;
    coeffPerformance[ 3 ][ 0 ][ 10 ]   = -.383328E-01;
    coeffPerformance[ 4 ][ 0 ][ 10 ]   =  4.16348;
    coeffPerformance[ 5 ][ 0 ][ 10 ]   =  9.43713;
    coeffPerformance[ 6 ][ 0 ][ 10 ]   = -4.73864;
    coeffPerformance[ 7 ][ 0 ][ 10 ]   = -.196152;
    coeffPerformance[ 8 ][ 0 ][ 10 ]   = -.467446;
    coeffPerformance[ 9 ][ 0 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 10 ]  =  0.00000;
    powerMin[ 0 ][ 10 ]                = 0.410653;
    powerMax[ 0 ][ 10 ]                = 0.883952;
    coeffPower[ 0 ][ 0 ][ 10 ]         = 0.640394;
    coeffPower[ 1 ][ 0 ][ 10 ]         =  4.21276;
    coeffPower[ 2 ][ 0 ][ 10 ]         =  1.11912;
    coeffPower[ 3 ][ 0 ][ 10 ]         = -.499032;
    coeffPower[ 4 ][ 0 ][ 10 ]         = -9.26393;
    coeffPower[ 5 ][ 0 ][ 10 ]         =  1.72753;
    coeffPower[ 6 ][ 0 ][ 10 ]         = -1.24213;
    coeffPower[ 7 ][ 0 ][ 10 ]         = -.377405;
    coeffPower[ 8 ][ 0 ][ 10 ]         = -.692529E-01;
    coeffPower[ 9 ][ 0 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 10 ]        =  0.00000;
    energyMin[ 1 ][ 10 ]               = 0.608107;
    energyMax[ 1 ][ 10 ]               =  1.35176;
    coeffEnergy[ 0 ][ 1 ][ 10 ]        =  1.09412;
    coeffEnergy[ 1 ][ 1 ][ 10 ]        =  7.60270;
    coeffEnergy[ 2 ][ 1 ][ 10 ]        = 0.942393;
    coeffEnergy[ 3 ][ 1 ][ 10 ]        = -.489789;
    coeffEnergy[ 4 ][ 1 ][ 10 ]        = -16.6780;
    coeffEnergy[ 5 ][ 1 ][ 10 ]        = -9.26626;
    coeffEnergy[ 6 ][ 1 ][ 10 ]        =  4.25912;
    coeffEnergy[ 7 ][ 1 ][ 10 ]        = -.524309;
    coeffEnergy[ 8 ][ 1 ][ 10 ]        = 0.772268;
    coeffEnergy[ 9 ][ 1 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 10 ]       =  0.00000;
    performanceMin[ 1 ][ 10 ]          = 0.464085;
    performanceMax[ 1 ][ 10 ]          =  1.08320;
    coeffPerformance[ 0 ][ 1 ][ 10 ]   = 0.631489;
    coeffPerformance[ 1 ][ 1 ][ 10 ]   = -2.60407;
    coeffPerformance[ 2 ][ 1 ][ 10 ]   = 0.141940;
    coeffPerformance[ 3 ][ 1 ][ 10 ]   = -.112632E-01;
    coeffPerformance[ 4 ][ 1 ][ 10 ]   =  5.68430;
    coeffPerformance[ 5 ][ 1 ][ 10 ]   =  8.81991;
    coeffPerformance[ 6 ][ 1 ][ 10 ]   = -4.17034;
    coeffPerformance[ 7 ][ 1 ][ 10 ]   = -.846551E-01;
    coeffPerformance[ 8 ][ 1 ][ 10 ]   = -.677061;
    coeffPerformance[ 9 ][ 1 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 10 ]  =  0.00000;
    powerMin[ 1 ][ 10 ]                = 0.445124;
    powerMax[ 1 ][ 10 ]                = 0.944109;
    coeffPower[ 0 ][ 1 ][ 10 ]         = 0.691636;
    coeffPower[ 1 ][ 1 ][ 10 ]         =  1.81392;
    coeffPower[ 2 ][ 1 ][ 10 ]         = 0.473141;
    coeffPower[ 3 ][ 1 ][ 10 ]         = -.208550;
    coeffPower[ 4 ][ 1 ][ 10 ]         = -4.00656;
    coeffPower[ 5 ][ 1 ][ 10 ]         =  1.55079;
    coeffPower[ 6 ][ 1 ][ 10 ]         = -.952735;
    coeffPower[ 7 ][ 1 ][ 10 ]         = -.438114;
    coeffPower[ 8 ][ 1 ][ 10 ]         = -.166016E-01;
    coeffPower[ 9 ][ 1 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 10 ]        =  0.00000;
    energyMin[ 2 ][ 10 ]               = 0.614023;
    energyMax[ 2 ][ 10 ]               =  1.31285;
    coeffEnergy[ 0 ][ 2 ][ 10 ]        =  1.05575;
    coeffEnergy[ 1 ][ 2 ][ 10 ]        =  7.58122;
    coeffEnergy[ 2 ][ 2 ][ 10 ]        = 0.539919;
    coeffEnergy[ 3 ][ 2 ][ 10 ]        = -.296001;
    coeffEnergy[ 4 ][ 2 ][ 10 ]        = -16.6285;
    coeffEnergy[ 5 ][ 2 ][ 10 ]        = -7.55629;
    coeffEnergy[ 6 ][ 2 ][ 10 ]        =  3.68460;
    coeffEnergy[ 7 ][ 2 ][ 10 ]        = -.411453;
    coeffEnergy[ 8 ][ 2 ][ 10 ]        = 0.583991;
    coeffEnergy[ 9 ][ 2 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 10 ]       =  0.00000;
    performanceMin[ 2 ][ 10 ]          = 0.501700;
    performanceMax[ 2 ][ 10 ]          =  1.10799;
    coeffPerformance[ 0 ][ 2 ][ 10 ]   = 0.684524;
    coeffPerformance[ 1 ][ 2 ][ 10 ]   = -3.61419;
    coeffPerformance[ 2 ][ 2 ][ 10 ]   = -.134492;
    coeffPerformance[ 3 ][ 2 ][ 10 ]   = 0.109860;
    coeffPerformance[ 4 ][ 2 ][ 10 ]   =  7.89993;
    coeffPerformance[ 5 ][ 2 ][ 10 ]   =  8.09846;
    coeffPerformance[ 6 ][ 2 ][ 10 ]   = -3.86179;
    coeffPerformance[ 7 ][ 2 ][ 10 ]   = -.140640;
    coeffPerformance[ 8 ][ 2 ][ 10 ]   = -.542089;
    coeffPerformance[ 9 ][ 2 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 10 ]  =  0.00000;
    powerMin[ 2 ][ 10 ]                = 0.468409;
    powerMax[ 2 ][ 10 ]                = 0.970279;
    coeffPower[ 0 ][ 2 ][ 10 ]         = 0.719720;
    coeffPower[ 1 ][ 2 ][ 10 ]         =  1.49903;
    coeffPower[ 2 ][ 2 ][ 10 ]         = -.328533E-01;
    coeffPower[ 3 ][ 2 ][ 10 ]         = 0.230537E-01;
    coeffPower[ 4 ][ 2 ][ 10 ]         = -3.31343;
    coeffPower[ 5 ][ 2 ][ 10 ]         =  1.84724;
    coeffPower[ 6 ][ 2 ][ 10 ]         = -.915464;
    coeffPower[ 7 ][ 2 ][ 10 ]         = -.421330;
    coeffPower[ 8 ][ 2 ][ 10 ]         = -.221932E-01;
    coeffPower[ 9 ][ 2 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 10 ]        =  0.00000;
    energyMin[ 3 ][ 10 ]               = 0.617052;
    energyMax[ 3 ][ 10 ]               =  1.31871;
    coeffEnergy[ 0 ][ 3 ][ 10 ]        =  1.01104;
    coeffEnergy[ 1 ][ 3 ][ 10 ]        =  8.58867;
    coeffEnergy[ 2 ][ 3 ][ 10 ]        =  1.04776;
    coeffEnergy[ 3 ][ 3 ][ 10 ]        = -.513240;
    coeffEnergy[ 4 ][ 3 ][ 10 ]        = -18.8310;
    coeffEnergy[ 5 ][ 3 ][ 10 ]        = -6.13441;
    coeffEnergy[ 6 ][ 3 ][ 10 ]        =  3.24000;
    coeffEnergy[ 7 ][ 3 ][ 10 ]        = -.717186E-01;
    coeffEnergy[ 8 ][ 3 ][ 10 ]        = 0.560686E-02;
    coeffEnergy[ 9 ][ 3 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 10 ]       =  0.00000;
    performanceMin[ 3 ][ 10 ]          = 0.513840;
    performanceMax[ 3 ][ 10 ]          =  1.13670;
    coeffPerformance[ 0 ][ 3 ][ 10 ]   = 0.741605;
    coeffPerformance[ 1 ][ 3 ][ 10 ]   = -4.60401;
    coeffPerformance[ 2 ][ 3 ][ 10 ]   = -.686900;
    coeffPerformance[ 3 ][ 3 ][ 10 ]   = 0.353604;
    coeffPerformance[ 4 ][ 3 ][ 10 ]   =  10.0682;
    coeffPerformance[ 5 ][ 3 ][ 10 ]   =  7.14783;
    coeffPerformance[ 6 ][ 3 ][ 10 ]   = -3.55445;
    coeffPerformance[ 7 ][ 3 ][ 10 ]   = -.309151;
    coeffPerformance[ 8 ][ 3 ][ 10 ]   = -.162405;
    coeffPerformance[ 9 ][ 3 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 10 ]  =  0.00000;
    powerMin[ 3 ][ 10 ]                = 0.495056;
    powerMax[ 3 ][ 10 ]                = 0.991517;
    coeffPower[ 0 ][ 3 ][ 10 ]         = 0.743563;
    coeffPower[ 1 ][ 3 ][ 10 ]         =  1.95858;
    coeffPower[ 2 ][ 3 ][ 10 ]         = -.166627E-01;
    coeffPower[ 3 ][ 3 ][ 10 ]         = 0.178505E-01;
    coeffPower[ 4 ][ 3 ][ 10 ]         = -4.31848;
    coeffPower[ 5 ][ 3 ][ 10 ]         =  1.79556;
    coeffPower[ 6 ][ 3 ][ 10 ]         = -.791308;
    coeffPower[ 7 ][ 3 ][ 10 ]         = -.302295;
    coeffPower[ 8 ][ 3 ][ 10 ]         = -.163022;
    coeffPower[ 9 ][ 3 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 10 ]        =  0.00000;
    energyMin[ 4 ][ 10 ]               = 0.625657;
    energyMax[ 4 ][ 10 ]               =  1.25526;
    coeffEnergy[ 0 ][ 4 ][ 10 ]        = 0.992008;
    coeffEnergy[ 1 ][ 4 ][ 10 ]        =  7.30285;
    coeffEnergy[ 2 ][ 4 ][ 10 ]        = 0.938336;
    coeffEnergy[ 3 ][ 4 ][ 10 ]        = -.457415;
    coeffEnergy[ 4 ][ 4 ][ 10 ]        = -16.0106;
    coeffEnergy[ 5 ][ 4 ][ 10 ]        = -4.76751;
    coeffEnergy[ 6 ][ 4 ][ 10 ]        =  2.47509;
    coeffEnergy[ 7 ][ 4 ][ 10 ]        = -.708273E-01;
    coeffEnergy[ 8 ][ 4 ][ 10 ]        = 0.653879E-01;
    coeffEnergy[ 9 ][ 4 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 10 ]       =  0.00000;
    performanceMin[ 4 ][ 10 ]          = 0.568896;
    performanceMax[ 4 ][ 10 ]          =  1.15334;
    coeffPerformance[ 0 ][ 4 ][ 10 ]   = 0.778034;
    coeffPerformance[ 1 ][ 4 ][ 10 ]   = -4.56372;
    coeffPerformance[ 2 ][ 4 ][ 10 ]   = -.551384;
    coeffPerformance[ 3 ][ 4 ][ 10 ]   = 0.290210;
    coeffPerformance[ 4 ][ 4 ][ 10 ]   =  9.98579;
    coeffPerformance[ 5 ][ 4 ][ 10 ]   =  6.42616;
    coeffPerformance[ 6 ][ 4 ][ 10 ]   = -3.13496;
    coeffPerformance[ 7 ][ 4 ][ 10 ]   = -.162769;
    coeffPerformance[ 8 ][ 4 ][ 10 ]   = -.355364;
    coeffPerformance[ 9 ][ 4 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 10 ]  =  0.00000;
    powerMin[ 4 ][ 10 ]                = 0.526671;
    powerMax[ 4 ][ 10 ]                =  1.02047;
    coeffPower[ 0 ][ 4 ][ 10 ]         = 0.765917;
    coeffPower[ 1 ][ 4 ][ 10 ]         =  1.53016;
    coeffPower[ 2 ][ 4 ][ 10 ]         = 0.139611;
    coeffPower[ 3 ][ 4 ][ 10 ]         = -.514428E-01;
    coeffPower[ 4 ][ 4 ][ 10 ]         = -3.37239;
    coeffPower[ 5 ][ 4 ][ 10 ]         =  2.12382;
    coeffPower[ 6 ][ 4 ][ 10 ]         = -.964522;
    coeffPower[ 7 ][ 4 ][ 10 ]         = -.187154;
    coeffPower[ 8 ][ 4 ][ 10 ]         = -.265412;
    coeffPower[ 9 ][ 4 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 10 ]        =  0.00000;
    energyMin[ 5 ][ 10 ]               = 0.662700;
    energyMax[ 5 ][ 10 ]               =  1.23857;
    coeffEnergy[ 0 ][ 5 ][ 10 ]        = 0.979695;
    coeffEnergy[ 1 ][ 5 ][ 10 ]        =  5.36082;
    coeffEnergy[ 2 ][ 5 ][ 10 ]        = 0.747819;
    coeffEnergy[ 3 ][ 5 ][ 10 ]        = -.362207;
    coeffEnergy[ 4 ][ 5 ][ 10 ]        = -11.7495;
    coeffEnergy[ 5 ][ 5 ][ 10 ]        = -3.93093;
    coeffEnergy[ 6 ][ 5 ][ 10 ]        =  2.10941;
    coeffEnergy[ 7 ][ 5 ][ 10 ]        = 0.414416E-01;
    coeffEnergy[ 8 ][ 5 ][ 10 ]        = -.166628;
    coeffEnergy[ 9 ][ 5 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 10 ]       =  0.00000;
    performanceMin[ 5 ][ 10 ]          = 0.603728;
    performanceMax[ 5 ][ 10 ]          =  1.16444;
    coeffPerformance[ 0 ][ 5 ][ 10 ]   = 0.826833;
    coeffPerformance[ 1 ][ 5 ][ 10 ]   = -4.59604;
    coeffPerformance[ 2 ][ 5 ][ 10 ]   = -.856070;
    coeffPerformance[ 3 ][ 5 ][ 10 ]   = 0.420851;
    coeffPerformance[ 4 ][ 5 ][ 10 ]   =  10.0573;
    coeffPerformance[ 5 ][ 5 ][ 10 ]   =  5.39787;
    coeffPerformance[ 6 ][ 5 ][ 10 ]   = -2.80509;
    coeffPerformance[ 7 ][ 5 ][ 10 ]   = -.277270;
    coeffPerformance[ 8 ][ 5 ][ 10 ]   = -.452651E-01;
    coeffPerformance[ 9 ][ 5 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 10 ]  =  0.00000;
    powerMin[ 5 ][ 10 ]                = 0.569580;
    powerMax[ 5 ][ 10 ]                =  1.04580;
    coeffPower[ 0 ][ 5 ][ 10 ]         = 0.804163;
    coeffPower[ 1 ][ 5 ][ 10 ]         = 0.141155;
    coeffPower[ 2 ][ 5 ][ 10 ]         = -.220504;
    coeffPower[ 3 ][ 5 ][ 10 ]         = 0.111665;
    coeffPower[ 4 ][ 5 ][ 10 ]         = -.323619;
    coeffPower[ 5 ][ 5 ][ 10 ]         =  1.73625;
    coeffPower[ 6 ][ 5 ][ 10 ]         = -.861708;
    coeffPower[ 7 ][ 5 ][ 10 ]         = -.187850;
    coeffPower[ 8 ][ 5 ][ 10 ]         = -.213858;
    coeffPower[ 9 ][ 5 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 10 ]        =  0.00000;
    energyMin[ 6 ][ 10 ]               = 0.651205;
    energyMax[ 6 ][ 10 ]               =  1.23643;
    coeffEnergy[ 0 ][ 6 ][ 10 ]        = 0.977241;
    coeffEnergy[ 1 ][ 6 ][ 10 ]        =  3.98022;
    coeffEnergy[ 2 ][ 6 ][ 10 ]        = 0.586963;
    coeffEnergy[ 3 ][ 6 ][ 10 ]        = -.280458;
    coeffEnergy[ 4 ][ 6 ][ 10 ]        = -8.72302;
    coeffEnergy[ 5 ][ 6 ][ 10 ]        = -3.45462;
    coeffEnergy[ 6 ][ 6 ][ 10 ]        =  2.01313;
    coeffEnergy[ 7 ][ 6 ][ 10 ]        = 0.215121;
    coeffEnergy[ 8 ][ 6 ][ 10 ]        = -.540271;
    coeffEnergy[ 9 ][ 6 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 10 ]       =  0.00000;
    performanceMin[ 6 ][ 10 ]          = 0.617507;
    performanceMax[ 6 ][ 10 ]          =  1.22998;
    coeffPerformance[ 0 ][ 6 ][ 10 ]   = 0.869870;
    coeffPerformance[ 1 ][ 6 ][ 10 ]   = -4.25875;
    coeffPerformance[ 2 ][ 6 ][ 10 ]   = -.889073;
    coeffPerformance[ 3 ][ 6 ][ 10 ]   = 0.425843;
    coeffPerformance[ 4 ][ 6 ][ 10 ]   =  9.32076;
    coeffPerformance[ 5 ][ 6 ][ 10 ]   =  4.46921;
    coeffPerformance[ 6 ][ 6 ][ 10 ]   = -2.50240;
    coeffPerformance[ 7 ][ 6 ][ 10 ]   = -.435522;
    coeffPerformance[ 8 ][ 6 ][ 10 ]   = 0.376299;
    coeffPerformance[ 9 ][ 6 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 10 ]  =  0.00000;
    powerMin[ 6 ][ 10 ]                = 0.618496;
    powerMax[ 6 ][ 10 ]                =  1.07357;
    coeffPower[ 0 ][ 6 ][ 10 ]         = 0.845057;
    coeffPower[ 1 ][ 6 ][ 10 ]         = -.631454;
    coeffPower[ 2 ][ 6 ][ 10 ]         = -.355780;
    coeffPower[ 3 ][ 6 ][ 10 ]         = 0.171164;
    coeffPower[ 4 ][ 6 ][ 10 ]         =  1.37288;
    coeffPower[ 5 ][ 6 ][ 10 ]         =  1.19020;
    coeffPower[ 6 ][ 6 ][ 10 ]         = -.587759;
    coeffPower[ 7 ][ 6 ][ 10 ]         = -.185879;
    coeffPower[ 8 ][ 6 ][ 10 ]         = -.180760;
    coeffPower[ 9 ][ 6 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 10 ]        =  0.00000;
    energyMin[ 7 ][ 10 ]               = 0.696364;
    energyMax[ 7 ][ 10 ]               =  1.21190;
    coeffEnergy[ 0 ][ 7 ][ 10 ]        = 0.980652;
    coeffEnergy[ 1 ][ 7 ][ 10 ]        =  2.45835;
    coeffEnergy[ 2 ][ 7 ][ 10 ]        = 0.282752;
    coeffEnergy[ 3 ][ 7 ][ 10 ]        = -.139711;
    coeffEnergy[ 4 ][ 7 ][ 10 ]        = -5.38591;
    coeffEnergy[ 5 ][ 7 ][ 10 ]        = -2.42052;
    coeffEnergy[ 6 ][ 7 ][ 10 ]        =  1.28067;
    coeffEnergy[ 7 ][ 7 ][ 10 ]        = 0.290633E-01;
    coeffEnergy[ 8 ][ 7 ][ 10 ]        = -.174966;
    coeffEnergy[ 9 ][ 7 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 10 ]       =  0.00000;
    performanceMin[ 7 ][ 10 ]          = 0.684685;
    performanceMax[ 7 ][ 10 ]          =  1.18369;
    coeffPerformance[ 0 ][ 7 ][ 10 ]   = 0.901434;
    coeffPerformance[ 1 ][ 7 ][ 10 ]   = -3.02468;
    coeffPerformance[ 2 ][ 7 ][ 10 ]   = -.524841;
    coeffPerformance[ 3 ][ 7 ][ 10 ]   = 0.257270;
    coeffPerformance[ 4 ][ 7 ][ 10 ]   =  6.61861;
    coeffPerformance[ 5 ][ 7 ][ 10 ]   =  3.21015;
    coeffPerformance[ 6 ][ 7 ][ 10 ]   = -1.61302;
    coeffPerformance[ 7 ][ 7 ][ 10 ]   = -.142244;
    coeffPerformance[ 8 ][ 7 ][ 10 ]   = -.536571E-01;
    coeffPerformance[ 9 ][ 7 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 10 ]  =  0.00000;
    powerMin[ 7 ][ 10 ]                = 0.660268;
    powerMax[ 7 ][ 10 ]                =  1.10435;
    coeffPower[ 0 ][ 7 ][ 10 ]         = 0.881923;
    coeffPower[ 1 ][ 7 ][ 10 ]         = -.686441;
    coeffPower[ 2 ][ 7 ][ 10 ]         = -.266110;
    coeffPower[ 3 ][ 7 ][ 10 ]         = 0.128996;
    coeffPower[ 4 ][ 7 ][ 10 ]         =  1.49639;
    coeffPower[ 5 ][ 7 ][ 10 ]         = 0.870850;
    coeffPower[ 6 ][ 7 ][ 10 ]         = -.387725;
    coeffPower[ 7 ][ 7 ][ 10 ]         = -.963528E-01;
    coeffPower[ 8 ][ 7 ][ 10 ]         = -.227812;
    coeffPower[ 9 ][ 7 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 10 ]        =  0.00000;
    energyMin[ 8 ][ 10 ]               = 0.724000;
    energyMax[ 8 ][ 10 ]               =  1.33822;
    coeffEnergy[ 0 ][ 8 ][ 10 ]        = 0.980406;
    coeffEnergy[ 1 ][ 8 ][ 10 ]        =  1.87187;
    coeffEnergy[ 2 ][ 8 ][ 10 ]        = 0.200370;
    coeffEnergy[ 3 ][ 8 ][ 10 ]        = -.970392E-01;
    coeffEnergy[ 4 ][ 8 ][ 10 ]        = -4.09871;
    coeffEnergy[ 5 ][ 8 ][ 10 ]        = -1.46561;
    coeffEnergy[ 6 ][ 8 ][ 10 ]        = 0.792747;
    coeffEnergy[ 7 ][ 8 ][ 10 ]        = 0.176990E-01;
    coeffEnergy[ 8 ][ 8 ][ 10 ]        = -.141419;
    coeffEnergy[ 9 ][ 8 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 10 ]       =  0.00000;
    performanceMin[ 8 ][ 10 ]          = 0.648304;
    performanceMax[ 8 ][ 10 ]          =  1.19250;
    coeffPerformance[ 0 ][ 8 ][ 10 ]   = 0.940613;
    coeffPerformance[ 1 ][ 8 ][ 10 ]   = -2.38472;
    coeffPerformance[ 2 ][ 8 ][ 10 ]   = -.366519;
    coeffPerformance[ 3 ][ 8 ][ 10 ]   = 0.177158;
    coeffPerformance[ 4 ][ 8 ][ 10 ]   =  5.21698;
    coeffPerformance[ 5 ][ 8 ][ 10 ]   =  1.89985;
    coeffPerformance[ 6 ][ 8 ][ 10 ]   = -.943424;
    coeffPerformance[ 7 ][ 8 ][ 10 ]   = -.945257E-01;
    coeffPerformance[ 8 ][ 8 ][ 10 ]   = 0.458637E-02;
    coeffPerformance[ 9 ][ 8 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 10 ]  =  0.00000;
    powerMin[ 8 ][ 10 ]                = 0.698431;
    powerMax[ 8 ][ 10 ]                =  1.13417;
    coeffPower[ 0 ][ 8 ][ 10 ]         = 0.922466;
    coeffPower[ 1 ][ 8 ][ 10 ]         = -.639008;
    coeffPower[ 2 ][ 8 ][ 10 ]         = -.200683;
    coeffPower[ 3 ][ 8 ][ 10 ]         = 0.957980E-01;
    coeffPower[ 4 ][ 8 ][ 10 ]         =  1.39432;
    coeffPower[ 5 ][ 8 ][ 10 ]         = 0.409302;
    coeffPower[ 6 ][ 8 ][ 10 ]         = -.140181;
    coeffPower[ 7 ][ 8 ][ 10 ]         = -.702052E-01;
    coeffPower[ 8 ][ 8 ][ 10 ]         = -.138607;
    coeffPower[ 9 ][ 8 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 10 ]        =  0.00000;
    energyMin[ 9 ][ 10 ]               = 0.745341;
    energyMax[ 9 ][ 10 ]               =  1.21310;
    coeffEnergy[ 0 ][ 9 ][ 10 ]        = 0.989199;
    coeffEnergy[ 1 ][ 9 ][ 10 ]        = 0.717421;
    coeffEnergy[ 2 ][ 9 ][ 10 ]        = 0.499132E-01;
    coeffEnergy[ 3 ][ 9 ][ 10 ]        = -.251649E-01;
    coeffEnergy[ 4 ][ 9 ][ 10 ]        = -1.57113;
    coeffEnergy[ 5 ][ 9 ][ 10 ]        = -.721395;
    coeffEnergy[ 6 ][ 9 ][ 10 ]        = 0.396709;
    coeffEnergy[ 7 ][ 9 ][ 10 ]        = 0.259068E-01;
    coeffEnergy[ 8 ][ 9 ][ 10 ]        = -.922160E-01;
    coeffEnergy[ 9 ][ 9 ][ 10 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 10 ]       =  0.00000;
    performanceMin[ 9 ][ 10 ]          = 0.746419;
    performanceMax[ 9 ][ 10 ]          =  1.21558;
    coeffPerformance[ 0 ][ 9 ][ 10 ]   = 0.965178;
    coeffPerformance[ 1 ][ 9 ][ 10 ]   = -1.01463;
    coeffPerformance[ 2 ][ 9 ][ 10 ]   = -.131395;
    coeffPerformance[ 3 ][ 9 ][ 10 ]   = 0.658298E-01;
    coeffPerformance[ 4 ][ 9 ][ 10 ]   =  2.22139;
    coeffPerformance[ 5 ][ 9 ][ 10 ]   =  1.15187;
    coeffPerformance[ 6 ][ 9 ][ 10 ]   = -.608497;
    coeffPerformance[ 7 ][ 9 ][ 10 ]   = -.527170E-01;
    coeffPerformance[ 8 ][ 9 ][ 10 ]   = 0.135762E-01;
    coeffPerformance[ 9 ][ 9 ][ 10 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 10 ]  =  0.00000;
    powerMin[ 9 ][ 10 ]                = 0.745506;
    powerMax[ 9 ][ 10 ]                =  1.16753;
    coeffPower[ 0 ][ 9 ][ 10 ]         = 0.954457;
    coeffPower[ 1 ][ 9 ][ 10 ]         = -.314011;
    coeffPower[ 2 ][ 9 ][ 10 ]         = -.848018E-01;
    coeffPower[ 3 ][ 9 ][ 10 ]         = 0.422216E-01;
    coeffPower[ 4 ][ 9 ][ 10 ]         = 0.687146;
    coeffPower[ 5 ][ 9 ][ 10 ]         = 0.433236;
    coeffPower[ 6 ][ 9 ][ 10 ]         = -.212681;
    coeffPower[ 7 ][ 9 ][ 10 ]         = -.249934E-01;
    coeffPower[ 8 ][ 9 ][ 10 ]         = -.804603E-01;
    coeffPower[ 9 ][ 9 ][ 10 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 10 ]        =  0.00000;
    energyMin[ 10 ][ 10 ]              = 0.800000;
    energyMax[ 10 ][ 10 ]              =  1.20000;
    coeffEnergy[ 0 ][ 10 ][ 10 ]       =  1.00000;
    coeffEnergy[ 1 ][ 10 ][ 10 ]       = 0.313049E-12;
    coeffEnergy[ 2 ][ 10 ][ 10 ]       = 0.854132E-13;
    coeffEnergy[ 3 ][ 10 ][ 10 ]       = -.422999E-13;
    coeffEnergy[ 4 ][ 10 ][ 10 ]       = -.690121E-12;
    coeffEnergy[ 5 ][ 10 ][ 10 ]       = -.267747E-12;
    coeffEnergy[ 6 ][ 10 ][ 10 ]       = 0.213269E-12;
    coeffEnergy[ 7 ][ 10 ][ 10 ]       = -.250183E-13;
    coeffEnergy[ 8 ][ 10 ][ 10 ]       = 0.114389E-12;
    coeffEnergy[ 9 ][ 10 ][ 10 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 10 ]      =  0.00000;
    performanceMin[ 10 ][ 10 ]         = 0.800000;
    performanceMax[ 10 ][ 10 ]         =  1.20000;
    coeffPerformance[ 0 ][ 10 ][ 10 ]  =  1.00000;
    coeffPerformance[ 1 ][ 10 ][ 10 ]  = 0.293736E-11;
    coeffPerformance[ 2 ][ 10 ][ 10 ]  = -.131555E-12;
    coeffPerformance[ 3 ][ 10 ][ 10 ]  = 0.534609E-13;
    coeffPerformance[ 4 ][ 10 ][ 10 ]  = -.646454E-11;
    coeffPerformance[ 5 ][ 10 ][ 10 ]  = 0.155004E-13;
    coeffPerformance[ 6 ][ 10 ][ 10 ]  = -.463641E-12;
    coeffPerformance[ 7 ][ 10 ][ 10 ]  = -.368638E-12;
    coeffPerformance[ 8 ][ 10 ][ 10 ]  = 0.459652E-12;
    coeffPerformance[ 9 ][ 10 ][ 10 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 10 ] =  0.00000;
    powerMin[ 10 ][ 10 ]               = 0.800000;
    powerMax[ 10 ][ 10 ]               =  1.20000;
    coeffPower[ 0 ][ 10 ][ 10 ]        =  1.00000;
    coeffPower[ 1 ][ 10 ][ 10 ]        = 0.601579E-15;
    coeffPower[ 2 ][ 10 ][ 10 ]        = 0.212036E-12;
    coeffPower[ 3 ][ 10 ][ 10 ]        = -.971925E-13;
    coeffPower[ 4 ][ 10 ][ 10 ]        = -.475403E-15;
    coeffPower[ 5 ][ 10 ][ 10 ]        = 0.559196E-13;
    coeffPower[ 6 ][ 10 ][ 10 ]        = -.165555E-13;
    coeffPower[ 7 ][ 10 ][ 10 ]        = 0.872278E-14;
    coeffPower[ 8 ][ 10 ][ 10 ]        = -.136743E-13;
    coeffPower[ 9 ][ 10 ][ 10 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 10 ]       =  0.00000;
    energyMin[ 11 ][ 10 ]              = 0.766500;
    energyMax[ 11 ][ 10 ]              =  1.28103;
    coeffEnergy[ 0 ][ 11 ][ 10 ]       =  1.01038;
    coeffEnergy[ 1 ][ 11 ][ 10 ]       = -1.08986;
    coeffEnergy[ 2 ][ 11 ][ 10 ]       = -.340193;
    coeffEnergy[ 3 ][ 11 ][ 10 ]       = 0.160507;
    coeffEnergy[ 4 ][ 11 ][ 10 ]       =  2.38915;
    coeffEnergy[ 5 ][ 11 ][ 10 ]       = 0.965000;
    coeffEnergy[ 6 ][ 11 ][ 10 ]       = -.551216;
    coeffEnergy[ 7 ][ 11 ][ 10 ]       = -.787648E-01;
    coeffEnergy[ 8 ][ 11 ][ 10 ]       = 0.765214E-01;
    coeffEnergy[ 9 ][ 11 ][ 10 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 10 ]      =  0.00000;
    performanceMin[ 11 ][ 10 ]         = 0.783462;
    performanceMax[ 11 ][ 10 ]         =  1.31386;
    coeffPerformance[ 0 ][ 11 ][ 10 ]  =  1.03531;
    coeffPerformance[ 1 ][ 11 ][ 10 ]  =  1.46024;
    coeffPerformance[ 2 ][ 11 ][ 10 ]  = 0.430349;
    coeffPerformance[ 3 ][ 11 ][ 10 ]  = -.204456;
    coeffPerformance[ 4 ][ 11 ][ 10 ]  = -3.19882;
    coeffPerformance[ 5 ][ 11 ][ 10 ]  = -1.33616;
    coeffPerformance[ 6 ][ 11 ][ 10 ]  = 0.738515;
    coeffPerformance[ 7 ][ 11 ][ 10 ]  = 0.100749;
    coeffPerformance[ 8 ][ 11 ][ 10 ]  = 0.113832E-02;
    coeffPerformance[ 9 ][ 11 ][ 10 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 10 ] =  0.00000;
    powerMin[ 11 ][ 10 ]               = 0.825702;
    powerMax[ 11 ][ 10 ]               =  1.28678;
    coeffPower[ 0 ][ 11 ][ 10 ]        =  1.04512;
    coeffPower[ 1 ][ 11 ][ 10 ]        = 0.354142;
    coeffPower[ 2 ][ 11 ][ 10 ]        = 0.972388E-01;
    coeffPower[ 3 ][ 11 ][ 10 ]        = -.469439E-01;
    coeffPower[ 4 ][ 11 ][ 10 ]        = -.773734;
    coeffPower[ 5 ][ 11 ][ 10 ]        = -.365170;
    coeffPower[ 6 ][ 11 ][ 10 ]        = 0.193652;
    coeffPower[ 7 ][ 11 ][ 10 ]        = 0.322415E-01;
    coeffPower[ 8 ][ 11 ][ 10 ]        = 0.603734E-01;
    coeffPower[ 9 ][ 11 ][ 10 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 10 ]       =  0.00000;
    energyMin[ 12 ][ 10 ]              = 0.770930;
    energyMax[ 12 ][ 10 ]              =  1.32335;
    coeffEnergy[ 0 ][ 12 ][ 10 ]       =  1.02644;
    coeffEnergy[ 1 ][ 12 ][ 10 ]       = -2.25157;
    coeffEnergy[ 2 ][ 12 ][ 10 ]       = -.426418;
    coeffEnergy[ 3 ][ 12 ][ 10 ]       = 0.203966;
    coeffEnergy[ 4 ][ 12 ][ 10 ]       =  4.93364;
    coeffEnergy[ 5 ][ 12 ][ 10 ]       =  1.68527;
    coeffEnergy[ 6 ][ 12 ][ 10 ]       = -.865617;
    coeffEnergy[ 7 ][ 12 ][ 10 ]       = -.120534;
    coeffEnergy[ 8 ][ 12 ][ 10 ]       = 0.734724E-02;
    coeffEnergy[ 9 ][ 12 ][ 10 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 10 ]      =  0.00000;
    performanceMin[ 12 ][ 10 ]         = 0.793999;
    performanceMax[ 12 ][ 10 ]         =  1.37302;
    coeffPerformance[ 0 ][ 12 ][ 10 ]  =  1.07127;
    coeffPerformance[ 1 ][ 12 ][ 10 ]  =  2.91675;
    coeffPerformance[ 2 ][ 12 ][ 10 ]  = 0.582211;
    coeffPerformance[ 3 ][ 12 ][ 10 ]  = -.281874;
    coeffPerformance[ 4 ][ 12 ][ 10 ]  = -6.38953;
    coeffPerformance[ 5 ][ 12 ][ 10 ]  = -2.60159;
    coeffPerformance[ 6 ][ 12 ][ 10 ]  =  1.32006;
    coeffPerformance[ 7 ][ 12 ][ 10 ]  = 0.115577;
    coeffPerformance[ 8 ][ 12 ][ 10 ]  = 0.138267;
    coeffPerformance[ 9 ][ 12 ][ 10 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 10 ] =  0.00000;
    powerMin[ 12 ][ 10 ]               = 0.850783;
    powerMax[ 12 ][ 10 ]               =  1.34534;
    coeffPower[ 0 ][ 12 ][ 10 ]        =  1.09785;
    coeffPower[ 1 ][ 12 ][ 10 ]        = 0.649198;
    coeffPower[ 2 ][ 12 ][ 10 ]        = 0.161763;
    coeffPower[ 3 ][ 12 ][ 10 ]        = -.804870E-01;
    coeffPower[ 4 ][ 12 ][ 10 ]        = -1.42046;
    coeffPower[ 5 ][ 12 ][ 10 ]        = -.916129;
    coeffPower[ 6 ][ 12 ][ 10 ]        = 0.459968;
    coeffPower[ 7 ][ 12 ][ 10 ]        = 0.443856E-02;
    coeffPower[ 8 ][ 12 ][ 10 ]        = 0.134760;
    coeffPower[ 9 ][ 12 ][ 10 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 10 ]       =  0.00000;
    energyMin[ 13 ][ 10 ]              = 0.774693;
    energyMax[ 13 ][ 10 ]              =  1.37002;
    coeffEnergy[ 0 ][ 13 ][ 10 ]       =  1.03272;
    coeffEnergy[ 1 ][ 13 ][ 10 ]       = -2.66058;
    coeffEnergy[ 2 ][ 13 ][ 10 ]       = -.325516;
    coeffEnergy[ 3 ][ 13 ][ 10 ]       = 0.164078;
    coeffEnergy[ 4 ][ 13 ][ 10 ]       =  5.83149;
    coeffEnergy[ 5 ][ 13 ][ 10 ]       =  2.66089;
    coeffEnergy[ 6 ][ 13 ][ 10 ]       = -1.34143;
    coeffEnergy[ 7 ][ 13 ][ 10 ]       = -.278361E-01;
    coeffEnergy[ 8 ][ 13 ][ 10 ]       = -.765309E-01;
    coeffEnergy[ 9 ][ 13 ][ 10 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 10 ]      =  0.00000;
    performanceMin[ 13 ][ 10 ]         = 0.796788;
    performanceMax[ 13 ][ 10 ]         =  1.42884;
    coeffPerformance[ 0 ][ 13 ][ 10 ]  =  1.10750;
    coeffPerformance[ 1 ][ 13 ][ 10 ]  =  3.64438;
    coeffPerformance[ 2 ][ 13 ][ 10 ]  = 0.497413;
    coeffPerformance[ 3 ][ 13 ][ 10 ]  = -.250861;
    coeffPerformance[ 4 ][ 13 ][ 10 ]  = -7.98119;
    coeffPerformance[ 5 ][ 13 ][ 10 ]  = -3.95662;
    coeffPerformance[ 6 ][ 13 ][ 10 ]  =  1.93421;
    coeffPerformance[ 7 ][ 13 ][ 10 ]  = 0.725573E-01;
    coeffPerformance[ 8 ][ 13 ][ 10 ]  = 0.282526;
    coeffPerformance[ 9 ][ 13 ][ 10 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 10 ] =  0.00000;
    powerMin[ 13 ][ 10 ]               = 0.878980;
    powerMax[ 13 ][ 10 ]               =  1.42131;
    coeffPower[ 0 ][ 13 ][ 10 ]        =  1.14107;
    coeffPower[ 1 ][ 13 ][ 10 ]        = 0.959493;
    coeffPower[ 2 ][ 13 ][ 10 ]        = 0.158018;
    coeffPower[ 3 ][ 13 ][ 10 ]        = -.803672E-01;
    coeffPower[ 4 ][ 13 ][ 10 ]        = -2.09545;
    coeffPower[ 5 ][ 13 ][ 10 ]        = -1.29942;
    coeffPower[ 6 ][ 13 ][ 10 ]        = 0.582072;
    coeffPower[ 7 ][ 13 ][ 10 ]        = 0.582175E-01;
    coeffPower[ 8 ][ 13 ][ 10 ]        = 0.211798;
    coeffPower[ 9 ][ 13 ][ 10 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 10 ]       =  0.00000;
    energyMin[ 14 ][ 10 ]              = 0.783172;
    energyMax[ 14 ][ 10 ]              =  1.41400;
    coeffEnergy[ 0 ][ 14 ][ 10 ]       =  1.04311;
    coeffEnergy[ 1 ][ 14 ][ 10 ]       = -4.13104;
    coeffEnergy[ 2 ][ 14 ][ 10 ]       = -.471927;
    coeffEnergy[ 3 ][ 14 ][ 10 ]       = 0.237544;
    coeffEnergy[ 4 ][ 14 ][ 10 ]       =  9.05933;
    coeffEnergy[ 5 ][ 14 ][ 10 ]       =  3.58475;
    coeffEnergy[ 6 ][ 14 ][ 10 ]       = -1.82274;
    coeffEnergy[ 7 ][ 14 ][ 10 ]       = -.393560E-01;
    coeffEnergy[ 8 ][ 14 ][ 10 ]       = -.141917;
    coeffEnergy[ 9 ][ 14 ][ 10 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 10 ]      =  0.00000;
    performanceMin[ 14 ][ 10 ]         = 0.798572;
    performanceMax[ 14 ][ 10 ]         =  1.48800;
    coeffPerformance[ 0 ][ 14 ][ 10 ]  =  1.14870;
    coeffPerformance[ 1 ][ 14 ][ 10 ]  =  5.74003;
    coeffPerformance[ 2 ][ 14 ][ 10 ]  = 0.791391;
    coeffPerformance[ 3 ][ 14 ][ 10 ]  = -.393462;
    coeffPerformance[ 4 ][ 14 ][ 10 ]  = -12.5782;
    coeffPerformance[ 5 ][ 14 ][ 10 ]  = -5.24917;
    coeffPerformance[ 6 ][ 14 ][ 10 ]  =  2.57796;
    coeffPerformance[ 7 ][ 14 ][ 10 ]  = 0.125406;
    coeffPerformance[ 8 ][ 14 ][ 10 ]  = 0.332290;
    coeffPerformance[ 9 ][ 14 ][ 10 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 10 ] =  0.00000;
    powerMin[ 14 ][ 10 ]               = 0.906477;
    powerMax[ 14 ][ 10 ]               =  1.49192;
    coeffPower[ 0 ][ 14 ][ 10 ]        =  1.19451;
    coeffPower[ 1 ][ 14 ][ 10 ]        =  1.56281;
    coeffPower[ 2 ][ 14 ][ 10 ]        = 0.283860;
    coeffPower[ 3 ][ 14 ][ 10 ]        = -.139800;
    coeffPower[ 4 ][ 14 ][ 10 ]        = -3.41582;
    coeffPower[ 5 ][ 14 ][ 10 ]        = -1.72053;
    coeffPower[ 6 ][ 14 ][ 10 ]        = 0.766279;
    coeffPower[ 7 ][ 14 ][ 10 ]        = 0.105797;
    coeffPower[ 8 ][ 14 ][ 10 ]        = 0.201539;
    coeffPower[ 9 ][ 14 ][ 10 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 10 ]       =  0.00000;
    energyMin[ 15 ][ 10 ]              = 0.791497;
    energyMax[ 15 ][ 10 ]              =  1.46531;
    coeffEnergy[ 0 ][ 15 ][ 10 ]       =  1.05727;
    coeffEnergy[ 1 ][ 15 ][ 10 ]       = -4.27242;
    coeffEnergy[ 2 ][ 15 ][ 10 ]       = -.453931;
    coeffEnergy[ 3 ][ 15 ][ 10 ]       = 0.237290;
    coeffEnergy[ 4 ][ 15 ][ 10 ]       =  9.36689;
    coeffEnergy[ 5 ][ 15 ][ 10 ]       =  4.65670;
    coeffEnergy[ 6 ][ 15 ][ 10 ]       = -2.30886;
    coeffEnergy[ 7 ][ 15 ][ 10 ]       = 0.392627E-01;
    coeffEnergy[ 8 ][ 15 ][ 10 ]       = -.359712;
    coeffEnergy[ 9 ][ 15 ][ 10 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 10 ]      =  0.00000;
    performanceMin[ 15 ][ 10 ]         = 0.802736;
    performanceMax[ 15 ][ 10 ]         =  1.54493;
    coeffPerformance[ 0 ][ 15 ][ 10 ]  =  1.18434;
    coeffPerformance[ 1 ][ 15 ][ 10 ]  =  5.91430;
    coeffPerformance[ 2 ][ 15 ][ 10 ]  = 0.762879;
    coeffPerformance[ 3 ][ 15 ][ 10 ]  = -.390771;
    coeffPerformance[ 4 ][ 15 ][ 10 ]  = -12.9526;
    coeffPerformance[ 5 ][ 15 ][ 10 ]  = -6.87058;
    coeffPerformance[ 6 ][ 15 ][ 10 ]  =  3.37682;
    coeffPerformance[ 7 ][ 15 ][ 10 ]  = 0.108311;
    coeffPerformance[ 8 ][ 15 ][ 10 ]  = 0.534875;
    coeffPerformance[ 9 ][ 15 ][ 10 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 10 ] =  0.00000;
    powerMin[ 15 ][ 10 ]               = 0.936064;
    powerMax[ 15 ][ 10 ]               =  1.62010;
    coeffPower[ 0 ][ 15 ][ 10 ]        =  1.24480;
    coeffPower[ 1 ][ 15 ][ 10 ]        =  1.75791;
    coeffPower[ 2 ][ 15 ][ 10 ]        = 0.318260;
    coeffPower[ 3 ][ 15 ][ 10 ]        = -.157329;
    coeffPower[ 4 ][ 15 ][ 10 ]        = -3.83707;
    coeffPower[ 5 ][ 15 ][ 10 ]        = -2.26446;
    coeffPower[ 6 ][ 15 ][ 10 ]        =  1.08993;
    coeffPower[ 7 ][ 15 ][ 10 ]        = 0.205514;
    coeffPower[ 8 ][ 15 ][ 10 ]        = 0.136338;
    coeffPower[ 9 ][ 15 ][ 10 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 10 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 2.30;
    energyMin[ 0 ][ 11 ]               = 0.557628;
    energyMax[ 0 ][ 11 ]               =  1.41599;
    coeffEnergy[ 0 ][ 0 ][ 11 ]        =  1.08104;
    coeffEnergy[ 1 ][ 0 ][ 11 ]        =  10.8368;
    coeffEnergy[ 2 ][ 0 ][ 11 ]        = 0.756834;
    coeffEnergy[ 3 ][ 0 ][ 11 ]        = -.390573;
    coeffEnergy[ 4 ][ 0 ][ 11 ]        = -24.8365;
    coeffEnergy[ 5 ][ 0 ][ 11 ]        = -11.3879;
    coeffEnergy[ 6 ][ 0 ][ 11 ]        =  5.36817;
    coeffEnergy[ 7 ][ 0 ][ 11 ]        = -.335842;
    coeffEnergy[ 8 ][ 0 ][ 11 ]        = 0.600537;
    coeffEnergy[ 9 ][ 0 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 11 ]       =  0.00000;
    performanceMin[ 0 ][ 11 ]          = 0.413519;
    performanceMax[ 0 ][ 11 ]          =  1.03459;
    coeffPerformance[ 0 ][ 0 ][ 11 ]   = 0.564895;
    coeffPerformance[ 1 ][ 0 ][ 11 ]   = -3.54110;
    coeffPerformance[ 2 ][ 0 ][ 11 ]   = -.513138E-01;
    coeffPerformance[ 3 ][ 0 ][ 11 ]   = 0.788113E-01;
    coeffPerformance[ 4 ][ 0 ][ 11 ]   =  8.09148;
    coeffPerformance[ 5 ][ 0 ][ 11 ]   =  9.78184;
    coeffPerformance[ 6 ][ 0 ][ 11 ]   = -4.97295;
    coeffPerformance[ 7 ][ 0 ][ 11 ]   = -.244839;
    coeffPerformance[ 8 ][ 0 ][ 11 ]   = -.473587;
    coeffPerformance[ 9 ][ 0 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 11 ]  =  0.00000;
    powerMin[ 0 ][ 11 ]                = 0.388722;
    powerMax[ 0 ][ 11 ]                = 0.855017;
    coeffPower[ 0 ][ 0 ][ 11 ]         = 0.605248;
    coeffPower[ 1 ][ 0 ][ 11 ]         =  2.61124;
    coeffPower[ 2 ][ 0 ][ 11 ]         = 0.152516;
    coeffPower[ 3 ][ 0 ][ 11 ]         = -.525183E-01;
    coeffPower[ 4 ][ 0 ][ 11 ]         = -6.00645;
    coeffPower[ 5 ][ 0 ][ 11 ]         =  1.55395;
    coeffPower[ 6 ][ 0 ][ 11 ]         = -1.18270;
    coeffPower[ 7 ][ 0 ][ 11 ]         = -.363204;
    coeffPower[ 8 ][ 0 ][ 11 ]         = -.796602E-01;
    coeffPower[ 9 ][ 0 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 11 ]        =  0.00000;
    energyMin[ 1 ][ 11 ]               = 0.586095;
    energyMax[ 1 ][ 11 ]               =  1.34918;
    coeffEnergy[ 0 ][ 1 ][ 11 ]        =  1.08121;
    coeffEnergy[ 1 ][ 1 ][ 11 ]        =  8.66103;
    coeffEnergy[ 2 ][ 1 ][ 11 ]        = 0.597293;
    coeffEnergy[ 3 ][ 1 ][ 11 ]        = -.321246;
    coeffEnergy[ 4 ][ 1 ][ 11 ]        = -19.8596;
    coeffEnergy[ 5 ][ 1 ][ 11 ]        = -10.0236;
    coeffEnergy[ 6 ][ 1 ][ 11 ]        =  4.69914;
    coeffEnergy[ 7 ][ 1 ][ 11 ]        = -.449203;
    coeffEnergy[ 8 ][ 1 ][ 11 ]        = 0.770930;
    coeffEnergy[ 9 ][ 1 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 11 ]       =  0.00000;
    performanceMin[ 1 ][ 11 ]          = 0.447091;
    performanceMax[ 1 ][ 11 ]          =  1.07676;
    coeffPerformance[ 0 ][ 1 ][ 11 ]   = 0.610283;
    coeffPerformance[ 1 ][ 1 ][ 11 ]   = -4.03697;
    coeffPerformance[ 2 ][ 1 ][ 11 ]   = -.196346;
    coeffPerformance[ 3 ][ 1 ][ 11 ]   = 0.141638;
    coeffPerformance[ 4 ][ 1 ][ 11 ]   =  9.22852;
    coeffPerformance[ 5 ][ 1 ][ 11 ]   =  9.30498;
    coeffPerformance[ 6 ][ 1 ][ 11 ]   = -4.49383;
    coeffPerformance[ 7 ][ 1 ][ 11 ]   = -.141400;
    coeffPerformance[ 8 ][ 1 ][ 11 ]   = -.689551;
    coeffPerformance[ 9 ][ 1 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 11 ]  =  0.00000;
    powerMin[ 1 ][ 11 ]                = 0.422618;
    powerMax[ 1 ][ 11 ]                = 0.913205;
    coeffPower[ 0 ][ 1 ][ 11 ]         = 0.659097;
    coeffPower[ 1 ][ 1 ][ 11 ]         =  1.34191;
    coeffPower[ 2 ][ 1 ][ 11 ]         = 0.309319E-01;
    coeffPower[ 3 ][ 1 ][ 11 ]         = -.403563E-02;
    coeffPower[ 4 ][ 1 ][ 11 ]         = -3.10409;
    coeffPower[ 5 ][ 1 ][ 11 ]         =  1.57024;
    coeffPower[ 6 ][ 1 ][ 11 ]         = -.989214;
    coeffPower[ 7 ][ 1 ][ 11 ]         = -.400192;
    coeffPower[ 8 ][ 1 ][ 11 ]         = -.723757E-01;
    coeffPower[ 9 ][ 1 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 11 ]        =  0.00000;
    energyMin[ 2 ][ 11 ]               = 0.588112;
    energyMax[ 2 ][ 11 ]               =  1.31035;
    coeffEnergy[ 0 ][ 2 ][ 11 ]        =  1.04485;
    coeffEnergy[ 1 ][ 2 ][ 11 ]        =  8.35560;
    coeffEnergy[ 2 ][ 2 ][ 11 ]        =  1.07571;
    coeffEnergy[ 3 ][ 2 ][ 11 ]        = -.523318;
    coeffEnergy[ 4 ][ 2 ][ 11 ]        = -19.1562;
    coeffEnergy[ 5 ][ 2 ][ 11 ]        = -8.45263;
    coeffEnergy[ 6 ][ 2 ][ 11 ]        =  4.26559;
    coeffEnergy[ 7 ][ 2 ][ 11 ]        = -.342076;
    coeffEnergy[ 8 ][ 2 ][ 11 ]        = 0.599314;
    coeffEnergy[ 9 ][ 2 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 11 ]       =  0.00000;
    performanceMin[ 2 ][ 11 ]          = 0.480923;
    performanceMax[ 2 ][ 11 ]          =  1.10158;
    coeffPerformance[ 0 ][ 2 ][ 11 ]   = 0.662765;
    coeffPerformance[ 1 ][ 2 ][ 11 ]   = -4.95658;
    coeffPerformance[ 2 ][ 2 ][ 11 ]   = -.345862;
    coeffPerformance[ 3 ][ 2 ][ 11 ]   = 0.202112;
    coeffPerformance[ 4 ][ 2 ][ 11 ]   =  11.3362;
    coeffPerformance[ 5 ][ 2 ][ 11 ]   =  8.68641;
    coeffPerformance[ 6 ][ 2 ][ 11 ]   = -4.22722;
    coeffPerformance[ 7 ][ 2 ][ 11 ]   = -.197546;
    coeffPerformance[ 8 ][ 2 ][ 11 ]   = -.563770;
    coeffPerformance[ 9 ][ 2 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 11 ]  =  0.00000;
    powerMin[ 2 ][ 11 ]                = 0.444726;
    powerMax[ 2 ][ 11 ]                = 0.938518;
    coeffPower[ 0 ][ 2 ][ 11 ]         = 0.687699;
    coeffPower[ 1 ][ 2 ][ 11 ]         = 0.865946;
    coeffPower[ 2 ][ 2 ][ 11 ]         = 0.356298;
    coeffPower[ 3 ][ 2 ][ 11 ]         = -.148061;
    coeffPower[ 4 ][ 2 ][ 11 ]         = -2.01020;
    coeffPower[ 5 ][ 2 ][ 11 ]         =  1.79247;
    coeffPower[ 6 ][ 2 ][ 11 ]         = -.843757;
    coeffPower[ 7 ][ 2 ][ 11 ]         = -.388826;
    coeffPower[ 8 ][ 2 ][ 11 ]         = -.634967E-01;
    coeffPower[ 9 ][ 2 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 11 ]        =  0.00000;
    energyMin[ 3 ][ 11 ]               = 0.591013;
    energyMax[ 3 ][ 11 ]               =  1.31028;
    coeffEnergy[ 0 ][ 3 ][ 11 ]        = 0.997761;
    coeffEnergy[ 1 ][ 3 ][ 11 ]        =  8.41895;
    coeffEnergy[ 2 ][ 3 ][ 11 ]        =  1.24510;
    coeffEnergy[ 3 ][ 3 ][ 11 ]        = -.583110;
    coeffEnergy[ 4 ][ 3 ][ 11 ]        = -19.2914;
    coeffEnergy[ 5 ][ 3 ][ 11 ]        = -7.15282;
    coeffEnergy[ 6 ][ 3 ][ 11 ]        =  3.86093;
    coeffEnergy[ 7 ][ 3 ][ 11 ]        = -.505626E-01;
    coeffEnergy[ 8 ][ 3 ][ 11 ]        = 0.699281E-01;
    coeffEnergy[ 9 ][ 3 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 11 ]       =  0.00000;
    performanceMin[ 3 ][ 11 ]          = 0.490419;
    performanceMax[ 3 ][ 11 ]          =  1.12995;
    coeffPerformance[ 0 ][ 3 ][ 11 ]   = 0.719723;
    coeffPerformance[ 1 ][ 3 ][ 11 ]   = -5.76083;
    coeffPerformance[ 2 ][ 3 ][ 11 ]   = -.589950;
    coeffPerformance[ 3 ][ 3 ][ 11 ]   = 0.300102;
    coeffPerformance[ 4 ][ 3 ][ 11 ]   =  13.1765;
    coeffPerformance[ 5 ][ 3 ][ 11 ]   =  7.81396;
    coeffPerformance[ 6 ][ 3 ][ 11 ]   = -3.92257;
    coeffPerformance[ 7 ][ 3 ][ 11 ]   = -.354067;
    coeffPerformance[ 8 ][ 3 ][ 11 ]   = -.200784;
    coeffPerformance[ 9 ][ 3 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 11 ]  =  0.00000;
    powerMin[ 3 ][ 11 ]                = 0.470026;
    powerMax[ 3 ][ 11 ]                = 0.960024;
    coeffPower[ 0 ][ 3 ][ 11 ]         = 0.709235;
    coeffPower[ 1 ][ 3 ][ 11 ]         = 0.763476;
    coeffPower[ 2 ][ 3 ][ 11 ]         = 0.343242;
    coeffPower[ 3 ][ 3 ][ 11 ]         = -.140742;
    coeffPower[ 4 ][ 3 ][ 11 ]         = -1.77085;
    coeffPower[ 5 ][ 3 ][ 11 ]         =  1.67588;
    coeffPower[ 6 ][ 3 ][ 11 ]         = -.674362;
    coeffPower[ 7 ][ 3 ][ 11 ]         = -.296447;
    coeffPower[ 8 ][ 3 ][ 11 ]         = -.172957;
    coeffPower[ 9 ][ 3 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 11 ]        =  0.00000;
    energyMin[ 4 ][ 11 ]               = 0.599255;
    energyMax[ 4 ][ 11 ]               =  1.25287;
    coeffEnergy[ 0 ][ 4 ][ 11 ]        = 0.976769;
    coeffEnergy[ 1 ][ 4 ][ 11 ]        =  6.61204;
    coeffEnergy[ 2 ][ 4 ][ 11 ]        = 0.684513;
    coeffEnergy[ 3 ][ 4 ][ 11 ]        = -.331783;
    coeffEnergy[ 4 ][ 4 ][ 11 ]        = -15.1466;
    coeffEnergy[ 5 ][ 4 ][ 11 ]        = -5.88921;
    coeffEnergy[ 6 ][ 4 ][ 11 ]        =  3.13447;
    coeffEnergy[ 7 ][ 4 ][ 11 ]        = -.531381E-01;
    coeffEnergy[ 8 ][ 4 ][ 11 ]        = 0.122230;
    coeffEnergy[ 9 ][ 4 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 11 ]       =  0.00000;
    performanceMin[ 4 ][ 11 ]          = 0.544339;
    performanceMax[ 4 ][ 11 ]          =  1.14845;
    coeffPerformance[ 0 ][ 4 ][ 11 ]   = 0.755351;
    coeffPerformance[ 1 ][ 4 ][ 11 ]   = -5.57469;
    coeffPerformance[ 2 ][ 4 ][ 11 ]   = -.459909;
    coeffPerformance[ 3 ][ 4 ][ 11 ]   = 0.242406;
    coeffPerformance[ 4 ][ 4 ][ 11 ]   =  12.7546;
    coeffPerformance[ 5 ][ 4 ][ 11 ]   =  7.23132;
    coeffPerformance[ 6 ][ 4 ][ 11 ]   = -3.58720;
    coeffPerformance[ 7 ][ 4 ][ 11 ]   = -.216984;
    coeffPerformance[ 8 ][ 4 ][ 11 ]   = -.397146;
    coeffPerformance[ 9 ][ 4 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 11 ]  =  0.00000;
    powerMin[ 4 ][ 11 ]                = 0.501156;
    powerMax[ 4 ][ 11 ]                = 0.987761;
    coeffPower[ 0 ][ 4 ][ 11 ]         = 0.728681;
    coeffPower[ 1 ][ 4 ][ 11 ]         = -.694608E-01;
    coeffPower[ 2 ][ 4 ][ 11 ]         = 0.484789E-01;
    coeffPower[ 3 ][ 4 ][ 11 ]         = -.901160E-02;
    coeffPower[ 4 ][ 4 ][ 11 ]         = 0.146325;
    coeffPower[ 5 ][ 4 ][ 11 ]         =  1.97922;
    coeffPower[ 6 ][ 4 ][ 11 ]         = -.858096;
    coeffPower[ 7 ][ 4 ][ 11 ]         = -.200186;
    coeffPower[ 8 ][ 4 ][ 11 ]         = -.270236;
    coeffPower[ 9 ][ 4 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 11 ]        =  0.00000;
    energyMin[ 5 ][ 11 ]               = 0.634734;
    energyMax[ 5 ][ 11 ]               =  1.22643;
    coeffEnergy[ 0 ][ 5 ][ 11 ]        = 0.969339;
    coeffEnergy[ 1 ][ 5 ][ 11 ]        =  6.12831;
    coeffEnergy[ 2 ][ 5 ][ 11 ]        =  1.04852;
    coeffEnergy[ 3 ][ 5 ][ 11 ]        = -.482936;
    coeffEnergy[ 4 ][ 5 ][ 11 ]        = -14.0408;
    coeffEnergy[ 5 ][ 5 ][ 11 ]        = -4.80560;
    coeffEnergy[ 6 ][ 5 ][ 11 ]        =  2.62132;
    coeffEnergy[ 7 ][ 5 ][ 11 ]        = 0.891925E-01;
    coeffEnergy[ 8 ][ 5 ][ 11 ]        = -.164007;
    coeffEnergy[ 9 ][ 5 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 11 ]       =  0.00000;
    performanceMin[ 5 ][ 11 ]          = 0.577979;
    performanceMax[ 5 ][ 11 ]          =  1.16672;
    coeffPerformance[ 0 ][ 5 ][ 11 ]   = 0.802918;
    coeffPerformance[ 1 ][ 5 ][ 11 ]   = -5.87518;
    coeffPerformance[ 2 ][ 5 ][ 11 ]   = -.724818;
    coeffPerformance[ 3 ][ 5 ][ 11 ]   = 0.349543;
    coeffPerformance[ 4 ][ 5 ][ 11 ]   =  13.4444;
    coeffPerformance[ 5 ][ 5 ][ 11 ]   =  6.21324;
    coeffPerformance[ 6 ][ 5 ][ 11 ]   = -3.24208;
    coeffPerformance[ 7 ][ 5 ][ 11 ]   = -.344797;
    coeffPerformance[ 8 ][ 5 ][ 11 ]   = -.638462E-01;
    coeffPerformance[ 9 ][ 5 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 11 ]  =  0.00000;
    powerMin[ 5 ][ 11 ]                = 0.541987;
    powerMax[ 5 ][ 11 ]                =  1.01258;
    coeffPower[ 0 ][ 5 ][ 11 ]         = 0.769036;
    coeffPower[ 1 ][ 5 ][ 11 ]         = -.508888;
    coeffPower[ 2 ][ 5 ][ 11 ]         = 0.185874;
    coeffPower[ 3 ][ 5 ][ 11 ]         = -.706782E-01;
    coeffPower[ 4 ][ 5 ][ 11 ]         =  1.15266;
    coeffPower[ 5 ][ 5 ][ 11 ]         =  1.77068;
    coeffPower[ 6 ][ 5 ][ 11 ]         = -.832678;
    coeffPower[ 7 ][ 5 ][ 11 ]         = -.182137;
    coeffPower[ 8 ][ 5 ][ 11 ]         = -.256459;
    coeffPower[ 9 ][ 5 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 11 ]        =  0.00000;
    energyMin[ 6 ][ 11 ]               = 0.628497;
    energyMax[ 6 ][ 11 ]               =  1.22465;
    coeffEnergy[ 0 ][ 6 ][ 11 ]        = 0.967992;
    coeffEnergy[ 1 ][ 6 ][ 11 ]        =  4.94867;
    coeffEnergy[ 2 ][ 6 ][ 11 ]        =  1.01538;
    coeffEnergy[ 3 ][ 6 ][ 11 ]        = -.460671;
    coeffEnergy[ 4 ][ 6 ][ 11 ]        = -11.3385;
    coeffEnergy[ 5 ][ 6 ][ 11 ]        = -4.27144;
    coeffEnergy[ 6 ][ 6 ][ 11 ]        =  2.49041;
    coeffEnergy[ 7 ][ 6 ][ 11 ]        = 0.251801;
    coeffEnergy[ 8 ][ 6 ][ 11 ]        = -.541683;
    coeffEnergy[ 9 ][ 6 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 11 ]       =  0.00000;
    performanceMin[ 6 ][ 11 ]          = 0.590488;
    performanceMax[ 6 ][ 11 ]          =  1.24295;
    coeffPerformance[ 0 ][ 6 ][ 11 ]   = 0.844201;
    coeffPerformance[ 1 ][ 6 ][ 11 ]   = -5.47203;
    coeffPerformance[ 2 ][ 6 ][ 11 ]   = -.831902;
    coeffPerformance[ 3 ][ 6 ][ 11 ]   = 0.387329;
    coeffPerformance[ 4 ][ 6 ][ 11 ]   =  12.5228;
    coeffPerformance[ 5 ][ 6 ][ 11 ]   =  5.35775;
    coeffPerformance[ 6 ][ 6 ][ 11 ]   = -2.97084;
    coeffPerformance[ 7 ][ 6 ][ 11 ]   = -.487208;
    coeffPerformance[ 8 ][ 6 ][ 11 ]   = 0.334686;
    coeffPerformance[ 9 ][ 6 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 11 ]  =  0.00000;
    powerMin[ 6 ][ 11 ]                = 0.591515;
    powerMax[ 6 ][ 11 ]                =  1.03947;
    coeffPower[ 0 ][ 6 ][ 11 ]         = 0.809471;
    coeffPower[ 1 ][ 6 ][ 11 ]         = -.958478;
    coeffPower[ 2 ][ 6 ][ 11 ]         = 0.108649;
    coeffPower[ 3 ][ 6 ][ 11 ]         = -.388906E-01;
    coeffPower[ 4 ][ 6 ][ 11 ]         =  2.18401;
    coeffPower[ 5 ][ 6 ][ 11 ]         =  1.33376;
    coeffPower[ 6 ][ 6 ][ 11 ]         = -.620677;
    coeffPower[ 7 ][ 6 ][ 11 ]         = -.179780;
    coeffPower[ 8 ][ 6 ][ 11 ]         = -.234990;
    coeffPower[ 9 ][ 6 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 11 ]        =  0.00000;
    energyMin[ 7 ][ 11 ]               = 0.679604;
    energyMax[ 7 ][ 11 ]               =  1.20960;
    coeffEnergy[ 0 ][ 7 ][ 11 ]        = 0.970815;
    coeffEnergy[ 1 ][ 7 ][ 11 ]        =  3.37376;
    coeffEnergy[ 2 ][ 7 ][ 11 ]        = 0.806226;
    coeffEnergy[ 3 ][ 7 ][ 11 ]        = -.367682;
    coeffEnergy[ 4 ][ 7 ][ 11 ]        = -7.72792;
    coeffEnergy[ 5 ][ 7 ][ 11 ]        = -3.28627;
    coeffEnergy[ 6 ][ 7 ][ 11 ]        =  1.80078;
    coeffEnergy[ 7 ][ 7 ][ 11 ]        = 0.879101E-01;
    coeffEnergy[ 8 ][ 7 ][ 11 ]        = -.203594;
    coeffEnergy[ 9 ][ 7 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 11 ]       =  0.00000;
    performanceMin[ 7 ][ 11 ]          = 0.655405;
    performanceMax[ 7 ][ 11 ]          =  1.18698;
    coeffPerformance[ 0 ][ 7 ][ 11 ]   = 0.874266;
    coeffPerformance[ 1 ][ 7 ][ 11 ]   = -4.17157;
    coeffPerformance[ 2 ][ 7 ][ 11 ]   = -.595935;
    coeffPerformance[ 3 ][ 7 ][ 11 ]   = 0.282762;
    coeffPerformance[ 4 ][ 7 ][ 11 ]   =  9.54515;
    coeffPerformance[ 5 ][ 7 ][ 11 ]   =  4.23378;
    coeffPerformance[ 6 ][ 7 ][ 11 ]   = -2.17389;
    coeffPerformance[ 7 ][ 7 ][ 11 ]   = -.216982;
    coeffPerformance[ 8 ][ 7 ][ 11 ]   = -.771442E-01;
    coeffPerformance[ 9 ][ 7 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 11 ]  =  0.00000;
    powerMin[ 7 ][ 11 ]                = 0.623886;
    powerMax[ 7 ][ 11 ]                =  1.06927;
    coeffPower[ 0 ][ 7 ][ 11 ]         = 0.844633;
    coeffPower[ 1 ][ 7 ][ 11 ]         = -.991730;
    coeffPower[ 2 ][ 7 ][ 11 ]         = 0.176262;
    coeffPower[ 3 ][ 7 ][ 11 ]         = -.692840E-01;
    coeffPower[ 4 ][ 7 ][ 11 ]         =  2.26284;
    coeffPower[ 5 ][ 7 ][ 11 ]         =  1.07022;
    coeffPower[ 6 ][ 7 ][ 11 ]         = -.453403;
    coeffPower[ 7 ][ 7 ][ 11 ]         = -.975293E-01;
    coeffPower[ 8 ][ 7 ][ 11 ]         = -.285455;
    coeffPower[ 9 ][ 7 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 11 ]        =  0.00000;
    energyMin[ 8 ][ 11 ]               = 0.698624;
    energyMax[ 8 ][ 11 ]               =  1.32837;
    coeffEnergy[ 0 ][ 8 ][ 11 ]        = 0.970202;
    coeffEnergy[ 1 ][ 8 ][ 11 ]        =  2.75000;
    coeffEnergy[ 2 ][ 8 ][ 11 ]        = 0.761384;
    coeffEnergy[ 3 ][ 8 ][ 11 ]        = -.343373;
    coeffEnergy[ 4 ][ 8 ][ 11 ]        = -6.29657;
    coeffEnergy[ 5 ][ 8 ][ 11 ]        = -2.36869;
    coeffEnergy[ 6 ][ 8 ][ 11 ]        =  1.33401;
    coeffEnergy[ 7 ][ 8 ][ 11 ]        = 0.820511E-01;
    coeffEnergy[ 8 ][ 8 ][ 11 ]        = -.177281;
    coeffEnergy[ 9 ][ 8 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 11 ]       =  0.00000;
    performanceMin[ 8 ][ 11 ]          = 0.620316;
    performanceMax[ 8 ][ 11 ]          =  1.19756;
    coeffPerformance[ 0 ][ 8 ][ 11 ]   = 0.911622;
    coeffPerformance[ 1 ][ 8 ][ 11 ]   = -3.53155;
    coeffPerformance[ 2 ][ 8 ][ 11 ]   = -.444759;
    coeffPerformance[ 3 ][ 8 ][ 11 ]   = 0.209653;
    coeffPerformance[ 4 ][ 8 ][ 11 ]   =  8.07958;
    coeffPerformance[ 5 ][ 8 ][ 11 ]   =  3.03458;
    coeffPerformance[ 6 ][ 8 ][ 11 ]   = -1.56339;
    coeffPerformance[ 7 ][ 8 ][ 11 ]   = -.176397;
    coeffPerformance[ 8 ][ 8 ][ 11 ]   = -.147654E-01;
    coeffPerformance[ 9 ][ 8 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 11 ]  =  0.00000;
    powerMin[ 8 ][ 11 ]                = 0.657940;
    powerMax[ 8 ][ 11 ]                =  1.09719;
    coeffPower[ 0 ][ 8 ][ 11 ]         = 0.883622;
    coeffPower[ 1 ][ 8 ][ 11 ]         = -.892742;
    coeffPower[ 2 ][ 8 ][ 11 ]         = 0.278128;
    coeffPower[ 3 ][ 8 ][ 11 ]         = -.116785;
    coeffPower[ 4 ][ 8 ][ 11 ]         =  2.03743;
    coeffPower[ 5 ][ 8 ][ 11 ]         = 0.667375;
    coeffPower[ 6 ][ 8 ][ 11 ]         = -.234375;
    coeffPower[ 7 ][ 8 ][ 11 ]         = -.749395E-01;
    coeffPower[ 8 ][ 8 ][ 11 ]         = -.202424;
    coeffPower[ 9 ][ 8 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 11 ]        =  0.00000;
    energyMin[ 9 ][ 11 ]               = 0.721575;
    energyMax[ 9 ][ 11 ]               =  1.20154;
    coeffEnergy[ 0 ][ 9 ][ 11 ]        = 0.979209;
    coeffEnergy[ 1 ][ 9 ][ 11 ]        =  1.70369;
    coeffEnergy[ 2 ][ 9 ][ 11 ]        = 0.682787;
    coeffEnergy[ 3 ][ 9 ][ 11 ]        = -.306037;
    coeffEnergy[ 4 ][ 9 ][ 11 ]        = -3.90235;
    coeffEnergy[ 5 ][ 9 ][ 11 ]        = -1.62167;
    coeffEnergy[ 6 ][ 9 ][ 11 ]        = 0.937051;
    coeffEnergy[ 7 ][ 9 ][ 11 ]        = 0.942789E-01;
    coeffEnergy[ 8 ][ 9 ][ 11 ]        = -.144130;
    coeffEnergy[ 9 ][ 9 ][ 11 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 11 ]       =  0.00000;
    performanceMin[ 9 ][ 11 ]          = 0.713760;
    performanceMax[ 9 ][ 11 ]          =  1.20787;
    coeffPerformance[ 0 ][ 9 ][ 11 ]   = 0.934696;
    coeffPerformance[ 1 ][ 9 ][ 11 ]   = -2.16332;
    coeffPerformance[ 2 ][ 9 ][ 11 ]   = -.421367;
    coeffPerformance[ 3 ][ 9 ][ 11 ]   = 0.196345;
    coeffPerformance[ 4 ][ 9 ][ 11 ]   =  4.95143;
    coeffPerformance[ 5 ][ 9 ][ 11 ]   =  2.34459;
    coeffPerformance[ 6 ][ 9 ][ 11 ]   = -1.27263;
    coeffPerformance[ 7 ][ 9 ][ 11 ]   = -.137475;
    coeffPerformance[ 8 ][ 9 ][ 11 ]   = -.279833E-02;
    coeffPerformance[ 9 ][ 9 ][ 11 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 11 ]  =  0.00000;
    powerMin[ 9 ][ 11 ]                = 0.703694;
    powerMax[ 9 ][ 11 ]                =  1.13045;
    coeffPower[ 0 ][ 9 ][ 11 ]         = 0.914350;
    coeffPower[ 1 ][ 9 ][ 11 ]         = -.493810;
    coeffPower[ 2 ][ 9 ][ 11 ]         = 0.256477;
    coeffPower[ 3 ][ 9 ][ 11 ]         = -.107490;
    coeffPower[ 4 ][ 9 ][ 11 ]         =  1.12768;
    coeffPower[ 5 ][ 9 ][ 11 ]         = 0.730768;
    coeffPower[ 6 ][ 9 ][ 11 ]         = -.342228;
    coeffPower[ 7 ][ 9 ][ 11 ]         = -.374687E-01;
    coeffPower[ 8 ][ 9 ][ 11 ]         = -.145946;
    coeffPower[ 9 ][ 9 ][ 11 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 11 ]        =  0.00000;
    energyMin[ 10 ][ 11 ]              = 0.749399;
    energyMax[ 10 ][ 11 ]              =  1.25245;
    coeffEnergy[ 0 ][ 10 ][ 11 ]       = 0.989707;
    coeffEnergy[ 1 ][ 10 ][ 11 ]       =  1.12175;
    coeffEnergy[ 2 ][ 10 ][ 11 ]       = 0.366108;
    coeffEnergy[ 3 ][ 10 ][ 11 ]       = -.164782;
    coeffEnergy[ 4 ][ 10 ][ 11 ]       = -2.57080;
    coeffEnergy[ 5 ][ 10 ][ 11 ]       = -.911408;
    coeffEnergy[ 6 ][ 10 ][ 11 ]       = 0.516953;
    coeffEnergy[ 7 ][ 10 ][ 11 ]       = 0.743662E-01;
    coeffEnergy[ 8 ][ 10 ][ 11 ]       = -.612043E-01;
    coeffEnergy[ 9 ][ 10 ][ 11 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 11 ]      =  0.00000;
    performanceMin[ 10 ][ 11 ]         = 0.730671;
    performanceMax[ 10 ][ 11 ]         =  1.22533;
    coeffPerformance[ 0 ][ 10 ][ 11 ]  = 0.968424;
    coeffPerformance[ 1 ][ 10 ][ 11 ]  = -1.30364;
    coeffPerformance[ 2 ][ 10 ][ 11 ]  = -.206365;
    coeffPerformance[ 3 ][ 10 ][ 11 ]  = 0.965598E-01;
    coeffPerformance[ 4 ][ 10 ][ 11 ]  =  2.98435;
    coeffPerformance[ 5 ][ 10 ][ 11 ]  =  1.24574;
    coeffPerformance[ 6 ][ 10 ][ 11 ]  = -.686486;
    coeffPerformance[ 7 ][ 10 ][ 11 ]  = -.103112;
    coeffPerformance[ 8 ][ 10 ][ 11 ]  = 0.112069E-01;
    coeffPerformance[ 9 ][ 10 ][ 11 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 11 ] =  0.00000;
    powerMin[ 10 ][ 11 ]               = 0.746048;
    powerMax[ 10 ][ 11 ]               =  1.16265;
    coeffPower[ 0 ][ 10 ][ 11 ]        = 0.957604;
    coeffPower[ 1 ][ 10 ][ 11 ]        = -.189968;
    coeffPower[ 2 ][ 10 ][ 11 ]        = 0.161874;
    coeffPower[ 3 ][ 10 ][ 11 ]        = -.689088E-01;
    coeffPower[ 4 ][ 10 ][ 11 ]        = 0.432378;
    coeffPower[ 5 ][ 10 ][ 11 ]        = 0.343799;
    coeffPower[ 6 ][ 10 ][ 11 ]        = -.166556;
    coeffPower[ 7 ][ 10 ][ 11 ]        = -.196059E-01;
    coeffPower[ 8 ][ 10 ][ 11 ]        = -.664784E-01;
    coeffPower[ 9 ][ 10 ][ 11 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 11 ]       =  0.00000;
    energyMin[ 11 ][ 11 ]              = 0.800000;
    energyMax[ 11 ][ 11 ]              =  1.20000;
    coeffEnergy[ 0 ][ 11 ][ 11 ]       =  1.00000;
    coeffEnergy[ 1 ][ 11 ][ 11 ]       = -.497971E-12;
    coeffEnergy[ 2 ][ 11 ][ 11 ]       = 0.151954E-13;
    coeffEnergy[ 3 ][ 11 ][ 11 ]       = -.882048E-14;
    coeffEnergy[ 4 ][ 11 ][ 11 ]       = 0.114078E-11;
    coeffEnergy[ 5 ][ 11 ][ 11 ]       = -.496090E-12;
    coeffEnergy[ 6 ][ 11 ][ 11 ]       = 0.270545E-12;
    coeffEnergy[ 7 ][ 11 ][ 11 ]       = -.202419E-13;
    coeffEnergy[ 8 ][ 11 ][ 11 ]       = 0.289962E-13;
    coeffEnergy[ 9 ][ 11 ][ 11 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 11 ]      =  0.00000;
    performanceMin[ 11 ][ 11 ]         = 0.800000;
    performanceMax[ 11 ][ 11 ]         =  1.20000;
    coeffPerformance[ 0 ][ 11 ][ 11 ]  =  1.00000;
    coeffPerformance[ 1 ][ 11 ][ 11 ]  = -.636095E-13;
    coeffPerformance[ 2 ][ 11 ][ 11 ]  = -.296974E-12;
    coeffPerformance[ 3 ][ 11 ][ 11 ]  = 0.128462E-12;
    coeffPerformance[ 4 ][ 11 ][ 11 ]  = 0.142515E-12;
    coeffPerformance[ 5 ][ 11 ][ 11 ]  = -.309601E-12;
    coeffPerformance[ 6 ][ 11 ][ 11 ]  = 0.154116E-12;
    coeffPerformance[ 7 ][ 11 ][ 11 ]  = 0.861806E-15;
    coeffPerformance[ 8 ][ 11 ][ 11 ]  = -.151550E-13;
    coeffPerformance[ 9 ][ 11 ][ 11 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 11 ] =  0.00000;
    powerMin[ 11 ][ 11 ]               = 0.800000;
    powerMax[ 11 ][ 11 ]               =  1.20000;
    coeffPower[ 0 ][ 11 ][ 11 ]        =  1.00000;
    coeffPower[ 1 ][ 11 ][ 11 ]        = -.622693E-13;
    coeffPower[ 2 ][ 11 ][ 11 ]        = 0.130519E-12;
    coeffPower[ 3 ][ 11 ][ 11 ]        = -.579153E-13;
    coeffPower[ 4 ][ 11 ][ 11 ]        = 0.142059E-12;
    coeffPower[ 5 ][ 11 ][ 11 ]        = -.890805E-13;
    coeffPower[ 6 ][ 11 ][ 11 ]        = 0.104504E-12;
    coeffPower[ 7 ][ 11 ][ 11 ]        = 0.143353E-14;
    coeffPower[ 8 ][ 11 ][ 11 ]        = -.210257E-13;
    coeffPower[ 9 ][ 11 ][ 11 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 11 ]       =  0.00000;
    energyMin[ 12 ][ 11 ]              = 0.767724;
    energyMax[ 12 ][ 11 ]              =  1.26080;
    coeffEnergy[ 0 ][ 12 ][ 11 ]       =  1.01735;
    coeffEnergy[ 1 ][ 12 ][ 11 ]       = -.378059;
    coeffEnergy[ 2 ][ 12 ][ 11 ]       = -.154245;
    coeffEnergy[ 3 ][ 12 ][ 11 ]       = 0.721855E-01;
    coeffEnergy[ 4 ][ 12 ][ 11 ]       = 0.860977;
    coeffEnergy[ 5 ][ 12 ][ 11 ]       = 0.822583;
    coeffEnergy[ 6 ][ 12 ][ 11 ]       = -.403542;
    coeffEnergy[ 7 ][ 12 ][ 11 ]       = -.141162E-01;
    coeffEnergy[ 8 ][ 12 ][ 11 ]       = -.111396;
    coeffEnergy[ 9 ][ 12 ][ 11 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 11 ]      =  0.00000;
    performanceMin[ 12 ][ 11 ]         = 0.794104;
    performanceMax[ 12 ][ 11 ]         =  1.27887;
    coeffPerformance[ 0 ][ 12 ][ 11 ]  =  1.03279;
    coeffPerformance[ 1 ][ 12 ][ 11 ]  = 0.787831;
    coeffPerformance[ 2 ][ 12 ][ 11 ]  = 0.471806E-01;
    coeffPerformance[ 3 ][ 12 ][ 11 ]  = -.285642E-01;
    coeffPerformance[ 4 ][ 12 ][ 11 ]  = -1.80066;
    coeffPerformance[ 5 ][ 12 ][ 11 ]  = -1.30308;
    coeffPerformance[ 6 ][ 12 ][ 11 ]  = 0.619042;
    coeffPerformance[ 7 ][ 12 ][ 11 ]  = -.883596E-02;
    coeffPerformance[ 8 ][ 12 ][ 11 ]  = 0.175273;
    coeffPerformance[ 9 ][ 12 ][ 11 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 11 ] =  0.00000;
    powerMin[ 12 ][ 11 ]               = 0.814162;
    powerMax[ 12 ][ 11 ]               =  1.26976;
    coeffPower[ 0 ][ 12 ][ 11 ]        =  1.05060;
    coeffPower[ 1 ][ 12 ][ 11 ]        = 0.444004;
    coeffPower[ 2 ][ 12 ][ 11 ]        = -.101554;
    coeffPower[ 3 ][ 12 ][ 11 ]        = 0.411874E-01;
    coeffPower[ 4 ][ 12 ][ 11 ]        = -1.01833;
    coeffPower[ 5 ][ 12 ][ 11 ]        = -.483256;
    coeffPower[ 6 ][ 12 ][ 11 ]        = 0.216630;
    coeffPower[ 7 ][ 12 ][ 11 ]        = -.234332E-01;
    coeffPower[ 8 ][ 12 ][ 11 ]        = 0.631367E-01;
    coeffPower[ 9 ][ 12 ][ 11 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 11 ]       =  0.00000;
    energyMin[ 13 ][ 11 ]              = 0.798038;
    energyMax[ 13 ][ 11 ]              =  1.31341;
    coeffEnergy[ 0 ][ 13 ][ 11 ]       =  1.02164;
    coeffEnergy[ 1 ][ 13 ][ 11 ]       = -1.27961;
    coeffEnergy[ 2 ][ 13 ][ 11 ]       = -.315505;
    coeffEnergy[ 3 ][ 13 ][ 11 ]       = 0.148708;
    coeffEnergy[ 4 ][ 13 ][ 11 ]       =  2.93060;
    coeffEnergy[ 5 ][ 13 ][ 11 ]       =  1.70864;
    coeffEnergy[ 6 ][ 13 ][ 11 ]       = -.848755;
    coeffEnergy[ 7 ][ 13 ][ 11 ]       = 0.589746E-01;
    coeffEnergy[ 8 ][ 13 ][ 11 ]       = -.173485;
    coeffEnergy[ 9 ][ 13 ][ 11 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 11 ]      =  0.00000;
    performanceMin[ 13 ][ 11 ]         = 0.798915;
    performanceMax[ 13 ][ 11 ]         =  1.32243;
    coeffPerformance[ 0 ][ 13 ][ 11 ]  =  1.06813;
    coeffPerformance[ 1 ][ 13 ][ 11 ]  =  1.51977;
    coeffPerformance[ 2 ][ 13 ][ 11 ]  = 0.206165E-01;
    coeffPerformance[ 3 ][ 13 ][ 11 ]  = -.244546E-01;
    coeffPerformance[ 4 ][ 13 ][ 11 ]  = -3.47509;
    coeffPerformance[ 5 ][ 13 ][ 11 ]  = -2.59935;
    coeffPerformance[ 6 ][ 13 ][ 11 ]  =  1.21496;
    coeffPerformance[ 7 ][ 13 ][ 11 ]  = -.542447E-01;
    coeffPerformance[ 8 ][ 13 ][ 11 ]  = 0.328431;
    coeffPerformance[ 9 ][ 13 ][ 11 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 11 ] =  0.00000;
    powerMin[ 13 ][ 11 ]               = 0.850422;
    powerMax[ 13 ][ 11 ]               =  1.34048;
    coeffPower[ 0 ][ 13 ][ 11 ]        =  1.09063;
    coeffPower[ 1 ][ 13 ][ 11 ]        = 0.247936;
    coeffPower[ 2 ][ 13 ][ 11 ]        = -.301746;
    coeffPower[ 3 ][ 13 ][ 11 ]        = 0.127190;
    coeffPower[ 4 ][ 13 ][ 11 ]        = -.562103;
    coeffPower[ 5 ][ 13 ][ 11 ]        = -.904883;
    coeffPower[ 6 ][ 13 ][ 11 ]        = 0.366612;
    coeffPower[ 7 ][ 13 ][ 11 ]        = 0.834602E-02;
    coeffPower[ 8 ][ 13 ][ 11 ]        = 0.158975;
    coeffPower[ 9 ][ 13 ][ 11 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 11 ]       =  0.00000;
    energyMin[ 14 ][ 11 ]              = 0.809776;
    energyMax[ 14 ][ 11 ]              =  1.35936;
    coeffEnergy[ 0 ][ 14 ][ 11 ]       =  1.03401;
    coeffEnergy[ 1 ][ 14 ][ 11 ]       = -2.13877;
    coeffEnergy[ 2 ][ 14 ][ 11 ]       = -.373184;
    coeffEnergy[ 3 ][ 14 ][ 11 ]       = 0.180423;
    coeffEnergy[ 4 ][ 14 ][ 11 ]       =  4.90105;
    coeffEnergy[ 5 ][ 14 ][ 11 ]       =  2.70148;
    coeffEnergy[ 6 ][ 14 ][ 11 ]       = -1.38458;
    coeffEnergy[ 7 ][ 14 ][ 11 ]       = 0.599543E-01;
    coeffEnergy[ 8 ][ 14 ][ 11 ]       = -.267436;
    coeffEnergy[ 9 ][ 14 ][ 11 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 11 ]      =  0.00000;
    performanceMin[ 14 ][ 11 ]         = 0.798962;
    performanceMax[ 14 ][ 11 ]         =  1.37150;
    coeffPerformance[ 0 ][ 14 ][ 11 ]  =  1.10515;
    coeffPerformance[ 1 ][ 14 ][ 11 ]  =  3.00342;
    coeffPerformance[ 2 ][ 14 ][ 11 ]  = 0.152300;
    coeffPerformance[ 3 ][ 14 ][ 11 ]  = -.897847E-01;
    coeffPerformance[ 4 ][ 14 ][ 11 ]  = -6.87525;
    coeffPerformance[ 5 ][ 14 ][ 11 ]  = -3.92022;
    coeffPerformance[ 6 ][ 14 ][ 11 ]  =  1.88934;
    coeffPerformance[ 7 ][ 14 ][ 11 ]  = -.155491E-01;
    coeffPerformance[ 8 ][ 14 ][ 11 ]  = 0.403300;
    coeffPerformance[ 9 ][ 14 ][ 11 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 11 ] =  0.00000;
    powerMin[ 14 ][ 11 ]               = 0.877585;
    powerMax[ 14 ][ 11 ]               =  1.40881;
    coeffPower[ 0 ][ 14 ][ 11 ]        =  1.14185;
    coeffPower[ 1 ][ 14 ][ 11 ]        = 0.882548;
    coeffPower[ 2 ][ 14 ][ 11 ]        = -.240300;
    coeffPower[ 3 ][ 14 ][ 11 ]        = 0.987520E-01;
    coeffPower[ 4 ][ 14 ][ 11 ]        = -2.01476;
    coeffPower[ 5 ][ 14 ][ 11 ]        = -1.27346;
    coeffPower[ 6 ][ 14 ][ 11 ]        = 0.517582;
    coeffPower[ 7 ][ 14 ][ 11 ]        = 0.481174E-01;
    coeffPower[ 8 ][ 14 ][ 11 ]        = 0.152614;
    coeffPower[ 9 ][ 14 ][ 11 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 11 ]       =  0.00000;
    energyMin[ 15 ][ 11 ]              = 0.770805;
    energyMax[ 15 ][ 11 ]              =  1.42713;
    coeffEnergy[ 0 ][ 15 ][ 11 ]       =  1.04861;
    coeffEnergy[ 1 ][ 15 ][ 11 ]       = -2.12316;
    coeffEnergy[ 2 ][ 15 ][ 11 ]       = -.264373;
    coeffEnergy[ 3 ][ 15 ][ 11 ]       = 0.140290;
    coeffEnergy[ 4 ][ 15 ][ 11 ]       =  4.86235;
    coeffEnergy[ 5 ][ 15 ][ 11 ]       =  3.76447;
    coeffEnergy[ 6 ][ 15 ][ 11 ]       = -1.87227;
    coeffEnergy[ 7 ][ 15 ][ 11 ]       = 0.132317;
    coeffEnergy[ 8 ][ 15 ][ 11 ]       = -.487602;
    coeffEnergy[ 9 ][ 15 ][ 11 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 11 ]      =  0.00000;
    performanceMin[ 15 ][ 11 ]         = 0.804152;
    performanceMax[ 15 ][ 11 ]         =  1.51534;
    coeffPerformance[ 0 ][ 15 ][ 11 ]  =  1.13736;
    coeffPerformance[ 1 ][ 15 ][ 11 ]  =  2.76422;
    coeffPerformance[ 2 ][ 15 ][ 11 ]  = -.116092;
    coeffPerformance[ 3 ][ 15 ][ 11 ]  = 0.183674E-01;
    coeffPerformance[ 4 ][ 15 ][ 11 ]  = -6.31795;
    coeffPerformance[ 5 ][ 15 ][ 11 ]  = -5.51513;
    coeffPerformance[ 6 ][ 15 ][ 11 ]  =  2.69406;
    coeffPerformance[ 7 ][ 15 ][ 11 ]  = -.281700E-01;
    coeffPerformance[ 8 ][ 15 ][ 11 ]  = 0.589940;
    coeffPerformance[ 9 ][ 15 ][ 11 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 11 ] =  0.00000;
    powerMin[ 15 ][ 11 ]               = 0.905723;
    powerMax[ 15 ][ 11 ]               =  1.53866;
    coeffPower[ 0 ][ 15 ][ 11 ]        =  1.18958;
    coeffPower[ 1 ][ 15 ][ 11 ]        = 0.850736;
    coeffPower[ 2 ][ 15 ][ 11 ]        = -.360263;
    coeffPower[ 3 ][ 15 ][ 11 ]        = 0.149629;
    coeffPower[ 4 ][ 15 ][ 11 ]        = -1.93508;
    coeffPower[ 5 ][ 15 ][ 11 ]        = -1.78949;
    coeffPower[ 6 ][ 15 ][ 11 ]        = 0.821123;
    coeffPower[ 7 ][ 15 ][ 11 ]        = 0.124691;
    coeffPower[ 8 ][ 15 ][ 11 ]        = 0.106181;
    coeffPower[ 9 ][ 15 ][ 11 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 11 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 2.40;
    energyMin[ 0 ][ 12 ]               = 0.542141;
    energyMax[ 0 ][ 12 ]               =  1.41288;
    coeffEnergy[ 0 ][ 0 ][ 12 ]        =  1.03747;
    coeffEnergy[ 1 ][ 0 ][ 12 ]        =  10.4385;
    coeffEnergy[ 2 ][ 0 ][ 12 ]        =  1.96166;
    coeffEnergy[ 3 ][ 0 ][ 12 ]        = -.879893;
    coeffEnergy[ 4 ][ 0 ][ 12 ]        = -24.9433;
    coeffEnergy[ 5 ][ 0 ][ 12 ]        = -11.0387;
    coeffEnergy[ 6 ][ 0 ][ 12 ]        =  5.30178;
    coeffEnergy[ 7 ][ 0 ][ 12 ]        = -.258395;
    coeffEnergy[ 8 ][ 0 ][ 12 ]        = 0.676556;
    coeffEnergy[ 9 ][ 0 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 12 ]       =  0.00000;
    performanceMin[ 0 ][ 12 ]          = 0.395962;
    performanceMax[ 0 ][ 12 ]          =  1.03404;
    coeffPerformance[ 0 ][ 0 ][ 12 ]   = 0.555742;
    coeffPerformance[ 1 ][ 0 ][ 12 ]   = -3.86460;
    coeffPerformance[ 2 ][ 0 ][ 12 ]   = -1.16192;
    coeffPerformance[ 3 ][ 0 ][ 12 ]   = 0.545063;
    coeffPerformance[ 4 ][ 0 ][ 12 ]   =  9.21125;
    coeffPerformance[ 5 ][ 0 ][ 12 ]   =  9.86644;
    coeffPerformance[ 6 ][ 0 ][ 12 ]   = -5.07616;
    coeffPerformance[ 7 ][ 0 ][ 12 ]   = -.231065;
    coeffPerformance[ 8 ][ 0 ][ 12 ]   = -.590850;
    coeffPerformance[ 9 ][ 0 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 12 ]  =  0.00000;
    powerMin[ 0 ][ 12 ]                = 0.377224;
    powerMax[ 0 ][ 12 ]                = 0.831189;
    coeffPower[ 0 ][ 0 ][ 12 ]         = 0.569775;
    coeffPower[ 1 ][ 0 ][ 12 ]         =  2.04386;
    coeffPower[ 2 ][ 0 ][ 12 ]         = 0.913959E-01;
    coeffPower[ 3 ][ 0 ][ 12 ]         = -.223691E-01;
    coeffPower[ 4 ][ 0 ][ 12 ]         = -4.90461;
    coeffPower[ 5 ][ 0 ][ 12 ]         =  1.79885;
    coeffPower[ 6 ][ 0 ][ 12 ]         = -1.29183;
    coeffPower[ 7 ][ 0 ][ 12 ]         = -.301597;
    coeffPower[ 8 ][ 0 ][ 12 ]         = -.123145;
    coeffPower[ 9 ][ 0 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 12 ]        =  0.00000;
    energyMin[ 1 ][ 12 ]               = 0.562258;
    energyMax[ 1 ][ 12 ]               =  1.34622;
    coeffEnergy[ 0 ][ 1 ][ 12 ]        =  1.03980;
    coeffEnergy[ 1 ][ 1 ][ 12 ]        =  7.22637;
    coeffEnergy[ 2 ][ 1 ][ 12 ]        =  1.18881;
    coeffEnergy[ 3 ][ 1 ][ 12 ]        = -.557137;
    coeffEnergy[ 4 ][ 1 ][ 12 ]        = -17.2697;
    coeffEnergy[ 5 ][ 1 ][ 12 ]        = -10.1125;
    coeffEnergy[ 6 ][ 1 ][ 12 ]        =  4.87041;
    coeffEnergy[ 7 ][ 1 ][ 12 ]        = -.389198;
    coeffEnergy[ 8 ][ 1 ][ 12 ]        = 0.856356;
    coeffEnergy[ 9 ][ 1 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 12 ]       =  0.00000;
    performanceMin[ 1 ][ 12 ]          = 0.425260;
    performanceMax[ 1 ][ 12 ]          =  1.07618;
    coeffPerformance[ 0 ][ 1 ][ 12 ]   = 0.601680;
    coeffPerformance[ 1 ][ 1 ][ 12 ]   = -4.38486;
    coeffPerformance[ 2 ][ 1 ][ 12 ]   = -1.03363;
    coeffPerformance[ 3 ][ 1 ][ 12 ]   = 0.490303;
    coeffPerformance[ 4 ][ 1 ][ 12 ]   =  10.4550;
    coeffPerformance[ 5 ][ 1 ][ 12 ]   =  9.43801;
    coeffPerformance[ 6 ][ 1 ][ 12 ]   = -4.60620;
    coeffPerformance[ 7 ][ 1 ][ 12 ]   = -.139549;
    coeffPerformance[ 8 ][ 1 ][ 12 ]   = -.802067;
    coeffPerformance[ 9 ][ 1 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 12 ]  =  0.00000;
    powerMin[ 1 ][ 12 ]                = 0.406383;
    powerMax[ 1 ][ 12 ]                = 0.887756;
    coeffPower[ 0 ][ 1 ][ 12 ]         = 0.622879;
    coeffPower[ 1 ][ 1 ][ 12 ]         = -.574590E-02;
    coeffPower[ 2 ][ 1 ][ 12 ]         = -.275237;
    coeffPower[ 3 ][ 1 ][ 12 ]         = 0.126139;
    coeffPower[ 4 ][ 1 ][ 12 ]         = -.820701E-02;
    coeffPower[ 5 ][ 1 ][ 12 ]         =  1.56406;
    coeffPower[ 6 ][ 1 ][ 12 ]         = -.951053;
    coeffPower[ 7 ][ 1 ][ 12 ]         = -.358143;
    coeffPower[ 8 ][ 1 ][ 12 ]         = -.990979E-01;
    coeffPower[ 9 ][ 1 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 12 ]        =  0.00000;
    energyMin[ 2 ][ 12 ]               = 0.571723;
    energyMax[ 2 ][ 12 ]               =  1.30747;
    coeffEnergy[ 0 ][ 2 ][ 12 ]        =  1.00576;
    coeffEnergy[ 1 ][ 2 ][ 12 ]        =  7.22157;
    coeffEnergy[ 2 ][ 2 ][ 12 ]        =  1.43179;
    coeffEnergy[ 3 ][ 2 ][ 12 ]        = -.651876;
    coeffEnergy[ 4 ][ 2 ][ 12 ]        = -17.2568;
    coeffEnergy[ 5 ][ 2 ][ 12 ]        = -8.55923;
    coeffEnergy[ 6 ][ 2 ][ 12 ]        =  4.39976;
    coeffEnergy[ 7 ][ 2 ][ 12 ]        = -.291966;
    coeffEnergy[ 8 ][ 2 ][ 12 ]        = 0.690815;
    coeffEnergy[ 9 ][ 2 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 12 ]       =  0.00000;
    performanceMin[ 2 ][ 12 ]          = 0.460299;
    performanceMax[ 2 ][ 12 ]          =  1.10081;
    coeffPerformance[ 0 ][ 2 ][ 12 ]   = 0.654872;
    coeffPerformance[ 1 ][ 2 ][ 12 ]   = -5.22483;
    coeffPerformance[ 2 ][ 2 ][ 12 ]   = -1.14950;
    coeffPerformance[ 3 ][ 2 ][ 12 ]   = 0.534192;
    coeffPerformance[ 4 ][ 2 ][ 12 ]   =  12.4623;
    coeffPerformance[ 5 ][ 2 ][ 12 ]   =  8.83636;
    coeffPerformance[ 6 ][ 2 ][ 12 ]   = -4.34065;
    coeffPerformance[ 7 ][ 2 ][ 12 ]   = -.193986;
    coeffPerformance[ 8 ][ 2 ][ 12 ]   = -.690158;
    coeffPerformance[ 9 ][ 2 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 12 ]  =  0.00000;
    powerMin[ 2 ][ 12 ]                = 0.427641;
    powerMax[ 2 ][ 12 ]                = 0.912363;
    coeffPower[ 0 ][ 2 ][ 12 ]         = 0.651620;
    coeffPower[ 1 ][ 2 ][ 12 ]         = -.222801;
    coeffPower[ 2 ][ 2 ][ 12 ]         = -.878710E-01;
    coeffPower[ 3 ][ 2 ][ 12 ]         = 0.462778E-01;
    coeffPower[ 4 ][ 2 ][ 12 ]         = 0.512264;
    coeffPower[ 5 ][ 2 ][ 12 ]         =  1.79831;
    coeffPower[ 6 ][ 2 ][ 12 ]         = -.837313;
    coeffPower[ 7 ][ 2 ][ 12 ]         = -.346362;
    coeffPower[ 8 ][ 2 ][ 12 ]         = -.978669E-01;
    coeffPower[ 9 ][ 2 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 12 ]        =  0.00000;
    energyMin[ 3 ][ 12 ]               = 0.576170;
    energyMax[ 3 ][ 12 ]               =  1.30457;
    coeffEnergy[ 0 ][ 3 ][ 12 ]        = 0.960087;
    coeffEnergy[ 1 ][ 3 ][ 12 ]        =  7.41772;
    coeffEnergy[ 2 ][ 3 ][ 12 ]        =  1.67428;
    coeffEnergy[ 3 ][ 3 ][ 12 ]        = -.739947;
    coeffEnergy[ 4 ][ 3 ][ 12 ]        = -17.7166;
    coeffEnergy[ 5 ][ 3 ][ 12 ]        = -7.25746;
    coeffEnergy[ 6 ][ 3 ][ 12 ]        =  3.98442;
    coeffEnergy[ 7 ][ 3 ][ 12 ]        = -.776480E-02;
    coeffEnergy[ 8 ][ 3 ][ 12 ]        = 0.163526;
    coeffEnergy[ 9 ][ 3 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 12 ]       =  0.00000;
    performanceMin[ 3 ][ 12 ]          = 0.469596;
    performanceMax[ 3 ][ 12 ]          =  1.12934;
    coeffPerformance[ 0 ][ 3 ][ 12 ]   = 0.712154;
    coeffPerformance[ 1 ][ 3 ][ 12 ]   = -5.91176;
    coeffPerformance[ 2 ][ 3 ][ 12 ]   = -1.33336;
    coeffPerformance[ 3 ][ 3 ][ 12 ]   = 0.602898;
    coeffPerformance[ 4 ][ 3 ][ 12 ]   =  14.1006;
    coeffPerformance[ 5 ][ 3 ][ 12 ]   =  8.01050;
    coeffPerformance[ 6 ][ 3 ][ 12 ]   = -4.05490;
    coeffPerformance[ 7 ][ 3 ][ 12 ]   = -.347071;
    coeffPerformance[ 8 ][ 3 ][ 12 ]   = -.337365;
    coeffPerformance[ 9 ][ 3 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 12 ]  =  0.00000;
    powerMin[ 3 ][ 12 ]                = 0.451969;
    powerMax[ 3 ][ 12 ]                = 0.931337;
    coeffPower[ 0 ][ 3 ][ 12 ]         = 0.672810;
    coeffPower[ 1 ][ 3 ][ 12 ]         = -.163177;
    coeffPower[ 2 ][ 3 ][ 12 ]         = 0.512916E-01;
    coeffPower[ 3 ][ 3 ][ 12 ]         = -.106035E-01;
    coeffPower[ 4 ][ 3 ][ 12 ]         = 0.373288;
    coeffPower[ 5 ][ 3 ][ 12 ]         =  1.73690;
    coeffPower[ 6 ][ 3 ][ 12 ]         = -.695074;
    coeffPower[ 7 ][ 3 ][ 12 ]         = -.256937;
    coeffPower[ 8 ][ 3 ][ 12 ]         = -.208150;
    coeffPower[ 9 ][ 3 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 12 ]        =  0.00000;
    energyMin[ 4 ][ 12 ]               = 0.584205;
    energyMax[ 4 ][ 12 ]               =  1.25012;
    coeffEnergy[ 0 ][ 4 ][ 12 ]        = 0.944106;
    coeffEnergy[ 1 ][ 4 ][ 12 ]        =  6.85919;
    coeffEnergy[ 2 ][ 4 ][ 12 ]        =  1.12284;
    coeffEnergy[ 3 ][ 4 ][ 12 ]        = -.502364;
    coeffEnergy[ 4 ][ 4 ][ 12 ]        = -16.3833;
    coeffEnergy[ 5 ][ 4 ][ 12 ]        = -5.88844;
    coeffEnergy[ 6 ][ 4 ][ 12 ]        =  3.15313;
    coeffEnergy[ 7 ][ 4 ][ 12 ]        = 0.985472E-02;
    coeffEnergy[ 8 ][ 4 ][ 12 ]        = 0.179466;
    coeffEnergy[ 9 ][ 4 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 12 ]       =  0.00000;
    performanceMin[ 4 ][ 12 ]          = 0.521247;
    performanceMax[ 4 ][ 12 ]          =  1.14587;
    coeffPerformance[ 0 ][ 4 ][ 12 ]   = 0.746362;
    coeffPerformance[ 1 ][ 4 ][ 12 ]   = -6.04280;
    coeffPerformance[ 2 ][ 4 ][ 12 ]   = -1.24068;
    coeffPerformance[ 3 ][ 4 ][ 12 ]   = 0.563313;
    coeffPerformance[ 4 ][ 4 ][ 12 ]   =  14.4193;
    coeffPerformance[ 5 ][ 4 ][ 12 ]   =  7.44433;
    coeffPerformance[ 6 ][ 4 ][ 12 ]   = -3.71651;
    coeffPerformance[ 7 ][ 4 ][ 12 ]   = -.225239;
    coeffPerformance[ 8 ][ 4 ][ 12 ]   = -.526071;
    coeffPerformance[ 9 ][ 4 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 12 ]  =  0.00000;
    powerMin[ 4 ][ 12 ]                = 0.483798;
    powerMax[ 4 ][ 12 ]                = 0.959561;
    coeffPower[ 0 ][ 4 ][ 12 ]         = 0.693160;
    coeffPower[ 1 ][ 4 ][ 12 ]         = -.302494;
    coeffPower[ 2 ][ 4 ][ 12 ]         = -.287332;
    coeffPower[ 3 ][ 4 ][ 12 ]         = 0.134601;
    coeffPower[ 4 ][ 4 ][ 12 ]         = 0.711369;
    coeffPower[ 5 ][ 4 ][ 12 ]         =  2.14668;
    coeffPower[ 6 ][ 4 ][ 12 ]         = -.963056;
    coeffPower[ 7 ][ 4 ][ 12 ]         = -.156514;
    coeffPower[ 8 ][ 4 ][ 12 ]         = -.322836;
    coeffPower[ 9 ][ 4 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 12 ]        =  0.00000;
    energyMin[ 5 ][ 12 ]               = 0.618793;
    energyMax[ 5 ][ 12 ]               =  1.22198;
    coeffEnergy[ 0 ][ 5 ][ 12 ]        = 0.938689;
    coeffEnergy[ 1 ][ 5 ][ 12 ]        =  6.07717;
    coeffEnergy[ 2 ][ 5 ][ 12 ]        =  1.35224;
    coeffEnergy[ 3 ][ 5 ][ 12 ]        = -.591593;
    coeffEnergy[ 4 ][ 5 ][ 12 ]        = -14.5159;
    coeffEnergy[ 5 ][ 5 ][ 12 ]        = -4.94871;
    coeffEnergy[ 6 ][ 5 ][ 12 ]        =  2.70705;
    coeffEnergy[ 7 ][ 5 ][ 12 ]        = 0.119471;
    coeffEnergy[ 8 ][ 5 ][ 12 ]        = -.707043E-01;
    coeffEnergy[ 9 ][ 5 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 12 ]       =  0.00000;
    performanceMin[ 5 ][ 12 ]          = 0.554257;
    performanceMax[ 5 ][ 12 ]          =  1.15689;
    coeffPerformance[ 0 ][ 5 ][ 12 ]   = 0.793288;
    coeffPerformance[ 1 ][ 5 ][ 12 ]   = -6.13911;
    coeffPerformance[ 2 ][ 5 ][ 12 ]   = -1.30115;
    coeffPerformance[ 3 ][ 5 ][ 12 ]   = 0.580515;
    coeffPerformance[ 4 ][ 5 ][ 12 ]   =  14.6495;
    coeffPerformance[ 5 ][ 5 ][ 12 ]   =  6.53100;
    coeffPerformance[ 6 ][ 5 ][ 12 ]   = -3.41136;
    coeffPerformance[ 7 ][ 5 ][ 12 ]   = -.339000;
    coeffPerformance[ 8 ][ 5 ][ 12 ]   = -.215710;
    coeffPerformance[ 9 ][ 5 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 12 ]  =  0.00000;
    powerMin[ 5 ][ 12 ]                = 0.523214;
    powerMax[ 5 ][ 12 ]                = 0.982923;
    coeffPower[ 0 ][ 5 ][ 12 ]         = 0.733501;
    coeffPower[ 1 ][ 5 ][ 12 ]         = -.739217;
    coeffPower[ 2 ][ 5 ][ 12 ]         = -.503689E-01;
    coeffPower[ 3 ][ 5 ][ 12 ]         = 0.333867E-01;
    coeffPower[ 4 ][ 5 ][ 12 ]         =  1.75425;
    coeffPower[ 5 ][ 5 ][ 12 ]         =  1.93651;
    coeffPower[ 6 ][ 5 ][ 12 ]         = -.929267;
    coeffPower[ 7 ][ 5 ][ 12 ]         = -.149752;
    coeffPower[ 8 ][ 5 ][ 12 ]         = -.299721;
    coeffPower[ 9 ][ 5 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 12 ]        =  0.00000;
    energyMin[ 6 ][ 12 ]               = 0.618077;
    energyMax[ 6 ][ 12 ]               =  1.21547;
    coeffEnergy[ 0 ][ 6 ][ 12 ]        = 0.940457;
    coeffEnergy[ 1 ][ 6 ][ 12 ]        =  4.90093;
    coeffEnergy[ 2 ][ 6 ][ 12 ]        =  1.43045;
    coeffEnergy[ 3 ][ 6 ][ 12 ]        = -.617794;
    coeffEnergy[ 4 ][ 6 ][ 12 ]        = -11.7056;
    coeffEnergy[ 5 ][ 6 ][ 12 ]        = -4.52250;
    coeffEnergy[ 6 ][ 6 ][ 12 ]        =  2.63903;
    coeffEnergy[ 7 ][ 6 ][ 12 ]        = 0.267732;
    coeffEnergy[ 8 ][ 6 ][ 12 ]        = -.437571;
    coeffEnergy[ 9 ][ 6 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 12 ]       =  0.00000;
    performanceMin[ 6 ][ 12 ]          = 0.566768;
    performanceMax[ 6 ][ 12 ]          =  1.21098;
    coeffPerformance[ 0 ][ 6 ][ 12 ]   = 0.832227;
    coeffPerformance[ 1 ][ 6 ][ 12 ]   = -5.64131;
    coeffPerformance[ 2 ][ 6 ][ 12 ]   = -1.37278;
    coeffPerformance[ 3 ][ 6 ][ 12 ]   = 0.602459;
    coeffPerformance[ 4 ][ 6 ][ 12 ]   =  13.4613;
    coeffPerformance[ 5 ][ 6 ][ 12 ]   =  5.79780;
    coeffPerformance[ 6 ][ 6 ][ 12 ]   = -3.19958;
    coeffPerformance[ 7 ][ 6 ][ 12 ]   = -.469005;
    coeffPerformance[ 8 ][ 6 ][ 12 ]   = 0.166469;
    coeffPerformance[ 9 ][ 6 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 12 ]  =  0.00000;
    powerMin[ 6 ][ 12 ]                = 0.567789;
    powerMax[ 6 ][ 12 ]                =  1.00925;
    coeffPower[ 0 ][ 6 ][ 12 ]         = 0.773580;
    coeffPower[ 1 ][ 6 ][ 12 ]         = -1.13534;
    coeffPower[ 2 ][ 6 ][ 12 ]         = 0.180345E-01;
    coeffPower[ 3 ][ 6 ][ 12 ]         = 0.255339E-02;
    coeffPower[ 4 ][ 6 ][ 12 ]         =  2.70170;
    coeffPower[ 5 ][ 6 ][ 12 ]         =  1.51667;
    coeffPower[ 6 ][ 6 ][ 12 ]         = -.713904;
    coeffPower[ 7 ][ 6 ][ 12 ]         = -.149791;
    coeffPower[ 8 ][ 6 ][ 12 ]         = -.279652;
    coeffPower[ 9 ][ 6 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 12 ]        =  0.00000;
    energyMin[ 7 ][ 12 ]               = 0.658152;
    energyMax[ 7 ][ 12 ]               =  1.20694;
    coeffEnergy[ 0 ][ 7 ][ 12 ]        = 0.945829;
    coeffEnergy[ 1 ][ 7 ][ 12 ]        =  3.61039;
    coeffEnergy[ 2 ][ 7 ][ 12 ]        = 0.903603;
    coeffEnergy[ 3 ][ 7 ][ 12 ]        = -.395328;
    coeffEnergy[ 4 ][ 7 ][ 12 ]        = -8.62054;
    coeffEnergy[ 5 ][ 7 ][ 12 ]        = -3.62563;
    coeffEnergy[ 6 ][ 7 ][ 12 ]        =  1.96430;
    coeffEnergy[ 7 ][ 7 ][ 12 ]        = 0.112885;
    coeffEnergy[ 8 ][ 7 ][ 12 ]        = -.113859;
    coeffEnergy[ 9 ][ 7 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 12 ]       =  0.00000;
    performanceMin[ 7 ][ 12 ]          = 0.628619;
    performanceMax[ 7 ][ 12 ]          =  1.17601;
    coeffPerformance[ 0 ][ 7 ][ 12 ]   = 0.858620;
    coeffPerformance[ 1 ][ 7 ][ 12 ]   = -4.77901;
    coeffPerformance[ 2 ][ 7 ][ 12 ]   = -.970530;
    coeffPerformance[ 3 ][ 7 ][ 12 ]   = 0.432538;
    coeffPerformance[ 4 ][ 7 ][ 12 ]   =  11.4043;
    coeffPerformance[ 5 ][ 7 ][ 12 ]   =  4.77265;
    coeffPerformance[ 6 ][ 7 ][ 12 ]   = -2.43107;
    coeffPerformance[ 7 ][ 7 ][ 12 ]   = -.221014;
    coeffPerformance[ 8 ][ 7 ][ 12 ]   = -.222805;
    coeffPerformance[ 9 ][ 7 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 12 ]  =  0.00000;
    powerMin[ 7 ][ 12 ]                = 0.601101;
    powerMax[ 7 ][ 12 ]                =  1.03765;
    coeffPower[ 0 ][ 7 ][ 12 ]         = 0.806590;
    coeffPower[ 1 ][ 7 ][ 12 ]         = -1.31740;
    coeffPower[ 2 ][ 7 ][ 12 ]         = -.834056E-01;
    coeffPower[ 3 ][ 7 ][ 12 ]         = 0.446011E-01;
    coeffPower[ 4 ][ 7 ][ 12 ]         =  3.14007;
    coeffPower[ 5 ][ 7 ][ 12 ]         =  1.27148;
    coeffPower[ 6 ][ 7 ][ 12 ]         = -.562698;
    coeffPower[ 7 ][ 7 ][ 12 ]         = -.779011E-01;
    coeffPower[ 8 ][ 7 ][ 12 ]         = -.326053;
    coeffPower[ 9 ][ 7 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 12 ]        =  0.00000;
    energyMin[ 8 ][ 12 ]               = 0.671721;
    energyMax[ 8 ][ 12 ]               =  1.32340;
    coeffEnergy[ 0 ][ 8 ][ 12 ]        = 0.946048;
    coeffEnergy[ 1 ][ 8 ][ 12 ]        =  2.55179;
    coeffEnergy[ 2 ][ 8 ][ 12 ]        = 0.651514;
    coeffEnergy[ 3 ][ 8 ][ 12 ]        = -.285738;
    coeffEnergy[ 4 ][ 8 ][ 12 ]        = -6.08639;
    coeffEnergy[ 5 ][ 8 ][ 12 ]        = -2.88940;
    coeffEnergy[ 6 ][ 8 ][ 12 ]        =  1.59105;
    coeffEnergy[ 7 ][ 8 ][ 12 ]        = 0.911371E-01;
    coeffEnergy[ 8 ][ 8 ][ 12 ]        = -.676493E-01;
    coeffEnergy[ 9 ][ 8 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 12 ]       =  0.00000;
    performanceMin[ 8 ][ 12 ]          = 0.593681;
    performanceMax[ 8 ][ 12 ]          =  1.19040;
    coeffPerformance[ 0 ][ 8 ][ 12 ]   = 0.893309;
    coeffPerformance[ 1 ][ 8 ][ 12 ]   = -3.70916;
    coeffPerformance[ 2 ][ 8 ][ 12 ]   = -.737504;
    coeffPerformance[ 3 ][ 8 ][ 12 ]   = 0.329161;
    coeffPerformance[ 4 ][ 8 ][ 12 ]   =  8.84613;
    coeffPerformance[ 5 ][ 8 ][ 12 ]   =  3.80880;
    coeffPerformance[ 6 ][ 8 ][ 12 ]   = -1.95118;
    coeffPerformance[ 7 ][ 8 ][ 12 ]   = -.169163;
    coeffPerformance[ 8 ][ 8 ][ 12 ]   = -.180395;
    coeffPerformance[ 9 ][ 8 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 12 ]  =  0.00000;
    powerMin[ 8 ][ 12 ]                = 0.638108;
    powerMax[ 8 ][ 12 ]                =  1.06647;
    coeffPower[ 0 ][ 8 ][ 12 ]         = 0.843519;
    coeffPower[ 1 ][ 8 ][ 12 ]         = -1.15471;
    coeffPower[ 2 ][ 8 ][ 12 ]         = -.699420E-01;
    coeffPower[ 3 ][ 8 ][ 12 ]         = 0.365489E-01;
    coeffPower[ 4 ][ 8 ][ 12 ]         =  2.75220;
    coeffPower[ 5 ][ 8 ][ 12 ]         = 0.932455;
    coeffPower[ 6 ][ 8 ][ 12 ]         = -.383753;
    coeffPower[ 7 ][ 8 ][ 12 ]         = -.575344E-01;
    coeffPower[ 8 ][ 8 ][ 12 ]         = -.246713;
    coeffPower[ 9 ][ 8 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 12 ]        =  0.00000;
    energyMin[ 9 ][ 12 ]               = 0.691295;
    energyMax[ 9 ][ 12 ]               =  1.19266;
    coeffEnergy[ 0 ][ 9 ][ 12 ]        = 0.957775;
    coeffEnergy[ 1 ][ 9 ][ 12 ]        =  1.96473;
    coeffEnergy[ 2 ][ 9 ][ 12 ]        = 0.652334;
    coeffEnergy[ 3 ][ 9 ][ 12 ]        = -.283481;
    coeffEnergy[ 4 ][ 9 ][ 12 ]        = -4.68879;
    coeffEnergy[ 5 ][ 9 ][ 12 ]        = -2.17175;
    coeffEnergy[ 6 ][ 9 ][ 12 ]        =  1.19914;
    coeffEnergy[ 7 ][ 9 ][ 12 ]        = 0.112855;
    coeffEnergy[ 8 ][ 9 ][ 12 ]        = -.483461E-01;
    coeffEnergy[ 9 ][ 9 ][ 12 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 12 ]       =  0.00000;
    performanceMin[ 9 ][ 12 ]          = 0.685088;
    performanceMax[ 9 ][ 12 ]          =  1.19456;
    coeffPerformance[ 0 ][ 9 ][ 12 ]   = 0.912294;
    coeffPerformance[ 1 ][ 9 ][ 12 ]   = -2.88617;
    coeffPerformance[ 2 ][ 9 ][ 12 ]   = -.652642;
    coeffPerformance[ 3 ][ 9 ][ 12 ]   = 0.290751;
    coeffPerformance[ 4 ][ 9 ][ 12 ]   =  6.88828;
    coeffPerformance[ 5 ][ 9 ][ 12 ]   =  3.17306;
    coeffPerformance[ 6 ][ 9 ][ 12 ]   = -1.66713;
    coeffPerformance[ 7 ][ 9 ][ 12 ]   = -.139321;
    coeffPerformance[ 8 ][ 9 ][ 12 ]   = -.153832;
    coeffPerformance[ 9 ][ 9 ][ 12 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 12 ]  =  0.00000;
    powerMin[ 9 ][ 12 ]                = 0.672624;
    powerMax[ 9 ][ 12 ]                =  1.09730;
    coeffPower[ 0 ][ 9 ][ 12 ]         = 0.872085;
    coeffPower[ 1 ][ 9 ][ 12 ]         = -.927377;
    coeffPower[ 2 ][ 9 ][ 12 ]         = 0.395609E-02;
    coeffPower[ 3 ][ 9 ][ 12 ]         = 0.533016E-02;
    coeffPower[ 4 ][ 9 ][ 12 ]         =  2.21372;
    coeffPower[ 5 ][ 9 ][ 12 ]         =  1.00170;
    coeffPower[ 6 ][ 9 ][ 12 ]         = -.478242;
    coeffPower[ 7 ][ 9 ][ 12 ]         = -.229903E-01;
    coeffPower[ 8 ][ 9 ][ 12 ]         = -.190223;
    coeffPower[ 9 ][ 9 ][ 12 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 12 ]        =  0.00000;
    energyMin[ 10 ][ 12 ]              = 0.725431;
    energyMax[ 10 ][ 12 ]              =  1.24525;
    coeffEnergy[ 0 ][ 10 ][ 12 ]       = 0.969933;
    coeffEnergy[ 1 ][ 10 ][ 12 ]       =  1.29308;
    coeffEnergy[ 2 ][ 10 ][ 12 ]       = 0.545785;
    coeffEnergy[ 3 ][ 10 ][ 12 ]       = -.237102;
    coeffEnergy[ 4 ][ 10 ][ 12 ]       = -3.08504;
    coeffEnergy[ 5 ][ 10 ][ 12 ]       = -1.57235;
    coeffEnergy[ 6 ][ 10 ][ 12 ]       = 0.852331;
    coeffEnergy[ 7 ][ 10 ][ 12 ]       = 0.872871E-01;
    coeffEnergy[ 8 ][ 10 ][ 12 ]       = 0.448331E-01;
    coeffEnergy[ 9 ][ 10 ][ 12 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 12 ]      =  0.00000;
    performanceMin[ 10 ][ 12 ]         = 0.699187;
    performanceMax[ 10 ][ 12 ]         =  1.20907;
    coeffPerformance[ 0 ][ 10 ][ 12 ]  = 0.942766;
    coeffPerformance[ 1 ][ 10 ][ 12 ]  = -1.81851;
    coeffPerformance[ 2 ][ 10 ][ 12 ]  = -.505707;
    coeffPerformance[ 3 ][ 10 ][ 12 ]  = 0.224698;
    coeffPerformance[ 4 ][ 10 ][ 12 ]  =  4.33815;
    coeffPerformance[ 5 ][ 10 ][ 12 ]  =  2.27000;
    coeffPerformance[ 6 ][ 10 ][ 12 ]  = -1.19485;
    coeffPerformance[ 7 ][ 10 ][ 12 ]  = -.972820E-01;
    coeffPerformance[ 8 ][ 10 ][ 12 ]  = -.152953;
    coeffPerformance[ 9 ][ 10 ][ 12 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 12 ] =  0.00000;
    powerMin[ 10 ][ 12 ]               = 0.713572;
    powerMax[ 10 ][ 12 ]               =  1.12837;
    coeffPower[ 0 ][ 10 ][ 12 ]        = 0.912952;
    coeffPower[ 1 ][ 10 ][ 12 ]        = -.509281;
    coeffPower[ 2 ][ 10 ][ 12 ]        = 0.568691E-01;
    coeffPower[ 3 ][ 10 ][ 12 ]        = -.193062E-01;
    coeffPower[ 4 ][ 10 ][ 12 ]        =  1.21472;
    coeffPower[ 5 ][ 10 ][ 12 ]        = 0.707345;
    coeffPower[ 6 ][ 10 ][ 12 ]        = -.343613;
    coeffPower[ 7 ][ 10 ][ 12 ]        = -.226341E-02;
    coeffPower[ 8 ][ 10 ][ 12 ]        = -.118005;
    coeffPower[ 9 ][ 10 ][ 12 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 12 ]       =  0.00000;
    energyMin[ 11 ][ 12 ]              = 0.761420;
    energyMax[ 11 ][ 12 ]              =  1.25045;
    coeffEnergy[ 0 ][ 11 ][ 12 ]       = 0.981743;
    coeffEnergy[ 1 ][ 11 ][ 12 ]       = 0.212903;
    coeffEnergy[ 2 ][ 11 ][ 12 ]       = 0.167608;
    coeffEnergy[ 3 ][ 11 ][ 12 ]       = -.745049E-01;
    coeffEnergy[ 4 ][ 11 ][ 12 ]       = -.502810;
    coeffEnergy[ 5 ][ 11 ][ 12 ]       = -.778166;
    coeffEnergy[ 6 ][ 11 ][ 12 ]       = 0.395010;
    coeffEnergy[ 7 ][ 11 ][ 12 ]       = 0.216061E-01;
    coeffEnergy[ 8 ][ 11 ][ 12 ]       = 0.983947E-01;
    coeffEnergy[ 9 ][ 11 ][ 12 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 12 ]      =  0.00000;
    performanceMin[ 11 ][ 12 ]         = 0.750661;
    performanceMax[ 11 ][ 12 ]         =  1.20891;
    coeffPerformance[ 0 ][ 11 ][ 12 ]  = 0.970520;
    coeffPerformance[ 1 ][ 11 ][ 12 ]  = -.660878;
    coeffPerformance[ 2 ][ 11 ][ 12 ]  = -.185224;
    coeffPerformance[ 3 ][ 11 ][ 12 ]  = 0.847785E-01;
    coeffPerformance[ 4 ][ 11 ][ 12 ]  =  1.57452;
    coeffPerformance[ 5 ][ 11 ][ 12 ]  =  1.18570;
    coeffPerformance[ 6 ][ 11 ][ 12 ]  = -.581492;
    coeffPerformance[ 7 ][ 11 ][ 12 ]  = -.100244E-02;
    coeffPerformance[ 8 ][ 11 ][ 12 ]  = -.158290;
    coeffPerformance[ 9 ][ 11 ][ 12 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 12 ] =  0.00000;
    powerMin[ 11 ][ 12 ]               = 0.756047;
    powerMax[ 11 ][ 12 ]               =  1.17913;
    coeffPower[ 0 ][ 11 ][ 12 ]        = 0.952655;
    coeffPower[ 1 ][ 11 ][ 12 ]        = -.417073;
    coeffPower[ 2 ][ 11 ][ 12 ]        = -.105589E-01;
    coeffPower[ 3 ][ 11 ][ 12 ]        = 0.729397E-02;
    coeffPower[ 4 ][ 11 ][ 12 ]        = 0.997655;
    coeffPower[ 5 ][ 11 ][ 12 ]        = 0.406827;
    coeffPower[ 6 ][ 11 ][ 12 ]        = -.186518;
    coeffPower[ 7 ][ 11 ][ 12 ]        = 0.198377E-01;
    coeffPower[ 8 ][ 11 ][ 12 ]        = -.599357E-01;
    coeffPower[ 9 ][ 11 ][ 12 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 12 ]       =  0.00000;
    energyMin[ 12 ][ 12 ]              = 0.800000;
    energyMax[ 12 ][ 12 ]              =  1.20000;
    coeffEnergy[ 0 ][ 12 ][ 12 ]       =  1.00000;
    coeffEnergy[ 1 ][ 12 ][ 12 ]       = 0.215973E-14;
    coeffEnergy[ 2 ][ 12 ][ 12 ]       = 0.674202E-14;
    coeffEnergy[ 3 ][ 12 ][ 12 ]       = -.272147E-14;
    coeffEnergy[ 4 ][ 12 ][ 12 ]       = -.505901E-14;
    coeffEnergy[ 5 ][ 12 ][ 12 ]       = -.810559E-14;
    coeffEnergy[ 6 ][ 12 ][ 12 ]       = 0.650777E-14;
    coeffEnergy[ 7 ][ 12 ][ 12 ]       = 0.648508E-14;
    coeffEnergy[ 8 ][ 12 ][ 12 ]       = -.842757E-14;
    coeffEnergy[ 9 ][ 12 ][ 12 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 12 ]      =  0.00000;
    performanceMin[ 12 ][ 12 ]         = 0.800000;
    performanceMax[ 12 ][ 12 ]         =  1.20000;
    coeffPerformance[ 0 ][ 12 ][ 12 ]  =  1.00000;
    coeffPerformance[ 1 ][ 12 ][ 12 ]  = -.169693E-11;
    coeffPerformance[ 2 ][ 12 ][ 12 ]  = -.350263E-12;
    coeffPerformance[ 3 ][ 12 ][ 12 ]  = 0.142354E-12;
    coeffPerformance[ 4 ][ 12 ][ 12 ]  = 0.405906E-11;
    coeffPerformance[ 5 ][ 12 ][ 12 ]  = -.312078E-12;
    coeffPerformance[ 6 ][ 12 ][ 12 ]  = 0.192045E-12;
    coeffPerformance[ 7 ][ 12 ][ 12 ]  = -.152636E-12;
    coeffPerformance[ 8 ][ 12 ][ 12 ]  = 0.229802E-12;
    coeffPerformance[ 9 ][ 12 ][ 12 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 12 ] =  0.00000;
    powerMin[ 12 ][ 12 ]               = 0.800000;
    powerMax[ 12 ][ 12 ]               =  1.20000;
    coeffPower[ 0 ][ 12 ][ 12 ]        =  1.00000;
    coeffPower[ 1 ][ 12 ][ 12 ]        = -.148479E-12;
    coeffPower[ 2 ][ 12 ][ 12 ]        = -.225243E-12;
    coeffPower[ 3 ][ 12 ][ 12 ]        = 0.930347E-13;
    coeffPower[ 4 ][ 12 ][ 12 ]        = 0.353124E-12;
    coeffPower[ 5 ][ 12 ][ 12 ]        = -.609197E-12;
    coeffPower[ 6 ][ 12 ][ 12 ]        = 0.369829E-12;
    coeffPower[ 7 ][ 12 ][ 12 ]        = 0.657658E-14;
    coeffPower[ 8 ][ 12 ][ 12 ]        = -.312923E-13;
    coeffPower[ 9 ][ 12 ][ 12 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 12 ]       =  0.00000;
    energyMin[ 13 ][ 12 ]              = 0.779976;
    energyMax[ 13 ][ 12 ]              =  1.28829;
    coeffEnergy[ 0 ][ 13 ][ 12 ]       =  1.00703;
    coeffEnergy[ 1 ][ 13 ][ 12 ]       = -.844602;
    coeffEnergy[ 2 ][ 13 ][ 12 ]       = 0.103168;
    coeffEnergy[ 3 ][ 13 ][ 12 ]       = -.384792E-01;
    coeffEnergy[ 4 ][ 13 ][ 12 ]       =  2.02202;
    coeffEnergy[ 5 ][ 13 ][ 12 ]       = 0.779313;
    coeffEnergy[ 6 ][ 13 ][ 12 ]       = -.375551;
    coeffEnergy[ 7 ][ 13 ][ 12 ]       = 0.709056E-01;
    coeffEnergy[ 8 ][ 13 ][ 12 ]       = -.600962E-01;
    coeffEnergy[ 9 ][ 13 ][ 12 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 12 ]      =  0.00000;
    performanceMin[ 13 ][ 12 ]         = 0.797268;
    performanceMax[ 13 ][ 12 ]         =  1.29772;
    coeffPerformance[ 0 ][ 13 ][ 12 ]  =  1.03153;
    coeffPerformance[ 1 ][ 13 ][ 12 ]  = 0.660295;
    coeffPerformance[ 2 ][ 13 ][ 12 ]  = -.179086;
    coeffPerformance[ 3 ][ 13 ][ 12 ]  = 0.688222E-01;
    coeffPerformance[ 4 ][ 13 ][ 12 ]  = -1.57506;
    coeffPerformance[ 5 ][ 13 ][ 12 ]  = -1.16227;
    coeffPerformance[ 6 ][ 13 ][ 12 ]  = 0.522578;
    coeffPerformance[ 7 ][ 13 ][ 12 ]  = -.378090E-01;
    coeffPerformance[ 8 ][ 13 ][ 12 ]  = 0.141887;
    coeffPerformance[ 9 ][ 13 ][ 12 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 12 ] =  0.00000;
    powerMin[ 13 ][ 12 ]               = 0.825359;
    powerMax[ 13 ][ 12 ]               =  1.30165;
    coeffPower[ 0 ][ 13 ][ 12 ]        =  1.03846;
    coeffPower[ 1 ][ 13 ][ 12 ]        = -.166513;
    coeffPower[ 2 ][ 13 ][ 12 ]        = -.719214E-01;
    coeffPower[ 3 ][ 13 ][ 12 ]        = 0.287252E-01;
    coeffPower[ 4 ][ 13 ][ 12 ]        = 0.404546;
    coeffPower[ 5 ][ 13 ][ 12 ]        = -.375538;
    coeffPower[ 6 ][ 13 ][ 12 ]        = 0.141813;
    coeffPower[ 7 ][ 13 ][ 12 ]        = 0.354784E-01;
    coeffPower[ 8 ][ 13 ][ 12 ]        = 0.808654E-01;
    coeffPower[ 9 ][ 13 ][ 12 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 12 ]       =  0.00000;
    energyMin[ 14 ][ 12 ]              = 0.807769;
    energyMax[ 14 ][ 12 ]              =  1.33532;
    coeffEnergy[ 0 ][ 14 ][ 12 ]       =  1.02102;
    coeffEnergy[ 1 ][ 14 ][ 12 ]       = -1.45640;
    coeffEnergy[ 2 ][ 14 ][ 12 ]       = -.118892E-01;
    coeffEnergy[ 3 ][ 14 ][ 12 ]       = 0.157800E-01;
    coeffEnergy[ 4 ][ 14 ][ 12 ]       =  3.48497;
    coeffEnergy[ 5 ][ 14 ][ 12 ]       =  1.71326;
    coeffEnergy[ 6 ][ 14 ][ 12 ]       = -.896787;
    coeffEnergy[ 7 ][ 14 ][ 12 ]       = 0.743850E-01;
    coeffEnergy[ 8 ][ 14 ][ 12 ]       = -.155765;
    coeffEnergy[ 9 ][ 14 ][ 12 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 12 ]      =  0.00000;
    performanceMin[ 14 ][ 12 ]         = 0.794222;
    performanceMax[ 14 ][ 12 ]         =  1.31368;
    coeffPerformance[ 0 ][ 14 ][ 12 ]  =  1.06354;
    coeffPerformance[ 1 ][ 14 ][ 12 ]  =  1.86822;
    coeffPerformance[ 2 ][ 14 ][ 12 ]  = -.379662E-01;
    coeffPerformance[ 3 ][ 14 ][ 12 ]  = 0.290130E-02;
    coeffPerformance[ 4 ][ 14 ][ 12 ]  = -4.46137;
    coeffPerformance[ 5 ][ 14 ][ 12 ]  = -2.34281;
    coeffPerformance[ 6 ][ 14 ][ 12 ]  =  1.13612;
    coeffPerformance[ 7 ][ 14 ][ 12 ]  = -.105666E-02;
    coeffPerformance[ 8 ][ 14 ][ 12 ]  = 0.220228;
    coeffPerformance[ 9 ][ 14 ][ 12 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 12 ] =  0.00000;
    powerMin[ 14 ][ 12 ]               = 0.851334;
    powerMax[ 14 ][ 12 ]               =  1.35747;
    coeffPower[ 0 ][ 14 ][ 12 ]        =  1.08551;
    coeffPower[ 1 ][ 14 ][ 12 ]        = 0.417038;
    coeffPower[ 2 ][ 14 ][ 12 ]        = -.601922E-01;
    coeffPower[ 3 ][ 14 ][ 12 ]        = 0.228827E-01;
    coeffPower[ 4 ][ 14 ][ 12 ]        = -.988488;
    coeffPower[ 5 ][ 14 ][ 12 ]        = -.652737;
    coeffPower[ 6 ][ 14 ][ 12 ]        = 0.245522;
    coeffPower[ 7 ][ 14 ][ 12 ]        = 0.764172E-01;
    coeffPower[ 8 ][ 14 ][ 12 ]        = 0.707104E-01;
    coeffPower[ 9 ][ 14 ][ 12 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 12 ]       =  0.00000;
    energyMin[ 15 ][ 12 ]              = 0.747409;
    energyMax[ 15 ][ 12 ]              =  1.38671;
    coeffEnergy[ 0 ][ 15 ][ 12 ]       =  1.03370;
    coeffEnergy[ 1 ][ 15 ][ 12 ]       = -2.14865;
    coeffEnergy[ 2 ][ 15 ][ 12 ]       = -.335214;
    coeffEnergy[ 3 ][ 15 ][ 12 ]       = 0.158302;
    coeffEnergy[ 4 ][ 15 ][ 12 ]       =  5.14023;
    coeffEnergy[ 5 ][ 15 ][ 12 ]       =  2.55206;
    coeffEnergy[ 6 ][ 15 ][ 12 ]       = -1.26911;
    coeffEnergy[ 7 ][ 15 ][ 12 ]       = 0.135769;
    coeffEnergy[ 8 ][ 15 ][ 12 ]       = -.359177;
    coeffEnergy[ 9 ][ 15 ][ 12 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 12 ]      =  0.00000;
    performanceMin[ 15 ][ 12 ]         = 0.799381;
    performanceMax[ 15 ][ 12 ]         =  1.50473;
    coeffPerformance[ 0 ][ 15 ][ 12 ]  =  1.09578;
    coeffPerformance[ 1 ][ 15 ][ 12 ]  =  2.02014;
    coeffPerformance[ 2 ][ 15 ][ 12 ]  = 0.853003E-01;
    coeffPerformance[ 3 ][ 15 ][ 12 ]  = -.575491E-01;
    coeffPerformance[ 4 ][ 15 ][ 12 ]  = -4.81750;
    coeffPerformance[ 5 ][ 15 ][ 12 ]  = -3.74726;
    coeffPerformance[ 6 ][ 15 ][ 12 ]  =  1.85636;
    coeffPerformance[ 7 ][ 15 ][ 12 ]  = -.699728E-02;
    coeffPerformance[ 8 ][ 15 ][ 12 ]  = 0.391733;
    coeffPerformance[ 9 ][ 15 ][ 12 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 12 ] =  0.00000;
    powerMin[ 15 ][ 12 ]               = 0.879121;
    powerMax[ 15 ][ 12 ]               =  1.46725;
    coeffPower[ 0 ][ 15 ][ 12 ]        =  1.13029;
    coeffPower[ 1 ][ 15 ][ 12 ]        = 0.429634E-01;
    coeffPower[ 2 ][ 15 ][ 12 ]        = -.224191;
    coeffPower[ 3 ][ 15 ][ 12 ]        = 0.901618E-01;
    coeffPower[ 4 ][ 15 ][ 12 ]        = -.862444E-01;
    coeffPower[ 5 ][ 15 ][ 12 ]        = -1.17450;
    coeffPower[ 6 ][ 15 ][ 12 ]        = 0.566205;
    coeffPower[ 7 ][ 15 ][ 12 ]        = 0.144143;
    coeffPower[ 8 ][ 15 ][ 12 ]        = 0.268773E-01;
    coeffPower[ 9 ][ 15 ][ 12 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 12 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 2.50;
    energyMin[ 0 ][ 13 ]               = 0.527092;
    energyMax[ 0 ][ 13 ]               =  1.39661;
    coeffEnergy[ 0 ][ 0 ][ 13 ]        =  1.06423;
    coeffEnergy[ 1 ][ 0 ][ 13 ]        =  12.1989;
    coeffEnergy[ 2 ][ 0 ][ 13 ]        =  1.54279;
    coeffEnergy[ 3 ][ 0 ][ 13 ]        = -.679734;
    coeffEnergy[ 4 ][ 0 ][ 13 ]        = -30.3940;
    coeffEnergy[ 5 ][ 0 ][ 13 ]        = -11.5324;
    coeffEnergy[ 6 ][ 0 ][ 13 ]        =  5.54960;
    coeffEnergy[ 7 ][ 0 ][ 13 ]        = -.193284;
    coeffEnergy[ 8 ][ 0 ][ 13 ]        = 0.386525;
    coeffEnergy[ 9 ][ 0 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 13 ]       =  0.00000;
    performanceMin[ 0 ][ 13 ]          = 0.380702;
    performanceMax[ 0 ][ 13 ]          =  1.03042;
    coeffPerformance[ 0 ][ 0 ][ 13 ]   = 0.531804;
    coeffPerformance[ 1 ][ 0 ][ 13 ]   = -3.08193;
    coeffPerformance[ 2 ][ 0 ][ 13 ]   = -1.01061;
    coeffPerformance[ 3 ][ 0 ][ 13 ]   = 0.467716;
    coeffPerformance[ 4 ][ 0 ][ 13 ]   =  7.64653;
    coeffPerformance[ 5 ][ 0 ][ 13 ]   =  10.4918;
    coeffPerformance[ 6 ][ 0 ][ 13 ]   = -5.44513;
    coeffPerformance[ 7 ][ 0 ][ 13 ]   = -.168327;
    coeffPerformance[ 8 ][ 0 ][ 13 ]   = -.688871;
    coeffPerformance[ 9 ][ 0 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 13 ]  =  0.00000;
    powerMin[ 0 ][ 13 ]                = 0.352131;
    powerMax[ 0 ][ 13 ]                = 0.804322;
    coeffPower[ 0 ][ 0 ][ 13 ]         = 0.556936;
    coeffPower[ 1 ][ 0 ][ 13 ]         =  3.35771;
    coeffPower[ 2 ][ 0 ][ 13 ]         = -.398757;
    coeffPower[ 3 ][ 0 ][ 13 ]         = 0.178695;
    coeffPower[ 4 ][ 0 ][ 13 ]         = -8.39293;
    coeffPower[ 5 ][ 0 ][ 13 ]         =  2.05037;
    coeffPower[ 6 ][ 0 ][ 13 ]         = -1.51667;
    coeffPower[ 7 ][ 0 ][ 13 ]         = -.222587;
    coeffPower[ 8 ][ 0 ][ 13 ]         = -.324096;
    coeffPower[ 9 ][ 0 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 13 ]        =  0.00000;
    energyMin[ 1 ][ 13 ]               = 0.539737;
    energyMax[ 1 ][ 13 ]               =  1.33072;
    coeffEnergy[ 0 ][ 1 ][ 13 ]        =  1.05776;
    coeffEnergy[ 1 ][ 1 ][ 13 ]        =  8.96929;
    coeffEnergy[ 2 ][ 1 ][ 13 ]        =  1.21821;
    coeffEnergy[ 3 ][ 1 ][ 13 ]        = -.550663;
    coeffEnergy[ 4 ][ 1 ][ 13 ]        = -22.3514;
    coeffEnergy[ 5 ][ 1 ][ 13 ]        = -10.5601;
    coeffEnergy[ 6 ][ 1 ][ 13 ]        =  5.12085;
    coeffEnergy[ 7 ][ 1 ][ 13 ]        = -.346673;
    coeffEnergy[ 8 ][ 1 ][ 13 ]        = 0.655861;
    coeffEnergy[ 9 ][ 1 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 13 ]       =  0.00000;
    performanceMin[ 1 ][ 13 ]          = 0.407486;
    performanceMax[ 1 ][ 13 ]          =  1.07241;
    coeffPerformance[ 0 ][ 1 ][ 13 ]   = 0.573694;
    coeffPerformance[ 1 ][ 1 ][ 13 ]   = -3.64601;
    coeffPerformance[ 2 ][ 1 ][ 13 ]   = -1.17851;
    coeffPerformance[ 3 ][ 1 ][ 13 ]   = 0.535410;
    coeffPerformance[ 4 ][ 1 ][ 13 ]   =  9.05238;
    coeffPerformance[ 5 ][ 1 ][ 13 ]   =  10.1379;
    coeffPerformance[ 6 ][ 1 ][ 13 ]   = -5.02576;
    coeffPerformance[ 7 ][ 1 ][ 13 ]   = -.767922E-01;
    coeffPerformance[ 8 ][ 1 ][ 13 ]   = -.905823;
    coeffPerformance[ 9 ][ 1 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 13 ]  =  0.00000;
    powerMin[ 1 ][ 13 ]                = 0.390167;
    powerMax[ 1 ][ 13 ]                = 0.859061;
    coeffPower[ 0 ][ 1 ][ 13 ]         = 0.602689;
    coeffPower[ 1 ][ 1 ][ 13 ]         =  1.44380;
    coeffPower[ 2 ][ 1 ][ 13 ]         = -.590620;
    coeffPower[ 3 ][ 1 ][ 13 ]         = 0.251215;
    coeffPower[ 4 ][ 1 ][ 13 ]         = -3.62737;
    coeffPower[ 5 ][ 1 ][ 13 ]         =  1.88942;
    coeffPower[ 6 ][ 1 ][ 13 ]         = -1.19919;
    coeffPower[ 7 ][ 1 ][ 13 ]         = -.284825;
    coeffPower[ 8 ][ 1 ][ 13 ]         = -.264615;
    coeffPower[ 9 ][ 1 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 13 ]        =  0.00000;
    energyMin[ 2 ][ 13 ]               = 0.553144;
    energyMax[ 2 ][ 13 ]               =  1.29242;
    coeffEnergy[ 0 ][ 2 ][ 13 ]        =  1.02390;
    coeffEnergy[ 1 ][ 2 ][ 13 ]        =  8.66633;
    coeffEnergy[ 2 ][ 2 ][ 13 ]        =  1.50285;
    coeffEnergy[ 3 ][ 2 ][ 13 ]        = -.659038;
    coeffEnergy[ 4 ][ 2 ][ 13 ]        = -21.5941;
    coeffEnergy[ 5 ][ 2 ][ 13 ]        = -9.09695;
    coeffEnergy[ 6 ][ 2 ][ 13 ]        =  4.70381;
    coeffEnergy[ 7 ][ 2 ][ 13 ]        = -.261771;
    coeffEnergy[ 8 ][ 2 ][ 13 ]        = 0.513906;
    coeffEnergy[ 9 ][ 2 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 13 ]       =  0.00000;
    performanceMin[ 2 ][ 13 ]          = 0.442318;
    performanceMax[ 2 ][ 13 ]          =  1.09696;
    coeffPerformance[ 0 ][ 2 ][ 13 ]   = 0.621855;
    coeffPerformance[ 1 ][ 2 ][ 13 ]   = -4.71093;
    coeffPerformance[ 2 ][ 2 ][ 13 ]   = -1.37360;
    coeffPerformance[ 3 ][ 2 ][ 13 ]   = 0.609886;
    coeffPerformance[ 4 ][ 2 ][ 13 ]   =  11.7060;
    coeffPerformance[ 5 ][ 2 ][ 13 ]   =  9.59053;
    coeffPerformance[ 6 ][ 2 ][ 13 ]   = -4.77861;
    coeffPerformance[ 7 ][ 2 ][ 13 ]   = -.136630;
    coeffPerformance[ 8 ][ 2 ][ 13 ]   = -.776184;
    coeffPerformance[ 9 ][ 2 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 13 ]  =  0.00000;
    powerMin[ 2 ][ 13 ]                = 0.410577;
    powerMax[ 2 ][ 13 ]                = 0.882873;
    coeffPower[ 0 ][ 2 ][ 13 ]         = 0.629123;
    coeffPower[ 1 ][ 2 ][ 13 ]         =  1.00978;
    coeffPower[ 2 ][ 2 ][ 13 ]         = -.383337;
    coeffPower[ 3 ][ 2 ][ 13 ]         = 0.166210;
    coeffPower[ 4 ][ 2 ][ 13 ]         = -2.54363;
    coeffPower[ 5 ][ 2 ][ 13 ]         =  2.10076;
    coeffPower[ 6 ][ 2 ][ 13 ]         = -1.05935;
    coeffPower[ 7 ][ 2 ][ 13 ]         = -.283343;
    coeffPower[ 8 ][ 2 ][ 13 ]         = -.245681;
    coeffPower[ 9 ][ 2 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 13 ]        =  0.00000;
    energyMin[ 3 ][ 13 ]               = 0.557408;
    energyMax[ 3 ][ 13 ]               =  1.28944;
    coeffEnergy[ 0 ][ 3 ][ 13 ]        = 0.981542;
    coeffEnergy[ 1 ][ 3 ][ 13 ]        =  8.78806;
    coeffEnergy[ 2 ][ 3 ][ 13 ]        =  1.93278;
    coeffEnergy[ 3 ][ 3 ][ 13 ]        = -.820255;
    coeffEnergy[ 4 ][ 3 ][ 13 ]        = -21.8889;
    coeffEnergy[ 5 ][ 3 ][ 13 ]        = -7.85779;
    coeffEnergy[ 6 ][ 3 ][ 13 ]        =  4.33703;
    coeffEnergy[ 7 ][ 3 ][ 13 ]        = -.279582E-02;
    coeffEnergy[ 8 ][ 3 ][ 13 ]        = 0.176322E-01;
    coeffEnergy[ 9 ][ 3 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 13 ]       =  0.00000;
    performanceMin[ 3 ][ 13 ]          = 0.451499;
    performanceMax[ 3 ][ 13 ]          =  1.12538;
    coeffPerformance[ 0 ][ 3 ][ 13 ]   = 0.675134;
    coeffPerformance[ 1 ][ 3 ][ 13 ]   = -5.39158;
    coeffPerformance[ 2 ][ 3 ][ 13 ]   = -1.55399;
    coeffPerformance[ 3 ][ 3 ][ 13 ]   = 0.674997;
    coeffPerformance[ 4 ][ 3 ][ 13 ]   =  13.3983;
    coeffPerformance[ 5 ][ 3 ][ 13 ]   =  8.85632;
    coeffPerformance[ 6 ][ 3 ][ 13 ]   = -4.53551;
    coeffPerformance[ 7 ][ 3 ][ 13 ]   = -.283740;
    coeffPerformance[ 8 ][ 3 ][ 13 ]   = -.421212;
    coeffPerformance[ 9 ][ 3 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 13 ]  =  0.00000;
    powerMin[ 3 ][ 13 ]                = 0.433934;
    powerMax[ 3 ][ 13 ]                = 0.902425;
    coeffPower[ 0 ][ 3 ][ 13 ]         = 0.651594;
    coeffPower[ 1 ][ 3 ][ 13 ]         =  1.11820;
    coeffPower[ 2 ][ 3 ][ 13 ]         = -.363085E-01;
    coeffPower[ 3 ][ 3 ][ 13 ]         = 0.270320E-01;
    coeffPower[ 4 ][ 3 ][ 13 ]         = -2.81122;
    coeffPower[ 5 ][ 3 ][ 13 ]         =  2.04542;
    coeffPower[ 6 ][ 3 ][ 13 ]         = -.898656;
    coeffPower[ 7 ][ 3 ][ 13 ]         = -.209972;
    coeffPower[ 8 ][ 3 ][ 13 ]         = -.336327;
    coeffPower[ 9 ][ 3 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 13 ]        =  0.00000;
    energyMin[ 4 ][ 13 ]               = 0.565181;
    energyMax[ 4 ][ 13 ]               =  1.23573;
    coeffEnergy[ 0 ][ 4 ][ 13 ]        = 0.964587;
    coeffEnergy[ 1 ][ 4 ][ 13 ]        =  8.22447;
    coeffEnergy[ 2 ][ 4 ][ 13 ]        =  1.55261;
    coeffEnergy[ 3 ][ 4 ][ 13 ]        = -.661251;
    coeffEnergy[ 4 ][ 4 ][ 13 ]        = -20.4865;
    coeffEnergy[ 5 ][ 4 ][ 13 ]        = -6.51579;
    coeffEnergy[ 6 ][ 4 ][ 13 ]        =  3.50414;
    coeffEnergy[ 7 ][ 4 ][ 13 ]        = 0.312032E-02;
    coeffEnergy[ 8 ][ 4 ][ 13 ]        = 0.594324E-01;
    coeffEnergy[ 9 ][ 4 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 13 ]       =  0.00000;
    performanceMin[ 4 ][ 13 ]          = 0.500383;
    performanceMax[ 4 ][ 13 ]          =  1.14186;
    coeffPerformance[ 0 ][ 4 ][ 13 ]   = 0.707507;
    coeffPerformance[ 1 ][ 4 ][ 13 ]   = -5.68549;
    coeffPerformance[ 2 ][ 4 ][ 13 ]   = -1.46932;
    coeffPerformance[ 3 ][ 4 ][ 13 ]   = 0.640271;
    coeffPerformance[ 4 ][ 4 ][ 13 ]   =  14.1364;
    coeffPerformance[ 5 ][ 4 ][ 13 ]   =  8.33484;
    coeffPerformance[ 6 ][ 4 ][ 13 ]   = -4.20753;
    coeffPerformance[ 7 ][ 4 ][ 13 ]   = -.172823;
    coeffPerformance[ 8 ][ 4 ][ 13 ]   = -.599080;
    coeffPerformance[ 9 ][ 4 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 13 ]  =  0.00000;
    powerMin[ 4 ][ 13 ]                = 0.466555;
    powerMax[ 4 ][ 13 ]                = 0.928546;
    coeffPower[ 0 ][ 4 ][ 13 ]         = 0.670928;
    coeffPower[ 1 ][ 4 ][ 13 ]         = 0.902543;
    coeffPower[ 2 ][ 4 ][ 13 ]         = -.206937;
    coeffPower[ 3 ][ 4 ][ 13 ]         = 0.985689E-01;
    coeffPower[ 4 ][ 4 ][ 13 ]         = -2.26890;
    coeffPower[ 5 ][ 4 ][ 13 ]         =  2.44075;
    coeffPower[ 6 ][ 4 ][ 13 ]         = -1.15378;
    coeffPower[ 7 ][ 4 ][ 13 ]         = -.122734;
    coeffPower[ 8 ][ 4 ][ 13 ]         = -.438465;
    coeffPower[ 9 ][ 4 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 13 ]        =  0.00000;
    energyMin[ 5 ][ 13 ]               = 0.598643;
    energyMax[ 5 ][ 13 ]               =  1.21116;
    coeffEnergy[ 0 ][ 5 ][ 13 ]        = 0.955365;
    coeffEnergy[ 1 ][ 5 ][ 13 ]        =  7.39085;
    coeffEnergy[ 2 ][ 5 ][ 13 ]        =  1.45936;
    coeffEnergy[ 3 ][ 5 ][ 13 ]        = -.616217;
    coeffEnergy[ 4 ][ 5 ][ 13 ]        = -18.4106;
    coeffEnergy[ 5 ][ 5 ][ 13 ]        = -5.57696;
    coeffEnergy[ 6 ][ 5 ][ 13 ]        =  3.04068;
    coeffEnergy[ 7 ][ 5 ][ 13 ]        = 0.112319;
    coeffEnergy[ 8 ][ 5 ][ 13 ]        = -.190480;
    coeffEnergy[ 9 ][ 5 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 13 ]       =  0.00000;
    performanceMin[ 5 ][ 13 ]          = 0.531294;
    performanceMax[ 5 ][ 13 ]          =  1.15300;
    coeffPerformance[ 0 ][ 5 ][ 13 ]   = 0.752294;
    coeffPerformance[ 1 ][ 5 ][ 13 ]   = -5.99369;
    coeffPerformance[ 2 ][ 5 ][ 13 ]   = -1.43870;
    coeffPerformance[ 3 ][ 5 ][ 13 ]   = 0.619936;
    coeffPerformance[ 4 ][ 5 ][ 13 ]   =  14.9049;
    coeffPerformance[ 5 ][ 5 ][ 13 ]   =  7.44732;
    coeffPerformance[ 6 ][ 5 ][ 13 ]   = -3.89248;
    coeffPerformance[ 7 ][ 5 ][ 13 ]   = -.290284;
    coeffPerformance[ 8 ][ 5 ][ 13 ]   = -.275190;
    coeffPerformance[ 9 ][ 5 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 13 ]  =  0.00000;
    powerMin[ 5 ][ 13 ]                = 0.504567;
    powerMax[ 5 ][ 13 ]                = 0.951830;
    coeffPower[ 0 ][ 5 ][ 13 ]         = 0.707330;
    coeffPower[ 1 ][ 5 ][ 13 ]         = 0.361083;
    coeffPower[ 2 ][ 5 ][ 13 ]         = -.170160;
    coeffPower[ 3 ][ 5 ][ 13 ]         = 0.824290E-01;
    coeffPower[ 4 ][ 5 ][ 13 ]         = -.920262;
    coeffPower[ 5 ][ 5 ][ 13 ]         =  2.24909;
    coeffPower[ 6 ][ 5 ][ 13 ]         = -1.12480;
    coeffPower[ 7 ][ 5 ][ 13 ]         = -.119551;
    coeffPower[ 8 ][ 5 ][ 13 ]         = -.412492;
    coeffPower[ 9 ][ 5 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 13 ]        =  0.00000;
    energyMin[ 6 ][ 13 ]               = 0.617495;
    energyMax[ 6 ][ 13 ]               =  1.20148;
    coeffEnergy[ 0 ][ 6 ][ 13 ]        = 0.952870;
    coeffEnergy[ 1 ][ 6 ][ 13 ]        =  6.15033;
    coeffEnergy[ 2 ][ 6 ][ 13 ]        =  1.36088;
    coeffEnergy[ 3 ][ 6 ][ 13 ]        = -.569913;
    coeffEnergy[ 4 ][ 6 ][ 13 ]        = -15.3205;
    coeffEnergy[ 5 ][ 6 ][ 13 ]        = -5.15321;
    coeffEnergy[ 6 ][ 6 ][ 13 ]        =  2.97075;
    coeffEnergy[ 7 ][ 6 ][ 13 ]        = 0.250249;
    coeffEnergy[ 8 ][ 6 ][ 13 ]        = -.530721;
    coeffEnergy[ 9 ][ 6 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 13 ]       =  0.00000;
    performanceMin[ 6 ][ 13 ]          = 0.544243;
    performanceMax[ 6 ][ 13 ]          =  1.16544;
    coeffPerformance[ 0 ][ 6 ][ 13 ]   = 0.790638;
    coeffPerformance[ 1 ][ 6 ][ 13 ]   = -5.74370;
    coeffPerformance[ 2 ][ 6 ][ 13 ]   = -1.40774;
    coeffPerformance[ 3 ][ 6 ][ 13 ]   = 0.599520;
    coeffPerformance[ 4 ][ 6 ][ 13 ]   =  14.2845;
    coeffPerformance[ 5 ][ 6 ][ 13 ]   =  6.72239;
    coeffPerformance[ 6 ][ 6 ][ 13 ]   = -3.66528;
    coeffPerformance[ 7 ][ 6 ][ 13 ]   = -.417886;
    coeffPerformance[ 8 ][ 6 ][ 13 ]   = 0.102764;
    coeffPerformance[ 9 ][ 6 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 13 ]  =  0.00000;
    powerMin[ 6 ][ 13 ]                = 0.533171;
    powerMax[ 6 ][ 13 ]                = 0.977104;
    coeffPower[ 0 ][ 6 ][ 13 ]         = 0.743682;
    coeffPower[ 1 ][ 6 ][ 13 ]         = -.264560;
    coeffPower[ 2 ][ 6 ][ 13 ]         = -.165316;
    coeffPower[ 3 ][ 6 ][ 13 ]         = 0.784490E-01;
    coeffPower[ 4 ][ 6 ][ 13 ]         = 0.640087;
    coeffPower[ 5 ][ 6 ][ 13 ]         =  1.82422;
    coeffPower[ 6 ][ 6 ][ 13 ]         = -.888517;
    coeffPower[ 7 ][ 6 ][ 13 ]         = -.127349;
    coeffPower[ 8 ][ 6 ][ 13 ]         = -.378744;
    coeffPower[ 9 ][ 6 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 13 ]        =  0.00000;
    energyMin[ 7 ][ 13 ]               = 0.638768;
    energyMax[ 7 ][ 13 ]               =  1.19304;
    coeffEnergy[ 0 ][ 7 ][ 13 ]        = 0.954853;
    coeffEnergy[ 1 ][ 7 ][ 13 ]        =  4.82825;
    coeffEnergy[ 2 ][ 7 ][ 13 ]        = 0.965285;
    coeffEnergy[ 3 ][ 7 ][ 13 ]        = -.409290;
    coeffEnergy[ 4 ][ 7 ][ 13 ]        = -12.0261;
    coeffEnergy[ 5 ][ 7 ][ 13 ]        = -4.27339;
    coeffEnergy[ 6 ][ 7 ][ 13 ]        =  2.30278;
    coeffEnergy[ 7 ][ 7 ][ 13 ]        = 0.863391E-01;
    coeffEnergy[ 8 ][ 7 ][ 13 ]        = -.170798;
    coeffEnergy[ 9 ][ 7 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 13 ]       =  0.00000;
    performanceMin[ 7 ][ 13 ]          = 0.602457;
    performanceMax[ 7 ][ 13 ]          =  1.17190;
    coeffPerformance[ 0 ][ 7 ][ 13 ]   = 0.818443;
    coeffPerformance[ 1 ][ 7 ][ 13 ]   = -4.85929;
    coeffPerformance[ 2 ][ 7 ][ 13 ]   = -1.12946;
    coeffPerformance[ 3 ][ 7 ][ 13 ]   = 0.486455;
    coeffPerformance[ 4 ][ 7 ][ 13 ]   =  12.0847;
    coeffPerformance[ 5 ][ 7 ][ 13 ]   =  5.76247;
    coeffPerformance[ 6 ][ 7 ][ 13 ]   = -2.93615;
    coeffPerformance[ 7 ][ 7 ][ 13 ]   = -.179240;
    coeffPerformance[ 8 ][ 7 ][ 13 ]   = -.296095;
    coeffPerformance[ 9 ][ 7 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 13 ]  =  0.00000;
    powerMin[ 7 ][ 13 ]                = 0.561804;
    powerMax[ 7 ][ 13 ]                =  1.00512;
    coeffPower[ 0 ][ 7 ][ 13 ]         = 0.775435;
    coeffPower[ 1 ][ 7 ][ 13 ]         = -.404268;
    coeffPower[ 2 ][ 7 ][ 13 ]         = -.230646;
    coeffPower[ 3 ][ 7 ][ 13 ]         = 0.104267;
    coeffPower[ 4 ][ 7 ][ 13 ]         = 0.990795;
    coeffPower[ 5 ][ 7 ][ 13 ]         =  1.61002;
    coeffPower[ 6 ][ 7 ][ 13 ]         = -.752599;
    coeffPower[ 7 ][ 7 ][ 13 ]         = -.666413E-01;
    coeffPower[ 8 ][ 7 ][ 13 ]         = -.415994;
    coeffPower[ 9 ][ 7 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 13 ]        =  0.00000;
    energyMin[ 8 ][ 13 ]               = 0.652014;
    energyMax[ 8 ][ 13 ]               =  1.31035;
    coeffEnergy[ 0 ][ 8 ][ 13 ]        = 0.955037;
    coeffEnergy[ 1 ][ 8 ][ 13 ]        =  4.57082;
    coeffEnergy[ 2 ][ 8 ][ 13 ]        = 0.854960;
    coeffEnergy[ 3 ][ 8 ][ 13 ]        = -.360510;
    coeffEnergy[ 4 ][ 8 ][ 13 ]        = -11.3844;
    coeffEnergy[ 5 ][ 8 ][ 13 ]        = -3.37154;
    coeffEnergy[ 6 ][ 8 ][ 13 ]        =  1.80524;
    coeffEnergy[ 7 ][ 8 ][ 13 ]        = 0.776448E-01;
    coeffEnergy[ 8 ][ 8 ][ 13 ]        = -.138247;
    coeffEnergy[ 9 ][ 8 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 13 ]       =  0.00000;
    performanceMin[ 8 ][ 13 ]          = 0.570420;
    performanceMax[ 8 ][ 13 ]          =  1.18062;
    coeffPerformance[ 0 ][ 8 ][ 13 ]   = 0.851584;
    coeffPerformance[ 1 ][ 8 ][ 13 ]   = -4.66633;
    coeffPerformance[ 2 ][ 8 ][ 13 ]   = -1.01286;
    coeffPerformance[ 3 ][ 8 ][ 13 ]   = 0.433472;
    coeffPerformance[ 4 ][ 8 ][ 13 ]   =  11.6068;
    coeffPerformance[ 5 ][ 8 ][ 13 ]   =  4.68312;
    coeffPerformance[ 6 ][ 8 ][ 13 ]   = -2.35967;
    coeffPerformance[ 7 ][ 8 ][ 13 ]   = -.149051;
    coeffPerformance[ 8 ][ 8 ][ 13 ]   = -.230408;
    coeffPerformance[ 9 ][ 8 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 13 ]  =  0.00000;
    powerMin[ 8 ][ 13 ]                = 0.596008;
    powerMax[ 8 ][ 13 ]                =  1.03200;
    coeffPower[ 0 ][ 8 ][ 13 ]         = 0.810382;
    coeffPower[ 1 ][ 8 ][ 13 ]         = -.482718;
    coeffPower[ 2 ][ 8 ][ 13 ]         = -.243644;
    coeffPower[ 3 ][ 8 ][ 13 ]         = 0.107154;
    coeffPower[ 4 ][ 8 ][ 13 ]         =  1.18811;
    coeffPower[ 5 ][ 8 ][ 13 ]         =  1.26850;
    coeffPower[ 6 ][ 8 ][ 13 ]         = -.563137;
    coeffPower[ 7 ][ 8 ][ 13 ]         = -.565403E-01;
    coeffPower[ 8 ][ 8 ][ 13 ]         = -.331494;
    coeffPower[ 9 ][ 8 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 13 ]        =  0.00000;
    energyMin[ 9 ][ 13 ]               = 0.671013;
    energyMax[ 9 ][ 13 ]               =  1.18388;
    coeffEnergy[ 0 ][ 9 ][ 13 ]        = 0.960297;
    coeffEnergy[ 1 ][ 9 ][ 13 ]        =  2.90340;
    coeffEnergy[ 2 ][ 9 ][ 13 ]        = 0.599858;
    coeffEnergy[ 3 ][ 9 ][ 13 ]        = -.255790;
    coeffEnergy[ 4 ][ 9 ][ 13 ]        = -7.23057;
    coeffEnergy[ 5 ][ 9 ][ 13 ]        = -2.85218;
    coeffEnergy[ 6 ][ 9 ][ 13 ]        =  1.53834;
    coeffEnergy[ 7 ][ 9 ][ 13 ]        = 0.610689E-01;
    coeffEnergy[ 8 ][ 9 ][ 13 ]        = -.495009E-01;
    coeffEnergy[ 9 ][ 9 ][ 13 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 13 ]       =  0.00000;
    performanceMin[ 9 ][ 13 ]          = 0.657861;
    performanceMax[ 9 ][ 13 ]          =  1.18482;
    coeffPerformance[ 0 ][ 9 ][ 13 ]   = 0.874808;
    coeffPerformance[ 1 ][ 9 ][ 13 ]   = -3.22637;
    coeffPerformance[ 2 ][ 9 ][ 13 ]   = -.759002;
    coeffPerformance[ 3 ][ 9 ][ 13 ]   = 0.328902;
    coeffPerformance[ 4 ][ 9 ][ 13 ]   =  8.02506;
    coeffPerformance[ 5 ][ 9 ][ 13 ]   =  4.20031;
    coeffPerformance[ 6 ][ 9 ][ 13 ]   = -2.16984;
    coeffPerformance[ 7 ][ 9 ][ 13 ]   = -.973302E-01;
    coeffPerformance[ 8 ][ 9 ][ 13 ]   = -.256121;
    coeffPerformance[ 9 ][ 9 ][ 13 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 13 ]  =  0.00000;
    powerMin[ 9 ][ 13 ]                = 0.637455;
    powerMax[ 9 ][ 13 ]                =  1.06262;
    coeffPower[ 0 ][ 9 ][ 13 ]         = 0.837903;
    coeffPower[ 1 ][ 9 ][ 13 ]         = -.429205;
    coeffPower[ 2 ][ 9 ][ 13 ]         = -.175614;
    coeffPower[ 3 ][ 9 ][ 13 ]         = 0.793942E-01;
    coeffPower[ 4 ][ 9 ][ 13 ]         =  1.06005;
    coeffPower[ 5 ][ 9 ][ 13 ]         =  1.33129;
    coeffPower[ 6 ][ 9 ][ 13 ]         = -.647614;
    coeffPower[ 7 ][ 9 ][ 13 ]         = -.331752E-01;
    coeffPower[ 8 ][ 9 ][ 13 ]         = -.269588;
    coeffPower[ 9 ][ 9 ][ 13 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 13 ]        =  0.00000;
    energyMin[ 10 ][ 13 ]              = 0.700718;
    energyMax[ 10 ][ 13 ]              =  1.23920;
    coeffEnergy[ 0 ][ 10 ][ 13 ]       = 0.971139;
    coeffEnergy[ 1 ][ 10 ][ 13 ]       =  2.52762;
    coeffEnergy[ 2 ][ 10 ][ 13 ]       = 0.443207;
    coeffEnergy[ 3 ][ 10 ][ 13 ]       = -.190649;
    coeffEnergy[ 4 ][ 10 ][ 13 ]       = -6.29716;
    coeffEnergy[ 5 ][ 10 ][ 13 ]       = -2.20777;
    coeffEnergy[ 6 ][ 10 ][ 13 ]       =  1.14611;
    coeffEnergy[ 7 ][ 10 ][ 13 ]       = 0.379376E-01;
    coeffEnergy[ 8 ][ 10 ][ 13 ]       = 0.417922E-01;
    coeffEnergy[ 9 ][ 10 ][ 13 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 13 ]      =  0.00000;
    performanceMin[ 10 ][ 13 ]         = 0.671875;
    performanceMax[ 10 ][ 13 ]         =  1.20484;
    coeffPerformance[ 0 ][ 10 ][ 13 ]  = 0.905854;
    coeffPerformance[ 1 ][ 10 ][ 13 ]  = -2.67298;
    coeffPerformance[ 2 ][ 10 ][ 13 ]  = -.570265;
    coeffPerformance[ 3 ][ 10 ][ 13 ]  = 0.248030;
    coeffPerformance[ 4 ][ 10 ][ 13 ]  =  6.64997;
    coeffPerformance[ 5 ][ 10 ][ 13 ]  =  3.23751;
    coeffPerformance[ 6 ][ 10 ][ 13 ]  = -1.63596;
    coeffPerformance[ 7 ][ 10 ][ 13 ]  = -.664185E-01;
    coeffPerformance[ 8 ][ 10 ][ 13 ]  = -.248872;
    coeffPerformance[ 9 ][ 10 ][ 13 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 13 ] =  0.00000;
    powerMin[ 10 ][ 13 ]               = 0.675434;
    powerMax[ 10 ][ 13 ]               =  1.09217;
    coeffPower[ 0 ][ 10 ][ 13 ]        = 0.877632;
    coeffPower[ 1 ][ 10 ][ 13 ]        = -.208941;
    coeffPower[ 2 ][ 10 ][ 13 ]        = -.140236;
    coeffPower[ 3 ][ 10 ][ 13 ]        = 0.627014E-01;
    coeffPower[ 4 ][ 10 ][ 13 ]        = 0.512243;
    coeffPower[ 5 ][ 10 ][ 13 ]        =  1.02638;
    coeffPower[ 6 ][ 10 ][ 13 ]        = -.498027;
    coeffPower[ 7 ][ 10 ][ 13 ]        = -.208349E-01;
    coeffPower[ 8 ][ 10 ][ 13 ]        = -.197738;
    coeffPower[ 9 ][ 10 ][ 13 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 13 ]       =  0.00000;
    energyMin[ 11 ][ 13 ]              = 0.730921;
    energyMax[ 11 ][ 13 ]              =  1.20295;
    coeffEnergy[ 0 ][ 11 ][ 13 ]       = 0.979266;
    coeffEnergy[ 1 ][ 11 ][ 13 ]       =  1.14709;
    coeffEnergy[ 2 ][ 11 ][ 13 ]       = 0.216526;
    coeffEnergy[ 3 ][ 11 ][ 13 ]       = -.961272E-01;
    coeffEnergy[ 4 ][ 11 ][ 13 ]       = -2.85593;
    coeffEnergy[ 5 ][ 11 ][ 13 ]       = -1.49211;
    coeffEnergy[ 6 ][ 11 ][ 13 ]       = 0.747070;
    coeffEnergy[ 7 ][ 11 ][ 13 ]       = -.435596E-01;
    coeffEnergy[ 8 ][ 11 ][ 13 ]       = 0.143859;
    coeffEnergy[ 9 ][ 11 ][ 13 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 13 ]      =  0.00000;
    performanceMin[ 11 ][ 13 ]         = 0.725937;
    performanceMax[ 11 ][ 13 ]         =  1.20163;
    coeffPerformance[ 0 ][ 11 ][ 13 ]  = 0.936440;
    coeffPerformance[ 1 ][ 11 ][ 13 ]  = -1.26788;
    coeffPerformance[ 2 ][ 11 ][ 13 ]  = -.330472;
    coeffPerformance[ 3 ][ 11 ][ 13 ]  = 0.146546;
    coeffPerformance[ 4 ][ 11 ][ 13 ]  =  3.15123;
    coeffPerformance[ 5 ][ 11 ][ 13 ]  =  2.25511;
    coeffPerformance[ 6 ][ 11 ][ 13 ]  = -1.09204;
    coeffPerformance[ 7 ][ 11 ][ 13 ]  = 0.352563E-01;
    coeffPerformance[ 8 ][ 11 ][ 13 ]  = -.286796;
    coeffPerformance[ 9 ][ 11 ][ 13 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 13 ] =  0.00000;
    powerMin[ 11 ][ 13 ]               = 0.716163;
    powerMax[ 11 ][ 13 ]               =  1.12885;
    coeffPower[ 0 ][ 11 ][ 13 ]        = 0.916530;
    coeffPower[ 1 ][ 11 ][ 13 ]        = -.119890;
    coeffPower[ 2 ][ 11 ][ 13 ]        = -.108066;
    coeffPower[ 3 ][ 11 ][ 13 ]        = 0.479651E-01;
    coeffPower[ 4 ][ 11 ][ 13 ]        = 0.293236;
    coeffPower[ 5 ][ 11 ][ 13 ]        = 0.750764;
    coeffPower[ 6 ][ 11 ][ 13 ]        = -.343803;
    coeffPower[ 7 ][ 11 ][ 13 ]        = -.585192E-02;
    coeffPower[ 8 ][ 11 ][ 13 ]        = -.138217;
    coeffPower[ 9 ][ 11 ][ 13 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 13 ]       =  0.00000;
    energyMin[ 12 ][ 13 ]              = 0.745172;
    energyMax[ 12 ][ 13 ]              =  1.23081;
    coeffEnergy[ 0 ][ 12 ][ 13 ]       = 0.995743;
    coeffEnergy[ 1 ][ 12 ][ 13 ]       = 0.732648;
    coeffEnergy[ 2 ][ 12 ][ 13 ]       = 0.103838;
    coeffEnergy[ 3 ][ 12 ][ 13 ]       = -.468854E-01;
    coeffEnergy[ 4 ][ 12 ][ 13 ]       = -1.82830;
    coeffEnergy[ 5 ][ 12 ][ 13 ]       = -.797206;
    coeffEnergy[ 6 ][ 12 ][ 13 ]       = 0.404658;
    coeffEnergy[ 7 ][ 12 ][ 13 ]       = -.612415E-01;
    coeffEnergy[ 8 ][ 12 ][ 13 ]       = 0.485391E-01;
    coeffEnergy[ 9 ][ 12 ][ 13 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 13 ]      =  0.00000;
    performanceMin[ 12 ][ 13 ]         = 0.739757;
    performanceMax[ 12 ][ 13 ]         =  1.20411;
    coeffPerformance[ 0 ][ 12 ][ 13 ]  = 0.967168;
    coeffPerformance[ 1 ][ 12 ][ 13 ]  = -.609656;
    coeffPerformance[ 2 ][ 12 ][ 13 ]  = -.113057;
    coeffPerformance[ 3 ][ 12 ][ 13 ]  = 0.520247E-01;
    coeffPerformance[ 4 ][ 12 ][ 13 ]  =  1.51595;
    coeffPerformance[ 5 ][ 12 ][ 13 ]  =  1.12293;
    coeffPerformance[ 6 ][ 12 ][ 13 ]  = -.529806;
    coeffPerformance[ 7 ][ 12 ][ 13 ]  = 0.335289E-01;
    coeffPerformance[ 8 ][ 12 ][ 13 ]  = -.133046;
    coeffPerformance[ 9 ][ 12 ][ 13 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 13 ] =  0.00000;
    powerMin[ 12 ][ 13 ]               = 0.737524;
    powerMax[ 12 ][ 13 ]               =  1.16313;
    coeffPower[ 0 ][ 12 ][ 13 ]        = 0.962856;
    coeffPower[ 1 ][ 12 ][ 13 ]        = 0.135606;
    coeffPower[ 2 ][ 12 ][ 13 ]        = -.577411E-02;
    coeffPower[ 3 ][ 12 ][ 13 ]        = 0.379578E-02;
    coeffPower[ 4 ][ 12 ][ 13 ]        = -.343636;
    coeffPower[ 5 ][ 12 ][ 13 ]        = 0.331590;
    coeffPower[ 6 ][ 12 ][ 13 ]        = -.129396;
    coeffPower[ 7 ][ 12 ][ 13 ]        = -.257054E-01;
    coeffPower[ 8 ][ 12 ][ 13 ]        = -.852876E-01;
    coeffPower[ 9 ][ 12 ][ 13 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 13 ]       =  0.00000;
    energyMin[ 13 ][ 13 ]              = 0.800000;
    energyMax[ 13 ][ 13 ]              =  1.20000;
    coeffEnergy[ 0 ][ 13 ][ 13 ]       =  1.00000;
    coeffEnergy[ 1 ][ 13 ][ 13 ]       = 0.310287E-12;
    coeffEnergy[ 2 ][ 13 ][ 13 ]       = -.612486E-12;
    coeffEnergy[ 3 ][ 13 ][ 13 ]       = 0.245378E-12;
    coeffEnergy[ 4 ][ 13 ][ 13 ]       = -.778564E-12;
    coeffEnergy[ 5 ][ 13 ][ 13 ]       = -.559145E-12;
    coeffEnergy[ 6 ][ 13 ][ 13 ]       = 0.138960E-12;
    coeffEnergy[ 7 ][ 13 ][ 13 ]       = -.655623E-13;
    coeffEnergy[ 8 ][ 13 ][ 13 ]       = 0.863263E-13;
    coeffEnergy[ 9 ][ 13 ][ 13 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 13 ]      =  0.00000;
    performanceMin[ 13 ][ 13 ]         = 0.800000;
    performanceMax[ 13 ][ 13 ]         =  1.20000;
    coeffPerformance[ 0 ][ 13 ][ 13 ]  =  1.00000;
    coeffPerformance[ 1 ][ 13 ][ 13 ]  = -.164829E-12;
    coeffPerformance[ 2 ][ 13 ][ 13 ]  = 0.446647E-13;
    coeffPerformance[ 3 ][ 13 ][ 13 ]  = -.197799E-13;
    coeffPerformance[ 4 ][ 13 ][ 13 ]  = 0.409569E-12;
    coeffPerformance[ 5 ][ 13 ][ 13 ]  = -.316497E-12;
    coeffPerformance[ 6 ][ 13 ][ 13 ]  = 0.121189E-12;
    coeffPerformance[ 7 ][ 13 ][ 13 ]  = -.459623E-13;
    coeffPerformance[ 8 ][ 13 ][ 13 ]  = 0.996335E-13;
    coeffPerformance[ 9 ][ 13 ][ 13 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 13 ] =  0.00000;
    powerMin[ 13 ][ 13 ]               = 0.800000;
    powerMax[ 13 ][ 13 ]               =  1.20000;
    coeffPower[ 0 ][ 13 ][ 13 ]        =  1.00000;
    coeffPower[ 1 ][ 13 ][ 13 ]        = 0.533756E-14;
    coeffPower[ 2 ][ 13 ][ 13 ]        = 0.207337E-13;
    coeffPower[ 3 ][ 13 ][ 13 ]        = -.793359E-14;
    coeffPower[ 4 ][ 13 ][ 13 ]        = -.122695E-13;
    coeffPower[ 5 ][ 13 ][ 13 ]        = 0.711855E-13;
    coeffPower[ 6 ][ 13 ][ 13 ]        = -.378368E-13;
    coeffPower[ 7 ][ 13 ][ 13 ]        = -.110456E-14;
    coeffPower[ 8 ][ 13 ][ 13 ]        = 0.272601E-15;
    coeffPower[ 9 ][ 13 ][ 13 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 13 ]       =  0.00000;
    energyMin[ 14 ][ 13 ]              = 0.792051;
    energyMax[ 14 ][ 13 ]              =  1.29517;
    coeffEnergy[ 0 ][ 14 ][ 13 ]       =  1.01033;
    coeffEnergy[ 1 ][ 14 ][ 13 ]       = -1.06841;
    coeffEnergy[ 2 ][ 14 ][ 13 ]       = -.194340;
    coeffEnergy[ 3 ][ 14 ][ 13 ]       = 0.837016E-01;
    coeffEnergy[ 4 ][ 14 ][ 13 ]       =  2.66469;
    coeffEnergy[ 5 ][ 14 ][ 13 ]       = 0.805345;
    coeffEnergy[ 6 ][ 14 ][ 13 ]       = -.440981;
    coeffEnergy[ 7 ][ 14 ][ 13 ]       = -.937137E-02;
    coeffEnergy[ 8 ][ 14 ][ 13 ]       = -.636158E-01;
    coeffEnergy[ 9 ][ 14 ][ 13 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 13 ]      =  0.00000;
    performanceMin[ 14 ][ 13 ]         = 0.792813;
    performanceMax[ 14 ][ 13 ]         =  1.28333;
    coeffPerformance[ 0 ][ 14 ][ 13 ]  =  1.03632;
    coeffPerformance[ 1 ][ 14 ][ 13 ]  =  1.52170;
    coeffPerformance[ 2 ][ 14 ][ 13 ]  = 0.319386;
    coeffPerformance[ 3 ][ 14 ][ 13 ]  = -.135270;
    coeffPerformance[ 4 ][ 14 ][ 13 ]  = -3.79226;
    coeffPerformance[ 5 ][ 14 ][ 13 ]  = -1.08063;
    coeffPerformance[ 6 ][ 14 ][ 13 ]  = 0.560689;
    coeffPerformance[ 7 ][ 14 ][ 13 ]  = 0.426528E-01;
    coeffPerformance[ 8 ][ 14 ][ 13 ]  = 0.501659E-01;
    coeffPerformance[ 9 ][ 14 ][ 13 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 13 ] =  0.00000;
    powerMin[ 14 ][ 13 ]               = 0.825026;
    powerMax[ 14 ][ 13 ]               =  1.29502;
    coeffPower[ 0 ][ 14 ][ 13 ]        =  1.04703;
    coeffPower[ 1 ][ 14 ][ 13 ]        = 0.463864;
    coeffPower[ 2 ][ 14 ][ 13 ]        = 0.126617;
    coeffPower[ 3 ][ 14 ][ 13 ]        = -.522523E-01;
    coeffPower[ 4 ][ 14 ][ 13 ]        = -1.15393;
    coeffPower[ 5 ][ 14 ][ 13 ]        = -.283843;
    coeffPower[ 6 ][ 14 ][ 13 ]        = 0.124213;
    coeffPower[ 7 ][ 14 ][ 13 ]        = 0.337659E-01;
    coeffPower[ 8 ][ 14 ][ 13 ]        = -.130434E-01;
    coeffPower[ 9 ][ 14 ][ 13 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 13 ]       =  0.00000;
    energyMin[ 15 ][ 13 ]              = 0.763487;
    energyMax[ 15 ][ 13 ]              =  1.34105;
    coeffEnergy[ 0 ][ 15 ][ 13 ]       =  1.02395;
    coeffEnergy[ 1 ][ 15 ][ 13 ]       = -1.19875;
    coeffEnergy[ 2 ][ 15 ][ 13 ]       = -.226804;
    coeffEnergy[ 3 ][ 15 ][ 13 ]       = 0.103257;
    coeffEnergy[ 4 ][ 15 ][ 13 ]       =  2.98741;
    coeffEnergy[ 5 ][ 15 ][ 13 ]       =  1.72516;
    coeffEnergy[ 6 ][ 15 ][ 13 ]       = -.872313;
    coeffEnergy[ 7 ][ 15 ][ 13 ]       = 0.516951E-01;
    coeffEnergy[ 8 ][ 15 ][ 13 ]       = -.261619;
    coeffEnergy[ 9 ][ 15 ][ 13 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 13 ]      =  0.00000;
    performanceMin[ 15 ][ 13 ]         = 0.792798;
    performanceMax[ 15 ][ 13 ]         =  1.39142;
    coeffPerformance[ 0 ][ 15 ][ 13 ]  =  1.06607;
    coeffPerformance[ 1 ][ 15 ][ 13 ]  =  1.45781;
    coeffPerformance[ 2 ][ 15 ][ 13 ]  = 0.317556;
    coeffPerformance[ 3 ][ 15 ][ 13 ]  = -.142612;
    coeffPerformance[ 4 ][ 15 ][ 13 ]  = -3.62521;
    coeffPerformance[ 5 ][ 15 ][ 13 ]  = -2.43418;
    coeffPerformance[ 6 ][ 15 ][ 13 ]  =  1.26131;
    coeffPerformance[ 7 ][ 15 ][ 13 ]  = 0.331756E-01;
    coeffPerformance[ 8 ][ 15 ][ 13 ]  = 0.226901;
    coeffPerformance[ 9 ][ 15 ][ 13 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 13 ] =  0.00000;
    powerMin[ 15 ][ 13 ]               = 0.851954;
    powerMax[ 15 ][ 13 ]               =  1.39221;
    coeffPower[ 0 ][ 15 ][ 13 ]        =  1.09043;
    coeffPower[ 1 ][ 15 ][ 13 ]        = 0.342963;
    coeffPower[ 2 ][ 15 ][ 13 ]        = 0.115988;
    coeffPower[ 3 ][ 15 ][ 13 ]        = -.492967E-01;
    coeffPower[ 4 ][ 15 ][ 13 ]        = -.846373;
    coeffPower[ 5 ][ 15 ][ 13 ]        = -.701880;
    coeffPower[ 6 ][ 15 ][ 13 ]        = 0.394317;
    coeffPower[ 7 ][ 15 ][ 13 ]        = 0.975946E-01;
    coeffPower[ 8 ][ 15 ][ 13 ]        = -.588692E-01;
    coeffPower[ 9 ][ 15 ][ 13 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 13 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 2.60;
    energyMin[ 0 ][ 14 ]               = 0.509570;
    energyMax[ 0 ][ 14 ]               =  1.39308;
    coeffEnergy[ 0 ][ 0 ][ 14 ]        =  1.06723;
    coeffEnergy[ 1 ][ 0 ][ 14 ]        =  11.6218;
    coeffEnergy[ 2 ][ 0 ][ 14 ]        =  1.63922;
    coeffEnergy[ 3 ][ 0 ][ 14 ]        = -.697909;
    coeffEnergy[ 4 ][ 0 ][ 14 ]        = -30.1221;
    coeffEnergy[ 5 ][ 0 ][ 14 ]        = -13.1159;
    coeffEnergy[ 6 ][ 0 ][ 14 ]        =  6.62254;
    coeffEnergy[ 7 ][ 0 ][ 14 ]        = -.101474;
    coeffEnergy[ 8 ][ 0 ][ 14 ]        = 0.296259;
    coeffEnergy[ 9 ][ 0 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 14 ]       =  0.00000;
    performanceMin[ 0 ][ 14 ]          = 0.365771;
    performanceMax[ 0 ][ 14 ]          =  1.02655;
    coeffPerformance[ 0 ][ 0 ][ 14 ]   = 0.522465;
    coeffPerformance[ 1 ][ 0 ][ 14 ]   = -2.24784;
    coeffPerformance[ 2 ][ 0 ][ 14 ]   = -.836560;
    coeffPerformance[ 3 ][ 0 ][ 14 ]   = 0.384213;
    coeffPerformance[ 4 ][ 0 ][ 14 ]   =  5.78684;
    coeffPerformance[ 5 ][ 0 ][ 14 ]   =  10.8812;
    coeffPerformance[ 6 ][ 0 ][ 14 ]   = -5.55308;
    coeffPerformance[ 7 ][ 0 ][ 14 ]   = -.152875;
    coeffPerformance[ 8 ][ 0 ][ 14 ]   = -.758362;
    coeffPerformance[ 9 ][ 0 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 14 ]  =  0.00000;
    powerMin[ 0 ][ 14 ]                = 0.337653;
    powerMax[ 0 ][ 14 ]                = 0.779427;
    coeffPower[ 0 ][ 0 ][ 14 ]         = 0.547517;
    coeffPower[ 1 ][ 0 ][ 14 ]         =  3.79399;
    coeffPower[ 2 ][ 0 ][ 14 ]         = -.177202E-01;
    coeffPower[ 3 ][ 0 ][ 14 ]         = 0.209994E-01;
    coeffPower[ 4 ][ 0 ][ 14 ]         = -9.86677;
    coeffPower[ 5 ][ 0 ][ 14 ]         =  1.50649;
    coeffPower[ 6 ][ 0 ][ 14 ]         = -1.00587;
    coeffPower[ 7 ][ 0 ][ 14 ]         = -.162273;
    coeffPower[ 8 ][ 0 ][ 14 ]         = -.396498;
    coeffPower[ 9 ][ 0 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 14 ]        =  0.00000;
    energyMin[ 1 ][ 14 ]               = 0.521491;
    energyMax[ 1 ][ 14 ]               =  1.32736;
    coeffEnergy[ 0 ][ 1 ][ 14 ]        =  1.05677;
    coeffEnergy[ 1 ][ 1 ][ 14 ]        =  8.96706;
    coeffEnergy[ 2 ][ 1 ][ 14 ]        =  1.37697;
    coeffEnergy[ 3 ][ 1 ][ 14 ]        = -.596373;
    coeffEnergy[ 4 ][ 1 ][ 14 ]        = -23.2465;
    coeffEnergy[ 5 ][ 1 ][ 14 ]        = -11.7872;
    coeffEnergy[ 6 ][ 1 ][ 14 ]        =  5.92720;
    coeffEnergy[ 7 ][ 1 ][ 14 ]        = -.250403;
    coeffEnergy[ 8 ][ 1 ][ 14 ]        = 0.563443;
    coeffEnergy[ 9 ][ 1 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 14 ]       =  0.00000;
    performanceMin[ 1 ][ 14 ]          = 0.392784;
    performanceMax[ 1 ][ 14 ]          =  1.06838;
    coeffPerformance[ 0 ][ 1 ][ 14 ]   = 0.562127;
    coeffPerformance[ 1 ][ 1 ][ 14 ]   = -2.77328;
    coeffPerformance[ 2 ][ 1 ][ 14 ]   = -.948570;
    coeffPerformance[ 3 ][ 1 ][ 14 ]   = 0.428167;
    coeffPerformance[ 4 ][ 1 ][ 14 ]   =  7.14902;
    coeffPerformance[ 5 ][ 1 ][ 14 ]   =  10.6858;
    coeffPerformance[ 6 ][ 1 ][ 14 ]   = -5.23776;
    coeffPerformance[ 7 ][ 1 ][ 14 ]   = -.721036E-01;
    coeffPerformance[ 8 ][ 1 ][ 14 ]   = -.966807;
    coeffPerformance[ 9 ][ 1 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 14 ]  =  0.00000;
    powerMin[ 1 ][ 14 ]                = 0.372474;
    powerMax[ 1 ][ 14 ]                = 0.832472;
    coeffPower[ 0 ][ 1 ][ 14 ]         = 0.589201;
    coeffPower[ 1 ][ 1 ][ 14 ]         =  2.30123;
    coeffPower[ 2 ][ 1 ][ 14 ]         = -.147616;
    coeffPower[ 3 ][ 1 ][ 14 ]         = 0.679334E-01;
    coeffPower[ 4 ][ 1 ][ 14 ]         = -6.00155;
    coeffPower[ 5 ][ 1 ][ 14 ]         =  1.62382;
    coeffPower[ 6 ][ 1 ][ 14 ]         = -.901003;
    coeffPower[ 7 ][ 1 ][ 14 ]         = -.224979;
    coeffPower[ 8 ][ 1 ][ 14 ]         = -.336932;
    coeffPower[ 9 ][ 1 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 14 ]        =  0.00000;
    energyMin[ 2 ][ 14 ]               = 0.535399;
    energyMax[ 2 ][ 14 ]               =  1.28915;
    coeffEnergy[ 0 ][ 2 ][ 14 ]        =  1.02101;
    coeffEnergy[ 1 ][ 2 ][ 14 ]        =  8.37257;
    coeffEnergy[ 2 ][ 2 ][ 14 ]        =  1.30972;
    coeffEnergy[ 3 ][ 2 ][ 14 ]        = -.563965;
    coeffEnergy[ 4 ][ 2 ][ 14 ]        = -21.7019;
    coeffEnergy[ 5 ][ 2 ][ 14 ]        = -10.4099;
    coeffEnergy[ 6 ][ 2 ][ 14 ]        =  5.52998;
    coeffEnergy[ 7 ][ 2 ][ 14 ]        = -.179042;
    coeffEnergy[ 8 ][ 2 ][ 14 ]        = 0.439077;
    coeffEnergy[ 9 ][ 2 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 14 ]       =  0.00000;
    performanceMin[ 2 ][ 14 ]          = 0.424573;
    performanceMax[ 2 ][ 14 ]          =  1.09284;
    coeffPerformance[ 0 ][ 2 ][ 14 ]   = 0.607051;
    coeffPerformance[ 1 ][ 2 ][ 14 ]   = -3.76700;
    coeffPerformance[ 2 ][ 2 ][ 14 ]   = -1.20805;
    coeffPerformance[ 3 ][ 2 ][ 14 ]   = 0.525557;
    coeffPerformance[ 4 ][ 2 ][ 14 ]   =  9.72488;
    coeffPerformance[ 5 ][ 2 ][ 14 ]   =  10.3125;
    coeffPerformance[ 6 ][ 2 ][ 14 ]   = -5.11109;
    coeffPerformance[ 7 ][ 2 ][ 14 ]   = -.136181;
    coeffPerformance[ 8 ][ 2 ][ 14 ]   = -.834111;
    coeffPerformance[ 9 ][ 2 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 14 ]  =  0.00000;
    powerMin[ 2 ][ 14 ]                = 0.391959;
    powerMax[ 2 ][ 14 ]                = 0.855546;
    coeffPower[ 0 ][ 2 ][ 14 ]         = 0.611910;
    coeffPower[ 1 ][ 2 ][ 14 ]         =  1.70416;
    coeffPower[ 2 ][ 2 ][ 14 ]         = -.271549;
    coeffPower[ 3 ][ 2 ][ 14 ]         = 0.115213;
    coeffPower[ 4 ][ 2 ][ 14 ]         = -4.45073;
    coeffPower[ 5 ][ 2 ][ 14 ]         =  1.83578;
    coeffPower[ 6 ][ 2 ][ 14 ]         = -.797565;
    coeffPower[ 7 ][ 2 ][ 14 ]         = -.229840;
    coeffPower[ 8 ][ 2 ][ 14 ]         = -.312298;
    coeffPower[ 9 ][ 2 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 14 ]        =  0.00000;
    energyMin[ 3 ][ 14 ]               = 0.538804;
    energyMax[ 3 ][ 14 ]               =  1.27570;
    coeffEnergy[ 0 ][ 3 ][ 14 ]        = 0.982533;
    coeffEnergy[ 1 ][ 3 ][ 14 ]        =  8.93914;
    coeffEnergy[ 2 ][ 3 ][ 14 ]        =  1.71006;
    coeffEnergy[ 3 ][ 3 ][ 14 ]        = -.707509;
    coeffEnergy[ 4 ][ 3 ][ 14 ]        = -23.1644;
    coeffEnergy[ 5 ][ 3 ][ 14 ]        = -9.14617;
    coeffEnergy[ 6 ][ 3 ][ 14 ]        =  5.11086;
    coeffEnergy[ 7 ][ 3 ][ 14 ]        = 0.697670E-01;
    coeffEnergy[ 8 ][ 3 ][ 14 ]        = -.566751E-01;
    coeffEnergy[ 9 ][ 3 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 14 ]       =  0.00000;
    performanceMin[ 3 ][ 14 ]          = 0.433790;
    performanceMax[ 3 ][ 14 ]          =  1.12116;
    coeffPerformance[ 0 ][ 3 ][ 14 ]   = 0.657082;
    coeffPerformance[ 1 ][ 3 ][ 14 ]   = -4.53069;
    coeffPerformance[ 2 ][ 3 ][ 14 ]   = -1.22471;
    coeffPerformance[ 3 ][ 3 ][ 14 ]   = 0.525171;
    coeffPerformance[ 4 ][ 3 ][ 14 ]   =  11.7013;
    coeffPerformance[ 5 ][ 3 ][ 14 ]   =  9.72825;
    coeffPerformance[ 6 ][ 3 ][ 14 ]   = -4.95705;
    coeffPerformance[ 7 ][ 3 ][ 14 ]   = -.285765;
    coeffPerformance[ 8 ][ 3 ][ 14 ]   = -.472252;
    coeffPerformance[ 9 ][ 3 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 14 ]  =  0.00000;
    powerMin[ 3 ][ 14 ]                = 0.414257;
    powerMax[ 3 ][ 14 ]                = 0.875051;
    coeffPower[ 0 ][ 3 ][ 14 ]         = 0.634206;
    coeffPower[ 1 ][ 3 ][ 14 ]         =  2.01112;
    coeffPower[ 2 ][ 3 ][ 14 ]         = 0.141736;
    coeffPower[ 3 ][ 3 ][ 14 ]         = -.439800E-01;
    coeffPower[ 4 ][ 3 ][ 14 ]         = -5.24482;
    coeffPower[ 5 ][ 3 ][ 14 ]         =  1.86624;
    coeffPower[ 6 ][ 3 ][ 14 ]         = -.717831;
    coeffPower[ 7 ][ 3 ][ 14 ]         = -.160125;
    coeffPower[ 8 ][ 3 ][ 14 ]         = -.404495;
    coeffPower[ 9 ][ 3 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 14 ]        =  0.00000;
    energyMin[ 4 ][ 14 ]               = 0.546318;
    energyMax[ 4 ][ 14 ]               =  1.23260;
    coeffEnergy[ 0 ][ 4 ][ 14 ]        = 0.960923;
    coeffEnergy[ 1 ][ 4 ][ 14 ]        =  7.56377;
    coeffEnergy[ 2 ][ 4 ][ 14 ]        =  1.39468;
    coeffEnergy[ 3 ][ 4 ][ 14 ]        = -.580354;
    coeffEnergy[ 4 ][ 4 ][ 14 ]        = -19.5973;
    coeffEnergy[ 5 ][ 4 ][ 14 ]        = -7.87889;
    coeffEnergy[ 6 ][ 4 ][ 14 ]        =  4.35700;
    coeffEnergy[ 7 ][ 4 ][ 14 ]        = 0.484088E-01;
    coeffEnergy[ 8 ][ 4 ][ 14 ]        = 0.372865E-01;
    coeffEnergy[ 9 ][ 4 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 14 ]       =  0.00000;
    performanceMin[ 4 ][ 14 ]          = 0.481286;
    performanceMax[ 4 ][ 14 ]          =  1.14100;
    coeffPerformance[ 0 ][ 4 ][ 14 ]   = 0.689497;
    coeffPerformance[ 1 ][ 4 ][ 14 ]   = -4.57665;
    coeffPerformance[ 2 ][ 4 ][ 14 ]   = -1.14706;
    coeffPerformance[ 3 ][ 4 ][ 14 ]   = 0.494939;
    coeffPerformance[ 4 ][ 4 ][ 14 ]   =  11.8246;
    coeffPerformance[ 5 ][ 4 ][ 14 ]   =  9.32518;
    coeffPerformance[ 6 ][ 4 ][ 14 ]   = -4.71524;
    coeffPerformance[ 7 ][ 4 ][ 14 ]   = -.180542;
    coeffPerformance[ 8 ][ 4 ][ 14 ]   = -.652722;
    coeffPerformance[ 9 ][ 4 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 14 ]  =  0.00000;
    powerMin[ 4 ][ 14 ]                = 0.447171;
    powerMax[ 4 ][ 14 ]                = 0.900332;
    coeffPower[ 0 ][ 4 ][ 14 ]         = 0.650521;
    coeffPower[ 1 ][ 4 ][ 14 ]         =  1.38526;
    coeffPower[ 2 ][ 4 ][ 14 ]         = 0.328462E-01;
    coeffPower[ 3 ][ 4 ][ 14 ]         = 0.474406E-03;
    coeffPower[ 4 ][ 4 ][ 14 ]         = -3.61604;
    coeffPower[ 5 ][ 4 ][ 14 ]         =  2.24358;
    coeffPower[ 6 ][ 4 ][ 14 ]         = -.943002;
    coeffPower[ 7 ][ 4 ][ 14 ]         = -.971127E-01;
    coeffPower[ 8 ][ 4 ][ 14 ]         = -.470429;
    coeffPower[ 9 ][ 4 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 14 ]        =  0.00000;
    energyMin[ 5 ][ 14 ]               = 0.578476;
    energyMax[ 5 ][ 14 ]               =  1.20397;
    coeffEnergy[ 0 ][ 5 ][ 14 ]        = 0.954278;
    coeffEnergy[ 1 ][ 5 ][ 14 ]        =  7.32534;
    coeffEnergy[ 2 ][ 5 ][ 14 ]        =  1.38164;
    coeffEnergy[ 3 ][ 5 ][ 14 ]        = -.568176;
    coeffEnergy[ 4 ][ 5 ][ 14 ]        = -18.9832;
    coeffEnergy[ 5 ][ 5 ][ 14 ]        = -6.86910;
    coeffEnergy[ 6 ][ 5 ][ 14 ]        =  3.83985;
    coeffEnergy[ 7 ][ 5 ][ 14 ]        = 0.157292;
    coeffEnergy[ 8 ][ 5 ][ 14 ]        = -.214302;
    coeffEnergy[ 9 ][ 5 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 14 ]       =  0.00000;
    performanceMin[ 5 ][ 14 ]          = 0.510636;
    performanceMax[ 5 ][ 14 ]          =  1.15300;
    coeffPerformance[ 0 ][ 5 ][ 14 ]   = 0.730942;
    coeffPerformance[ 1 ][ 5 ][ 14 ]   = -5.03974;
    coeffPerformance[ 2 ][ 5 ][ 14 ]   = -1.14236;
    coeffPerformance[ 3 ][ 5 ][ 14 ]   = 0.486027;
    coeffPerformance[ 4 ][ 5 ][ 14 ]   =  13.0264;
    coeffPerformance[ 5 ][ 5 ][ 14 ]   =  8.56146;
    coeffPerformance[ 6 ][ 5 ][ 14 ]   = -4.48967;
    coeffPerformance[ 7 ][ 5 ][ 14 ]   = -.302793;
    coeffPerformance[ 8 ][ 5 ][ 14 ]   = -.320170;
    coeffPerformance[ 9 ][ 5 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 14 ]  =  0.00000;
    powerMin[ 5 ][ 14 ]                = 0.483603;
    powerMax[ 5 ][ 14 ]                = 0.922958;
    coeffPower[ 0 ][ 5 ][ 14 ]         = 0.685124;
    coeffPower[ 1 ][ 5 ][ 14 ]         =  1.07550;
    coeffPower[ 2 ][ 5 ][ 14 ]         = 0.553245E-01;
    coeffPower[ 3 ][ 5 ][ 14 ]         = -.901348E-02;
    coeffPower[ 4 ][ 5 ][ 14 ]         = -2.81438;
    coeffPower[ 5 ][ 5 ][ 14 ]         =  2.16747;
    coeffPower[ 6 ][ 5 ][ 14 ]         = -.999311;
    coeffPower[ 7 ][ 5 ][ 14 ]         = -.956904E-01;
    coeffPower[ 8 ][ 5 ][ 14 ]         = -.445456;
    coeffPower[ 9 ][ 5 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 14 ]        =  0.00000;
    energyMin[ 6 ][ 14 ]               = 0.596709;
    energyMax[ 6 ][ 14 ]               =  1.19844;
    coeffEnergy[ 0 ][ 6 ][ 14 ]        = 0.948103;
    coeffEnergy[ 1 ][ 6 ][ 14 ]        =  6.10170;
    coeffEnergy[ 2 ][ 6 ][ 14 ]        =  1.06305;
    coeffEnergy[ 3 ][ 6 ][ 14 ]        = -.437591;
    coeffEnergy[ 4 ][ 6 ][ 14 ]        = -15.8114;
    coeffEnergy[ 5 ][ 6 ][ 14 ]        = -6.28625;
    coeffEnergy[ 6 ][ 6 ][ 14 ]        =  3.63471;
    coeffEnergy[ 7 ][ 6 ][ 14 ]        = 0.274421;
    coeffEnergy[ 8 ][ 6 ][ 14 ]        = -.526785;
    coeffEnergy[ 9 ][ 6 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 14 ]       =  0.00000;
    performanceMin[ 6 ][ 14 ]          = 0.523146;
    performanceMax[ 6 ][ 14 ]          =  1.16207;
    coeffPerformance[ 0 ][ 6 ][ 14 ]   = 0.769520;
    coeffPerformance[ 1 ][ 6 ][ 14 ]   = -4.65738;
    coeffPerformance[ 2 ][ 6 ][ 14 ]   = -1.01260;
    coeffPerformance[ 3 ][ 6 ][ 14 ]   = 0.428331;
    coeffPerformance[ 4 ][ 6 ][ 14 ]   =  12.0368;
    coeffPerformance[ 5 ][ 6 ][ 14 ]   =  7.87670;
    coeffPerformance[ 6 ][ 6 ][ 14 ]   = -4.27755;
    coeffPerformance[ 7 ][ 6 ][ 14 ]   = -.415587;
    coeffPerformance[ 8 ][ 6 ][ 14 ]   = 0.319890E-01;
    coeffPerformance[ 9 ][ 6 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 14 ]  =  0.00000;
    powerMin[ 6 ][ 14 ]                = 0.509226;
    powerMax[ 6 ][ 14 ]                = 0.947465;
    coeffPower[ 0 ][ 6 ][ 14 ]         = 0.719149;
    coeffPower[ 1 ][ 6 ][ 14 ]         = 0.703477;
    coeffPower[ 2 ][ 6 ][ 14 ]         = -.340224E-01;
    coeffPower[ 3 ][ 6 ][ 14 ]         = 0.244661E-01;
    coeffPower[ 4 ][ 6 ][ 14 ]         = -1.84944;
    coeffPower[ 5 ][ 6 ][ 14 ]         =  1.89818;
    coeffPower[ 6 ][ 6 ][ 14 ]         = -.884240;
    coeffPower[ 7 ][ 6 ][ 14 ]         = -.102193;
    coeffPower[ 8 ][ 6 ][ 14 ]         = -.419583;
    coeffPower[ 9 ][ 6 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 14 ]        =  0.00000;
    energyMin[ 7 ][ 14 ]               = 0.623547;
    energyMax[ 7 ][ 14 ]               =  1.19003;
    coeffEnergy[ 0 ][ 7 ][ 14 ]        = 0.949461;
    coeffEnergy[ 1 ][ 7 ][ 14 ]        =  5.16318;
    coeffEnergy[ 2 ][ 7 ][ 14 ]        = 0.715870;
    coeffEnergy[ 3 ][ 7 ][ 14 ]        = -.301498;
    coeffEnergy[ 4 ][ 7 ][ 14 ]        = -13.3797;
    coeffEnergy[ 5 ][ 7 ][ 14 ]        = -5.30521;
    coeffEnergy[ 6 ][ 7 ][ 14 ]        =  2.90559;
    coeffEnergy[ 7 ][ 7 ][ 14 ]        = 0.127830;
    coeffEnergy[ 8 ][ 7 ][ 14 ]        = -.187602;
    coeffEnergy[ 9 ][ 7 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 14 ]       =  0.00000;
    performanceMin[ 7 ][ 14 ]          = 0.579489;
    performanceMax[ 7 ][ 14 ]          =  1.17537;
    coeffPerformance[ 0 ][ 7 ][ 14 ]   = 0.793896;
    coeffPerformance[ 1 ][ 7 ][ 14 ]   = -4.31967;
    coeffPerformance[ 2 ][ 7 ][ 14 ]   = -.903915;
    coeffPerformance[ 3 ][ 7 ][ 14 ]   = 0.385561;
    coeffPerformance[ 4 ][ 7 ][ 14 ]   =  11.1675;
    coeffPerformance[ 5 ][ 7 ][ 14 ]   =  6.92057;
    coeffPerformance[ 6 ][ 7 ][ 14 ]   = -3.55776;
    coeffPerformance[ 7 ][ 7 ][ 14 ]   = -.200468;
    coeffPerformance[ 8 ][ 7 ][ 14 ]   = -.342656;
    coeffPerformance[ 9 ][ 7 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 14 ]  =  0.00000;
    powerMin[ 7 ][ 14 ]                = 0.536573;
    powerMax[ 7 ][ 14 ]                = 0.974627;
    coeffPower[ 0 ][ 7 ][ 14 ]         = 0.746567;
    coeffPower[ 1 ][ 7 ][ 14 ]         = 0.312866;
    coeffPower[ 2 ][ 7 ][ 14 ]         = -.252278;
    coeffPower[ 3 ][ 7 ][ 14 ]         = 0.109061;
    coeffPower[ 4 ][ 7 ][ 14 ]         = -.832968;
    coeffPower[ 5 ][ 7 ][ 14 ]         =  1.74607;
    coeffPower[ 6 ][ 7 ][ 14 ]         = -.791270;
    coeffPower[ 7 ][ 7 ][ 14 ]         = -.503214E-01;
    coeffPower[ 8 ][ 7 ][ 14 ]         = -.450744;
    coeffPower[ 9 ][ 7 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 14 ]        =  0.00000;
    energyMin[ 8 ][ 14 ]               = 0.636403;
    energyMax[ 8 ][ 14 ]               =  1.29551;
    coeffEnergy[ 0 ][ 8 ][ 14 ]        = 0.944722;
    coeffEnergy[ 1 ][ 8 ][ 14 ]        =  4.16668;
    coeffEnergy[ 2 ][ 8 ][ 14 ]        = 0.561248;
    coeffEnergy[ 3 ][ 8 ][ 14 ]        = -.237745;
    coeffEnergy[ 4 ][ 8 ][ 14 ]        = -10.7928;
    coeffEnergy[ 5 ][ 8 ][ 14 ]        = -4.47947;
    coeffEnergy[ 6 ][ 8 ][ 14 ]        =  2.46889;
    coeffEnergy[ 7 ][ 8 ][ 14 ]        = 0.994990E-01;
    coeffEnergy[ 8 ][ 8 ][ 14 ]        = -.114432;
    coeffEnergy[ 9 ][ 8 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 14 ]       =  0.00000;
    performanceMin[ 8 ][ 14 ]          = 0.548229;
    performanceMax[ 8 ][ 14 ]          =  1.17726;
    coeffPerformance[ 0 ][ 8 ][ 14 ]   = 0.826989;
    coeffPerformance[ 1 ][ 8 ][ 14 ]   = -3.85261;
    coeffPerformance[ 2 ][ 8 ][ 14 ]   = -.871395;
    coeffPerformance[ 3 ][ 8 ][ 14 ]   = 0.367846;
    coeffPerformance[ 4 ][ 8 ][ 14 ]   =  9.95841;
    coeffPerformance[ 5 ][ 8 ][ 14 ]   =  5.94669;
    coeffPerformance[ 6 ][ 8 ][ 14 ]   = -3.06198;
    coeffPerformance[ 7 ][ 8 ][ 14 ]   = -.163465;
    coeffPerformance[ 8 ][ 8 ][ 14 ]   = -.297866;
    coeffPerformance[ 9 ][ 8 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 14 ]  =  0.00000;
    powerMin[ 8 ][ 14 ]                = 0.569607;
    powerMax[ 8 ][ 14 ]                =  1.00007;
    coeffPower[ 0 ][ 8 ][ 14 ]         = 0.777714;
    coeffPower[ 1 ][ 8 ][ 14 ]         = -.289647E-01;
    coeffPower[ 2 ][ 8 ][ 14 ]         = -.340383;
    coeffPower[ 3 ][ 8 ][ 14 ]         = 0.141246;
    coeffPower[ 4 ][ 8 ][ 14 ]         = 0.561636E-01;
    coeffPower[ 5 ][ 8 ][ 14 ]         =  1.44426;
    coeffPower[ 6 ][ 8 ][ 14 ]         = -.628973;
    coeffPower[ 7 ][ 8 ][ 14 ]         = -.492527E-01;
    coeffPower[ 8 ][ 8 ][ 14 ]         = -.356673;
    coeffPower[ 9 ][ 8 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 14 ]        =  0.00000;
    energyMin[ 9 ][ 14 ]               = 0.654947;
    energyMax[ 9 ][ 14 ]               =  1.17594;
    coeffEnergy[ 0 ][ 9 ][ 14 ]        = 0.950929;
    coeffEnergy[ 1 ][ 9 ][ 14 ]        =  3.16079;
    coeffEnergy[ 2 ][ 9 ][ 14 ]        = 0.257207;
    coeffEnergy[ 3 ][ 9 ][ 14 ]        = -.117604;
    coeffEnergy[ 4 ][ 9 ][ 14 ]        = -8.18893;
    coeffEnergy[ 5 ][ 9 ][ 14 ]        = -3.83593;
    coeffEnergy[ 6 ][ 9 ][ 14 ]        =  2.10221;
    coeffEnergy[ 7 ][ 9 ][ 14 ]        = 0.888244E-01;
    coeffEnergy[ 8 ][ 9 ][ 14 ]        = -.373810E-01;
    coeffEnergy[ 9 ][ 9 ][ 14 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 14 ]       =  0.00000;
    performanceMin[ 9 ][ 14 ]          = 0.632360;
    performanceMax[ 9 ][ 14 ]          =  1.18379;
    coeffPerformance[ 0 ][ 9 ][ 14 ]   = 0.848756;
    coeffPerformance[ 1 ][ 9 ][ 14 ]   = -3.02071;
    coeffPerformance[ 2 ][ 9 ][ 14 ]   = -.600603;
    coeffPerformance[ 3 ][ 9 ][ 14 ]   = 0.260284;
    coeffPerformance[ 4 ][ 9 ][ 14 ]   =  7.81021;
    coeffPerformance[ 5 ][ 9 ][ 14 ]   =  5.35375;
    coeffPerformance[ 6 ][ 9 ][ 14 ]   = -2.78150;
    coeffPerformance[ 7 ][ 9 ][ 14 ]   = -.121230;
    coeffPerformance[ 8 ][ 9 ][ 14 ]   = -.311072;
    coeffPerformance[ 9 ][ 9 ][ 14 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 14 ]  =  0.00000;
    powerMin[ 9 ][ 14 ]                = 0.608849;
    powerMax[ 9 ][ 14 ]                =  1.03039;
    coeffPower[ 0 ][ 9 ][ 14 ]         = 0.804155;
    coeffPower[ 1 ][ 9 ][ 14 ]         = -.349735E-01;
    coeffPower[ 2 ][ 9 ][ 14 ]         = -.354028;
    coeffPower[ 3 ][ 9 ][ 14 ]         = 0.146167;
    coeffPower[ 4 ][ 9 ][ 14 ]         = 0.767309E-01;
    coeffPower[ 5 ][ 9 ][ 14 ]         =  1.47588;
    coeffPower[ 6 ][ 9 ][ 14 ]         = -.692024;
    coeffPower[ 7 ][ 9 ][ 14 ]         = -.311988E-01;
    coeffPower[ 8 ][ 9 ][ 14 ]         = -.292825;
    coeffPower[ 9 ][ 9 ][ 14 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 14 ]        =  0.00000;
    energyMin[ 10 ][ 14 ]              = 0.678926;
    energyMax[ 10 ][ 14 ]              =  1.22578;
    coeffEnergy[ 0 ][ 10 ][ 14 ]       = 0.959690;
    coeffEnergy[ 1 ][ 10 ][ 14 ]       =  2.49124;
    coeffEnergy[ 2 ][ 10 ][ 14 ]       = 0.206593;
    coeffEnergy[ 3 ][ 10 ][ 14 ]       = -.964544E-01;
    coeffEnergy[ 4 ][ 10 ][ 14 ]       = -6.45483;
    coeffEnergy[ 5 ][ 10 ][ 14 ]       = -3.22754;
    coeffEnergy[ 6 ][ 10 ][ 14 ]       =  1.74616;
    coeffEnergy[ 7 ][ 10 ][ 14 ]       = 0.561302E-01;
    coeffEnergy[ 8 ][ 10 ][ 14 ]       = 0.769383E-01;
    coeffEnergy[ 9 ][ 10 ][ 14 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 14 ]      =  0.00000;
    performanceMin[ 10 ][ 14 ]         = 0.645161;
    performanceMax[ 10 ][ 14 ]         =  1.20215;
    coeffPerformance[ 0 ][ 10 ][ 14 ]  = 0.879298;
    coeffPerformance[ 1 ][ 10 ][ 14 ]  = -2.43980;
    coeffPerformance[ 2 ][ 10 ][ 14 ]  = -.613880;
    coeffPerformance[ 3 ][ 10 ][ 14 ]  = 0.261242;
    coeffPerformance[ 4 ][ 10 ][ 14 ]  =  6.30779;
    coeffPerformance[ 5 ][ 10 ][ 14 ]  =  4.41891;
    coeffPerformance[ 6 ][ 10 ][ 14 ]  = -2.28195;
    coeffPerformance[ 7 ][ 10 ][ 14 ]  = -.895043E-01;
    coeffPerformance[ 8 ][ 10 ][ 14 ]  = -.312188;
    coeffPerformance[ 9 ][ 10 ][ 14 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 14 ] =  0.00000;
    powerMin[ 10 ][ 14 ]               = 0.643468;
    powerMax[ 10 ][ 14 ]               =  1.05904;
    coeffPower[ 0 ][ 10 ][ 14 ]        = 0.841110;
    coeffPower[ 1 ][ 10 ][ 14 ]        = -.354782E-01;
    coeffPower[ 2 ][ 10 ][ 14 ]        = -.401002;
    coeffPower[ 3 ][ 10 ][ 14 ]        = 0.162139;
    coeffPower[ 4 ][ 10 ][ 14 ]        = 0.798291E-01;
    coeffPower[ 5 ][ 10 ][ 14 ]        =  1.16495;
    coeffPower[ 6 ][ 10 ][ 14 ]        = -.536412;
    coeffPower[ 7 ][ 10 ][ 14 ]        = -.256805E-01;
    coeffPower[ 8 ][ 10 ][ 14 ]        = -.215437;
    coeffPower[ 9 ][ 10 ][ 14 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 14 ]       =  0.00000;
    energyMin[ 11 ][ 14 ]              = 0.706212;
    energyMax[ 11 ][ 14 ]              =  1.18551;
    coeffEnergy[ 0 ][ 11 ][ 14 ]       = 0.968188;
    coeffEnergy[ 1 ][ 11 ][ 14 ]       =  1.67545;
    coeffEnergy[ 2 ][ 11 ][ 14 ]       = 0.356720E-02;
    coeffEnergy[ 3 ][ 11 ][ 14 ]       = -.143007E-01;
    coeffEnergy[ 4 ][ 11 ][ 14 ]       = -4.34094;
    coeffEnergy[ 5 ][ 11 ][ 14 ]       = -2.38048;
    coeffEnergy[ 6 ][ 11 ][ 14 ]       =  1.24438;
    coeffEnergy[ 7 ][ 11 ][ 14 ]       = -.184508E-01;
    coeffEnergy[ 8 ][ 11 ][ 14 ]       = 0.169883;
    coeffEnergy[ 9 ][ 11 ][ 14 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 14 ]      =  0.00000;
    performanceMin[ 11 ][ 14 ]         = 0.699963;
    performanceMax[ 11 ][ 14 ]         =  1.20156;
    coeffPerformance[ 0 ][ 11 ][ 14 ]  = 0.906359;
    coeffPerformance[ 1 ][ 11 ][ 14 ]  = -1.79762;
    coeffPerformance[ 2 ][ 11 ][ 14 ]  = -.423226;
    coeffPerformance[ 3 ][ 11 ][ 14 ]  = 0.182567;
    coeffPerformance[ 4 ][ 11 ][ 14 ]  =  4.64860;
    coeffPerformance[ 5 ][ 11 ][ 14 ]  =  3.35483;
    coeffPerformance[ 6 ][ 11 ][ 14 ]  = -1.66580;
    coeffPerformance[ 7 ][ 11 ][ 14 ]  = -.289252E-03;
    coeffPerformance[ 8 ][ 11 ][ 14 ]  = -.337918;
    coeffPerformance[ 9 ][ 11 ][ 14 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 14 ] =  0.00000;
    powerMin[ 11 ][ 14 ]               = 0.681427;
    powerMax[ 11 ][ 14 ]               =  1.09391;
    coeffPower[ 0 ][ 11 ][ 14 ]        = 0.876718;
    coeffPower[ 1 ][ 11 ][ 14 ]        = -.153974;
    coeffPower[ 2 ][ 11 ][ 14 ]        = -.411105;
    coeffPower[ 3 ][ 11 ][ 14 ]        = 0.164596;
    coeffPower[ 4 ][ 11 ][ 14 ]        = 0.390699;
    coeffPower[ 5 ][ 11 ][ 14 ]        = 0.931442;
    coeffPower[ 6 ][ 11 ][ 14 ]        = -.411122;
    coeffPower[ 7 ][ 11 ][ 14 ]        = -.185864E-01;
    coeffPower[ 8 ][ 11 ][ 14 ]        = -.148531;
    coeffPower[ 9 ][ 11 ][ 14 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 14 ]       =  0.00000;
    energyMin[ 12 ][ 14 ]              = 0.718929;
    energyMax[ 12 ][ 14 ]              =  1.18846;
    coeffEnergy[ 0 ][ 12 ][ 14 ]       = 0.984140;
    coeffEnergy[ 1 ][ 12 ][ 14 ]       =  1.30705;
    coeffEnergy[ 2 ][ 12 ][ 14 ]       = -.732910E-01;
    coeffEnergy[ 3 ][ 12 ][ 14 ]       = 0.188981E-01;
    coeffEnergy[ 4 ][ 12 ][ 14 ]       = -3.39100;
    coeffEnergy[ 5 ][ 12 ][ 14 ]       = -1.70418;
    coeffEnergy[ 6 ][ 12 ][ 14 ]       = 0.915768;
    coeffEnergy[ 7 ][ 12 ][ 14 ]       = -.388179E-01;
    coeffEnergy[ 8 ][ 12 ][ 14 ]       = 0.873234E-01;
    coeffEnergy[ 9 ][ 12 ][ 14 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 14 ]      =  0.00000;
    performanceMin[ 12 ][ 14 ]         = 0.730773;
    performanceMax[ 12 ][ 14 ]         =  1.20873;
    coeffPerformance[ 0 ][ 12 ][ 14 ]  = 0.935951;
    coeffPerformance[ 1 ][ 12 ][ 14 ]  = -1.25247;
    coeffPerformance[ 2 ][ 12 ][ 14 ]  = -.224405;
    coeffPerformance[ 3 ][ 12 ][ 14 ]  = 0.992464E-01;
    coeffPerformance[ 4 ][ 12 ][ 14 ]  =  3.24055;
    coeffPerformance[ 5 ][ 12 ][ 14 ]  =  2.26749;
    coeffPerformance[ 6 ][ 12 ][ 14 ]  = -1.13728;
    coeffPerformance[ 7 ][ 12 ][ 14 ]  = 0.813081E-04;
    coeffPerformance[ 8 ][ 12 ][ 14 ]  = -.194217;
    coeffPerformance[ 9 ][ 12 ][ 14 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 14 ] =  0.00000;
    powerMin[ 12 ][ 14 ]               = 0.707199;
    powerMax[ 12 ][ 14 ]               =  1.12764;
    coeffPower[ 0 ][ 12 ][ 14 ]        = 0.920943;
    coeffPower[ 1 ][ 12 ][ 14 ]        = 0.420738E-01;
    coeffPower[ 2 ][ 12 ][ 14 ]        = -.292230;
    coeffPower[ 3 ][ 12 ][ 14 ]        = 0.115874;
    coeffPower[ 4 ][ 12 ][ 14 ]        = -.117638;
    coeffPower[ 5 ][ 12 ][ 14 ]        = 0.543811;
    coeffPower[ 6 ][ 12 ][ 14 ]        = -.216207;
    coeffPower[ 7 ][ 12 ][ 14 ]        = -.375628E-01;
    coeffPower[ 8 ][ 12 ][ 14 ]        = -.986224E-01;
    coeffPower[ 9 ][ 12 ][ 14 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 14 ]       =  0.00000;
    energyMin[ 13 ][ 14 ]              = 0.741217;
    energyMax[ 13 ][ 14 ]              =  1.21204;
    coeffEnergy[ 0 ][ 13 ][ 14 ]       = 0.988177;
    coeffEnergy[ 1 ][ 13 ][ 14 ]       = 0.605566;
    coeffEnergy[ 2 ][ 13 ][ 14 ]       = 0.945663E-01;
    coeffEnergy[ 3 ][ 13 ][ 14 ]       = -.417454E-01;
    coeffEnergy[ 4 ][ 13 ][ 14 ]       = -1.57005;
    coeffEnergy[ 5 ][ 13 ][ 14 ]       = -.868606;
    coeffEnergy[ 6 ][ 13 ][ 14 ]       = 0.490957;
    coeffEnergy[ 7 ][ 13 ][ 14 ]       = 0.882502E-02;
    coeffEnergy[ 8 ][ 13 ][ 14 ]       = 0.638870E-01;
    coeffEnergy[ 9 ][ 13 ][ 14 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 14 ]      =  0.00000;
    performanceMin[ 13 ][ 14 ]         = 0.748052;
    performanceMax[ 13 ][ 14 ]         =  1.21088;
    coeffPerformance[ 0 ][ 13 ][ 14 ]  = 0.966147;
    coeffPerformance[ 1 ][ 13 ][ 14 ]  = -.895097;
    coeffPerformance[ 2 ][ 13 ][ 14 ]  = -.329226;
    coeffPerformance[ 3 ][ 13 ][ 14 ]  = 0.134187;
    coeffPerformance[ 4 ][ 13 ][ 14 ]  =  2.31840;
    coeffPerformance[ 5 ][ 13 ][ 14 ]  =  1.17051;
    coeffPerformance[ 6 ][ 13 ][ 14 ]  = -.632479;
    coeffPerformance[ 7 ][ 13 ][ 14 ]  = -.319485E-01;
    coeffPerformance[ 8 ][ 13 ][ 14 ]  = -.671473E-01;
    coeffPerformance[ 9 ][ 13 ][ 14 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 14 ] =  0.00000;
    powerMin[ 13 ][ 14 ]               = 0.741304;
    powerMax[ 13 ][ 14 ]               =  1.16360;
    coeffPower[ 0 ][ 13 ][ 14 ]        = 0.954757;
    coeffPower[ 1 ][ 13 ][ 14 ]        = -.275322;
    coeffPower[ 2 ][ 13 ][ 14 ]        = -.227455;
    coeffPower[ 3 ][ 13 ][ 14 ]        = 0.895886E-01;
    coeffPower[ 4 ][ 13 ][ 14 ]        = 0.711491;
    coeffPower[ 5 ][ 13 ][ 14 ]        = 0.293253;
    coeffPower[ 6 ][ 13 ][ 14 ]        = -.136775;
    coeffPower[ 7 ][ 13 ][ 14 ]        = -.227831E-01;
    coeffPower[ 8 ][ 13 ][ 14 ]        = -.260895E-02;
    coeffPower[ 9 ][ 13 ][ 14 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 14 ]       =  0.00000;
    energyMin[ 14 ][ 14 ]              = 0.800000;
    energyMax[ 14 ][ 14 ]              =  1.20000;
    coeffEnergy[ 0 ][ 14 ][ 14 ]       =  1.00000;
    coeffEnergy[ 1 ][ 14 ][ 14 ]       = 0.228017E-11;
    coeffEnergy[ 2 ][ 14 ][ 14 ]       = 0.101130E-11;
    coeffEnergy[ 3 ][ 14 ][ 14 ]       = -.399167E-12;
    coeffEnergy[ 4 ][ 14 ][ 14 ]       = -.593099E-11;
    coeffEnergy[ 5 ][ 14 ][ 14 ]       = -.891693E-12;
    coeffEnergy[ 6 ][ 14 ][ 14 ]       = 0.392630E-12;
    coeffEnergy[ 7 ][ 14 ][ 14 ]       = 0.501837E-13;
    coeffEnergy[ 8 ][ 14 ][ 14 ]       = 0.132800E-12;
    coeffEnergy[ 9 ][ 14 ][ 14 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 14 ]      =  0.00000;
    performanceMin[ 14 ][ 14 ]         = 0.800000;
    performanceMax[ 14 ][ 14 ]         =  1.20000;
    coeffPerformance[ 0 ][ 14 ][ 14 ]  =  1.00000;
    coeffPerformance[ 1 ][ 14 ][ 14 ]  = 0.315100E-12;
    coeffPerformance[ 2 ][ 14 ][ 14 ]  = -.464624E-13;
    coeffPerformance[ 3 ][ 14 ][ 14 ]  = 0.190995E-13;
    coeffPerformance[ 4 ][ 14 ][ 14 ]  = -.817982E-12;
    coeffPerformance[ 5 ][ 14 ][ 14 ]  = 0.176211E-12;
    coeffPerformance[ 6 ][ 14 ][ 14 ]  = -.120245E-12;
    coeffPerformance[ 7 ][ 14 ][ 14 ]  = 0.404460E-13;
    coeffPerformance[ 8 ][ 14 ][ 14 ]  = -.653225E-13;
    coeffPerformance[ 9 ][ 14 ][ 14 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 14 ] =  0.00000;
    powerMin[ 14 ][ 14 ]               = 0.800000;
    powerMax[ 14 ][ 14 ]               =  1.20000;
    coeffPower[ 0 ][ 14 ][ 14 ]        =  1.00000;
    coeffPower[ 1 ][ 14 ][ 14 ]        = 0.515497E-13;
    coeffPower[ 2 ][ 14 ][ 14 ]        = 0.123590E-12;
    coeffPower[ 3 ][ 14 ][ 14 ]        = -.480920E-13;
    coeffPower[ 4 ][ 14 ][ 14 ]        = -.134509E-12;
    coeffPower[ 5 ][ 14 ][ 14 ]        = 0.471466E-14;
    coeffPower[ 6 ][ 14 ][ 14 ]        = 0.134073E-14;
    coeffPower[ 7 ][ 14 ][ 14 ]        = -.242799E-14;
    coeffPower[ 8 ][ 14 ][ 14 ]        = -.634495E-14;
    coeffPower[ 9 ][ 14 ][ 14 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 14 ]       =  0.00000;
    energyMin[ 15 ][ 14 ]              = 0.738448;
    energyMax[ 15 ][ 14 ]              =  1.27537;
    coeffEnergy[ 0 ][ 15 ][ 14 ]       =  1.02006;
    coeffEnergy[ 1 ][ 15 ][ 14 ]       = 0.678753;
    coeffEnergy[ 2 ][ 15 ][ 14 ]       = 0.267968;
    coeffEnergy[ 3 ][ 15 ][ 14 ]       = -.985532E-01;
    coeffEnergy[ 4 ][ 15 ][ 14 ]       = -1.76564;
    coeffEnergy[ 5 ][ 15 ][ 14 ]       = 0.881791;
    coeffEnergy[ 6 ][ 15 ][ 14 ]       = -.405485;
    coeffEnergy[ 7 ][ 15 ][ 14 ]       = 0.637419E-01;
    coeffEnergy[ 8 ][ 15 ][ 14 ]       = -.201268;
    coeffEnergy[ 9 ][ 15 ][ 14 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 14 ]      =  0.00000;
    performanceMin[ 15 ][ 14 ]         = 0.781306;
    performanceMax[ 15 ][ 14 ]         =  1.38805;
    coeffPerformance[ 0 ][ 15 ][ 14 ]  =  1.02141;
    coeffPerformance[ 1 ][ 15 ][ 14 ]  = -.883883;
    coeffPerformance[ 2 ][ 15 ][ 14 ]  = -.174169;
    coeffPerformance[ 3 ][ 15 ][ 14 ]  = 0.608028E-01;
    coeffPerformance[ 4 ][ 15 ][ 14 ]  =  2.30327;
    coeffPerformance[ 5 ][ 15 ][ 14 ]  = -1.22330;
    coeffPerformance[ 6 ][ 15 ][ 14 ]  = 0.615988;
    coeffPerformance[ 7 ][ 15 ][ 14 ]  = -.208231E-01;
    coeffPerformance[ 8 ][ 15 ][ 14 ]  = 0.187567;
    coeffPerformance[ 9 ][ 15 ][ 14 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 14 ] =  0.00000;
    powerMin[ 15 ][ 14 ]               = 0.825267;
    powerMax[ 15 ][ 14 ]               =  1.31674;
    coeffPower[ 0 ][ 15 ][ 14 ]        =  1.04177;
    coeffPower[ 1 ][ 15 ][ 14 ]        = -.777703E-01;
    coeffPower[ 2 ][ 15 ][ 14 ]        = 0.128247;
    coeffPower[ 3 ][ 15 ][ 14 ]        = -.509157E-01;
    coeffPower[ 4 ][ 15 ][ 14 ]        = 0.207238;
    coeffPower[ 5 ][ 15 ][ 14 ]        = -.325323;
    coeffPower[ 6 ][ 15 ][ 14 ]        = 0.209254;
    coeffPower[ 7 ][ 15 ][ 14 ]        = 0.520039E-01;
    coeffPower[ 8 ][ 15 ][ 14 ]        = -.337431E-01;
    coeffPower[ 9 ][ 15 ][ 14 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 14 ]       =  0.00000;
    // Limits and Coefficients for Reference frequency: = 2.70;
    energyMin[ 0 ][ 15 ]               = 0.494523;
    energyMax[ 0 ][ 15 ]               =  1.38588;
    coeffEnergy[ 0 ][ 0 ][ 15 ]        =  1.02904;
    coeffEnergy[ 1 ][ 0 ][ 15 ]        =  8.29728;
    coeffEnergy[ 2 ][ 0 ][ 15 ]        =  2.60020;
    coeffEnergy[ 3 ][ 0 ][ 15 ]        = -1.03655;
    coeffEnergy[ 4 ][ 0 ][ 15 ]        = -22.3100;
    coeffEnergy[ 5 ][ 0 ][ 15 ]        = -13.5365;
    coeffEnergy[ 6 ][ 0 ][ 15 ]        =  7.17762;
    coeffEnergy[ 7 ][ 0 ][ 15 ]        = -.234680;
    coeffEnergy[ 8 ][ 0 ][ 15 ]        = 0.631302;
    coeffEnergy[ 9 ][ 0 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 0 ][ 15 ]       =  0.00000;
    performanceMin[ 0 ][ 15 ]          = 0.352384;
    performanceMax[ 0 ][ 15 ]          =  1.02572;
    coeffPerformance[ 0 ][ 0 ][ 15 ]   = 0.508477;
    coeffPerformance[ 1 ][ 0 ][ 15 ]   = -2.43486;
    coeffPerformance[ 2 ][ 0 ][ 15 ]   = -.501082;
    coeffPerformance[ 3 ][ 0 ][ 15 ]   = 0.248525;
    coeffPerformance[ 4 ][ 0 ][ 15 ]   =  6.51164;
    coeffPerformance[ 5 ][ 0 ][ 15 ]   =  11.4115;
    coeffPerformance[ 6 ][ 0 ][ 15 ]   = -6.01949;
    coeffPerformance[ 7 ][ 0 ][ 15 ]   = -.165207;
    coeffPerformance[ 8 ][ 0 ][ 15 ]   = -.784876;
    coeffPerformance[ 9 ][ 0 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 0 ][ 15 ]  =  0.00000;
    powerMin[ 0 ][ 15 ]                = 0.318559;
    powerMax[ 0 ][ 15 ]                = 0.755212;
    coeffPower[ 0 ][ 0 ][ 15 ]         = 0.511507;
    coeffPower[ 1 ][ 0 ][ 15 ]         =  1.73174;
    coeffPower[ 2 ][ 0 ][ 15 ]         = 0.965016;
    coeffPower[ 3 ][ 0 ][ 15 ]         = -.347208;
    coeffPower[ 4 ][ 0 ][ 15 ]         = -4.68374;
    coeffPower[ 5 ][ 0 ][ 15 ]         =  1.68620;
    coeffPower[ 6 ][ 0 ][ 15 ]         = -1.06371;
    coeffPower[ 7 ][ 0 ][ 15 ]         = -.229812;
    coeffPower[ 8 ][ 0 ][ 15 ]         = -.235449;
    coeffPower[ 9 ][ 0 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 0 ][ 15 ]        =  0.00000;
    energyMin[ 1 ][ 15 ]               = 0.506829;
    energyMax[ 1 ][ 15 ]               =  1.32049;
    coeffEnergy[ 0 ][ 1 ][ 15 ]        =  1.02293;
    coeffEnergy[ 1 ][ 1 ][ 15 ]        =  6.33547;
    coeffEnergy[ 2 ][ 1 ][ 15 ]        =  1.90633;
    coeffEnergy[ 3 ][ 1 ][ 15 ]        = -.777029;
    coeffEnergy[ 4 ][ 1 ][ 15 ]        = -17.0391;
    coeffEnergy[ 5 ][ 1 ][ 15 ]        = -12.2820;
    coeffEnergy[ 6 ][ 1 ][ 15 ]        =  6.45370;
    coeffEnergy[ 7 ][ 1 ][ 15 ]        = -.345334;
    coeffEnergy[ 8 ][ 1 ][ 15 ]        = 0.838017;
    coeffEnergy[ 9 ][ 1 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 1 ][ 15 ]       =  0.00000;
    performanceMin[ 1 ][ 15 ]          = 0.377463;
    performanceMax[ 1 ][ 15 ]          =  1.06752;
    coeffPerformance[ 0 ][ 1 ][ 15 ]   = 0.549570;
    coeffPerformance[ 1 ][ 1 ][ 15 ]   = -2.84367;
    coeffPerformance[ 2 ][ 1 ][ 15 ]   = -.579655;
    coeffPerformance[ 3 ][ 1 ][ 15 ]   = 0.278108;
    coeffPerformance[ 4 ][ 1 ][ 15 ]   =  7.61068;
    coeffPerformance[ 5 ][ 1 ][ 15 ]   =  11.2081;
    coeffPerformance[ 6 ][ 1 ][ 15 ]   = -5.68879;
    coeffPerformance[ 7 ][ 1 ][ 15 ]   = -.917206E-01;
    coeffPerformance[ 8 ][ 1 ][ 15 ]   = -.989233;
    coeffPerformance[ 9 ][ 1 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 1 ][ 15 ]  =  0.00000;
    powerMin[ 1 ][ 15 ]                = 0.352535;
    powerMax[ 1 ][ 15 ]                = 0.806609;
    coeffPower[ 0 ][ 1 ][ 15 ]         = 0.554616;
    coeffPower[ 1 ][ 1 ][ 15 ]         = 0.641631;
    coeffPower[ 2 ][ 1 ][ 15 ]         = 0.544495;
    coeffPower[ 3 ][ 1 ][ 15 ]         = -.193256;
    coeffPower[ 4 ][ 1 ][ 15 ]         = -1.75610;
    coeffPower[ 5 ][ 1 ][ 15 ]         =  1.74732;
    coeffPower[ 6 ][ 1 ][ 15 ]         = -.959223;
    coeffPower[ 7 ][ 1 ][ 15 ]         = -.276668;
    coeffPower[ 8 ][ 1 ][ 15 ]         = -.205309;
    coeffPower[ 9 ][ 1 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 1 ][ 15 ]        =  0.00000;
    energyMin[ 2 ][ 15 ]               = 0.518977;
    energyMax[ 2 ][ 15 ]               =  1.28248;
    coeffEnergy[ 0 ][ 2 ][ 15 ]        = 0.993110;
    coeffEnergy[ 1 ][ 2 ][ 15 ]        =  6.94540;
    coeffEnergy[ 2 ][ 2 ][ 15 ]        =  1.75330;
    coeffEnergy[ 3 ][ 2 ][ 15 ]        = -.712789;
    coeffEnergy[ 4 ][ 2 ][ 15 ]        = -18.6822;
    coeffEnergy[ 5 ][ 2 ][ 15 ]        = -10.7584;
    coeffEnergy[ 6 ][ 2 ][ 15 ]        =  5.90008;
    coeffEnergy[ 7 ][ 2 ][ 15 ]        = -.239574;
    coeffEnergy[ 8 ][ 2 ][ 15 ]        = 0.641588;
    coeffEnergy[ 9 ][ 2 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 2 ][ 15 ]       =  0.00000;
    performanceMin[ 2 ][ 15 ]          = 0.409480;
    performanceMax[ 2 ][ 15 ]          =  1.09196;
    coeffPerformance[ 0 ][ 2 ][ 15 ]   = 0.595146;
    coeffPerformance[ 1 ][ 2 ][ 15 ]   = -3.79153;
    coeffPerformance[ 2 ][ 2 ][ 15 ]   = -.849970;
    coeffPerformance[ 3 ][ 2 ][ 15 ]   = 0.375933;
    coeffPerformance[ 4 ][ 2 ][ 15 ]   =  10.1608;
    coeffPerformance[ 5 ][ 2 ][ 15 ]   =  10.8350;
    coeffPerformance[ 6 ][ 2 ][ 15 ]   = -5.55730;
    coeffPerformance[ 7 ][ 2 ][ 15 ]   = -.152164;
    coeffPerformance[ 8 ][ 2 ][ 15 ]   = -.867029;
    coeffPerformance[ 9 ][ 2 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 2 ][ 15 ]  =  0.00000;
    powerMin[ 2 ][ 15 ]                = 0.370976;
    powerMax[ 2 ][ 15 ]                = 0.828967;
    coeffPower[ 0 ][ 2 ][ 15 ]         = 0.579334;
    coeffPower[ 1 ][ 2 ][ 15 ]         = 0.752197;
    coeffPower[ 2 ][ 2 ][ 15 ]         = 0.316549;
    coeffPower[ 3 ][ 2 ][ 15 ]         = -.108248;
    coeffPower[ 4 ][ 2 ][ 15 ]         = -2.05372;
    coeffPower[ 5 ][ 2 ][ 15 ]         =  2.05627;
    coeffPower[ 6 ][ 2 ][ 15 ]         = -.953282;
    coeffPower[ 7 ][ 2 ][ 15 ]         = -.262491;
    coeffPower[ 8 ][ 2 ][ 15 ]         = -.220187;
    coeffPower[ 9 ][ 2 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 2 ][ 15 ]        =  0.00000;
    energyMin[ 3 ][ 15 ]               = 0.523815;
    energyMax[ 3 ][ 15 ]               =  1.25583;
    coeffEnergy[ 0 ][ 3 ][ 15 ]        = 0.953530;
    coeffEnergy[ 1 ][ 3 ][ 15 ]        =  7.52170;
    coeffEnergy[ 2 ][ 3 ][ 15 ]        =  1.78154;
    coeffEnergy[ 3 ][ 3 ][ 15 ]        = -.711395;
    coeffEnergy[ 4 ][ 3 ][ 15 ]        = -20.2269;
    coeffEnergy[ 5 ][ 3 ][ 15 ]        = -9.44680;
    coeffEnergy[ 6 ][ 3 ][ 15 ]        =  5.40584;
    coeffEnergy[ 7 ][ 3 ][ 15 ]        = -.683196E-02;
    coeffEnergy[ 8 ][ 3 ][ 15 ]        = 0.144422;
    coeffEnergy[ 9 ][ 3 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 3 ][ 15 ]       =  0.00000;
    performanceMin[ 3 ][ 15 ]          = 0.418081;
    performanceMax[ 3 ][ 15 ]          =  1.12026;
    coeffPerformance[ 0 ][ 3 ][ 15 ]   = 0.644249;
    coeffPerformance[ 1 ][ 3 ][ 15 ]   = -4.58659;
    coeffPerformance[ 2 ][ 3 ][ 15 ]   = -1.04757;
    coeffPerformance[ 3 ][ 3 ][ 15 ]   = 0.443385;
    coeffPerformance[ 4 ][ 3 ][ 15 ]   =  12.2972;
    coeffPerformance[ 5 ][ 3 ][ 15 ]   =  10.2256;
    coeffPerformance[ 6 ][ 3 ][ 15 ]   = -5.37415;
    coeffPerformance[ 7 ][ 3 ][ 15 ]   = -.286467;
    coeffPerformance[ 8 ][ 3 ][ 15 ]   = -.532772;
    coeffPerformance[ 9 ][ 3 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 3 ][ 15 ]  =  0.00000;
    powerMin[ 3 ][ 15 ]                = 0.392080;
    powerMax[ 3 ][ 15 ]                = 0.847393;
    coeffPower[ 0 ][ 3 ][ 15 ]         = 0.598680;
    coeffPower[ 1 ][ 3 ][ 15 ]         = 0.945805;
    coeffPower[ 2 ][ 3 ][ 15 ]         = 0.257890;
    coeffPower[ 3 ][ 3 ][ 15 ]         = -.847902E-01;
    coeffPower[ 4 ][ 3 ][ 15 ]         = -2.57261;
    coeffPower[ 5 ][ 3 ][ 15 ]         =  2.08830;
    coeffPower[ 6 ][ 3 ][ 15 ]         = -.899322;
    coeffPower[ 7 ][ 3 ][ 15 ]         = -.198831;
    coeffPower[ 8 ][ 3 ][ 15 ]         = -.314463;
    coeffPower[ 9 ][ 3 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 3 ][ 15 ]        =  0.00000;
    energyMin[ 4 ][ 15 ]               = 0.531120;
    energyMax[ 4 ][ 15 ]               =  1.22623;
    coeffEnergy[ 0 ][ 4 ][ 15 ]        = 0.934553;
    coeffEnergy[ 1 ][ 4 ][ 15 ]        =  6.31122;
    coeffEnergy[ 2 ][ 4 ][ 15 ]        =  1.45851;
    coeffEnergy[ 3 ][ 4 ][ 15 ]        = -.586361;
    coeffEnergy[ 4 ][ 4 ][ 15 ]        = -16.9682;
    coeffEnergy[ 5 ][ 4 ][ 15 ]        = -8.25279;
    coeffEnergy[ 6 ][ 4 ][ 15 ]        =  4.66590;
    coeffEnergy[ 7 ][ 4 ][ 15 ]        = -.224389E-01;
    coeffEnergy[ 8 ][ 4 ][ 15 ]        = 0.235524;
    coeffEnergy[ 9 ][ 4 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 4 ][ 15 ]       =  0.00000;
    performanceMin[ 4 ][ 15 ]          = 0.463294;
    performanceMax[ 4 ][ 15 ]          =  1.13671;
    coeffPerformance[ 0 ][ 4 ][ 15 ]   = 0.676095;
    coeffPerformance[ 1 ][ 4 ][ 15 ]   = -4.61656;
    coeffPerformance[ 2 ][ 4 ][ 15 ]   = -1.00978;
    coeffPerformance[ 3 ][ 4 ][ 15 ]   = 0.429368;
    coeffPerformance[ 4 ][ 4 ][ 15 ]   =  12.3815;
    coeffPerformance[ 5 ][ 4 ][ 15 ]   =  9.87073;
    coeffPerformance[ 6 ][ 4 ][ 15 ]   = -5.15591;
    coeffPerformance[ 7 ][ 4 ][ 15 ]   = -.187176;
    coeffPerformance[ 8 ][ 4 ][ 15 ]   = -.716448;
    coeffPerformance[ 9 ][ 4 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 4 ][ 15 ]  =  0.00000;
    powerMin[ 4 ][ 15 ]                = 0.428605;
    powerMax[ 4 ][ 15 ]                = 0.871875;
    coeffPower[ 0 ][ 4 ][ 15 ]         = 0.615691;
    coeffPower[ 1 ][ 4 ][ 15 ]         = 0.451373;
    coeffPower[ 2 ][ 4 ][ 15 ]         = 0.137222;
    coeffPower[ 3 ][ 4 ][ 15 ]         = -.376527E-01;
    coeffPower[ 4 ][ 4 ][ 15 ]         = -1.23657;
    coeffPower[ 5 ][ 4 ][ 15 ]         =  2.44537;
    coeffPower[ 6 ][ 4 ][ 15 ]         = -1.12188;
    coeffPower[ 7 ][ 4 ][ 15 ]         = -.137493;
    coeffPower[ 8 ][ 4 ][ 15 ]         = -.385618;
    coeffPower[ 9 ][ 4 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 4 ][ 15 ]        =  0.00000;
    energyMin[ 5 ][ 15 ]               = 0.545596;
    energyMax[ 5 ][ 15 ]               =  1.19775;
    coeffEnergy[ 0 ][ 5 ][ 15 ]        = 0.924060;
    coeffEnergy[ 1 ][ 5 ][ 15 ]        =  5.63193;
    coeffEnergy[ 2 ][ 5 ][ 15 ]        =  1.03413;
    coeffEnergy[ 3 ][ 5 ][ 15 ]        = -.420622;
    coeffEnergy[ 4 ][ 5 ][ 15 ]        = -15.1413;
    coeffEnergy[ 5 ][ 5 ][ 15 ]        = -7.27375;
    coeffEnergy[ 6 ][ 5 ][ 15 ]        =  4.11540;
    coeffEnergy[ 7 ][ 5 ][ 15 ]        = 0.742154E-01;
    coeffEnergy[ 8 ][ 5 ][ 15 ]        = 0.547195E-02;
    coeffEnergy[ 9 ][ 5 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 5 ][ 15 ]       =  0.00000;
    performanceMin[ 5 ][ 15 ]          = 0.492411;
    performanceMax[ 5 ][ 15 ]          =  1.14865;
    coeffPerformance[ 0 ][ 5 ][ 15 ]   = 0.718453;
    coeffPerformance[ 1 ][ 5 ][ 15 ]   = -4.89658;
    coeffPerformance[ 2 ][ 5 ][ 15 ]   = -1.04378;
    coeffPerformance[ 3 ][ 5 ][ 15 ]   = 0.435278;
    coeffPerformance[ 4 ][ 5 ][ 15 ]   =  13.1350;
    coeffPerformance[ 5 ][ 5 ][ 15 ]   =  9.12278;
    coeffPerformance[ 6 ][ 5 ][ 15 ]   = -4.92698;
    coeffPerformance[ 7 ][ 5 ][ 15 ]   = -.301525;
    coeffPerformance[ 8 ][ 5 ][ 15 ]   = -.400390;
    coeffPerformance[ 9 ][ 5 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 5 ][ 15 ]  =  0.00000;
    powerMin[ 5 ][ 15 ]                = 0.457512;
    powerMax[ 5 ][ 15 ]                = 0.893786;
    coeffPower[ 0 ][ 5 ][ 15 ]         = 0.647219;
    coeffPower[ 1 ][ 5 ][ 15 ]         = -.566244E-01;
    coeffPower[ 2 ][ 5 ][ 15 ]         = -.205934;
    coeffPower[ 3 ][ 5 ][ 15 ]         = 0.901014E-01;
    coeffPower[ 4 ][ 5 ][ 15 ]         = 0.130283;
    coeffPower[ 5 ][ 5 ][ 15 ]         =  2.35735;
    coeffPower[ 6 ][ 5 ][ 15 ]         = -1.19564;
    coeffPower[ 7 ][ 5 ][ 15 ]         = -.141528;
    coeffPower[ 8 ][ 5 ][ 15 ]         = -.356185;
    coeffPower[ 9 ][ 5 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 5 ][ 15 ]        =  0.00000;
    energyMin[ 6 ][ 15 ]               = 0.564581;
    energyMax[ 6 ][ 15 ]               =  1.19225;
    coeffEnergy[ 0 ][ 6 ][ 15 ]        = 0.922524;
    coeffEnergy[ 1 ][ 6 ][ 15 ]        =  4.70182;
    coeffEnergy[ 2 ][ 6 ][ 15 ]        = 0.958520;
    coeffEnergy[ 3 ][ 6 ][ 15 ]        = -.386383;
    coeffEnergy[ 4 ][ 6 ][ 15 ]        = -12.6402;
    coeffEnergy[ 5 ][ 6 ][ 15 ]        = -6.78222;
    coeffEnergy[ 6 ][ 6 ][ 15 ]        =  3.97460;
    coeffEnergy[ 7 ][ 6 ][ 15 ]        = 0.186105;
    coeffEnergy[ 8 ][ 6 ][ 15 ]        = -.309161;
    coeffEnergy[ 9 ][ 6 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 6 ][ 15 ]       =  0.00000;
    performanceMin[ 6 ][ 15 ]          = 0.502808;
    performanceMax[ 6 ][ 15 ]          =  1.16013;
    coeffPerformance[ 0 ][ 6 ][ 15 ]   = 0.754337;
    coeffPerformance[ 1 ][ 6 ][ 15 ]   = -4.52267;
    coeffPerformance[ 2 ][ 6 ][ 15 ]   = -1.05462;
    coeffPerformance[ 3 ][ 6 ][ 15 ]   = 0.432941;
    coeffPerformance[ 4 ][ 6 ][ 15 ]   =  12.1304;
    coeffPerformance[ 5 ][ 6 ][ 15 ]   =  8.52217;
    coeffPerformance[ 6 ][ 6 ][ 15 ]   = -4.75709;
    coeffPerformance[ 7 ][ 6 ][ 15 ]   = -.400110;
    coeffPerformance[ 8 ][ 6 ][ 15 ]   = -.763226E-01;
    coeffPerformance[ 9 ][ 6 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 6 ][ 15 ]  =  0.00000;
    powerMin[ 6 ][ 15 ]                = 0.483369;
    powerMax[ 6 ][ 15 ]                = 0.917518;
    coeffPower[ 0 ][ 6 ][ 15 ]         = 0.681868;
    coeffPower[ 1 ][ 6 ][ 15 ]         = -.300668;
    coeffPower[ 2 ][ 6 ][ 15 ]         = -.207805;
    coeffPower[ 3 ][ 6 ][ 15 ]         = 0.893598E-01;
    coeffPower[ 4 ][ 6 ][ 15 ]         = 0.786577;
    coeffPower[ 5 ][ 6 ][ 15 ]         =  2.06965;
    coeffPower[ 6 ][ 6 ][ 15 ]         = -1.05795;
    coeffPower[ 7 ][ 6 ][ 15 ]         = -.150973;
    coeffPower[ 8 ][ 6 ][ 15 ]         = -.327308;
    coeffPower[ 9 ][ 6 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 6 ][ 15 ]        =  0.00000;
    energyMin[ 7 ][ 15 ]               = 0.594614;
    energyMax[ 7 ][ 15 ]               =  1.18388;
    coeffEnergy[ 0 ][ 7 ][ 15 ]        = 0.924647;
    coeffEnergy[ 1 ][ 7 ][ 15 ]        =  3.75811;
    coeffEnergy[ 2 ][ 7 ][ 15 ]        = 0.646757;
    coeffEnergy[ 3 ][ 7 ][ 15 ]        = -.268841;
    coeffEnergy[ 4 ][ 7 ][ 15 ]        = -10.1015;
    coeffEnergy[ 5 ][ 7 ][ 15 ]        = -5.87793;
    coeffEnergy[ 6 ][ 7 ][ 15 ]        =  3.26887;
    coeffEnergy[ 7 ][ 7 ][ 15 ]        = 0.484046E-01;
    coeffEnergy[ 8 ][ 7 ][ 15 ]        = 0.333094E-01;
    coeffEnergy[ 9 ][ 7 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 7 ][ 15 ]       =  0.00000;
    performanceMin[ 7 ][ 15 ]          = 0.559424;
    performanceMax[ 7 ][ 15 ]          =  1.16779;
    coeffPerformance[ 0 ][ 7 ][ 15 ]   = 0.778609;
    coeffPerformance[ 1 ][ 7 ][ 15 ]   = -4.14547;
    coeffPerformance[ 2 ][ 7 ][ 15 ]   = -.917426;
    coeffPerformance[ 3 ][ 7 ][ 15 ]   = 0.381030;
    coeffPerformance[ 4 ][ 7 ][ 15 ]   =  11.1206;
    coeffPerformance[ 5 ][ 7 ][ 15 ]   =  7.61351;
    coeffPerformance[ 6 ][ 7 ][ 15 ]   = -4.04445;
    coeffPerformance[ 7 ][ 7 ][ 15 ]   = -.200230;
    coeffPerformance[ 8 ][ 7 ][ 15 ]   = -.439714;
    coeffPerformance[ 9 ][ 7 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 7 ][ 15 ]  =  0.00000;
    powerMin[ 7 ][ 15 ]                = 0.509327;
    powerMax[ 7 ][ 15 ]                = 0.943821;
    coeffPower[ 0 ][ 7 ][ 15 ]         = 0.709608;
    coeffPower[ 1 ][ 7 ][ 15 ]         = -.647079;
    coeffPower[ 2 ][ 7 ][ 15 ]         = -.335866;
    coeffPower[ 3 ][ 7 ][ 15 ]         = 0.136859;
    coeffPower[ 4 ][ 7 ][ 15 ]         =  1.72201;
    coeffPower[ 5 ][ 7 ][ 15 ]         =  1.89039;
    coeffPower[ 6 ][ 7 ][ 15 ]         = -.941248;
    coeffPower[ 7 ][ 7 ][ 15 ]         = -.104101;
    coeffPower[ 8 ][ 7 ][ 15 ]         = -.354740;
    coeffPower[ 9 ][ 7 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 7 ][ 15 ]        =  0.00000;
    energyMin[ 8 ][ 15 ]               = 0.613603;
    energyMax[ 8 ][ 15 ]               =  1.26937;
    coeffEnergy[ 0 ][ 8 ][ 15 ]        = 0.925800;
    coeffEnergy[ 1 ][ 8 ][ 15 ]        =  3.64839;
    coeffEnergy[ 2 ][ 8 ][ 15 ]        = 0.625571;
    coeffEnergy[ 3 ][ 8 ][ 15 ]        = -.257369;
    coeffEnergy[ 4 ][ 8 ][ 15 ]        = -9.80663;
    coeffEnergy[ 5 ][ 8 ][ 15 ]        = -5.04564;
    coeffEnergy[ 6 ][ 8 ][ 15 ]        =  2.80357;
    coeffEnergy[ 7 ][ 8 ][ 15 ]        = 0.441274E-01;
    coeffEnergy[ 8 ][ 8 ][ 15 ]        = 0.691562E-01;
    coeffEnergy[ 9 ][ 8 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 8 ][ 15 ]       =  0.00000;
    performanceMin[ 8 ][ 15 ]          = 0.527827;
    performanceMax[ 8 ][ 15 ]          =  1.17524;
    coeffPerformance[ 0 ][ 8 ][ 15 ]   = 0.807769;
    coeffPerformance[ 1 ][ 8 ][ 15 ]   = -4.19366;
    coeffPerformance[ 2 ][ 8 ][ 15 ]   = -.955158;
    coeffPerformance[ 3 ][ 8 ][ 15 ]   = 0.390262;
    coeffPerformance[ 4 ][ 8 ][ 15 ]   =  11.2540;
    coeffPerformance[ 5 ][ 8 ][ 15 ]   =  6.65617;
    coeffPerformance[ 6 ][ 8 ][ 15 ]   = -3.53529;
    coeffPerformance[ 7 ][ 8 ][ 15 ]   = -.179474;
    coeffPerformance[ 8 ][ 8 ][ 15 ]   = -.373574;
    coeffPerformance[ 9 ][ 8 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 8 ][ 15 ]  =  0.00000;
    powerMin[ 8 ][ 15 ]                = 0.537398;
    powerMax[ 8 ][ 15 ]                = 0.968986;
    coeffPower[ 0 ][ 8 ][ 15 ]         = 0.741187;
    coeffPower[ 1 ][ 8 ][ 15 ]         = -.814546;
    coeffPower[ 2 ][ 8 ][ 15 ]         = -.397156;
    coeffPower[ 3 ][ 8 ][ 15 ]         = 0.157774;
    coeffPower[ 4 ][ 8 ][ 15 ]         =  2.17450;
    coeffPower[ 5 ][ 8 ][ 15 ]         =  1.58582;
    coeffPower[ 6 ][ 8 ][ 15 ]         = -.768770;
    coeffPower[ 7 ][ 8 ][ 15 ]         = -.100232;
    coeffPower[ 8 ][ 8 ][ 15 ]         = -.272115;
    coeffPower[ 9 ][ 8 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 8 ][ 15 ]        =  0.00000;
    energyMin[ 9 ][ 15 ]               = 0.633360;
    energyMax[ 9 ][ 15 ]               =  1.17789;
    coeffEnergy[ 0 ][ 9 ][ 15 ]        = 0.931345;
    coeffEnergy[ 1 ][ 9 ][ 15 ]        =  2.38565;
    coeffEnergy[ 2 ][ 9 ][ 15 ]        = 0.383378;
    coeffEnergy[ 3 ][ 9 ][ 15 ]        = -.165060;
    coeffEnergy[ 4 ][ 9 ][ 15 ]        = -6.41046;
    coeffEnergy[ 5 ][ 9 ][ 15 ]        = -4.47255;
    coeffEnergy[ 6 ][ 9 ][ 15 ]        =  2.47557;
    coeffEnergy[ 7 ][ 9 ][ 15 ]        = 0.306506E-01;
    coeffEnergy[ 8 ][ 9 ][ 15 ]        = 0.152782;
    coeffEnergy[ 9 ][ 9 ][ 15 ]        =  0.00000;
    coeffEnergy[ 10 ][ 9 ][ 15 ]       =  0.00000;
    performanceMin[ 9 ][ 15 ]          = 0.607775;
    performanceMax[ 9 ][ 15 ]          =  1.17991;
    coeffPerformance[ 0 ][ 9 ][ 15 ]   = 0.829768;
    coeffPerformance[ 1 ][ 9 ][ 15 ]   = -3.01644;
    coeffPerformance[ 2 ][ 9 ][ 15 ]   = -.649867;
    coeffPerformance[ 3 ][ 9 ][ 15 ]   = 0.274195;
    coeffPerformance[ 4 ][ 9 ][ 15 ]   =  8.09205;
    coeffPerformance[ 5 ][ 9 ][ 15 ]   =  6.17398;
    coeffPerformance[ 6 ][ 9 ][ 15 ]   = -3.31099;
    coeffPerformance[ 7 ][ 9 ][ 15 ]   = -.131338;
    coeffPerformance[ 8 ][ 9 ][ 15 ]   = -.404895;
    coeffPerformance[ 9 ][ 9 ][ 15 ]   =  0.00000;
    coeffPerformance[ 10 ][ 9 ][ 15 ]  =  0.00000;
    powerMin[ 9 ][ 15 ]                = 0.566004;
    powerMax[ 9 ][ 15 ]                = 0.997821;
    coeffPower[ 0 ][ 9 ][ 15 ]         = 0.767527;
    coeffPower[ 1 ][ 9 ][ 15 ]         = -.644095;
    coeffPower[ 2 ][ 9 ][ 15 ]         = -.279970;
    coeffPower[ 3 ][ 9 ][ 15 ]         = 0.113712;
    coeffPower[ 4 ][ 9 ][ 15 ]         =  1.71962;
    coeffPower[ 5 ][ 9 ][ 15 ]         =  1.67051;
    coeffPower[ 6 ][ 9 ][ 15 ]         = -.859922;
    coeffPower[ 7 ][ 9 ][ 15 ]         = -.829592E-01;
    coeffPower[ 8 ][ 9 ][ 15 ]         = -.214264;
    coeffPower[ 9 ][ 9 ][ 15 ]         =  0.00000;
    coeffPower[ 10 ][ 9 ][ 15 ]        =  0.00000;
    energyMin[ 10 ][ 15 ]              = 0.655151;
    energyMax[ 10 ][ 15 ]              =  1.21289;
    coeffEnergy[ 0 ][ 10 ][ 15 ]       = 0.941481;
    coeffEnergy[ 1 ][ 10 ][ 15 ]       =  1.94823;
    coeffEnergy[ 2 ][ 10 ][ 15 ]       = 0.291849;
    coeffEnergy[ 3 ][ 10 ][ 15 ]       = -.129517;
    coeffEnergy[ 4 ][ 10 ][ 15 ]       = -5.23567;
    coeffEnergy[ 5 ][ 10 ][ 15 ]       = -3.89417;
    coeffEnergy[ 6 ][ 10 ][ 15 ]       =  2.11502;
    coeffEnergy[ 7 ][ 10 ][ 15 ]       = 0.730311E-02;
    coeffEnergy[ 8 ][ 10 ][ 15 ]       = 0.261289;
    coeffEnergy[ 9 ][ 10 ][ 15 ]       =  0.00000;
    coeffEnergy[ 10 ][ 10 ][ 15 ]      =  0.00000;
    performanceMin[ 10 ][ 15 ]         = 0.621387;
    performanceMax[ 10 ][ 15 ]         =  1.19591;
    coeffPerformance[ 0 ][ 10 ][ 15 ]  = 0.859091;
    coeffPerformance[ 1 ][ 10 ][ 15 ]  = -2.48375;
    coeffPerformance[ 2 ][ 10 ][ 15 ]  = -.611008;
    coeffPerformance[ 3 ][ 10 ][ 15 ]  = 0.255747;
    coeffPerformance[ 4 ][ 10 ][ 15 ]  =  6.66166;
    coeffPerformance[ 5 ][ 10 ][ 15 ]  =  5.32500;
    coeffPerformance[ 6 ][ 10 ][ 15 ]  = -2.85420;
    coeffPerformance[ 7 ][ 10 ][ 15 ]  = -.111844;
    coeffPerformance[ 8 ][ 10 ][ 15 ]  = -.390948;
    coeffPerformance[ 9 ][ 10 ][ 15 ]  =  0.00000;
    coeffPerformance[ 10 ][ 10 ][ 15 ] =  0.00000;
    powerMin[ 10 ][ 15 ]               = 0.592557;
    powerMax[ 10 ][ 15 ]               =  1.02557;
    coeffPower[ 0 ][ 10 ][ 15 ]        = 0.803650;
    coeffPower[ 1 ][ 10 ][ 15 ]        = -.482643;
    coeffPower[ 2 ][ 10 ][ 15 ]        = -.304200;
    coeffPower[ 3 ][ 10 ][ 15 ]        = 0.120809;
    coeffPower[ 4 ][ 10 ][ 15 ]        =  1.28596;
    coeffPower[ 5 ][ 10 ][ 15 ]        =  1.42195;
    coeffPower[ 6 ][ 10 ][ 15 ]        = -.741519;
    coeffPower[ 7 ][ 10 ][ 15 ]        = -.767941E-01;
    coeffPower[ 8 ][ 10 ][ 15 ]        = -.145519;
    coeffPower[ 9 ][ 10 ][ 15 ]        =  0.00000;
    coeffPower[ 10 ][ 10 ][ 15 ]       =  0.00000;
    energyMin[ 11 ][ 15 ]              = 0.672680;
    energyMax[ 11 ][ 15 ]              =  1.24545;
    coeffEnergy[ 0 ][ 11 ][ 15 ]       = 0.953008;
    coeffEnergy[ 1 ][ 11 ][ 15 ]       =  1.53742;
    coeffEnergy[ 2 ][ 11 ][ 15 ]       = 0.156696;
    coeffEnergy[ 3 ][ 11 ][ 15 ]       = -.758599E-01;
    coeffEnergy[ 4 ][ 11 ][ 15 ]       = -4.13282;
    coeffEnergy[ 5 ][ 11 ][ 15 ]       = -3.05910;
    coeffEnergy[ 6 ][ 11 ][ 15 ]       =  1.59954;
    coeffEnergy[ 7 ][ 11 ][ 15 ]       = -.592475E-01;
    coeffEnergy[ 8 ][ 11 ][ 15 ]       = 0.334955;
    coeffEnergy[ 9 ][ 11 ][ 15 ]       =  0.00000;
    coeffEnergy[ 10 ][ 11 ][ 15 ]      =  0.00000;
    performanceMin[ 11 ][ 15 ]         = 0.633520;
    performanceMax[ 11 ][ 15 ]         =  1.19380;
    coeffPerformance[ 0 ][ 11 ][ 15 ]  = 0.883833;
    coeffPerformance[ 1 ][ 11 ][ 15 ]  = -2.00598;
    coeffPerformance[ 2 ][ 11 ][ 15 ]  = -.372284;
    coeffPerformance[ 3 ][ 11 ][ 15 ]  = 0.162210;
    coeffPerformance[ 4 ][ 11 ][ 15 ]  =  5.38179;
    coeffPerformance[ 5 ][ 11 ][ 15 ]  =  4.29050;
    coeffPerformance[ 6 ][ 11 ][ 15 ]  = -2.20935;
    coeffPerformance[ 7 ][ 11 ][ 15 ]  = -.208910E-01;
    coeffPerformance[ 8 ][ 11 ][ 15 ]  = -.429783;
    coeffPerformance[ 9 ][ 11 ][ 15 ]  =  0.00000;
    coeffPerformance[ 10 ][ 11 ][ 15 ] =  0.00000;
    powerMin[ 11 ][ 15 ]               = 0.623920;
    powerMax[ 11 ][ 15 ]               =  1.05993;
    coeffPower[ 0 ][ 11 ][ 15 ]        = 0.839678;
    coeffPower[ 1 ][ 11 ][ 15 ]        = -.418884;
    coeffPower[ 2 ][ 11 ][ 15 ]        = -.213814;
    coeffPower[ 3 ][ 11 ][ 15 ]        = 0.854889E-01;
    coeffPower[ 4 ][ 11 ][ 15 ]        =  1.11662;
    coeffPower[ 5 ][ 11 ][ 15 ]        =  1.19726;
    coeffPower[ 6 ][ 11 ][ 15 ]        = -.607559;
    coeffPower[ 7 ][ 11 ][ 15 ]        = -.702622E-01;
    coeffPower[ 8 ][ 11 ][ 15 ]        = -.846734E-01;
    coeffPower[ 9 ][ 11 ][ 15 ]        =  0.00000;
    coeffPower[ 10 ][ 11 ][ 15 ]       =  0.00000;
    energyMin[ 12 ][ 15 ]              = 0.692286;
    energyMax[ 12 ][ 15 ]              =  1.28444;
    coeffEnergy[ 0 ][ 12 ][ 15 ]       = 0.969338;
    coeffEnergy[ 1 ][ 12 ][ 15 ]       =  1.33034;
    coeffEnergy[ 2 ][ 12 ][ 15 ]       = 0.683096E-01;
    coeffEnergy[ 3 ][ 12 ][ 15 ]       = -.395648E-01;
    coeffEnergy[ 4 ][ 12 ][ 15 ]       = -3.58098;
    coeffEnergy[ 5 ][ 12 ][ 15 ]       = -2.40636;
    coeffEnergy[ 6 ][ 12 ][ 15 ]       =  1.26439;
    coeffEnergy[ 7 ][ 12 ][ 15 ]       = -.697750E-01;
    coeffEnergy[ 8 ][ 12 ][ 15 ]       = 0.244178;
    coeffEnergy[ 9 ][ 12 ][ 15 ]       =  0.00000;
    coeffEnergy[ 10 ][ 12 ][ 15 ]      =  0.00000;
    performanceMin[ 12 ][ 15 ]         = 0.637989;
    performanceMax[ 12 ][ 15 ]         =  1.20093;
    coeffPerformance[ 0 ][ 12 ][ 15 ]  = 0.911421;
    coeffPerformance[ 1 ][ 12 ][ 15 ]  = -1.59811;
    coeffPerformance[ 2 ][ 12 ][ 15 ]  = -.279075;
    coeffPerformance[ 3 ][ 12 ][ 15 ]  = 0.121597;
    coeffPerformance[ 4 ][ 12 ][ 15 ]  =  4.28943;
    coeffPerformance[ 5 ][ 12 ][ 15 ]  =  3.24400;
    coeffPerformance[ 6 ][ 12 ][ 15 ]  = -1.68385;
    coeffPerformance[ 7 ][ 12 ][ 15 ]  = -.254591E-01;
    coeffPerformance[ 8 ][ 12 ][ 15 ]  = -.285047;
    coeffPerformance[ 9 ][ 12 ][ 15 ]  =  0.00000;
    coeffPerformance[ 10 ][ 12 ][ 15 ] =  0.00000;
    powerMin[ 12 ][ 15 ]               = 0.654285;
    powerMax[ 12 ][ 15 ]               =  1.09200;
    coeffPower[ 0 ][ 12 ][ 15 ]        = 0.881659;
    coeffPower[ 1 ][ 12 ][ 15 ]        = -.221895;
    coeffPower[ 2 ][ 12 ][ 15 ]        = -.205210;
    coeffPower[ 3 ][ 12 ][ 15 ]        = 0.800071E-01;
    coeffPower[ 4 ][ 12 ][ 15 ]        = 0.586164;
    coeffPower[ 5 ][ 12 ][ 15 ]        = 0.836000;
    coeffPower[ 6 ][ 12 ][ 15 ]        = -.425100;
    coeffPower[ 7 ][ 12 ][ 15 ]        = -.869543E-01;
    coeffPower[ 8 ][ 12 ][ 15 ]        = -.414892E-01;
    coeffPower[ 9 ][ 12 ][ 15 ]        =  0.00000;
    coeffPower[ 10 ][ 12 ][ 15 ]       =  0.00000;
    energyMin[ 13 ][ 15 ]              = 0.715859;
    energyMax[ 13 ][ 15 ]              =  1.25739;
    coeffEnergy[ 0 ][ 13 ][ 15 ]       = 0.973196;
    coeffEnergy[ 1 ][ 13 ][ 15 ]       = 0.460882;
    coeffEnergy[ 2 ][ 13 ][ 15 ]       = 0.125110;
    coeffEnergy[ 3 ][ 13 ][ 15 ]       = -.569197E-01;
    coeffEnergy[ 4 ][ 13 ][ 15 ]       = -1.23771;
    coeffEnergy[ 5 ][ 13 ][ 15 ]       = -1.69791;
    coeffEnergy[ 6 ][ 13 ][ 15 ]       = 0.913716;
    coeffEnergy[ 7 ][ 13 ][ 15 ]       = -.270635E-01;
    coeffEnergy[ 8 ][ 13 ][ 15 ]       = 0.230607;
    coeffEnergy[ 9 ][ 13 ][ 15 ]       =  0.00000;
    coeffEnergy[ 10 ][ 13 ][ 15 ]      =  0.00000;
    performanceMin[ 13 ][ 15 ]         = 0.689944;
    performanceMax[ 13 ][ 15 ]         =  1.21090;
    coeffPerformance[ 0 ][ 13 ][ 15 ]  = 0.942283;
    coeffPerformance[ 1 ][ 13 ][ 15 ]  = -.888351;
    coeffPerformance[ 2 ][ 13 ][ 15 ]  = -.284176;
    coeffPerformance[ 3 ][ 13 ][ 15 ]  = 0.118290;
    coeffPerformance[ 4 ][ 13 ][ 15 ]  =  2.38154;
    coeffPerformance[ 5 ][ 13 ][ 15 ]  =  2.26702;
    coeffPerformance[ 6 ][ 13 ][ 15 ]  = -1.24340;
    coeffPerformance[ 7 ][ 13 ][ 15 ]  = -.520592E-01;
    coeffPerformance[ 8 ][ 13 ][ 15 ]  = -.169829;
    coeffPerformance[ 9 ][ 13 ][ 15 ]  =  0.00000;
    coeffPerformance[ 10 ][ 13 ][ 15 ] =  0.00000;
    powerMin[ 13 ][ 15 ]               = 0.689552;
    powerMax[ 13 ][ 15 ]               =  1.12682;
    coeffPower[ 0 ][ 13 ][ 15 ]        = 0.916016;
    coeffPower[ 1 ][ 13 ][ 15 ]        = -.352206;
    coeffPower[ 2 ][ 13 ][ 15 ]        = -.139039;
    coeffPower[ 3 ][ 13 ][ 15 ]        = 0.540559E-01;
    coeffPower[ 4 ][ 13 ][ 15 ]        = 0.941663;
    coeffPower[ 5 ][ 13 ][ 15 ]        = 0.573108;
    coeffPower[ 6 ][ 13 ][ 15 ]        = -.323746;
    coeffPower[ 7 ][ 13 ][ 15 ]        = -.700515E-01;
    coeffPower[ 8 ][ 13 ][ 15 ]        = 0.409669E-01;
    coeffPower[ 9 ][ 13 ][ 15 ]        =  0.00000;
    coeffPower[ 10 ][ 13 ][ 15 ]       =  0.00000;
    energyMin[ 14 ][ 15 ]              = 0.752723;
    energyMax[ 14 ][ 15 ]              =  1.30002;
    coeffEnergy[ 0 ][ 14 ][ 15 ]       = 0.987626;
    coeffEnergy[ 1 ][ 14 ][ 15 ]       = 0.330841;
    coeffEnergy[ 2 ][ 14 ][ 15 ]       = 0.100654;
    coeffEnergy[ 3 ][ 14 ][ 15 ]       = -.429840E-01;
    coeffEnergy[ 4 ][ 14 ][ 15 ]       = -.889403;
    coeffEnergy[ 5 ][ 14 ][ 15 ]       = -.817425;
    coeffEnergy[ 6 ][ 14 ][ 15 ]       = 0.388689;
    coeffEnergy[ 7 ][ 14 ][ 15 ]       = -.297190E-01;
    coeffEnergy[ 8 ][ 14 ][ 15 ]       = 0.157359;
    coeffEnergy[ 9 ][ 14 ][ 15 ]       =  0.00000;
    coeffEnergy[ 10 ][ 14 ][ 15 ]      =  0.00000;
    performanceMin[ 14 ][ 15 ]         = 0.691620;
    performanceMax[ 14 ][ 15 ]         =  1.22871;
    coeffPerformance[ 0 ][ 14 ][ 15 ]  = 0.971554;
    coeffPerformance[ 1 ][ 14 ][ 15 ]  = -.414870;
    coeffPerformance[ 2 ][ 14 ][ 15 ]  = -.140865;
    coeffPerformance[ 3 ][ 14 ][ 15 ]  = 0.589070E-01;
    coeffPerformance[ 4 ][ 14 ][ 15 ]  =  1.11101;
    coeffPerformance[ 5 ][ 14 ][ 15 ]  =  1.11910;
    coeffPerformance[ 6 ][ 14 ][ 15 ]  = -.592633;
    coeffPerformance[ 7 ][ 14 ][ 15 ]  = -.231361E-01;
    coeffPerformance[ 8 ][ 14 ][ 15 ]  = -.106522;
    coeffPerformance[ 9 ][ 14 ][ 15 ]  =  0.00000;
    coeffPerformance[ 10 ][ 14 ][ 15 ] =  0.00000;
    powerMin[ 14 ][ 15 ]               = 0.729076;
    powerMax[ 14 ][ 15 ]               =  1.16326;
    coeffPower[ 0 ][ 14 ][ 15 ]        = 0.958854;
    coeffPower[ 1 ][ 14 ][ 15 ]        = -.462169E-01;
    coeffPower[ 2 ][ 14 ][ 15 ]        = -.288018E-01;
    coeffPower[ 3 ][ 14 ][ 15 ]        = 0.118563E-01;
    coeffPower[ 4 ][ 14 ][ 15 ]        = 0.120017;
    coeffPower[ 5 ][ 14 ][ 15 ]        = 0.315667;
    coeffPower[ 6 ][ 14 ][ 15 ]        = -.204330;
    coeffPower[ 7 ][ 14 ][ 15 ]        = -.471486E-01;
    coeffPower[ 8 ][ 14 ][ 15 ]        = 0.360939E-01;
    coeffPower[ 9 ][ 14 ][ 15 ]        =  0.00000;
    coeffPower[ 10 ][ 14 ][ 15 ]       =  0.00000;
    energyMin[ 15 ][ 15 ]              = 0.800000;
    energyMax[ 15 ][ 15 ]              =  1.20000;
    coeffEnergy[ 0 ][ 15 ][ 15 ]       =  1.00000;
    coeffEnergy[ 1 ][ 15 ][ 15 ]       = -.119727E-13;
    coeffEnergy[ 2 ][ 15 ][ 15 ]       = 0.249084E-12;
    coeffEnergy[ 3 ][ 15 ][ 15 ]       = -.908244E-13;
    coeffEnergy[ 4 ][ 15 ][ 15 ]       = 0.376444E-13;
    coeffEnergy[ 5 ][ 15 ][ 15 ]       = 0.639803E-12;
    coeffEnergy[ 6 ][ 15 ][ 15 ]       = -.175462E-12;
    coeffEnergy[ 7 ][ 15 ][ 15 ]       = 0.820534E-13;
    coeffEnergy[ 8 ][ 15 ][ 15 ]       = -.145751E-12;
    coeffEnergy[ 9 ][ 15 ][ 15 ]       =  0.00000;
    coeffEnergy[ 10 ][ 15 ][ 15 ]      =  0.00000;
    performanceMin[ 15 ][ 15 ]         = 0.800000;
    performanceMax[ 15 ][ 15 ]         =  1.20000;
    coeffPerformance[ 0 ][ 15 ][ 15 ]  =  1.00000;
    coeffPerformance[ 1 ][ 15 ][ 15 ]  = -.618068E-12;
    coeffPerformance[ 2 ][ 15 ][ 15 ]  = -.678534E-13;
    coeffPerformance[ 3 ][ 15 ][ 15 ]  = 0.262884E-13;
    coeffPerformance[ 4 ][ 15 ][ 15 ]  = 0.166951E-11;
    coeffPerformance[ 5 ][ 15 ][ 15 ]  = 0.120874E-12;
    coeffPerformance[ 6 ][ 15 ][ 15 ]  = -.120868E-13;
    coeffPerformance[ 7 ][ 15 ][ 15 ]  = 0.223191E-13;
    coeffPerformance[ 8 ][ 15 ][ 15 ]  = 0.192362E-14;
    coeffPerformance[ 9 ][ 15 ][ 15 ]  =  0.00000;
    coeffPerformance[ 10 ][ 15 ][ 15 ] =  0.00000;
    powerMin[ 15 ][ 15 ]               = 0.800000;
    powerMax[ 15 ][ 15 ]               =  1.20000;
    coeffPower[ 0 ][ 15 ][ 15 ]        =  1.00000;
    coeffPower[ 1 ][ 15 ][ 15 ]        = 0.216237E-13;
    coeffPower[ 2 ][ 15 ][ 15 ]        = 0.575348E-14;
    coeffPower[ 3 ][ 15 ][ 15 ]        = -.221560E-14;
    coeffPower[ 4 ][ 15 ][ 15 ]        = -.584224E-13;
    coeffPower[ 5 ][ 15 ][ 15 ]        = -.170034E-13;
    coeffPower[ 6 ][ 15 ][ 15 ]        = 0.114223E-13;
    coeffPower[ 7 ][ 15 ][ 15 ]        = 0.839924E-15;
    coeffPower[ 8 ][ 15 ][ 15 ]        = -.176802E-14;
    coeffPower[ 9 ][ 15 ][ 15 ]        =  0.00000;
    coeffPower[ 10 ][ 15 ][ 15 ]       =  0.00000;
}

#define MODEL_ENERGY1 1
#define MODEL_ENERGY2 2
#define MODEL_ENERGYDELAY 3
#define MODEL_TCO 4
#define MODEL_POWERCAPPING 5
#define MODEL_POLICY1 6
#define MODEL_POLICY2 7
#define MODEL_POLICY3 8
#define MODEL_POLICY4 9




#endif /* MODEL_INC_H_ */
